var __create = Object.create;
var __defProp = Object.defineProperty;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __commonJS = (callback, module2) => () => {
  if (!module2) {
    module2 = {exports: {}};
    callback(module2.exports, module2);
  }
  return module2.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, {get: all[name], enumerable: true});
};
var __exportStar = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  return __exportStar(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? {get: () => module2.default, enumerable: true} : {value: module2, enumerable: true})), module2);
};

// node_modules/commander/index.js
var require_commander = __commonJS((exports2, module2) => {
  var EventEmitter3 = require("events").EventEmitter;
  var spawn = require("child_process").spawn;
  var path = require("path");
  var fs = require("fs");
  var Option = class {
    constructor(flags, description) {
      this.flags = flags;
      this.required = flags.includes("<");
      this.optional = flags.includes("[");
      this.variadic = /\w\.\.\.[>\]]$/.test(flags);
      this.mandatory = false;
      const optionFlags = _parseOptionFlags(flags);
      this.short = optionFlags.shortFlag;
      this.long = optionFlags.longFlag;
      this.negate = false;
      if (this.long) {
        this.negate = this.long.startsWith("--no-");
      }
      this.description = description || "";
      this.defaultValue = void 0;
    }
    name() {
      if (this.long) {
        return this.long.replace(/^--/, "");
      }
      return this.short.replace(/^-/, "");
    }
    attributeName() {
      return camelcase(this.name().replace(/^no-/, ""));
    }
    is(arg) {
      return this.short === arg || this.long === arg;
    }
  };
  var CommanderError = class extends Error {
    constructor(exitCode, code, message) {
      super(message);
      Error.captureStackTrace(this, this.constructor);
      this.name = this.constructor.name;
      this.code = code;
      this.exitCode = exitCode;
      this.nestedError = void 0;
    }
  };
  var Command = class extends EventEmitter3 {
    constructor(name) {
      super();
      this.commands = [];
      this.options = [];
      this.parent = null;
      this._allowUnknownOption = false;
      this._args = [];
      this.rawArgs = null;
      this._scriptPath = null;
      this._name = name || "";
      this._optionValues = {};
      this._storeOptionsAsProperties = true;
      this._storeOptionsAsPropertiesCalled = false;
      this._passCommandToAction = true;
      this._actionResults = [];
      this._actionHandler = null;
      this._executableHandler = false;
      this._executableFile = null;
      this._defaultCommandName = null;
      this._exitCallback = null;
      this._aliases = [];
      this._combineFlagAndOptionalValue = true;
      this._hidden = false;
      this._hasHelpOption = true;
      this._helpFlags = "-h, --help";
      this._helpDescription = "display help for command";
      this._helpShortFlag = "-h";
      this._helpLongFlag = "--help";
      this._hasImplicitHelpCommand = void 0;
      this._helpCommandName = "help";
      this._helpCommandnameAndArgs = "help [command]";
      this._helpCommandDescription = "display help for command";
    }
    command(nameAndArgs, actionOptsOrExecDesc, execOpts) {
      let desc = actionOptsOrExecDesc;
      let opts = execOpts;
      if (typeof desc === "object" && desc !== null) {
        opts = desc;
        desc = null;
      }
      opts = opts || {};
      const args = nameAndArgs.split(/ +/);
      const cmd = this.createCommand(args.shift());
      if (desc) {
        cmd.description(desc);
        cmd._executableHandler = true;
      }
      if (opts.isDefault)
        this._defaultCommandName = cmd._name;
      cmd._hidden = !!(opts.noHelp || opts.hidden);
      cmd._hasHelpOption = this._hasHelpOption;
      cmd._helpFlags = this._helpFlags;
      cmd._helpDescription = this._helpDescription;
      cmd._helpShortFlag = this._helpShortFlag;
      cmd._helpLongFlag = this._helpLongFlag;
      cmd._helpCommandName = this._helpCommandName;
      cmd._helpCommandnameAndArgs = this._helpCommandnameAndArgs;
      cmd._helpCommandDescription = this._helpCommandDescription;
      cmd._exitCallback = this._exitCallback;
      cmd._storeOptionsAsProperties = this._storeOptionsAsProperties;
      cmd._passCommandToAction = this._passCommandToAction;
      cmd._combineFlagAndOptionalValue = this._combineFlagAndOptionalValue;
      cmd._executableFile = opts.executableFile || null;
      this.commands.push(cmd);
      cmd._parseExpectedArgs(args);
      cmd.parent = this;
      if (desc)
        return this;
      return cmd;
    }
    createCommand(name) {
      return new Command(name);
    }
    addCommand(cmd, opts) {
      if (!cmd._name)
        throw new Error("Command passed to .addCommand() must have a name");
      function checkExplicitNames(commandArray) {
        commandArray.forEach((cmd2) => {
          if (cmd2._executableHandler && !cmd2._executableFile) {
            throw new Error(`Must specify executableFile for deeply nested executable: ${cmd2.name()}`);
          }
          checkExplicitNames(cmd2.commands);
        });
      }
      checkExplicitNames(cmd.commands);
      opts = opts || {};
      if (opts.isDefault)
        this._defaultCommandName = cmd._name;
      if (opts.noHelp || opts.hidden)
        cmd._hidden = true;
      this.commands.push(cmd);
      cmd.parent = this;
      return this;
    }
    arguments(desc) {
      return this._parseExpectedArgs(desc.split(/ +/));
    }
    addHelpCommand(enableOrNameAndArgs, description) {
      if (enableOrNameAndArgs === false) {
        this._hasImplicitHelpCommand = false;
      } else {
        this._hasImplicitHelpCommand = true;
        if (typeof enableOrNameAndArgs === "string") {
          this._helpCommandName = enableOrNameAndArgs.split(" ")[0];
          this._helpCommandnameAndArgs = enableOrNameAndArgs;
        }
        this._helpCommandDescription = description || this._helpCommandDescription;
      }
      return this;
    }
    _lazyHasImplicitHelpCommand() {
      if (this._hasImplicitHelpCommand === void 0) {
        this._hasImplicitHelpCommand = this.commands.length && !this._actionHandler && !this._findCommand("help");
      }
      return this._hasImplicitHelpCommand;
    }
    _parseExpectedArgs(args) {
      if (!args.length)
        return;
      args.forEach((arg) => {
        const argDetails = {
          required: false,
          name: "",
          variadic: false
        };
        switch (arg[0]) {
          case "<":
            argDetails.required = true;
            argDetails.name = arg.slice(1, -1);
            break;
          case "[":
            argDetails.name = arg.slice(1, -1);
            break;
        }
        if (argDetails.name.length > 3 && argDetails.name.slice(-3) === "...") {
          argDetails.variadic = true;
          argDetails.name = argDetails.name.slice(0, -3);
        }
        if (argDetails.name) {
          this._args.push(argDetails);
        }
      });
      this._args.forEach((arg, i) => {
        if (arg.variadic && i < this._args.length - 1) {
          throw new Error(`only the last argument can be variadic '${arg.name}'`);
        }
      });
      return this;
    }
    exitOverride(fn) {
      if (fn) {
        this._exitCallback = fn;
      } else {
        this._exitCallback = (err) => {
          if (err.code !== "commander.executeSubCommandAsync") {
            throw err;
          } else {
          }
        };
      }
      return this;
    }
    _exit(exitCode, code, message) {
      if (this._exitCallback) {
        this._exitCallback(new CommanderError(exitCode, code, message));
      }
      process.exit(exitCode);
    }
    action(fn) {
      const listener = (args) => {
        const expectedArgsCount = this._args.length;
        const actionArgs = args.slice(0, expectedArgsCount);
        if (this._passCommandToAction) {
          actionArgs[expectedArgsCount] = this;
        } else {
          actionArgs[expectedArgsCount] = this.opts();
        }
        if (args.length > expectedArgsCount) {
          actionArgs.push(args.slice(expectedArgsCount));
        }
        const actionResult = fn.apply(this, actionArgs);
        let rootCommand = this;
        while (rootCommand.parent) {
          rootCommand = rootCommand.parent;
        }
        rootCommand._actionResults.push(actionResult);
      };
      this._actionHandler = listener;
      return this;
    }
    _checkForOptionNameClash(option) {
      if (!this._storeOptionsAsProperties || this._storeOptionsAsPropertiesCalled) {
        return;
      }
      if (option.name() === "help") {
        return;
      }
      const commandProperty = this._getOptionValue(option.attributeName());
      if (commandProperty === void 0) {
        return;
      }
      let foundClash = true;
      if (option.negate) {
        const positiveLongFlag = option.long.replace(/^--no-/, "--");
        foundClash = !this._findOption(positiveLongFlag);
      } else if (option.long) {
        const negativeLongFlag = option.long.replace(/^--/, "--no-");
        foundClash = !this._findOption(negativeLongFlag);
      }
      if (foundClash) {
        throw new Error(`option '${option.name()}' clashes with existing property '${option.attributeName()}' on Command
- call storeOptionsAsProperties(false) to store option values safely,
- or call storeOptionsAsProperties(true) to suppress this check,
- or change option name

Read more on https://git.io/JJc0W`);
      }
    }
    _optionEx(config, flags, description, fn, defaultValue) {
      const option = new Option(flags, description);
      const oname = option.name();
      const name = option.attributeName();
      option.mandatory = !!config.mandatory;
      this._checkForOptionNameClash(option);
      if (typeof fn !== "function") {
        if (fn instanceof RegExp) {
          const regex = fn;
          fn = (val, def) => {
            const m = regex.exec(val);
            return m ? m[0] : def;
          };
        } else {
          defaultValue = fn;
          fn = null;
        }
      }
      if (option.negate || option.optional || option.required || typeof defaultValue === "boolean") {
        if (option.negate) {
          const positiveLongFlag = option.long.replace(/^--no-/, "--");
          defaultValue = this._findOption(positiveLongFlag) ? this._getOptionValue(name) : true;
        }
        if (defaultValue !== void 0) {
          this._setOptionValue(name, defaultValue);
          option.defaultValue = defaultValue;
        }
      }
      this.options.push(option);
      this.on("option:" + oname, (val) => {
        const oldValue = this._getOptionValue(name);
        if (val !== null && fn) {
          val = fn(val, oldValue === void 0 ? defaultValue : oldValue);
        } else if (val !== null && option.variadic) {
          if (oldValue === defaultValue || !Array.isArray(oldValue)) {
            val = [val];
          } else {
            val = oldValue.concat(val);
          }
        }
        if (typeof oldValue === "boolean" || typeof oldValue === "undefined") {
          if (val == null) {
            this._setOptionValue(name, option.negate ? false : defaultValue || true);
          } else {
            this._setOptionValue(name, val);
          }
        } else if (val !== null) {
          this._setOptionValue(name, option.negate ? false : val);
        }
      });
      return this;
    }
    option(flags, description, fn, defaultValue) {
      return this._optionEx({}, flags, description, fn, defaultValue);
    }
    requiredOption(flags, description, fn, defaultValue) {
      return this._optionEx({mandatory: true}, flags, description, fn, defaultValue);
    }
    combineFlagAndOptionalValue(arg) {
      this._combineFlagAndOptionalValue = arg === void 0 || arg;
      return this;
    }
    allowUnknownOption(arg) {
      this._allowUnknownOption = arg === void 0 || arg;
      return this;
    }
    storeOptionsAsProperties(value) {
      this._storeOptionsAsPropertiesCalled = true;
      this._storeOptionsAsProperties = value === void 0 || value;
      if (this.options.length) {
        throw new Error("call .storeOptionsAsProperties() before adding options");
      }
      return this;
    }
    passCommandToAction(value) {
      this._passCommandToAction = value === void 0 || value;
      return this;
    }
    _setOptionValue(key, value) {
      if (this._storeOptionsAsProperties) {
        this[key] = value;
      } else {
        this._optionValues[key] = value;
      }
    }
    _getOptionValue(key) {
      if (this._storeOptionsAsProperties) {
        return this[key];
      }
      return this._optionValues[key];
    }
    parse(argv2, parseOptions2) {
      if (argv2 !== void 0 && !Array.isArray(argv2)) {
        throw new Error("first parameter to parse must be array or undefined");
      }
      parseOptions2 = parseOptions2 || {};
      if (argv2 === void 0) {
        argv2 = process.argv;
        if (process.versions && process.versions.electron) {
          parseOptions2.from = "electron";
        }
      }
      this.rawArgs = argv2.slice();
      let userArgs;
      switch (parseOptions2.from) {
        case void 0:
        case "node":
          this._scriptPath = argv2[1];
          userArgs = argv2.slice(2);
          break;
        case "electron":
          if (process.defaultApp) {
            this._scriptPath = argv2[1];
            userArgs = argv2.slice(2);
          } else {
            userArgs = argv2.slice(1);
          }
          break;
        case "user":
          userArgs = argv2.slice(0);
          break;
        default:
          throw new Error(`unexpected parse option { from: '${parseOptions2.from}' }`);
      }
      if (!this._scriptPath && process.mainModule) {
        this._scriptPath = process.mainModule.filename;
      }
      this._name = this._name || this._scriptPath && path.basename(this._scriptPath, path.extname(this._scriptPath));
      this._parseCommand([], userArgs);
      return this;
    }
    parseAsync(argv2, parseOptions2) {
      this.parse(argv2, parseOptions2);
      return Promise.all(this._actionResults).then(() => this);
    }
    _executeSubCommand(subcommand, args) {
      args = args.slice();
      let launchWithNode = false;
      const sourceExt = [".js", ".ts", ".tsx", ".mjs"];
      this._checkForMissingMandatoryOptions();
      let scriptPath = this._scriptPath;
      if (!scriptPath && process.mainModule) {
        scriptPath = process.mainModule.filename;
      }
      let baseDir;
      try {
        const resolvedLink = fs.realpathSync(scriptPath);
        baseDir = path.dirname(resolvedLink);
      } catch (e) {
        baseDir = ".";
      }
      let bin = path.basename(scriptPath, path.extname(scriptPath)) + "-" + subcommand._name;
      if (subcommand._executableFile) {
        bin = subcommand._executableFile;
      }
      const localBin = path.join(baseDir, bin);
      if (fs.existsSync(localBin)) {
        bin = localBin;
      } else {
        sourceExt.forEach((ext) => {
          if (fs.existsSync(`${localBin}${ext}`)) {
            bin = `${localBin}${ext}`;
          }
        });
      }
      launchWithNode = sourceExt.includes(path.extname(bin));
      let proc;
      if (process.platform !== "win32") {
        if (launchWithNode) {
          args.unshift(bin);
          args = incrementNodeInspectorPort(process.execArgv).concat(args);
          proc = spawn(process.argv[0], args, {stdio: "inherit"});
        } else {
          proc = spawn(bin, args, {stdio: "inherit"});
        }
      } else {
        args.unshift(bin);
        args = incrementNodeInspectorPort(process.execArgv).concat(args);
        proc = spawn(process.execPath, args, {stdio: "inherit"});
      }
      const signals = ["SIGUSR1", "SIGUSR2", "SIGTERM", "SIGINT", "SIGHUP"];
      signals.forEach((signal) => {
        process.on(signal, () => {
          if (proc.killed === false && proc.exitCode === null) {
            proc.kill(signal);
          }
        });
      });
      const exitCallback = this._exitCallback;
      if (!exitCallback) {
        proc.on("close", process.exit.bind(process));
      } else {
        proc.on("close", () => {
          exitCallback(new CommanderError(process.exitCode || 0, "commander.executeSubCommandAsync", "(close)"));
        });
      }
      proc.on("error", (err) => {
        if (err.code === "ENOENT") {
          const executableMissing = `'${bin}' does not exist
 - if '${subcommand._name}' is not meant to be an executable command, remove description parameter from '.command()' and use '.description()' instead
 - if the default executable name is not suitable, use the executableFile option to supply a custom name`;
          throw new Error(executableMissing);
        } else if (err.code === "EACCES") {
          throw new Error(`'${bin}' not executable`);
        }
        if (!exitCallback) {
          process.exit(1);
        } else {
          const wrappedError = new CommanderError(1, "commander.executeSubCommandAsync", "(error)");
          wrappedError.nestedError = err;
          exitCallback(wrappedError);
        }
      });
      this.runningCommand = proc;
    }
    _dispatchSubcommand(commandName, operands, unknown) {
      const subCommand = this._findCommand(commandName);
      if (!subCommand)
        this._helpAndError();
      if (subCommand._executableHandler) {
        this._executeSubCommand(subCommand, operands.concat(unknown));
      } else {
        subCommand._parseCommand(operands, unknown);
      }
    }
    _parseCommand(operands, unknown) {
      const parsed = this.parseOptions(unknown);
      operands = operands.concat(parsed.operands);
      unknown = parsed.unknown;
      this.args = operands.concat(unknown);
      if (operands && this._findCommand(operands[0])) {
        this._dispatchSubcommand(operands[0], operands.slice(1), unknown);
      } else if (this._lazyHasImplicitHelpCommand() && operands[0] === this._helpCommandName) {
        if (operands.length === 1) {
          this.help();
        } else {
          this._dispatchSubcommand(operands[1], [], [this._helpLongFlag]);
        }
      } else if (this._defaultCommandName) {
        outputHelpIfRequested(this, unknown);
        this._dispatchSubcommand(this._defaultCommandName, operands, unknown);
      } else {
        if (this.commands.length && this.args.length === 0 && !this._actionHandler && !this._defaultCommandName) {
          this._helpAndError();
        }
        outputHelpIfRequested(this, parsed.unknown);
        this._checkForMissingMandatoryOptions();
        if (parsed.unknown.length > 0) {
          this.unknownOption(parsed.unknown[0]);
        }
        if (this._actionHandler) {
          const args = this.args.slice();
          this._args.forEach((arg, i) => {
            if (arg.required && args[i] == null) {
              this.missingArgument(arg.name);
            } else if (arg.variadic) {
              args[i] = args.splice(i);
            }
          });
          this._actionHandler(args);
          this.emit("command:" + this.name(), operands, unknown);
        } else if (operands.length) {
          if (this._findCommand("*")) {
            this._dispatchSubcommand("*", operands, unknown);
          } else if (this.listenerCount("command:*")) {
            this.emit("command:*", operands, unknown);
          } else if (this.commands.length) {
            this.unknownCommand();
          }
        } else if (this.commands.length) {
          this._helpAndError();
        } else {
        }
      }
    }
    _findCommand(name) {
      if (!name)
        return void 0;
      return this.commands.find((cmd) => cmd._name === name || cmd._aliases.includes(name));
    }
    _findOption(arg) {
      return this.options.find((option) => option.is(arg));
    }
    _checkForMissingMandatoryOptions() {
      for (let cmd = this; cmd; cmd = cmd.parent) {
        cmd.options.forEach((anOption) => {
          if (anOption.mandatory && cmd._getOptionValue(anOption.attributeName()) === void 0) {
            cmd.missingMandatoryOptionValue(anOption);
          }
        });
      }
    }
    parseOptions(argv2) {
      const operands = [];
      const unknown = [];
      let dest = operands;
      const args = argv2.slice();
      function maybeOption(arg) {
        return arg.length > 1 && arg[0] === "-";
      }
      let activeVariadicOption = null;
      while (args.length) {
        const arg = args.shift();
        if (arg === "--") {
          if (dest === unknown)
            dest.push(arg);
          dest.push(...args);
          break;
        }
        if (activeVariadicOption && !maybeOption(arg)) {
          this.emit(`option:${activeVariadicOption.name()}`, arg);
          continue;
        }
        activeVariadicOption = null;
        if (maybeOption(arg)) {
          const option = this._findOption(arg);
          if (option) {
            if (option.required) {
              const value = args.shift();
              if (value === void 0)
                this.optionMissingArgument(option);
              this.emit(`option:${option.name()}`, value);
            } else if (option.optional) {
              let value = null;
              if (args.length > 0 && !maybeOption(args[0])) {
                value = args.shift();
              }
              this.emit(`option:${option.name()}`, value);
            } else {
              this.emit(`option:${option.name()}`);
            }
            activeVariadicOption = option.variadic ? option : null;
            continue;
          }
        }
        if (arg.length > 2 && arg[0] === "-" && arg[1] !== "-") {
          const option = this._findOption(`-${arg[1]}`);
          if (option) {
            if (option.required || option.optional && this._combineFlagAndOptionalValue) {
              this.emit(`option:${option.name()}`, arg.slice(2));
            } else {
              this.emit(`option:${option.name()}`);
              args.unshift(`-${arg.slice(2)}`);
            }
            continue;
          }
        }
        if (/^--[^=]+=/.test(arg)) {
          const index = arg.indexOf("=");
          const option = this._findOption(arg.slice(0, index));
          if (option && (option.required || option.optional)) {
            this.emit(`option:${option.name()}`, arg.slice(index + 1));
            continue;
          }
        }
        if (arg.length > 1 && arg[0] === "-") {
          dest = unknown;
        }
        dest.push(arg);
      }
      return {operands, unknown};
    }
    opts() {
      if (this._storeOptionsAsProperties) {
        const result = {};
        const len = this.options.length;
        for (let i = 0; i < len; i++) {
          const key = this.options[i].attributeName();
          result[key] = key === this._versionOptionName ? this._version : this[key];
        }
        return result;
      }
      return this._optionValues;
    }
    missingArgument(name) {
      const message = `error: missing required argument '${name}'`;
      console.error(message);
      this._exit(1, "commander.missingArgument", message);
    }
    optionMissingArgument(option, flag) {
      let message;
      if (flag) {
        message = `error: option '${option.flags}' argument missing, got '${flag}'`;
      } else {
        message = `error: option '${option.flags}' argument missing`;
      }
      console.error(message);
      this._exit(1, "commander.optionMissingArgument", message);
    }
    missingMandatoryOptionValue(option) {
      const message = `error: required option '${option.flags}' not specified`;
      console.error(message);
      this._exit(1, "commander.missingMandatoryOptionValue", message);
    }
    unknownOption(flag) {
      if (this._allowUnknownOption)
        return;
      const message = `error: unknown option '${flag}'`;
      console.error(message);
      this._exit(1, "commander.unknownOption", message);
    }
    unknownCommand() {
      const partCommands = [this.name()];
      for (let parentCmd = this.parent; parentCmd; parentCmd = parentCmd.parent) {
        partCommands.unshift(parentCmd.name());
      }
      const fullCommand = partCommands.join(" ");
      const message = `error: unknown command '${this.args[0]}'.` + (this._hasHelpOption ? ` See '${fullCommand} ${this._helpLongFlag}'.` : "");
      console.error(message);
      this._exit(1, "commander.unknownCommand", message);
    }
    version(str, flags, description) {
      if (str === void 0)
        return this._version;
      this._version = str;
      flags = flags || "-V, --version";
      description = description || "output the version number";
      const versionOption = new Option(flags, description);
      this._versionOptionName = versionOption.attributeName();
      this.options.push(versionOption);
      this.on("option:" + versionOption.name(), () => {
        process.stdout.write(str + "\n");
        this._exit(0, "commander.version", str);
      });
      return this;
    }
    description(str, argsDescription) {
      if (str === void 0 && argsDescription === void 0)
        return this._description;
      this._description = str;
      this._argsDescription = argsDescription;
      return this;
    }
    alias(alias) {
      if (alias === void 0)
        return this._aliases[0];
      let command = this;
      if (this.commands.length !== 0 && this.commands[this.commands.length - 1]._executableHandler) {
        command = this.commands[this.commands.length - 1];
      }
      if (alias === command._name)
        throw new Error("Command alias can't be the same as its name");
      command._aliases.push(alias);
      return this;
    }
    aliases(aliases2) {
      if (aliases2 === void 0)
        return this._aliases;
      aliases2.forEach((alias) => this.alias(alias));
      return this;
    }
    usage(str) {
      if (str === void 0) {
        if (this._usage)
          return this._usage;
        const args = this._args.map((arg) => {
          return humanReadableArgName(arg);
        });
        return [].concat(this.options.length || this._hasHelpOption ? "[options]" : [], this.commands.length ? "[command]" : [], this._args.length ? args : []).join(" ");
      }
      this._usage = str;
      return this;
    }
    name(str) {
      if (str === void 0)
        return this._name;
      this._name = str;
      return this;
    }
    prepareCommands() {
      const commandDetails = this.commands.filter((cmd) => {
        return !cmd._hidden;
      }).map((cmd) => {
        const args = cmd._args.map((arg) => {
          return humanReadableArgName(arg);
        }).join(" ");
        return [
          cmd._name + (cmd._aliases[0] ? "|" + cmd._aliases[0] : "") + (cmd.options.length ? " [options]" : "") + (args ? " " + args : ""),
          cmd._description
        ];
      });
      if (this._lazyHasImplicitHelpCommand()) {
        commandDetails.push([this._helpCommandnameAndArgs, this._helpCommandDescription]);
      }
      return commandDetails;
    }
    largestCommandLength() {
      const commands = this.prepareCommands();
      return commands.reduce((max, command) => {
        return Math.max(max, command[0].length);
      }, 0);
    }
    largestOptionLength() {
      const options = [].slice.call(this.options);
      options.push({
        flags: this._helpFlags
      });
      return options.reduce((max, option) => {
        return Math.max(max, option.flags.length);
      }, 0);
    }
    largestArgLength() {
      return this._args.reduce((max, arg) => {
        return Math.max(max, arg.name.length);
      }, 0);
    }
    padWidth() {
      let width = this.largestOptionLength();
      if (this._argsDescription && this._args.length) {
        if (this.largestArgLength() > width) {
          width = this.largestArgLength();
        }
      }
      if (this.commands && this.commands.length) {
        if (this.largestCommandLength() > width) {
          width = this.largestCommandLength();
        }
      }
      return width;
    }
    optionHelp() {
      const width = this.padWidth();
      const columns = process.stdout.columns || 80;
      const descriptionWidth = columns - width - 4;
      function padOptionDetails(flags, description) {
        return pad(flags, width) + "  " + optionalWrap(description, descriptionWidth, width + 2);
      }
      ;
      const help = this.options.map((option) => {
        const fullDesc = option.description + (!option.negate && option.defaultValue !== void 0 ? " (default: " + JSON.stringify(option.defaultValue) + ")" : "");
        return padOptionDetails(option.flags, fullDesc);
      });
      const showShortHelpFlag = this._hasHelpOption && this._helpShortFlag && !this._findOption(this._helpShortFlag);
      const showLongHelpFlag = this._hasHelpOption && !this._findOption(this._helpLongFlag);
      if (showShortHelpFlag || showLongHelpFlag) {
        let helpFlags = this._helpFlags;
        if (!showShortHelpFlag) {
          helpFlags = this._helpLongFlag;
        } else if (!showLongHelpFlag) {
          helpFlags = this._helpShortFlag;
        }
        help.push(padOptionDetails(helpFlags, this._helpDescription));
      }
      return help.join("\n");
    }
    commandHelp() {
      if (!this.commands.length && !this._lazyHasImplicitHelpCommand())
        return "";
      const commands = this.prepareCommands();
      const width = this.padWidth();
      const columns = process.stdout.columns || 80;
      const descriptionWidth = columns - width - 4;
      return [
        "Commands:",
        commands.map((cmd) => {
          const desc = cmd[1] ? "  " + cmd[1] : "";
          return (desc ? pad(cmd[0], width) : cmd[0]) + optionalWrap(desc, descriptionWidth, width + 2);
        }).join("\n").replace(/^/gm, "  "),
        ""
      ].join("\n");
    }
    helpInformation() {
      let desc = [];
      if (this._description) {
        desc = [
          this._description,
          ""
        ];
        const argsDescription = this._argsDescription;
        if (argsDescription && this._args.length) {
          const width = this.padWidth();
          const columns = process.stdout.columns || 80;
          const descriptionWidth = columns - width - 5;
          desc.push("Arguments:");
          this._args.forEach((arg) => {
            desc.push("  " + pad(arg.name, width) + "  " + wrap(argsDescription[arg.name] || "", descriptionWidth, width + 4));
          });
          desc.push("");
        }
      }
      let cmdName = this._name;
      if (this._aliases[0]) {
        cmdName = cmdName + "|" + this._aliases[0];
      }
      let parentCmdNames = "";
      for (let parentCmd = this.parent; parentCmd; parentCmd = parentCmd.parent) {
        parentCmdNames = parentCmd.name() + " " + parentCmdNames;
      }
      const usage = [
        "Usage: " + parentCmdNames + cmdName + " " + this.usage(),
        ""
      ];
      let cmds = [];
      const commandHelp = this.commandHelp();
      if (commandHelp)
        cmds = [commandHelp];
      let options = [];
      if (this._hasHelpOption || this.options.length > 0) {
        options = [
          "Options:",
          "" + this.optionHelp().replace(/^/gm, "  "),
          ""
        ];
      }
      return usage.concat(desc).concat(options).concat(cmds).join("\n");
    }
    outputHelp(cb) {
      if (!cb) {
        cb = (passthru) => {
          return passthru;
        };
      }
      const cbOutput = cb(this.helpInformation());
      if (typeof cbOutput !== "string" && !Buffer.isBuffer(cbOutput)) {
        throw new Error("outputHelp callback must return a string or a Buffer");
      }
      process.stdout.write(cbOutput);
      this.emit(this._helpLongFlag);
    }
    helpOption(flags, description) {
      if (typeof flags === "boolean") {
        this._hasHelpOption = flags;
        return this;
      }
      this._helpFlags = flags || this._helpFlags;
      this._helpDescription = description || this._helpDescription;
      const helpFlags = _parseOptionFlags(this._helpFlags);
      this._helpShortFlag = helpFlags.shortFlag;
      this._helpLongFlag = helpFlags.longFlag;
      return this;
    }
    help(cb) {
      this.outputHelp(cb);
      this._exit(process.exitCode || 0, "commander.help", "(outputHelp)");
    }
    _helpAndError() {
      this.outputHelp();
      this._exit(1, "commander.help", "(outputHelp)");
    }
  };
  exports2 = module2.exports = new Command();
  exports2.program = exports2;
  exports2.Command = Command;
  exports2.Option = Option;
  exports2.CommanderError = CommanderError;
  function camelcase(flag) {
    return flag.split("-").reduce((str, word) => {
      return str + word[0].toUpperCase() + word.slice(1);
    });
  }
  function pad(str, width) {
    const len = Math.max(0, width - str.length);
    return str + Array(len + 1).join(" ");
  }
  function wrap(str, width, indent) {
    const regex = new RegExp(".{1," + (width - 1) + "}([\\s​]|$)|[^\\s​]+?([\\s​]|$)", "g");
    const lines = str.match(regex) || [];
    return lines.map((line, i) => {
      if (line.slice(-1) === "\n") {
        line = line.slice(0, line.length - 1);
      }
      return (i > 0 && indent ? Array(indent + 1).join(" ") : "") + line.trimRight();
    }).join("\n");
  }
  function optionalWrap(str, width, indent) {
    if (str.match(/[\n]\s+/))
      return str;
    const minWidth = 40;
    if (width < minWidth)
      return str;
    return wrap(str, width, indent);
  }
  function outputHelpIfRequested(cmd, args) {
    const helpOption = cmd._hasHelpOption && args.find((arg) => arg === cmd._helpLongFlag || arg === cmd._helpShortFlag);
    if (helpOption) {
      cmd.outputHelp();
      cmd._exit(0, "commander.helpDisplayed", "(outputHelp)");
    }
  }
  function humanReadableArgName(arg) {
    const nameOutput = arg.name + (arg.variadic === true ? "..." : "");
    return arg.required ? "<" + nameOutput + ">" : "[" + nameOutput + "]";
  }
  function _parseOptionFlags(flags) {
    let shortFlag;
    let longFlag;
    const flagParts = flags.split(/[ |,]+/);
    if (flagParts.length > 1 && !/^[[<]/.test(flagParts[1]))
      shortFlag = flagParts.shift();
    longFlag = flagParts.shift();
    if (!shortFlag && /^-[^-]$/.test(longFlag)) {
      shortFlag = longFlag;
      longFlag = void 0;
    }
    return {shortFlag, longFlag};
  }
  function incrementNodeInspectorPort(args) {
    return args.map((arg) => {
      if (!arg.startsWith("--inspect")) {
        return arg;
      }
      let debugOption;
      let debugHost = "127.0.0.1";
      let debugPort = "9229";
      let match;
      if ((match = arg.match(/^(--inspect(-brk)?)$/)) !== null) {
        debugOption = match[1];
      } else if ((match = arg.match(/^(--inspect(-brk|-port)?)=([^:]+)$/)) !== null) {
        debugOption = match[1];
        if (/^\d+$/.test(match[3])) {
          debugPort = match[3];
        } else {
          debugHost = match[3];
        }
      } else if ((match = arg.match(/^(--inspect(-brk|-port)?)=([^:]+):(\d+)$/)) !== null) {
        debugOption = match[1];
        debugHost = match[3];
        debugPort = match[4];
      }
      if (debugOption && debugPort !== "0") {
        return `${debugOption}=${debugHost}:${parseInt(debugPort) + 1}`;
      }
      return arg;
    });
  }
});

// node_modules/workerpool/src/requireFoolWebpack.js
var require_requireFoolWebpack = __commonJS((exports, module) => {
  var requireFoolWebpack = eval(`typeof require !== 'undefined' ? require : function (module) { throw new Error('Module " + module + " not found.') }`);
  module.exports = requireFoolWebpack;
});

// node_modules/workerpool/src/environment.js
var require_environment = __commonJS((exports2, module2) => {
  var requireFoolWebpack2 = require_requireFoolWebpack();
  var isNode = function(nodeProcess) {
    return typeof nodeProcess !== "undefined" && nodeProcess.versions != null && nodeProcess.versions.node != null;
  };
  module2.exports.isNode = isNode;
  module2.exports.platform = typeof process !== "undefined" && isNode(process) ? "node" : "browser";
  var worker_threads = tryRequireFoolWebpack("worker_threads");
  module2.exports.isMainThread = module2.exports.platform === "node" ? (!worker_threads || worker_threads.isMainThread) && !process.connected : typeof Window !== "undefined";
  module2.exports.cpus = module2.exports.platform === "browser" ? self.navigator.hardwareConcurrency : requireFoolWebpack2("os").cpus().length;
  function tryRequireFoolWebpack(module3) {
    try {
      return requireFoolWebpack2(module3);
    } catch (err) {
      return null;
    }
  }
});

// node_modules/workerpool/src/Promise.js
var require_Promise = __commonJS((exports2, module2) => {
  "use strict";
  function Promise2(handler, parent) {
    var me = this;
    if (!(this instanceof Promise2)) {
      throw new SyntaxError("Constructor must be called with the new operator");
    }
    if (typeof handler !== "function") {
      throw new SyntaxError("Function parameter handler(resolve, reject) missing");
    }
    var _onSuccess = [];
    var _onFail = [];
    this.resolved = false;
    this.rejected = false;
    this.pending = true;
    var _process = function(onSuccess, onFail) {
      _onSuccess.push(onSuccess);
      _onFail.push(onFail);
    };
    this.then = function(onSuccess, onFail) {
      return new Promise2(function(resolve2, reject) {
        var s = onSuccess ? _then(onSuccess, resolve2, reject) : resolve2;
        var f = onFail ? _then(onFail, resolve2, reject) : reject;
        _process(s, f);
      }, me);
    };
    var _resolve = function(result) {
      me.resolved = true;
      me.rejected = false;
      me.pending = false;
      _onSuccess.forEach(function(fn) {
        fn(result);
      });
      _process = function(onSuccess, onFail) {
        onSuccess(result);
      };
      _resolve = _reject = function() {
      };
      return me;
    };
    var _reject = function(error) {
      me.resolved = false;
      me.rejected = true;
      me.pending = false;
      _onFail.forEach(function(fn) {
        fn(error);
      });
      _process = function(onSuccess, onFail) {
        onFail(error);
      };
      _resolve = _reject = function() {
      };
      return me;
    };
    this.cancel = function() {
      if (parent) {
        parent.cancel();
      } else {
        _reject(new CancellationError());
      }
      return me;
    };
    this.timeout = function(delay) {
      if (parent) {
        parent.timeout(delay);
      } else {
        var timer = setTimeout(function() {
          _reject(new TimeoutError("Promise timed out after " + delay + " ms"));
        }, delay);
        me.always(function() {
          clearTimeout(timer);
        });
      }
      return me;
    };
    handler(function(result) {
      _resolve(result);
    }, function(error) {
      _reject(error);
    });
  }
  function _then(callback, resolve2, reject) {
    return function(result) {
      try {
        var res = callback(result);
        if (res && typeof res.then === "function" && typeof res["catch"] === "function") {
          res.then(resolve2, reject);
        } else {
          resolve2(res);
        }
      } catch (error) {
        reject(error);
      }
    };
  }
  Promise2.prototype["catch"] = function(onFail) {
    return this.then(null, onFail);
  };
  Promise2.prototype.always = function(fn) {
    return this.then(fn, fn);
  };
  Promise2.all = function(promises) {
    return new Promise2(function(resolve2, reject) {
      var remaining = promises.length, results = [];
      if (remaining) {
        promises.forEach(function(p, i) {
          p.then(function(result) {
            results[i] = result;
            remaining--;
            if (remaining == 0) {
              resolve2(results);
            }
          }, function(error) {
            remaining = 0;
            reject(error);
          });
        });
      } else {
        resolve2(results);
      }
    });
  };
  Promise2.defer = function() {
    var resolver = {};
    resolver.promise = new Promise2(function(resolve2, reject) {
      resolver.resolve = resolve2;
      resolver.reject = reject;
    });
    return resolver;
  };
  function CancellationError(message) {
    this.message = message || "promise cancelled";
    this.stack = new Error().stack;
  }
  CancellationError.prototype = new Error();
  CancellationError.prototype.constructor = Error;
  CancellationError.prototype.name = "CancellationError";
  Promise2.CancellationError = CancellationError;
  function TimeoutError(message) {
    this.message = message || "timeout exceeded";
    this.stack = new Error().stack;
  }
  TimeoutError.prototype = new Error();
  TimeoutError.prototype.constructor = Error;
  TimeoutError.prototype.name = "TimeoutError";
  Promise2.TimeoutError = TimeoutError;
  module2.exports = Promise2;
});

// node_modules/workerpool/src/generated/embeddedWorker.js
var require_embeddedWorker = __commonJS((exports2, module2) => {
  module2.exports = `!function(){var __webpack_exports__={};!function(){var exports=__webpack_exports__,__webpack_unused_export__;function _typeof(r){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(r){return typeof r}:function(r){return r&&"function"==typeof Symbol&&r.constructor===Symbol&&r!==Symbol.prototype?"symbol":typeof r})(r)}var requireFoolWebpack=eval("typeof require !== 'undefined' ? require : function (module) { throw new Error('Module \\" + module + \\" not found.') }"),TERMINATE_METHOD_ID="__workerpool-terminate__",worker={exit:function(){}},WorkerThreads,parentPort;if("undefined"!=typeof self&&"function"==typeof postMessage&&"function"==typeof addEventListener)worker.on=function(r,e){addEventListener(r,function(r){e(r.data)})},worker.send=function(r){postMessage(r)};else{if("undefined"==typeof process)throw new Error("Script must be executed as a worker");try{WorkerThreads=requireFoolWebpack("worker_threads")}catch(error){if("object"!==_typeof(error)||null===error||"MODULE_NOT_FOUND"!==error.code)throw error}WorkerThreads&&null!==WorkerThreads.parentPort?(parentPort=WorkerThreads.parentPort,worker.send=parentPort.postMessage.bind(parentPort),worker.on=parentPort.on.bind(parentPort)):(worker.on=process.on.bind(process),worker.send=process.send.bind(process),worker.on("disconnect",function(){process.exit(1)}),worker.exit=process.exit.bind(process))}function convertError(o){return Object.getOwnPropertyNames(o).reduce(function(r,e){return Object.defineProperty(r,e,{value:o[e],enumerable:!0})},{})}function isPromise(r){return r&&"function"==typeof r.then&&"function"==typeof r.catch}worker.methods={},worker.methods.run=function(r,e){r=new Function("return ("+r+").apply(null, arguments);");return r.apply(r,e)},worker.methods.methods=function(){return Object.keys(worker.methods)};var currentRequestId=null;worker.on("message",function(e){if(e===TERMINATE_METHOD_ID)return worker.exit(0);try{var r=worker.methods[e.method];if(!r)throw new Error('Unknown method "'+e.method+'"');currentRequestId=e.id;var o=r.apply(r,e.params);isPromise(o)?o.then(function(r){worker.send({id:e.id,result:r,error:null}),currentRequestId=null}).catch(function(r){worker.send({id:e.id,result:null,error:convertError(r)}),currentRequestId=null}):(worker.send({id:e.id,result:o,error:null}),currentRequestId=null)}catch(r){worker.send({id:e.id,result:null,error:convertError(r)})}}),worker.register=function(r){if(r)for(var e in r)r.hasOwnProperty(e)&&(worker.methods[e]=r[e]);worker.send("ready")},worker.emit=function(r){currentRequestId&&worker.send({id:currentRequestId,isEvent:!0,payload:r})},__webpack_unused_export__=worker.register,__webpack_unused_export__=worker.emit}()}();`;
});

// node_modules/workerpool/src/WorkerHandler.js
var require_WorkerHandler = __commonJS((exports2, module2) => {
  "use strict";
  var Promise2 = require_Promise();
  var environment = require_environment();
  var requireFoolWebpack2 = require_requireFoolWebpack();
  var TERMINATE_METHOD_ID2 = "__workerpool-terminate__";
  var CHILD_PROCESS_EXIT_TIMEOUT = 1e3;
  function ensureWorkerThreads() {
    var WorkerThreads2 = tryRequireWorkerThreads();
    if (!WorkerThreads2) {
      throw new Error("WorkerPool: workerType = 'thread' is not supported, Node >= 11.7.0 required");
    }
    return WorkerThreads2;
  }
  function ensureWebWorker() {
    if (typeof Worker !== "function" && (typeof Worker !== "object" || typeof Worker.prototype.constructor !== "function")) {
      throw new Error("WorkerPool: Web Workers not supported");
    }
  }
  function tryRequireWorkerThreads() {
    try {
      return requireFoolWebpack2("worker_threads");
    } catch (error) {
      if (typeof error === "object" && error !== null && error.code === "MODULE_NOT_FOUND") {
        return null;
      } else {
        throw error;
      }
    }
  }
  function getDefaultWorker() {
    if (environment.platform === "browser") {
      if (typeof Blob === "undefined") {
        throw new Error("Blob not supported by the browser");
      }
      if (!window.URL || typeof window.URL.createObjectURL !== "function") {
        throw new Error("URL.createObjectURL not supported by the browser");
      }
      var blob = new Blob([require_embeddedWorker()], {type: "text/javascript"});
      return window.URL.createObjectURL(blob);
    } else {
      return __dirname + "/worker.js";
    }
  }
  function setupWorker(script, options) {
    if (options.workerType === "web") {
      ensureWebWorker();
      return setupBrowserWorker(script, Worker);
    } else if (options.workerType === "thread") {
      WorkerThreads2 = ensureWorkerThreads();
      return setupWorkerThreadWorker(script, WorkerThreads2);
    } else if (options.workerType === "process" || !options.workerType) {
      return setupProcessWorker(script, resolveForkOptions(options), requireFoolWebpack2("child_process"));
    } else {
      if (environment.platform === "browser") {
        ensureWebWorker();
        return setupBrowserWorker(script, Worker);
      } else {
        var WorkerThreads2 = tryRequireWorkerThreads();
        if (WorkerThreads2) {
          return setupWorkerThreadWorker(script, WorkerThreads2);
        } else {
          return setupProcessWorker(script, resolveForkOptions(options), requireFoolWebpack2("child_process"));
        }
      }
    }
  }
  function setupBrowserWorker(script, Worker2) {
    var worker2 = new Worker2(script);
    worker2.isBrowserWorker = true;
    worker2.on = function(event, callback) {
      this.addEventListener(event, function(message) {
        callback(message.data);
      });
    };
    worker2.send = function(message) {
      this.postMessage(message);
    };
    return worker2;
  }
  function setupWorkerThreadWorker(script, WorkerThreads2) {
    var worker2 = new WorkerThreads2.Worker(script, {
      stdout: false,
      stderr: false
    });
    worker2.isWorkerThread = true;
    worker2.send = function(message) {
      this.postMessage(message);
    };
    worker2.kill = function() {
      this.terminate();
      return true;
    };
    worker2.disconnect = function() {
      this.terminate();
    };
    return worker2;
  }
  function setupProcessWorker(script, options, child_process) {
    var worker2 = child_process.fork(script, options.forkArgs, options.forkOpts);
    worker2.isChildProcess = true;
    return worker2;
  }
  function resolveForkOptions(opts) {
    opts = opts || {};
    var processExecArgv = process.execArgv.join(" ");
    var inspectorActive = processExecArgv.indexOf("--inspect") !== -1;
    var debugBrk = processExecArgv.indexOf("--debug-brk") !== -1;
    var execArgv = [];
    if (inspectorActive) {
      execArgv.push("--inspect=" + opts.debugPort);
      if (debugBrk) {
        execArgv.push("--debug-brk");
      }
    }
    process.execArgv.forEach(function(arg) {
      if (arg.indexOf("--max-old-space-size") > -1) {
        execArgv.push(arg);
      }
    });
    return Object.assign({}, opts, {
      forkArgs: opts.forkArgs,
      forkOpts: Object.assign({}, opts.forkOpts, {
        execArgv: (opts.forkOpts && opts.forkOpts.execArgv || []).concat(execArgv)
      })
    });
  }
  function objectToError(obj) {
    var temp = new Error("");
    var props = Object.keys(obj);
    for (var i = 0; i < props.length; i++) {
      temp[props[i]] = obj[props[i]];
    }
    return temp;
  }
  function WorkerHandler(script, _options) {
    var me = this;
    var options = _options || {};
    this.script = script || getDefaultWorker();
    this.worker = setupWorker(this.script, options);
    this.debugPort = options.debugPort;
    if (!script) {
      this.worker.ready = true;
    }
    this.requestQueue = [];
    this.worker.on("message", function(response) {
      if (me.terminated) {
        return;
      }
      if (typeof response === "string" && response === "ready") {
        me.worker.ready = true;
        dispatchQueuedRequests();
      } else {
        var id = response.id;
        var task = me.processing[id];
        if (task !== void 0) {
          if (response.isEvent) {
            if (task.options && typeof task.options.on === "function") {
              task.options.on(response.payload);
            }
          } else {
            delete me.processing[id];
            if (me.terminating === true) {
              me.terminate();
            }
            if (response.error) {
              task.resolver.reject(objectToError(response.error));
            } else {
              task.resolver.resolve(response.result);
            }
          }
        }
      }
    });
    function onError(error) {
      me.terminated = true;
      for (var id in me.processing) {
        if (me.processing[id] !== void 0) {
          me.processing[id].resolver.reject(error);
        }
      }
      me.processing = Object.create(null);
    }
    function dispatchQueuedRequests() {
      for (const request of me.requestQueue.splice(0)) {
        me.worker.send(request);
      }
    }
    var worker2 = this.worker;
    this.worker.on("error", onError);
    this.worker.on("exit", function(exitCode, signalCode) {
      var message = "Workerpool Worker terminated Unexpectedly\n";
      message += "    exitCode: `" + exitCode + "`\n";
      message += "    signalCode: `" + signalCode + "`\n";
      message += "    workerpool.script: `" + me.script + "`\n";
      message += "    spawnArgs: `" + worker2.spawnargs + "`\n";
      message += "    spawnfile: `" + worker2.spawnfile + "`\n";
      message += "    stdout: `" + worker2.stdout + "`\n";
      message += "    stderr: `" + worker2.stderr + "`\n";
      onError(new Error(message));
    });
    this.processing = Object.create(null);
    this.terminating = false;
    this.terminated = false;
    this.terminationHandler = null;
    this.lastId = 0;
  }
  WorkerHandler.prototype.methods = function() {
    return this.exec("methods");
  };
  WorkerHandler.prototype.exec = function(method, params, resolver, options) {
    if (!resolver) {
      resolver = Promise2.defer();
    }
    var id = ++this.lastId;
    this.processing[id] = {
      id,
      resolver,
      options
    };
    var request = {
      id,
      method,
      params
    };
    if (this.terminated) {
      resolver.reject(new Error("Worker is terminated"));
    } else if (this.worker.ready) {
      this.worker.send(request);
    } else {
      this.requestQueue.push(request);
    }
    var me = this;
    return resolver.promise.catch(function(error) {
      if (error instanceof Promise2.CancellationError || error instanceof Promise2.TimeoutError) {
        delete me.processing[id];
        return me.terminateAndNotify(true).then(function() {
          throw error;
        }, function(err) {
          throw err;
        });
      } else {
        throw error;
      }
    });
  };
  WorkerHandler.prototype.busy = function() {
    return Object.keys(this.processing).length > 0;
  };
  WorkerHandler.prototype.terminate = function(force, callback) {
    var me = this;
    if (force) {
      for (var id in this.processing) {
        if (this.processing[id] !== void 0) {
          this.processing[id].resolver.reject(new Error("Worker terminated"));
        }
      }
      this.processing = Object.create(null);
    }
    if (typeof callback === "function") {
      this.terminationHandler = callback;
    }
    if (!this.busy()) {
      var cleanup = function(err) {
        me.terminated = true;
        if (me.worker != null && me.worker.removeAllListeners) {
          me.worker.removeAllListeners("message");
        }
        me.worker = null;
        me.terminating = false;
        if (me.terminationHandler) {
          me.terminationHandler(err, me);
        } else if (err) {
          throw err;
        }
      };
      if (this.worker) {
        if (typeof this.worker.kill === "function") {
          if (this.worker.killed) {
            cleanup(new Error("worker already killed!"));
            return;
          }
          if (this.worker.isChildProcess) {
            var cleanExitTimeout = setTimeout(function() {
              me.worker.kill();
            }, CHILD_PROCESS_EXIT_TIMEOUT);
            this.worker.once("exit", function() {
              clearTimeout(cleanExitTimeout);
              me.worker.killed = true;
              cleanup();
            });
            if (this.worker.ready) {
              this.worker.send(TERMINATE_METHOD_ID2);
            } else {
              this.worker.requestQueue.push(TERMINATE_METHOD_ID2);
            }
          } else {
            this.worker.kill();
            this.worker.killed = true;
            cleanup();
          }
          return;
        } else if (typeof this.worker.terminate === "function") {
          this.worker.terminate();
          this.worker.killed = true;
        } else {
          throw new Error("Failed to terminate worker");
        }
      }
      cleanup();
    } else {
      this.terminating = true;
    }
  };
  WorkerHandler.prototype.terminateAndNotify = function(force, timeout) {
    var resolver = Promise2.defer();
    if (timeout) {
      resolver.promise.timeout = timeout;
    }
    this.terminate(force, function(err, worker2) {
      if (err) {
        resolver.reject(err);
      } else {
        resolver.resolve(worker2);
      }
    });
    return resolver.promise;
  };
  module2.exports = WorkerHandler;
  module2.exports._tryRequireWorkerThreads = tryRequireWorkerThreads;
  module2.exports._setupProcessWorker = setupProcessWorker;
  module2.exports._setupBrowserWorker = setupBrowserWorker;
  module2.exports._setupWorkerThreadWorker = setupWorkerThreadWorker;
  module2.exports.ensureWorkerThreads = ensureWorkerThreads;
});

// node_modules/workerpool/src/debug-port-allocator.js
var require_debug_port_allocator = __commonJS((exports2, module2) => {
  "use strict";
  var MAX_PORTS = 65535;
  module2.exports = DebugPortAllocator;
  function DebugPortAllocator() {
    this.ports = Object.create(null);
    this.length = 0;
  }
  DebugPortAllocator.prototype.nextAvailableStartingAt = function(starting) {
    while (this.ports[starting] === true) {
      starting++;
    }
    if (starting >= MAX_PORTS) {
      throw new Error("WorkerPool debug port limit reached: " + starting + ">= " + MAX_PORTS);
    }
    this.ports[starting] = true;
    this.length++;
    return starting;
  };
  DebugPortAllocator.prototype.releasePort = function(port) {
    delete this.ports[port];
    this.length--;
  };
});

// node_modules/workerpool/src/Pool.js
var require_Pool = __commonJS((exports2, module2) => {
  var Promise2 = require_Promise();
  var WorkerHandler = require_WorkerHandler();
  var environment = require_environment();
  var DebugPortAllocator = require_debug_port_allocator();
  var DEBUG_PORT_ALLOCATOR = new DebugPortAllocator();
  function Pool(script, options) {
    if (typeof script === "string") {
      this.script = script || null;
    } else {
      this.script = null;
      options = script;
    }
    this.workers = [];
    this.tasks = [];
    options = options || {};
    this.forkArgs = options.forkArgs || [];
    this.forkOpts = options.forkOpts || {};
    this.debugPortStart = options.debugPortStart || 43210;
    this.nodeWorker = options.nodeWorker;
    this.workerType = options.workerType || options.nodeWorker || "auto";
    this.maxQueueSize = options.maxQueueSize || Infinity;
    if (options && "maxWorkers" in options) {
      validateMaxWorkers(options.maxWorkers);
      this.maxWorkers = options.maxWorkers;
    } else {
      this.maxWorkers = Math.max((environment.cpus || 4) - 1, 1);
    }
    if (options && "minWorkers" in options) {
      if (options.minWorkers === "max") {
        this.minWorkers = this.maxWorkers;
      } else {
        validateMinWorkers(options.minWorkers);
        this.minWorkers = options.minWorkers;
        this.maxWorkers = Math.max(this.minWorkers, this.maxWorkers);
      }
      this._ensureMinWorkers();
    }
    this._boundNext = this._next.bind(this);
    if (this.workerType === "thread") {
      WorkerHandler.ensureWorkerThreads();
    }
  }
  Pool.prototype.exec = function(method, params, options) {
    if (params && !Array.isArray(params)) {
      throw new TypeError('Array expected as argument "params"');
    }
    if (typeof method === "string") {
      var resolver = Promise2.defer();
      if (this.tasks.length >= this.maxQueueSize) {
        throw new Error("Max queue size of " + this.maxQueueSize + " reached");
      }
      var tasks = this.tasks;
      var task = {
        method,
        params,
        resolver,
        timeout: null,
        options
      };
      tasks.push(task);
      var originalTimeout = resolver.promise.timeout;
      resolver.promise.timeout = function timeout(delay) {
        if (tasks.indexOf(task) !== -1) {
          task.timeout = delay;
          return resolver.promise;
        } else {
          return originalTimeout.call(resolver.promise, delay);
        }
      };
      this._next();
      return resolver.promise;
    } else if (typeof method === "function") {
      return this.exec("run", [String(method), params]);
    } else {
      throw new TypeError('Function or string expected as argument "method"');
    }
  };
  Pool.prototype.proxy = function() {
    if (arguments.length > 0) {
      throw new Error("No arguments expected");
    }
    var pool2 = this;
    return this.exec("methods").then(function(methods) {
      var proxy = {};
      methods.forEach(function(method) {
        proxy[method] = function() {
          return pool2.exec(method, Array.prototype.slice.call(arguments));
        };
      });
      return proxy;
    });
  };
  Pool.prototype._next = function() {
    if (this.tasks.length > 0) {
      var worker2 = this._getWorker();
      if (worker2) {
        var me = this;
        var task = this.tasks.shift();
        if (task.resolver.promise.pending) {
          var promise = worker2.exec(task.method, task.params, task.resolver, task.options).then(me._boundNext).catch(function() {
            if (worker2.terminated) {
              return me._removeWorker(worker2);
            }
          }).then(function() {
            me._next();
          });
          if (typeof task.timeout === "number") {
            promise.timeout(task.timeout);
          }
        } else {
          me._next();
        }
      }
    }
  };
  Pool.prototype._getWorker = function() {
    var workers = this.workers;
    for (var i = 0; i < workers.length; i++) {
      var worker2 = workers[i];
      if (worker2.busy() === false) {
        return worker2;
      }
    }
    if (workers.length < this.maxWorkers) {
      worker2 = this._createWorkerHandler();
      workers.push(worker2);
      return worker2;
    }
    return null;
  };
  Pool.prototype._removeWorker = function(worker2) {
    DEBUG_PORT_ALLOCATOR.releasePort(worker2.debugPort);
    this._removeWorkerFromList(worker2);
    this._ensureMinWorkers();
    return new Promise2(function(resolve2, reject) {
      worker2.terminate(false, function(err) {
        if (err) {
          reject(err);
        } else {
          resolve2(worker2);
        }
      });
    });
  };
  Pool.prototype._removeWorkerFromList = function(worker2) {
    var index = this.workers.indexOf(worker2);
    if (index !== -1) {
      this.workers.splice(index, 1);
    }
  };
  Pool.prototype.terminate = function(force, timeout) {
    this.tasks.forEach(function(task) {
      task.resolver.reject(new Error("Pool terminated"));
    });
    this.tasks.length = 0;
    var f = function(worker2) {
      this._removeWorkerFromList(worker2);
    };
    var removeWorker = f.bind(this);
    var promises = [];
    var workers = this.workers.slice();
    workers.forEach(function(worker2) {
      var termPromise = worker2.terminateAndNotify(force, timeout).then(removeWorker);
      promises.push(termPromise);
    });
    return Promise2.all(promises);
  };
  Pool.prototype.stats = function() {
    var totalWorkers = this.workers.length;
    var busyWorkers = this.workers.filter(function(worker2) {
      return worker2.busy();
    }).length;
    return {
      totalWorkers,
      busyWorkers,
      idleWorkers: totalWorkers - busyWorkers,
      pendingTasks: this.tasks.length,
      activeTasks: busyWorkers
    };
  };
  Pool.prototype._ensureMinWorkers = function() {
    if (this.minWorkers) {
      for (var i = this.workers.length; i < this.minWorkers; i++) {
        this.workers.push(this._createWorkerHandler());
      }
    }
  };
  Pool.prototype._createWorkerHandler = function() {
    return new WorkerHandler(this.script, {
      forkArgs: this.forkArgs,
      forkOpts: this.forkOpts,
      debugPort: DEBUG_PORT_ALLOCATOR.nextAvailableStartingAt(this.debugPortStart),
      workerType: this.workerType
    });
  };
  function validateMaxWorkers(maxWorkers) {
    if (!isNumber2(maxWorkers) || !isInteger(maxWorkers) || maxWorkers < 1) {
      throw new TypeError("Option maxWorkers must be an integer number >= 1");
    }
  }
  function validateMinWorkers(minWorkers) {
    if (!isNumber2(minWorkers) || !isInteger(minWorkers) || minWorkers < 0) {
      throw new TypeError("Option minWorkers must be an integer number >= 0");
    }
  }
  function isNumber2(value) {
    return typeof value === "number";
  }
  function isInteger(value) {
    return Math.round(value) == value;
  }
  module2.exports = Pool;
});

// node_modules/workerpool/src/worker.js
var require_worker = __commonJS((exports, module) => {
  var requireFoolWebpack = eval(`typeof require !== 'undefined' ? require : function (module) { throw new Error('Module " + module + " not found.') }`);
  var TERMINATE_METHOD_ID = "__workerpool-terminate__";
  var worker = {
    exit: function() {
    }
  };
  if (typeof self !== "undefined" && typeof postMessage === "function" && typeof addEventListener === "function") {
    worker.on = function(event, callback) {
      addEventListener(event, function(message) {
        callback(message.data);
      });
    };
    worker.send = function(message) {
      postMessage(message);
    };
  } else if (typeof process !== "undefined") {
    try {
      WorkerThreads = requireFoolWebpack("worker_threads");
    } catch (error) {
      if (typeof error === "object" && error !== null && error.code === "MODULE_NOT_FOUND") {
      } else {
        throw error;
      }
    }
    if (WorkerThreads && WorkerThreads.parentPort !== null) {
      parentPort = WorkerThreads.parentPort;
      worker.send = parentPort.postMessage.bind(parentPort);
      worker.on = parentPort.on.bind(parentPort);
    } else {
      worker.on = process.on.bind(process);
      worker.send = process.send.bind(process);
      worker.on("disconnect", function() {
        process.exit(1);
      });
      worker.exit = process.exit.bind(process);
    }
  } else {
    throw new Error("Script must be executed as a worker");
  }
  var WorkerThreads;
  var parentPort;
  function convertError(error) {
    return Object.getOwnPropertyNames(error).reduce(function(product, name) {
      return Object.defineProperty(product, name, {
        value: error[name],
        enumerable: true
      });
    }, {});
  }
  function isPromise(value) {
    return value && typeof value.then === "function" && typeof value.catch === "function";
  }
  worker.methods = {};
  worker.methods.run = function run2(fn, args) {
    var f = new Function("return (" + fn + ").apply(null, arguments);");
    return f.apply(f, args);
  };
  worker.methods.methods = function methods() {
    return Object.keys(worker.methods);
  };
  var currentRequestId = null;
  worker.on("message", function(request) {
    if (request === TERMINATE_METHOD_ID) {
      return worker.exit(0);
    }
    try {
      var method = worker.methods[request.method];
      if (method) {
        currentRequestId = request.id;
        var result = method.apply(method, request.params);
        if (isPromise(result)) {
          result.then(function(result2) {
            worker.send({
              id: request.id,
              result: result2,
              error: null
            });
            currentRequestId = null;
          }).catch(function(err) {
            worker.send({
              id: request.id,
              result: null,
              error: convertError(err)
            });
            currentRequestId = null;
          });
        } else {
          worker.send({
            id: request.id,
            result,
            error: null
          });
          currentRequestId = null;
        }
      } else {
        throw new Error('Unknown method "' + request.method + '"');
      }
    } catch (err) {
      worker.send({
        id: request.id,
        result: null,
        error: convertError(err)
      });
    }
  });
  worker.register = function(methods) {
    if (methods) {
      for (var name in methods) {
        if (methods.hasOwnProperty(name)) {
          worker.methods[name] = methods[name];
        }
      }
    }
    worker.send("ready");
  };
  worker.emit = function(payload) {
    if (currentRequestId) {
      worker.send({
        id: currentRequestId,
        isEvent: true,
        payload
      });
    }
  };
  if (typeof exports !== "undefined") {
    exports.add = worker.register;
    exports.emit = worker.emit;
  }
});

// node_modules/workerpool/src/index.js
var require_src = __commonJS((exports2) => {
  var environment = require_environment();
  exports2.pool = function pool2(script, options) {
    var Pool = require_Pool();
    return new Pool(script, options);
  };
  exports2.worker = function worker2(methods) {
    var worker3 = require_worker();
    worker3.add(methods);
  };
  exports2.workerEmit = function workerEmit(payload) {
    var worker2 = require_worker();
    worker2.emit(payload);
  };
  exports2.Promise = require_Promise();
  exports2.platform = environment.platform;
  exports2.isMainThread = environment.isMainThread;
  exports2.cpus = environment.cpus;
});

// node_modules/braces/lib/utils.js
var require_utils = __commonJS((exports2) => {
  "use strict";
  exports2.isInteger = (num) => {
    if (typeof num === "number") {
      return Number.isInteger(num);
    }
    if (typeof num === "string" && num.trim() !== "") {
      return Number.isInteger(Number(num));
    }
    return false;
  };
  exports2.find = (node, type) => node.nodes.find((node2) => node2.type === type);
  exports2.exceedsLimit = (min, max, step = 1, limit) => {
    if (limit === false)
      return false;
    if (!exports2.isInteger(min) || !exports2.isInteger(max))
      return false;
    return (Number(max) - Number(min)) / Number(step) >= limit;
  };
  exports2.escapeNode = (block, n = 0, type) => {
    let node = block.nodes[n];
    if (!node)
      return;
    if (type && node.type === type || node.type === "open" || node.type === "close") {
      if (node.escaped !== true) {
        node.value = "\\" + node.value;
        node.escaped = true;
      }
    }
  };
  exports2.encloseBrace = (node) => {
    if (node.type !== "brace")
      return false;
    if (node.commas >> 0 + node.ranges >> 0 === 0) {
      node.invalid = true;
      return true;
    }
    return false;
  };
  exports2.isInvalidBrace = (block) => {
    if (block.type !== "brace")
      return false;
    if (block.invalid === true || block.dollar)
      return true;
    if (block.commas >> 0 + block.ranges >> 0 === 0) {
      block.invalid = true;
      return true;
    }
    if (block.open !== true || block.close !== true) {
      block.invalid = true;
      return true;
    }
    return false;
  };
  exports2.isOpenOrClose = (node) => {
    if (node.type === "open" || node.type === "close") {
      return true;
    }
    return node.open === true || node.close === true;
  };
  exports2.reduce = (nodes) => nodes.reduce((acc, node) => {
    if (node.type === "text")
      acc.push(node.value);
    if (node.type === "range")
      node.type = "text";
    return acc;
  }, []);
  exports2.flatten = (...args) => {
    const result = [];
    const flat = (arr) => {
      for (let i = 0; i < arr.length; i++) {
        let ele = arr[i];
        Array.isArray(ele) ? flat(ele, result) : ele !== void 0 && result.push(ele);
      }
      return result;
    };
    flat(args);
    return result;
  };
});

// node_modules/braces/lib/stringify.js
var require_stringify = __commonJS((exports2, module2) => {
  "use strict";
  var utils4 = require_utils();
  module2.exports = (ast, options = {}) => {
    let stringify = (node, parent = {}) => {
      let invalidBlock = options.escapeInvalid && utils4.isInvalidBrace(parent);
      let invalidNode = node.invalid === true && options.escapeInvalid === true;
      let output = "";
      if (node.value) {
        if ((invalidBlock || invalidNode) && utils4.isOpenOrClose(node)) {
          return "\\" + node.value;
        }
        return node.value;
      }
      if (node.value) {
        return node.value;
      }
      if (node.nodes) {
        for (let child of node.nodes) {
          output += stringify(child);
        }
      }
      return output;
    };
    return stringify(ast);
  };
});

// node_modules/is-number/index.js
var require_is_number = __commonJS((exports2, module2) => {
  /*!
   * is-number <https://github.com/jonschlinkert/is-number>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Released under the MIT License.
   */
  "use strict";
  module2.exports = function(num) {
    if (typeof num === "number") {
      return num - num === 0;
    }
    if (typeof num === "string" && num.trim() !== "") {
      return Number.isFinite ? Number.isFinite(+num) : isFinite(+num);
    }
    return false;
  };
});

// node_modules/to-regex-range/index.js
var require_to_regex_range = __commonJS((exports2, module2) => {
  /*!
   * to-regex-range <https://github.com/micromatch/to-regex-range>
   *
   * Copyright (c) 2015-present, Jon Schlinkert.
   * Released under the MIT License.
   */
  "use strict";
  var isNumber2 = require_is_number();
  var toRegexRange = (min, max, options) => {
    if (isNumber2(min) === false) {
      throw new TypeError("toRegexRange: expected the first argument to be a number");
    }
    if (max === void 0 || min === max) {
      return String(min);
    }
    if (isNumber2(max) === false) {
      throw new TypeError("toRegexRange: expected the second argument to be a number.");
    }
    let opts = {relaxZeros: true, ...options};
    if (typeof opts.strictZeros === "boolean") {
      opts.relaxZeros = opts.strictZeros === false;
    }
    let relax = String(opts.relaxZeros);
    let shorthand = String(opts.shorthand);
    let capture = String(opts.capture);
    let wrap = String(opts.wrap);
    let cacheKey = min + ":" + max + "=" + relax + shorthand + capture + wrap;
    if (toRegexRange.cache.hasOwnProperty(cacheKey)) {
      return toRegexRange.cache[cacheKey].result;
    }
    let a = Math.min(min, max);
    let b = Math.max(min, max);
    if (Math.abs(a - b) === 1) {
      let result = min + "|" + max;
      if (opts.capture) {
        return `(${result})`;
      }
      if (opts.wrap === false) {
        return result;
      }
      return `(?:${result})`;
    }
    let isPadded = hasPadding(min) || hasPadding(max);
    let state = {min, max, a, b};
    let positives = [];
    let negatives = [];
    if (isPadded) {
      state.isPadded = isPadded;
      state.maxLen = String(state.max).length;
    }
    if (a < 0) {
      let newMin = b < 0 ? Math.abs(b) : 1;
      negatives = splitToPatterns(newMin, Math.abs(a), state, opts);
      a = state.a = 0;
    }
    if (b >= 0) {
      positives = splitToPatterns(a, b, state, opts);
    }
    state.negatives = negatives;
    state.positives = positives;
    state.result = collatePatterns(negatives, positives, opts);
    if (opts.capture === true) {
      state.result = `(${state.result})`;
    } else if (opts.wrap !== false && positives.length + negatives.length > 1) {
      state.result = `(?:${state.result})`;
    }
    toRegexRange.cache[cacheKey] = state;
    return state.result;
  };
  function collatePatterns(neg, pos, options) {
    let onlyNegative = filterPatterns(neg, pos, "-", false, options) || [];
    let onlyPositive = filterPatterns(pos, neg, "", false, options) || [];
    let intersected = filterPatterns(neg, pos, "-?", true, options) || [];
    let subpatterns = onlyNegative.concat(intersected).concat(onlyPositive);
    return subpatterns.join("|");
  }
  function splitToRanges(min, max) {
    let nines = 1;
    let zeros = 1;
    let stop = countNines(min, nines);
    let stops = new Set([max]);
    while (min <= stop && stop <= max) {
      stops.add(stop);
      nines += 1;
      stop = countNines(min, nines);
    }
    stop = countZeros(max + 1, zeros) - 1;
    while (min < stop && stop <= max) {
      stops.add(stop);
      zeros += 1;
      stop = countZeros(max + 1, zeros) - 1;
    }
    stops = [...stops];
    stops.sort(compare);
    return stops;
  }
  function rangeToPattern(start, stop, options) {
    if (start === stop) {
      return {pattern: start, count: [], digits: 0};
    }
    let zipped = zip(start, stop);
    let digits = zipped.length;
    let pattern = "";
    let count = 0;
    for (let i = 0; i < digits; i++) {
      let [startDigit, stopDigit] = zipped[i];
      if (startDigit === stopDigit) {
        pattern += startDigit;
      } else if (startDigit !== "0" || stopDigit !== "9") {
        pattern += toCharacterClass(startDigit, stopDigit, options);
      } else {
        count++;
      }
    }
    if (count) {
      pattern += options.shorthand === true ? "\\d" : "[0-9]";
    }
    return {pattern, count: [count], digits};
  }
  function splitToPatterns(min, max, tok, options) {
    let ranges = splitToRanges(min, max);
    let tokens = [];
    let start = min;
    let prev;
    for (let i = 0; i < ranges.length; i++) {
      let max2 = ranges[i];
      let obj = rangeToPattern(String(start), String(max2), options);
      let zeros = "";
      if (!tok.isPadded && prev && prev.pattern === obj.pattern) {
        if (prev.count.length > 1) {
          prev.count.pop();
        }
        prev.count.push(obj.count[0]);
        prev.string = prev.pattern + toQuantifier(prev.count);
        start = max2 + 1;
        continue;
      }
      if (tok.isPadded) {
        zeros = padZeros(max2, tok, options);
      }
      obj.string = zeros + obj.pattern + toQuantifier(obj.count);
      tokens.push(obj);
      start = max2 + 1;
      prev = obj;
    }
    return tokens;
  }
  function filterPatterns(arr, comparison, prefix, intersection, options) {
    let result = [];
    for (let ele of arr) {
      let {string: string2} = ele;
      if (!intersection && !contains(comparison, "string", string2)) {
        result.push(prefix + string2);
      }
      if (intersection && contains(comparison, "string", string2)) {
        result.push(prefix + string2);
      }
    }
    return result;
  }
  function zip(a, b) {
    let arr = [];
    for (let i = 0; i < a.length; i++)
      arr.push([a[i], b[i]]);
    return arr;
  }
  function compare(a, b) {
    return a > b ? 1 : b > a ? -1 : 0;
  }
  function contains(arr, key, val) {
    return arr.some((ele) => ele[key] === val);
  }
  function countNines(min, len) {
    return Number(String(min).slice(0, -len) + "9".repeat(len));
  }
  function countZeros(integer, zeros) {
    return integer - integer % Math.pow(10, zeros);
  }
  function toQuantifier(digits) {
    let [start = 0, stop = ""] = digits;
    if (stop || start > 1) {
      return `{${start + (stop ? "," + stop : "")}}`;
    }
    return "";
  }
  function toCharacterClass(a, b, options) {
    return `[${a}${b - a === 1 ? "" : "-"}${b}]`;
  }
  function hasPadding(str) {
    return /^-?(0+)\d/.test(str);
  }
  function padZeros(value, tok, options) {
    if (!tok.isPadded) {
      return value;
    }
    let diff = Math.abs(tok.maxLen - String(value).length);
    let relax = options.relaxZeros !== false;
    switch (diff) {
      case 0:
        return "";
      case 1:
        return relax ? "0?" : "0";
      case 2:
        return relax ? "0{0,2}" : "00";
      default: {
        return relax ? `0{0,${diff}}` : `0{${diff}}`;
      }
    }
  }
  toRegexRange.cache = {};
  toRegexRange.clearCache = () => toRegexRange.cache = {};
  module2.exports = toRegexRange;
});

// node_modules/fill-range/index.js
var require_fill_range = __commonJS((exports2, module2) => {
  /*!
   * fill-range <https://github.com/jonschlinkert/fill-range>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Licensed under the MIT License.
   */
  "use strict";
  var util = require("util");
  var toRegexRange = require_to_regex_range();
  var isObject = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
  var transform = (toNumber) => {
    return (value) => toNumber === true ? Number(value) : String(value);
  };
  var isValidValue = (value) => {
    return typeof value === "number" || typeof value === "string" && value !== "";
  };
  var isNumber2 = (num) => Number.isInteger(+num);
  var zeros = (input) => {
    let value = `${input}`;
    let index = -1;
    if (value[0] === "-")
      value = value.slice(1);
    if (value === "0")
      return false;
    while (value[++index] === "0")
      ;
    return index > 0;
  };
  var stringify = (start, end, options) => {
    if (typeof start === "string" || typeof end === "string") {
      return true;
    }
    return options.stringify === true;
  };
  var pad = (input, maxLength, toNumber) => {
    if (maxLength > 0) {
      let dash = input[0] === "-" ? "-" : "";
      if (dash)
        input = input.slice(1);
      input = dash + input.padStart(dash ? maxLength - 1 : maxLength, "0");
    }
    if (toNumber === false) {
      return String(input);
    }
    return input;
  };
  var toMaxLen = (input, maxLength) => {
    let negative = input[0] === "-" ? "-" : "";
    if (negative) {
      input = input.slice(1);
      maxLength--;
    }
    while (input.length < maxLength)
      input = "0" + input;
    return negative ? "-" + input : input;
  };
  var toSequence = (parts, options) => {
    parts.negatives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
    parts.positives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
    let prefix = options.capture ? "" : "?:";
    let positives = "";
    let negatives = "";
    let result;
    if (parts.positives.length) {
      positives = parts.positives.join("|");
    }
    if (parts.negatives.length) {
      negatives = `-(${prefix}${parts.negatives.join("|")})`;
    }
    if (positives && negatives) {
      result = `${positives}|${negatives}`;
    } else {
      result = positives || negatives;
    }
    if (options.wrap) {
      return `(${prefix}${result})`;
    }
    return result;
  };
  var toRange = (a, b, isNumbers, options) => {
    if (isNumbers) {
      return toRegexRange(a, b, {wrap: false, ...options});
    }
    let start = String.fromCharCode(a);
    if (a === b)
      return start;
    let stop = String.fromCharCode(b);
    return `[${start}-${stop}]`;
  };
  var toRegex = (start, end, options) => {
    if (Array.isArray(start)) {
      let wrap = options.wrap === true;
      let prefix = options.capture ? "" : "?:";
      return wrap ? `(${prefix}${start.join("|")})` : start.join("|");
    }
    return toRegexRange(start, end, options);
  };
  var rangeError = (...args) => {
    return new RangeError("Invalid range arguments: " + util.inspect(...args));
  };
  var invalidRange = (start, end, options) => {
    if (options.strictRanges === true)
      throw rangeError([start, end]);
    return [];
  };
  var invalidStep = (step, options) => {
    if (options.strictRanges === true) {
      throw new TypeError(`Expected step "${step}" to be a number`);
    }
    return [];
  };
  var fillNumbers = (start, end, step = 1, options = {}) => {
    let a = Number(start);
    let b = Number(end);
    if (!Number.isInteger(a) || !Number.isInteger(b)) {
      if (options.strictRanges === true)
        throw rangeError([start, end]);
      return [];
    }
    if (a === 0)
      a = 0;
    if (b === 0)
      b = 0;
    let descending = a > b;
    let startString = String(start);
    let endString = String(end);
    let stepString = String(step);
    step = Math.max(Math.abs(step), 1);
    let padded = zeros(startString) || zeros(endString) || zeros(stepString);
    let maxLen = padded ? Math.max(startString.length, endString.length, stepString.length) : 0;
    let toNumber = padded === false && stringify(start, end, options) === false;
    let format2 = options.transform || transform(toNumber);
    if (options.toRegex && step === 1) {
      return toRange(toMaxLen(start, maxLen), toMaxLen(end, maxLen), true, options);
    }
    let parts = {negatives: [], positives: []};
    let push = (num) => parts[num < 0 ? "negatives" : "positives"].push(Math.abs(num));
    let range = [];
    let index = 0;
    while (descending ? a >= b : a <= b) {
      if (options.toRegex === true && step > 1) {
        push(a);
      } else {
        range.push(pad(format2(a, index), maxLen, toNumber));
      }
      a = descending ? a - step : a + step;
      index++;
    }
    if (options.toRegex === true) {
      return step > 1 ? toSequence(parts, options) : toRegex(range, null, {wrap: false, ...options});
    }
    return range;
  };
  var fillLetters = (start, end, step = 1, options = {}) => {
    if (!isNumber2(start) && start.length > 1 || !isNumber2(end) && end.length > 1) {
      return invalidRange(start, end, options);
    }
    let format2 = options.transform || ((val) => String.fromCharCode(val));
    let a = `${start}`.charCodeAt(0);
    let b = `${end}`.charCodeAt(0);
    let descending = a > b;
    let min = Math.min(a, b);
    let max = Math.max(a, b);
    if (options.toRegex && step === 1) {
      return toRange(min, max, false, options);
    }
    let range = [];
    let index = 0;
    while (descending ? a >= b : a <= b) {
      range.push(format2(a, index));
      a = descending ? a - step : a + step;
      index++;
    }
    if (options.toRegex === true) {
      return toRegex(range, null, {wrap: false, options});
    }
    return range;
  };
  var fill = (start, end, step, options = {}) => {
    if (end == null && isValidValue(start)) {
      return [start];
    }
    if (!isValidValue(start) || !isValidValue(end)) {
      return invalidRange(start, end, options);
    }
    if (typeof step === "function") {
      return fill(start, end, 1, {transform: step});
    }
    if (isObject(step)) {
      return fill(start, end, 0, step);
    }
    let opts = {...options};
    if (opts.capture === true)
      opts.wrap = true;
    step = step || opts.step || 1;
    if (!isNumber2(step)) {
      if (step != null && !isObject(step))
        return invalidStep(step, opts);
      return fill(start, end, 1, step);
    }
    if (isNumber2(start) && isNumber2(end)) {
      return fillNumbers(start, end, step, opts);
    }
    return fillLetters(start, end, Math.max(Math.abs(step), 1), opts);
  };
  module2.exports = fill;
});

// node_modules/braces/lib/compile.js
var require_compile = __commonJS((exports2, module2) => {
  "use strict";
  var fill = require_fill_range();
  var utils4 = require_utils();
  var compile2 = (ast, options = {}) => {
    let walk = (node, parent = {}) => {
      let invalidBlock = utils4.isInvalidBrace(parent);
      let invalidNode = node.invalid === true && options.escapeInvalid === true;
      let invalid = invalidBlock === true || invalidNode === true;
      let prefix = options.escapeInvalid === true ? "\\" : "";
      let output = "";
      if (node.isOpen === true) {
        return prefix + node.value;
      }
      if (node.isClose === true) {
        return prefix + node.value;
      }
      if (node.type === "open") {
        return invalid ? prefix + node.value : "(";
      }
      if (node.type === "close") {
        return invalid ? prefix + node.value : ")";
      }
      if (node.type === "comma") {
        return node.prev.type === "comma" ? "" : invalid ? node.value : "|";
      }
      if (node.value) {
        return node.value;
      }
      if (node.nodes && node.ranges > 0) {
        let args = utils4.reduce(node.nodes);
        let range = fill(...args, {...options, wrap: false, toRegex: true});
        if (range.length !== 0) {
          return args.length > 1 && range.length > 1 ? `(${range})` : range;
        }
      }
      if (node.nodes) {
        for (let child of node.nodes) {
          output += walk(child, node);
        }
      }
      return output;
    };
    return walk(ast);
  };
  module2.exports = compile2;
});

// node_modules/braces/lib/expand.js
var require_expand = __commonJS((exports2, module2) => {
  "use strict";
  var fill = require_fill_range();
  var stringify = require_stringify();
  var utils4 = require_utils();
  var append = (queue = "", stash = "", enclose = false) => {
    let result = [];
    queue = [].concat(queue);
    stash = [].concat(stash);
    if (!stash.length)
      return queue;
    if (!queue.length) {
      return enclose ? utils4.flatten(stash).map((ele) => `{${ele}}`) : stash;
    }
    for (let item of queue) {
      if (Array.isArray(item)) {
        for (let value of item) {
          result.push(append(value, stash, enclose));
        }
      } else {
        for (let ele of stash) {
          if (enclose === true && typeof ele === "string")
            ele = `{${ele}}`;
          result.push(Array.isArray(ele) ? append(item, ele, enclose) : item + ele);
        }
      }
    }
    return utils4.flatten(result);
  };
  var expand = (ast, options = {}) => {
    let rangeLimit = options.rangeLimit === void 0 ? 1e3 : options.rangeLimit;
    let walk = (node, parent = {}) => {
      node.queue = [];
      let p = parent;
      let q = parent.queue;
      while (p.type !== "brace" && p.type !== "root" && p.parent) {
        p = p.parent;
        q = p.queue;
      }
      if (node.invalid || node.dollar) {
        q.push(append(q.pop(), stringify(node, options)));
        return;
      }
      if (node.type === "brace" && node.invalid !== true && node.nodes.length === 2) {
        q.push(append(q.pop(), ["{}"]));
        return;
      }
      if (node.nodes && node.ranges > 0) {
        let args = utils4.reduce(node.nodes);
        if (utils4.exceedsLimit(...args, options.step, rangeLimit)) {
          throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");
        }
        let range = fill(...args, options);
        if (range.length === 0) {
          range = stringify(node, options);
        }
        q.push(append(q.pop(), range));
        node.nodes = [];
        return;
      }
      let enclose = utils4.encloseBrace(node);
      let queue = node.queue;
      let block = node;
      while (block.type !== "brace" && block.type !== "root" && block.parent) {
        block = block.parent;
        queue = block.queue;
      }
      for (let i = 0; i < node.nodes.length; i++) {
        let child = node.nodes[i];
        if (child.type === "comma" && node.type === "brace") {
          if (i === 1)
            queue.push("");
          queue.push("");
          continue;
        }
        if (child.type === "close") {
          q.push(append(q.pop(), queue, enclose));
          continue;
        }
        if (child.value && child.type !== "open") {
          queue.push(append(queue.pop(), child.value));
          continue;
        }
        if (child.nodes) {
          walk(child, node);
        }
      }
      return queue;
    };
    return utils4.flatten(walk(ast));
  };
  module2.exports = expand;
});

// node_modules/braces/lib/constants.js
var require_constants = __commonJS((exports2, module2) => {
  "use strict";
  module2.exports = {
    MAX_LENGTH: 1024 * 64,
    CHAR_0: "0",
    CHAR_9: "9",
    CHAR_UPPERCASE_A: "A",
    CHAR_LOWERCASE_A: "a",
    CHAR_UPPERCASE_Z: "Z",
    CHAR_LOWERCASE_Z: "z",
    CHAR_LEFT_PARENTHESES: "(",
    CHAR_RIGHT_PARENTHESES: ")",
    CHAR_ASTERISK: "*",
    CHAR_AMPERSAND: "&",
    CHAR_AT: "@",
    CHAR_BACKSLASH: "\\",
    CHAR_BACKTICK: "`",
    CHAR_CARRIAGE_RETURN: "\r",
    CHAR_CIRCUMFLEX_ACCENT: "^",
    CHAR_COLON: ":",
    CHAR_COMMA: ",",
    CHAR_DOLLAR: "$",
    CHAR_DOT: ".",
    CHAR_DOUBLE_QUOTE: '"',
    CHAR_EQUAL: "=",
    CHAR_EXCLAMATION_MARK: "!",
    CHAR_FORM_FEED: "\f",
    CHAR_FORWARD_SLASH: "/",
    CHAR_HASH: "#",
    CHAR_HYPHEN_MINUS: "-",
    CHAR_LEFT_ANGLE_BRACKET: "<",
    CHAR_LEFT_CURLY_BRACE: "{",
    CHAR_LEFT_SQUARE_BRACKET: "[",
    CHAR_LINE_FEED: "\n",
    CHAR_NO_BREAK_SPACE: " ",
    CHAR_PERCENT: "%",
    CHAR_PLUS: "+",
    CHAR_QUESTION_MARK: "?",
    CHAR_RIGHT_ANGLE_BRACKET: ">",
    CHAR_RIGHT_CURLY_BRACE: "}",
    CHAR_RIGHT_SQUARE_BRACKET: "]",
    CHAR_SEMICOLON: ";",
    CHAR_SINGLE_QUOTE: "'",
    CHAR_SPACE: " ",
    CHAR_TAB: "	",
    CHAR_UNDERSCORE: "_",
    CHAR_VERTICAL_LINE: "|",
    CHAR_ZERO_WIDTH_NOBREAK_SPACE: "\uFEFF"
  };
});

// node_modules/braces/lib/parse.js
var require_parse = __commonJS((exports2, module2) => {
  "use strict";
  var stringify = require_stringify();
  var {
    MAX_LENGTH,
    CHAR_BACKSLASH,
    CHAR_BACKTICK,
    CHAR_COMMA,
    CHAR_DOT,
    CHAR_LEFT_PARENTHESES,
    CHAR_RIGHT_PARENTHESES,
    CHAR_LEFT_CURLY_BRACE,
    CHAR_RIGHT_CURLY_BRACE,
    CHAR_LEFT_SQUARE_BRACKET,
    CHAR_RIGHT_SQUARE_BRACKET,
    CHAR_DOUBLE_QUOTE,
    CHAR_SINGLE_QUOTE,
    CHAR_NO_BREAK_SPACE,
    CHAR_ZERO_WIDTH_NOBREAK_SPACE
  } = require_constants();
  var parse3 = (input, options = {}) => {
    if (typeof input !== "string") {
      throw new TypeError("Expected a string");
    }
    let opts = options || {};
    let max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
    if (input.length > max) {
      throw new SyntaxError(`Input length (${input.length}), exceeds max characters (${max})`);
    }
    let ast = {type: "root", input, nodes: []};
    let stack = [ast];
    let block = ast;
    let prev = ast;
    let brackets = 0;
    let length = input.length;
    let index = 0;
    let depth = 0;
    let value;
    let memo = {};
    const advance = () => input[index++];
    const push = (node) => {
      if (node.type === "text" && prev.type === "dot") {
        prev.type = "text";
      }
      if (prev && prev.type === "text" && node.type === "text") {
        prev.value += node.value;
        return;
      }
      block.nodes.push(node);
      node.parent = block;
      node.prev = prev;
      prev = node;
      return node;
    };
    push({type: "bos"});
    while (index < length) {
      block = stack[stack.length - 1];
      value = advance();
      if (value === CHAR_ZERO_WIDTH_NOBREAK_SPACE || value === CHAR_NO_BREAK_SPACE) {
        continue;
      }
      if (value === CHAR_BACKSLASH) {
        push({type: "text", value: (options.keepEscaping ? value : "") + advance()});
        continue;
      }
      if (value === CHAR_RIGHT_SQUARE_BRACKET) {
        push({type: "text", value: "\\" + value});
        continue;
      }
      if (value === CHAR_LEFT_SQUARE_BRACKET) {
        brackets++;
        let closed = true;
        let next;
        while (index < length && (next = advance())) {
          value += next;
          if (next === CHAR_LEFT_SQUARE_BRACKET) {
            brackets++;
            continue;
          }
          if (next === CHAR_BACKSLASH) {
            value += advance();
            continue;
          }
          if (next === CHAR_RIGHT_SQUARE_BRACKET) {
            brackets--;
            if (brackets === 0) {
              break;
            }
          }
        }
        push({type: "text", value});
        continue;
      }
      if (value === CHAR_LEFT_PARENTHESES) {
        block = push({type: "paren", nodes: []});
        stack.push(block);
        push({type: "text", value});
        continue;
      }
      if (value === CHAR_RIGHT_PARENTHESES) {
        if (block.type !== "paren") {
          push({type: "text", value});
          continue;
        }
        block = stack.pop();
        push({type: "text", value});
        block = stack[stack.length - 1];
        continue;
      }
      if (value === CHAR_DOUBLE_QUOTE || value === CHAR_SINGLE_QUOTE || value === CHAR_BACKTICK) {
        let open = value;
        let next;
        if (options.keepQuotes !== true) {
          value = "";
        }
        while (index < length && (next = advance())) {
          if (next === CHAR_BACKSLASH) {
            value += next + advance();
            continue;
          }
          if (next === open) {
            if (options.keepQuotes === true)
              value += next;
            break;
          }
          value += next;
        }
        push({type: "text", value});
        continue;
      }
      if (value === CHAR_LEFT_CURLY_BRACE) {
        depth++;
        let dollar = prev.value && prev.value.slice(-1) === "$" || block.dollar === true;
        let brace = {
          type: "brace",
          open: true,
          close: false,
          dollar,
          depth,
          commas: 0,
          ranges: 0,
          nodes: []
        };
        block = push(brace);
        stack.push(block);
        push({type: "open", value});
        continue;
      }
      if (value === CHAR_RIGHT_CURLY_BRACE) {
        if (block.type !== "brace") {
          push({type: "text", value});
          continue;
        }
        let type = "close";
        block = stack.pop();
        block.close = true;
        push({type, value});
        depth--;
        block = stack[stack.length - 1];
        continue;
      }
      if (value === CHAR_COMMA && depth > 0) {
        if (block.ranges > 0) {
          block.ranges = 0;
          let open = block.nodes.shift();
          block.nodes = [open, {type: "text", value: stringify(block)}];
        }
        push({type: "comma", value});
        block.commas++;
        continue;
      }
      if (value === CHAR_DOT && depth > 0 && block.commas === 0) {
        let siblings = block.nodes;
        if (depth === 0 || siblings.length === 0) {
          push({type: "text", value});
          continue;
        }
        if (prev.type === "dot") {
          block.range = [];
          prev.value += value;
          prev.type = "range";
          if (block.nodes.length !== 3 && block.nodes.length !== 5) {
            block.invalid = true;
            block.ranges = 0;
            prev.type = "text";
            continue;
          }
          block.ranges++;
          block.args = [];
          continue;
        }
        if (prev.type === "range") {
          siblings.pop();
          let before = siblings[siblings.length - 1];
          before.value += prev.value + value;
          prev = before;
          block.ranges--;
          continue;
        }
        push({type: "dot", value});
        continue;
      }
      push({type: "text", value});
    }
    do {
      block = stack.pop();
      if (block.type !== "root") {
        block.nodes.forEach((node) => {
          if (!node.nodes) {
            if (node.type === "open")
              node.isOpen = true;
            if (node.type === "close")
              node.isClose = true;
            if (!node.nodes)
              node.type = "text";
            node.invalid = true;
          }
        });
        let parent = stack[stack.length - 1];
        let index2 = parent.nodes.indexOf(block);
        parent.nodes.splice(index2, 1, ...block.nodes);
      }
    } while (stack.length > 0);
    push({type: "eos"});
    return ast;
  };
  module2.exports = parse3;
});

// node_modules/braces/index.js
var require_braces = __commonJS((exports2, module2) => {
  "use strict";
  var stringify = require_stringify();
  var compile2 = require_compile();
  var expand = require_expand();
  var parse3 = require_parse();
  var braces = (input, options = {}) => {
    let output = [];
    if (Array.isArray(input)) {
      for (let pattern of input) {
        let result = braces.create(pattern, options);
        if (Array.isArray(result)) {
          output.push(...result);
        } else {
          output.push(result);
        }
      }
    } else {
      output = [].concat(braces.create(input, options));
    }
    if (options && options.expand === true && options.nodupes === true) {
      output = [...new Set(output)];
    }
    return output;
  };
  braces.parse = (input, options = {}) => parse3(input, options);
  braces.stringify = (input, options = {}) => {
    if (typeof input === "string") {
      return stringify(braces.parse(input, options), options);
    }
    return stringify(input, options);
  };
  braces.compile = (input, options = {}) => {
    if (typeof input === "string") {
      input = braces.parse(input, options);
    }
    return compile2(input, options);
  };
  braces.expand = (input, options = {}) => {
    if (typeof input === "string") {
      input = braces.parse(input, options);
    }
    let result = expand(input, options);
    if (options.noempty === true) {
      result = result.filter(Boolean);
    }
    if (options.nodupes === true) {
      result = [...new Set(result)];
    }
    return result;
  };
  braces.create = (input, options = {}) => {
    if (input === "" || input.length < 3) {
      return [input];
    }
    return options.expand !== true ? braces.compile(input, options) : braces.expand(input, options);
  };
  module2.exports = braces;
});

// node_modules/picomatch/lib/constants.js
var require_constants2 = __commonJS((exports2, module2) => {
  "use strict";
  var path = require("path");
  var WIN_SLASH = "\\\\/";
  var WIN_NO_SLASH = `[^${WIN_SLASH}]`;
  var DOT_LITERAL = "\\.";
  var PLUS_LITERAL = "\\+";
  var QMARK_LITERAL = "\\?";
  var SLASH_LITERAL = "\\/";
  var ONE_CHAR = "(?=.)";
  var QMARK = "[^/]";
  var END_ANCHOR = `(?:${SLASH_LITERAL}|$)`;
  var START_ANCHOR = `(?:^|${SLASH_LITERAL})`;
  var DOTS_SLASH = `${DOT_LITERAL}{1,2}${END_ANCHOR}`;
  var NO_DOT = `(?!${DOT_LITERAL})`;
  var NO_DOTS = `(?!${START_ANCHOR}${DOTS_SLASH})`;
  var NO_DOT_SLASH = `(?!${DOT_LITERAL}{0,1}${END_ANCHOR})`;
  var NO_DOTS_SLASH = `(?!${DOTS_SLASH})`;
  var QMARK_NO_DOT = `[^.${SLASH_LITERAL}]`;
  var STAR = `${QMARK}*?`;
  var POSIX_CHARS = {
    DOT_LITERAL,
    PLUS_LITERAL,
    QMARK_LITERAL,
    SLASH_LITERAL,
    ONE_CHAR,
    QMARK,
    END_ANCHOR,
    DOTS_SLASH,
    NO_DOT,
    NO_DOTS,
    NO_DOT_SLASH,
    NO_DOTS_SLASH,
    QMARK_NO_DOT,
    STAR,
    START_ANCHOR
  };
  var WINDOWS_CHARS = {
    ...POSIX_CHARS,
    SLASH_LITERAL: `[${WIN_SLASH}]`,
    QMARK: WIN_NO_SLASH,
    STAR: `${WIN_NO_SLASH}*?`,
    DOTS_SLASH: `${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$)`,
    NO_DOT: `(?!${DOT_LITERAL})`,
    NO_DOTS: `(?!(?:^|[${WIN_SLASH}])${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
    NO_DOT_SLASH: `(?!${DOT_LITERAL}{0,1}(?:[${WIN_SLASH}]|$))`,
    NO_DOTS_SLASH: `(?!${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
    QMARK_NO_DOT: `[^.${WIN_SLASH}]`,
    START_ANCHOR: `(?:^|[${WIN_SLASH}])`,
    END_ANCHOR: `(?:[${WIN_SLASH}]|$)`
  };
  var POSIX_REGEX_SOURCE = {
    alnum: "a-zA-Z0-9",
    alpha: "a-zA-Z",
    ascii: "\\x00-\\x7F",
    blank: " \\t",
    cntrl: "\\x00-\\x1F\\x7F",
    digit: "0-9",
    graph: "\\x21-\\x7E",
    lower: "a-z",
    print: "\\x20-\\x7E ",
    punct: "\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",
    space: " \\t\\r\\n\\v\\f",
    upper: "A-Z",
    word: "A-Za-z0-9_",
    xdigit: "A-Fa-f0-9"
  };
  module2.exports = {
    MAX_LENGTH: 1024 * 64,
    POSIX_REGEX_SOURCE,
    REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
    REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
    REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
    REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
    REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
    REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,
    REPLACEMENTS: {
      "***": "*",
      "**/**": "**",
      "**/**/**": "**"
    },
    CHAR_0: 48,
    CHAR_9: 57,
    CHAR_UPPERCASE_A: 65,
    CHAR_LOWERCASE_A: 97,
    CHAR_UPPERCASE_Z: 90,
    CHAR_LOWERCASE_Z: 122,
    CHAR_LEFT_PARENTHESES: 40,
    CHAR_RIGHT_PARENTHESES: 41,
    CHAR_ASTERISK: 42,
    CHAR_AMPERSAND: 38,
    CHAR_AT: 64,
    CHAR_BACKWARD_SLASH: 92,
    CHAR_CARRIAGE_RETURN: 13,
    CHAR_CIRCUMFLEX_ACCENT: 94,
    CHAR_COLON: 58,
    CHAR_COMMA: 44,
    CHAR_DOT: 46,
    CHAR_DOUBLE_QUOTE: 34,
    CHAR_EQUAL: 61,
    CHAR_EXCLAMATION_MARK: 33,
    CHAR_FORM_FEED: 12,
    CHAR_FORWARD_SLASH: 47,
    CHAR_GRAVE_ACCENT: 96,
    CHAR_HASH: 35,
    CHAR_HYPHEN_MINUS: 45,
    CHAR_LEFT_ANGLE_BRACKET: 60,
    CHAR_LEFT_CURLY_BRACE: 123,
    CHAR_LEFT_SQUARE_BRACKET: 91,
    CHAR_LINE_FEED: 10,
    CHAR_NO_BREAK_SPACE: 160,
    CHAR_PERCENT: 37,
    CHAR_PLUS: 43,
    CHAR_QUESTION_MARK: 63,
    CHAR_RIGHT_ANGLE_BRACKET: 62,
    CHAR_RIGHT_CURLY_BRACE: 125,
    CHAR_RIGHT_SQUARE_BRACKET: 93,
    CHAR_SEMICOLON: 59,
    CHAR_SINGLE_QUOTE: 39,
    CHAR_SPACE: 32,
    CHAR_TAB: 9,
    CHAR_UNDERSCORE: 95,
    CHAR_VERTICAL_LINE: 124,
    CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279,
    SEP: path.sep,
    extglobChars(chars) {
      return {
        "!": {type: "negate", open: "(?:(?!(?:", close: `))${chars.STAR})`},
        "?": {type: "qmark", open: "(?:", close: ")?"},
        "+": {type: "plus", open: "(?:", close: ")+"},
        "*": {type: "star", open: "(?:", close: ")*"},
        "@": {type: "at", open: "(?:", close: ")"}
      };
    },
    globChars(win32) {
      return win32 === true ? WINDOWS_CHARS : POSIX_CHARS;
    }
  };
});

// node_modules/picomatch/lib/utils.js
var require_utils2 = __commonJS((exports2) => {
  "use strict";
  var path = require("path");
  var win32 = process.platform === "win32";
  var {
    REGEX_BACKSLASH,
    REGEX_REMOVE_BACKSLASH,
    REGEX_SPECIAL_CHARS,
    REGEX_SPECIAL_CHARS_GLOBAL
  } = require_constants2();
  exports2.isObject = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
  exports2.hasRegexChars = (str) => REGEX_SPECIAL_CHARS.test(str);
  exports2.isRegexChar = (str) => str.length === 1 && exports2.hasRegexChars(str);
  exports2.escapeRegex = (str) => str.replace(REGEX_SPECIAL_CHARS_GLOBAL, "\\$1");
  exports2.toPosixSlashes = (str) => str.replace(REGEX_BACKSLASH, "/");
  exports2.removeBackslashes = (str) => {
    return str.replace(REGEX_REMOVE_BACKSLASH, (match) => {
      return match === "\\" ? "" : match;
    });
  };
  exports2.supportsLookbehinds = () => {
    const segs = process.version.slice(1).split(".").map(Number);
    if (segs.length === 3 && segs[0] >= 9 || segs[0] === 8 && segs[1] >= 10) {
      return true;
    }
    return false;
  };
  exports2.isWindows = (options) => {
    if (options && typeof options.windows === "boolean") {
      return options.windows;
    }
    return win32 === true || path.sep === "\\";
  };
  exports2.escapeLast = (input, char, lastIdx) => {
    const idx = input.lastIndexOf(char, lastIdx);
    if (idx === -1)
      return input;
    if (input[idx - 1] === "\\")
      return exports2.escapeLast(input, char, idx - 1);
    return `${input.slice(0, idx)}\\${input.slice(idx)}`;
  };
  exports2.removePrefix = (input, state = {}) => {
    let output = input;
    if (output.startsWith("./")) {
      output = output.slice(2);
      state.prefix = "./";
    }
    return output;
  };
  exports2.wrapOutput = (input, state = {}, options = {}) => {
    const prepend = options.contains ? "" : "^";
    const append = options.contains ? "" : "$";
    let output = `${prepend}(?:${input})${append}`;
    if (state.negated === true) {
      output = `(?:^(?!${output}).*$)`;
    }
    return output;
  };
});

// node_modules/picomatch/lib/scan.js
var require_scan = __commonJS((exports2, module2) => {
  "use strict";
  var utils4 = require_utils2();
  var {
    CHAR_ASTERISK,
    CHAR_AT,
    CHAR_BACKWARD_SLASH,
    CHAR_COMMA,
    CHAR_DOT,
    CHAR_EXCLAMATION_MARK,
    CHAR_FORWARD_SLASH,
    CHAR_LEFT_CURLY_BRACE,
    CHAR_LEFT_PARENTHESES,
    CHAR_LEFT_SQUARE_BRACKET,
    CHAR_PLUS,
    CHAR_QUESTION_MARK,
    CHAR_RIGHT_CURLY_BRACE,
    CHAR_RIGHT_PARENTHESES,
    CHAR_RIGHT_SQUARE_BRACKET
  } = require_constants2();
  var isPathSeparator = (code) => {
    return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
  };
  var depth = (token) => {
    if (token.isPrefix !== true) {
      token.depth = token.isGlobstar ? Infinity : 1;
    }
  };
  var scan = (input, options) => {
    const opts = options || {};
    const length = input.length - 1;
    const scanToEnd = opts.parts === true || opts.scanToEnd === true;
    const slashes = [];
    const tokens = [];
    const parts = [];
    let str = input;
    let index = -1;
    let start = 0;
    let lastIndex = 0;
    let isBrace = false;
    let isBracket = false;
    let isGlob = false;
    let isExtglob = false;
    let isGlobstar = false;
    let braceEscaped = false;
    let backslashes = false;
    let negated = false;
    let negatedExtglob = false;
    let finished = false;
    let braces = 0;
    let prev;
    let code;
    let token = {value: "", depth: 0, isGlob: false};
    const eos = () => index >= length;
    const peek = () => str.charCodeAt(index + 1);
    const advance = () => {
      prev = code;
      return str.charCodeAt(++index);
    };
    while (index < length) {
      code = advance();
      let next;
      if (code === CHAR_BACKWARD_SLASH) {
        backslashes = token.backslashes = true;
        code = advance();
        if (code === CHAR_LEFT_CURLY_BRACE) {
          braceEscaped = true;
        }
        continue;
      }
      if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE) {
        braces++;
        while (eos() !== true && (code = advance())) {
          if (code === CHAR_BACKWARD_SLASH) {
            backslashes = token.backslashes = true;
            advance();
            continue;
          }
          if (code === CHAR_LEFT_CURLY_BRACE) {
            braces++;
            continue;
          }
          if (braceEscaped !== true && code === CHAR_DOT && (code = advance()) === CHAR_DOT) {
            isBrace = token.isBrace = true;
            isGlob = token.isGlob = true;
            finished = true;
            if (scanToEnd === true) {
              continue;
            }
            break;
          }
          if (braceEscaped !== true && code === CHAR_COMMA) {
            isBrace = token.isBrace = true;
            isGlob = token.isGlob = true;
            finished = true;
            if (scanToEnd === true) {
              continue;
            }
            break;
          }
          if (code === CHAR_RIGHT_CURLY_BRACE) {
            braces--;
            if (braces === 0) {
              braceEscaped = false;
              isBrace = token.isBrace = true;
              finished = true;
              break;
            }
          }
        }
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (code === CHAR_FORWARD_SLASH) {
        slashes.push(index);
        tokens.push(token);
        token = {value: "", depth: 0, isGlob: false};
        if (finished === true)
          continue;
        if (prev === CHAR_DOT && index === start + 1) {
          start += 2;
          continue;
        }
        lastIndex = index + 1;
        continue;
      }
      if (opts.noext !== true) {
        const isExtglobChar = code === CHAR_PLUS || code === CHAR_AT || code === CHAR_ASTERISK || code === CHAR_QUESTION_MARK || code === CHAR_EXCLAMATION_MARK;
        if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES) {
          isGlob = token.isGlob = true;
          isExtglob = token.isExtglob = true;
          finished = true;
          if (code === CHAR_EXCLAMATION_MARK && index === start) {
            negatedExtglob = true;
          }
          if (scanToEnd === true) {
            while (eos() !== true && (code = advance())) {
              if (code === CHAR_BACKWARD_SLASH) {
                backslashes = token.backslashes = true;
                code = advance();
                continue;
              }
              if (code === CHAR_RIGHT_PARENTHESES) {
                isGlob = token.isGlob = true;
                finished = true;
                break;
              }
            }
            continue;
          }
          break;
        }
      }
      if (code === CHAR_ASTERISK) {
        if (prev === CHAR_ASTERISK)
          isGlobstar = token.isGlobstar = true;
        isGlob = token.isGlob = true;
        finished = true;
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (code === CHAR_QUESTION_MARK) {
        isGlob = token.isGlob = true;
        finished = true;
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (code === CHAR_LEFT_SQUARE_BRACKET) {
        while (eos() !== true && (next = advance())) {
          if (next === CHAR_BACKWARD_SLASH) {
            backslashes = token.backslashes = true;
            advance();
            continue;
          }
          if (next === CHAR_RIGHT_SQUARE_BRACKET) {
            isBracket = token.isBracket = true;
            isGlob = token.isGlob = true;
            finished = true;
            break;
          }
        }
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK && index === start) {
        negated = token.negated = true;
        start++;
        continue;
      }
      if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES) {
        isGlob = token.isGlob = true;
        if (scanToEnd === true) {
          while (eos() !== true && (code = advance())) {
            if (code === CHAR_LEFT_PARENTHESES) {
              backslashes = token.backslashes = true;
              code = advance();
              continue;
            }
            if (code === CHAR_RIGHT_PARENTHESES) {
              finished = true;
              break;
            }
          }
          continue;
        }
        break;
      }
      if (isGlob === true) {
        finished = true;
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
    }
    if (opts.noext === true) {
      isExtglob = false;
      isGlob = false;
    }
    let base = str;
    let prefix = "";
    let glob = "";
    if (start > 0) {
      prefix = str.slice(0, start);
      str = str.slice(start);
      lastIndex -= start;
    }
    if (base && isGlob === true && lastIndex > 0) {
      base = str.slice(0, lastIndex);
      glob = str.slice(lastIndex);
    } else if (isGlob === true) {
      base = "";
      glob = str;
    } else {
      base = str;
    }
    if (base && base !== "" && base !== "/" && base !== str) {
      if (isPathSeparator(base.charCodeAt(base.length - 1))) {
        base = base.slice(0, -1);
      }
    }
    if (opts.unescape === true) {
      if (glob)
        glob = utils4.removeBackslashes(glob);
      if (base && backslashes === true) {
        base = utils4.removeBackslashes(base);
      }
    }
    const state = {
      prefix,
      input,
      start,
      base,
      glob,
      isBrace,
      isBracket,
      isGlob,
      isExtglob,
      isGlobstar,
      negated,
      negatedExtglob
    };
    if (opts.tokens === true) {
      state.maxDepth = 0;
      if (!isPathSeparator(code)) {
        tokens.push(token);
      }
      state.tokens = tokens;
    }
    if (opts.parts === true || opts.tokens === true) {
      let prevIndex;
      for (let idx = 0; idx < slashes.length; idx++) {
        const n = prevIndex ? prevIndex + 1 : start;
        const i = slashes[idx];
        const value = input.slice(n, i);
        if (opts.tokens) {
          if (idx === 0 && start !== 0) {
            tokens[idx].isPrefix = true;
            tokens[idx].value = prefix;
          } else {
            tokens[idx].value = value;
          }
          depth(tokens[idx]);
          state.maxDepth += tokens[idx].depth;
        }
        if (idx !== 0 || value !== "") {
          parts.push(value);
        }
        prevIndex = i;
      }
      if (prevIndex && prevIndex + 1 < input.length) {
        const value = input.slice(prevIndex + 1);
        parts.push(value);
        if (opts.tokens) {
          tokens[tokens.length - 1].value = value;
          depth(tokens[tokens.length - 1]);
          state.maxDepth += tokens[tokens.length - 1].depth;
        }
      }
      state.slashes = slashes;
      state.parts = parts;
    }
    return state;
  };
  module2.exports = scan;
});

// node_modules/picomatch/lib/parse.js
var require_parse2 = __commonJS((exports2, module2) => {
  "use strict";
  var constants = require_constants2();
  var utils4 = require_utils2();
  var {
    MAX_LENGTH,
    POSIX_REGEX_SOURCE,
    REGEX_NON_SPECIAL_CHARS,
    REGEX_SPECIAL_CHARS_BACKREF,
    REPLACEMENTS
  } = constants;
  var expandRange = (args, options) => {
    if (typeof options.expandRange === "function") {
      return options.expandRange(...args, options);
    }
    args.sort();
    const value = `[${args.join("-")}]`;
    try {
      new RegExp(value);
    } catch (ex) {
      return args.map((v) => utils4.escapeRegex(v)).join("..");
    }
    return value;
  };
  var syntaxError = (type, char) => {
    return `Missing ${type}: "${char}" - use "\\\\${char}" to match literal characters`;
  };
  var parse3 = (input, options) => {
    if (typeof input !== "string") {
      throw new TypeError("Expected a string");
    }
    input = REPLACEMENTS[input] || input;
    const opts = {...options};
    const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
    let len = input.length;
    if (len > max) {
      throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
    }
    const bos = {type: "bos", value: "", output: opts.prepend || ""};
    const tokens = [bos];
    const capture = opts.capture ? "" : "?:";
    const win32 = utils4.isWindows(options);
    const PLATFORM_CHARS = constants.globChars(win32);
    const EXTGLOB_CHARS = constants.extglobChars(PLATFORM_CHARS);
    const {
      DOT_LITERAL,
      PLUS_LITERAL,
      SLASH_LITERAL,
      ONE_CHAR,
      DOTS_SLASH,
      NO_DOT,
      NO_DOT_SLASH,
      NO_DOTS_SLASH,
      QMARK,
      QMARK_NO_DOT,
      STAR,
      START_ANCHOR
    } = PLATFORM_CHARS;
    const globstar = (opts2) => {
      return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
    };
    const nodot = opts.dot ? "" : NO_DOT;
    const qmarkNoDot = opts.dot ? QMARK : QMARK_NO_DOT;
    let star = opts.bash === true ? globstar(opts) : STAR;
    if (opts.capture) {
      star = `(${star})`;
    }
    if (typeof opts.noext === "boolean") {
      opts.noextglob = opts.noext;
    }
    const state = {
      input,
      index: -1,
      start: 0,
      dot: opts.dot === true,
      consumed: "",
      output: "",
      prefix: "",
      backtrack: false,
      negated: false,
      brackets: 0,
      braces: 0,
      parens: 0,
      quotes: 0,
      globstar: false,
      tokens
    };
    input = utils4.removePrefix(input, state);
    len = input.length;
    const extglobs = [];
    const braces = [];
    const stack = [];
    let prev = bos;
    let value;
    const eos = () => state.index === len - 1;
    const peek = state.peek = (n = 1) => input[state.index + n];
    const advance = state.advance = () => input[++state.index] || "";
    const remaining = () => input.slice(state.index + 1);
    const consume = (value2 = "", num = 0) => {
      state.consumed += value2;
      state.index += num;
    };
    const append = (token) => {
      state.output += token.output != null ? token.output : token.value;
      consume(token.value);
    };
    const negate = () => {
      let count = 1;
      while (peek() === "!" && (peek(2) !== "(" || peek(3) === "?")) {
        advance();
        state.start++;
        count++;
      }
      if (count % 2 === 0) {
        return false;
      }
      state.negated = true;
      state.start++;
      return true;
    };
    const increment = (type) => {
      state[type]++;
      stack.push(type);
    };
    const decrement = (type) => {
      state[type]--;
      stack.pop();
    };
    const push = (tok) => {
      if (prev.type === "globstar") {
        const isBrace = state.braces > 0 && (tok.type === "comma" || tok.type === "brace");
        const isExtglob = tok.extglob === true || extglobs.length && (tok.type === "pipe" || tok.type === "paren");
        if (tok.type !== "slash" && tok.type !== "paren" && !isBrace && !isExtglob) {
          state.output = state.output.slice(0, -prev.output.length);
          prev.type = "star";
          prev.value = "*";
          prev.output = star;
          state.output += prev.output;
        }
      }
      if (extglobs.length && tok.type !== "paren") {
        extglobs[extglobs.length - 1].inner += tok.value;
      }
      if (tok.value || tok.output)
        append(tok);
      if (prev && prev.type === "text" && tok.type === "text") {
        prev.value += tok.value;
        prev.output = (prev.output || "") + tok.value;
        return;
      }
      tok.prev = prev;
      tokens.push(tok);
      prev = tok;
    };
    const extglobOpen = (type, value2) => {
      const token = {...EXTGLOB_CHARS[value2], conditions: 1, inner: ""};
      token.prev = prev;
      token.parens = state.parens;
      token.output = state.output;
      const output = (opts.capture ? "(" : "") + token.open;
      increment("parens");
      push({type, value: value2, output: state.output ? "" : ONE_CHAR});
      push({type: "paren", extglob: true, value: advance(), output});
      extglobs.push(token);
    };
    const extglobClose = (token) => {
      let output = token.close + (opts.capture ? ")" : "");
      let rest;
      if (token.type === "negate") {
        let extglobStar = star;
        if (token.inner && token.inner.length > 1 && token.inner.includes("/")) {
          extglobStar = globstar(opts);
        }
        if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
          output = token.close = `)$))${extglobStar}`;
        }
        if (token.inner.includes("*") && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
          output = token.close = `)${rest})${extglobStar})`;
        }
        if (token.prev.type === "bos") {
          state.negatedExtglob = true;
        }
      }
      push({type: "paren", extglob: true, value, output});
      decrement("parens");
    };
    if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
      let backslashes = false;
      let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF, (m, esc, chars, first, rest, index) => {
        if (first === "\\") {
          backslashes = true;
          return m;
        }
        if (first === "?") {
          if (esc) {
            return esc + first + (rest ? QMARK.repeat(rest.length) : "");
          }
          if (index === 0) {
            return qmarkNoDot + (rest ? QMARK.repeat(rest.length) : "");
          }
          return QMARK.repeat(chars.length);
        }
        if (first === ".") {
          return DOT_LITERAL.repeat(chars.length);
        }
        if (first === "*") {
          if (esc) {
            return esc + first + (rest ? star : "");
          }
          return star;
        }
        return esc ? m : `\\${m}`;
      });
      if (backslashes === true) {
        if (opts.unescape === true) {
          output = output.replace(/\\/g, "");
        } else {
          output = output.replace(/\\+/g, (m) => {
            return m.length % 2 === 0 ? "\\\\" : m ? "\\" : "";
          });
        }
      }
      if (output === input && opts.contains === true) {
        state.output = input;
        return state;
      }
      state.output = utils4.wrapOutput(output, state, options);
      return state;
    }
    while (!eos()) {
      value = advance();
      if (value === "\0") {
        continue;
      }
      if (value === "\\") {
        const next = peek();
        if (next === "/" && opts.bash !== true) {
          continue;
        }
        if (next === "." || next === ";") {
          continue;
        }
        if (!next) {
          value += "\\";
          push({type: "text", value});
          continue;
        }
        const match = /^\\+/.exec(remaining());
        let slashes = 0;
        if (match && match[0].length > 2) {
          slashes = match[0].length;
          state.index += slashes;
          if (slashes % 2 !== 0) {
            value += "\\";
          }
        }
        if (opts.unescape === true) {
          value = advance();
        } else {
          value += advance();
        }
        if (state.brackets === 0) {
          push({type: "text", value});
          continue;
        }
      }
      if (state.brackets > 0 && (value !== "]" || prev.value === "[" || prev.value === "[^")) {
        if (opts.posix !== false && value === ":") {
          const inner = prev.value.slice(1);
          if (inner.includes("[")) {
            prev.posix = true;
            if (inner.includes(":")) {
              const idx = prev.value.lastIndexOf("[");
              const pre = prev.value.slice(0, idx);
              const rest2 = prev.value.slice(idx + 2);
              const posix = POSIX_REGEX_SOURCE[rest2];
              if (posix) {
                prev.value = pre + posix;
                state.backtrack = true;
                advance();
                if (!bos.output && tokens.indexOf(prev) === 1) {
                  bos.output = ONE_CHAR;
                }
                continue;
              }
            }
          }
        }
        if (value === "[" && peek() !== ":" || value === "-" && peek() === "]") {
          value = `\\${value}`;
        }
        if (value === "]" && (prev.value === "[" || prev.value === "[^")) {
          value = `\\${value}`;
        }
        if (opts.posix === true && value === "!" && prev.value === "[") {
          value = "^";
        }
        prev.value += value;
        append({value});
        continue;
      }
      if (state.quotes === 1 && value !== '"') {
        value = utils4.escapeRegex(value);
        prev.value += value;
        append({value});
        continue;
      }
      if (value === '"') {
        state.quotes = state.quotes === 1 ? 0 : 1;
        if (opts.keepQuotes === true) {
          push({type: "text", value});
        }
        continue;
      }
      if (value === "(") {
        increment("parens");
        push({type: "paren", value});
        continue;
      }
      if (value === ")") {
        if (state.parens === 0 && opts.strictBrackets === true) {
          throw new SyntaxError(syntaxError("opening", "("));
        }
        const extglob = extglobs[extglobs.length - 1];
        if (extglob && state.parens === extglob.parens + 1) {
          extglobClose(extglobs.pop());
          continue;
        }
        push({type: "paren", value, output: state.parens ? ")" : "\\)"});
        decrement("parens");
        continue;
      }
      if (value === "[") {
        if (opts.nobracket === true || !remaining().includes("]")) {
          if (opts.nobracket !== true && opts.strictBrackets === true) {
            throw new SyntaxError(syntaxError("closing", "]"));
          }
          value = `\\${value}`;
        } else {
          increment("brackets");
        }
        push({type: "bracket", value});
        continue;
      }
      if (value === "]") {
        if (opts.nobracket === true || prev && prev.type === "bracket" && prev.value.length === 1) {
          push({type: "text", value, output: `\\${value}`});
          continue;
        }
        if (state.brackets === 0) {
          if (opts.strictBrackets === true) {
            throw new SyntaxError(syntaxError("opening", "["));
          }
          push({type: "text", value, output: `\\${value}`});
          continue;
        }
        decrement("brackets");
        const prevValue = prev.value.slice(1);
        if (prev.posix !== true && prevValue[0] === "^" && !prevValue.includes("/")) {
          value = `/${value}`;
        }
        prev.value += value;
        append({value});
        if (opts.literalBrackets === false || utils4.hasRegexChars(prevValue)) {
          continue;
        }
        const escaped = utils4.escapeRegex(prev.value);
        state.output = state.output.slice(0, -prev.value.length);
        if (opts.literalBrackets === true) {
          state.output += escaped;
          prev.value = escaped;
          continue;
        }
        prev.value = `(${capture}${escaped}|${prev.value})`;
        state.output += prev.value;
        continue;
      }
      if (value === "{" && opts.nobrace !== true) {
        increment("braces");
        const open = {
          type: "brace",
          value,
          output: "(",
          outputIndex: state.output.length,
          tokensIndex: state.tokens.length
        };
        braces.push(open);
        push(open);
        continue;
      }
      if (value === "}") {
        const brace = braces[braces.length - 1];
        if (opts.nobrace === true || !brace) {
          push({type: "text", value, output: value});
          continue;
        }
        let output = ")";
        if (brace.dots === true) {
          const arr = tokens.slice();
          const range = [];
          for (let i = arr.length - 1; i >= 0; i--) {
            tokens.pop();
            if (arr[i].type === "brace") {
              break;
            }
            if (arr[i].type !== "dots") {
              range.unshift(arr[i].value);
            }
          }
          output = expandRange(range, opts);
          state.backtrack = true;
        }
        if (brace.comma !== true && brace.dots !== true) {
          const out = state.output.slice(0, brace.outputIndex);
          const toks = state.tokens.slice(brace.tokensIndex);
          brace.value = brace.output = "\\{";
          value = output = "\\}";
          state.output = out;
          for (const t of toks) {
            state.output += t.output || t.value;
          }
        }
        push({type: "brace", value, output});
        decrement("braces");
        braces.pop();
        continue;
      }
      if (value === "|") {
        if (extglobs.length > 0) {
          extglobs[extglobs.length - 1].conditions++;
        }
        push({type: "text", value});
        continue;
      }
      if (value === ",") {
        let output = value;
        const brace = braces[braces.length - 1];
        if (brace && stack[stack.length - 1] === "braces") {
          brace.comma = true;
          output = "|";
        }
        push({type: "comma", value, output});
        continue;
      }
      if (value === "/") {
        if (prev.type === "dot" && state.index === state.start + 1) {
          state.start = state.index + 1;
          state.consumed = "";
          state.output = "";
          tokens.pop();
          prev = bos;
          continue;
        }
        push({type: "slash", value, output: SLASH_LITERAL});
        continue;
      }
      if (value === ".") {
        if (state.braces > 0 && prev.type === "dot") {
          if (prev.value === ".")
            prev.output = DOT_LITERAL;
          const brace = braces[braces.length - 1];
          prev.type = "dots";
          prev.output += value;
          prev.value += value;
          brace.dots = true;
          continue;
        }
        if (state.braces + state.parens === 0 && prev.type !== "bos" && prev.type !== "slash") {
          push({type: "text", value, output: DOT_LITERAL});
          continue;
        }
        push({type: "dot", value, output: DOT_LITERAL});
        continue;
      }
      if (value === "?") {
        const isGroup = prev && prev.value === "(";
        if (!isGroup && opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
          extglobOpen("qmark", value);
          continue;
        }
        if (prev && prev.type === "paren") {
          const next = peek();
          let output = value;
          if (next === "<" && !utils4.supportsLookbehinds()) {
            throw new Error("Node.js v10 or higher is required for regex lookbehinds");
          }
          if (prev.value === "(" && !/[!=<:]/.test(next) || next === "<" && !/<([!=]|\w+>)/.test(remaining())) {
            output = `\\${value}`;
          }
          push({type: "text", value, output});
          continue;
        }
        if (opts.dot !== true && (prev.type === "slash" || prev.type === "bos")) {
          push({type: "qmark", value, output: QMARK_NO_DOT});
          continue;
        }
        push({type: "qmark", value, output: QMARK});
        continue;
      }
      if (value === "!") {
        if (opts.noextglob !== true && peek() === "(") {
          if (peek(2) !== "?" || !/[!=<:]/.test(peek(3))) {
            extglobOpen("negate", value);
            continue;
          }
        }
        if (opts.nonegate !== true && state.index === 0) {
          negate();
          continue;
        }
      }
      if (value === "+") {
        if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
          extglobOpen("plus", value);
          continue;
        }
        if (prev && prev.value === "(" || opts.regex === false) {
          push({type: "plus", value, output: PLUS_LITERAL});
          continue;
        }
        if (prev && (prev.type === "bracket" || prev.type === "paren" || prev.type === "brace") || state.parens > 0) {
          push({type: "plus", value});
          continue;
        }
        push({type: "plus", value: PLUS_LITERAL});
        continue;
      }
      if (value === "@") {
        if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
          push({type: "at", extglob: true, value, output: ""});
          continue;
        }
        push({type: "text", value});
        continue;
      }
      if (value !== "*") {
        if (value === "$" || value === "^") {
          value = `\\${value}`;
        }
        const match = REGEX_NON_SPECIAL_CHARS.exec(remaining());
        if (match) {
          value += match[0];
          state.index += match[0].length;
        }
        push({type: "text", value});
        continue;
      }
      if (prev && (prev.type === "globstar" || prev.star === true)) {
        prev.type = "star";
        prev.star = true;
        prev.value += value;
        prev.output = star;
        state.backtrack = true;
        state.globstar = true;
        consume(value);
        continue;
      }
      let rest = remaining();
      if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
        extglobOpen("star", value);
        continue;
      }
      if (prev.type === "star") {
        if (opts.noglobstar === true) {
          consume(value);
          continue;
        }
        const prior = prev.prev;
        const before = prior.prev;
        const isStart = prior.type === "slash" || prior.type === "bos";
        const afterStar = before && (before.type === "star" || before.type === "globstar");
        if (opts.bash === true && (!isStart || rest[0] && rest[0] !== "/")) {
          push({type: "star", value, output: ""});
          continue;
        }
        const isBrace = state.braces > 0 && (prior.type === "comma" || prior.type === "brace");
        const isExtglob = extglobs.length && (prior.type === "pipe" || prior.type === "paren");
        if (!isStart && prior.type !== "paren" && !isBrace && !isExtglob) {
          push({type: "star", value, output: ""});
          continue;
        }
        while (rest.slice(0, 3) === "/**") {
          const after = input[state.index + 4];
          if (after && after !== "/") {
            break;
          }
          rest = rest.slice(3);
          consume("/**", 3);
        }
        if (prior.type === "bos" && eos()) {
          prev.type = "globstar";
          prev.value += value;
          prev.output = globstar(opts);
          state.output = prev.output;
          state.globstar = true;
          consume(value);
          continue;
        }
        if (prior.type === "slash" && prior.prev.type !== "bos" && !afterStar && eos()) {
          state.output = state.output.slice(0, -(prior.output + prev.output).length);
          prior.output = `(?:${prior.output}`;
          prev.type = "globstar";
          prev.output = globstar(opts) + (opts.strictSlashes ? ")" : "|$)");
          prev.value += value;
          state.globstar = true;
          state.output += prior.output + prev.output;
          consume(value);
          continue;
        }
        if (prior.type === "slash" && prior.prev.type !== "bos" && rest[0] === "/") {
          const end = rest[1] !== void 0 ? "|$" : "";
          state.output = state.output.slice(0, -(prior.output + prev.output).length);
          prior.output = `(?:${prior.output}`;
          prev.type = "globstar";
          prev.output = `${globstar(opts)}${SLASH_LITERAL}|${SLASH_LITERAL}${end})`;
          prev.value += value;
          state.output += prior.output + prev.output;
          state.globstar = true;
          consume(value + advance());
          push({type: "slash", value: "/", output: ""});
          continue;
        }
        if (prior.type === "bos" && rest[0] === "/") {
          prev.type = "globstar";
          prev.value += value;
          prev.output = `(?:^|${SLASH_LITERAL}|${globstar(opts)}${SLASH_LITERAL})`;
          state.output = prev.output;
          state.globstar = true;
          consume(value + advance());
          push({type: "slash", value: "/", output: ""});
          continue;
        }
        state.output = state.output.slice(0, -prev.output.length);
        prev.type = "globstar";
        prev.output = globstar(opts);
        prev.value += value;
        state.output += prev.output;
        state.globstar = true;
        consume(value);
        continue;
      }
      const token = {type: "star", value, output: star};
      if (opts.bash === true) {
        token.output = ".*?";
        if (prev.type === "bos" || prev.type === "slash") {
          token.output = nodot + token.output;
        }
        push(token);
        continue;
      }
      if (prev && (prev.type === "bracket" || prev.type === "paren") && opts.regex === true) {
        token.output = value;
        push(token);
        continue;
      }
      if (state.index === state.start || prev.type === "slash" || prev.type === "dot") {
        if (prev.type === "dot") {
          state.output += NO_DOT_SLASH;
          prev.output += NO_DOT_SLASH;
        } else if (opts.dot === true) {
          state.output += NO_DOTS_SLASH;
          prev.output += NO_DOTS_SLASH;
        } else {
          state.output += nodot;
          prev.output += nodot;
        }
        if (peek() !== "*") {
          state.output += ONE_CHAR;
          prev.output += ONE_CHAR;
        }
      }
      push(token);
    }
    while (state.brackets > 0) {
      if (opts.strictBrackets === true)
        throw new SyntaxError(syntaxError("closing", "]"));
      state.output = utils4.escapeLast(state.output, "[");
      decrement("brackets");
    }
    while (state.parens > 0) {
      if (opts.strictBrackets === true)
        throw new SyntaxError(syntaxError("closing", ")"));
      state.output = utils4.escapeLast(state.output, "(");
      decrement("parens");
    }
    while (state.braces > 0) {
      if (opts.strictBrackets === true)
        throw new SyntaxError(syntaxError("closing", "}"));
      state.output = utils4.escapeLast(state.output, "{");
      decrement("braces");
    }
    if (opts.strictSlashes !== true && (prev.type === "star" || prev.type === "bracket")) {
      push({type: "maybe_slash", value: "", output: `${SLASH_LITERAL}?`});
    }
    if (state.backtrack === true) {
      state.output = "";
      for (const token of state.tokens) {
        state.output += token.output != null ? token.output : token.value;
        if (token.suffix) {
          state.output += token.suffix;
        }
      }
    }
    return state;
  };
  parse3.fastpaths = (input, options) => {
    const opts = {...options};
    const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
    const len = input.length;
    if (len > max) {
      throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
    }
    input = REPLACEMENTS[input] || input;
    const win32 = utils4.isWindows(options);
    const {
      DOT_LITERAL,
      SLASH_LITERAL,
      ONE_CHAR,
      DOTS_SLASH,
      NO_DOT,
      NO_DOTS,
      NO_DOTS_SLASH,
      STAR,
      START_ANCHOR
    } = constants.globChars(win32);
    const nodot = opts.dot ? NO_DOTS : NO_DOT;
    const slashDot = opts.dot ? NO_DOTS_SLASH : NO_DOT;
    const capture = opts.capture ? "" : "?:";
    const state = {negated: false, prefix: ""};
    let star = opts.bash === true ? ".*?" : STAR;
    if (opts.capture) {
      star = `(${star})`;
    }
    const globstar = (opts2) => {
      if (opts2.noglobstar === true)
        return star;
      return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
    };
    const create = (str) => {
      switch (str) {
        case "*":
          return `${nodot}${ONE_CHAR}${star}`;
        case ".*":
          return `${DOT_LITERAL}${ONE_CHAR}${star}`;
        case "*.*":
          return `${nodot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
        case "*/*":
          return `${nodot}${star}${SLASH_LITERAL}${ONE_CHAR}${slashDot}${star}`;
        case "**":
          return nodot + globstar(opts);
        case "**/*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${ONE_CHAR}${star}`;
        case "**/*.*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
        case "**/.*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${DOT_LITERAL}${ONE_CHAR}${star}`;
        default: {
          const match = /^(.*?)\.(\w+)$/.exec(str);
          if (!match)
            return;
          const source2 = create(match[1]);
          if (!source2)
            return;
          return source2 + DOT_LITERAL + match[2];
        }
      }
    };
    const output = utils4.removePrefix(input, state);
    let source = create(output);
    if (source && opts.strictSlashes !== true) {
      source += `${SLASH_LITERAL}?`;
    }
    return source;
  };
  module2.exports = parse3;
});

// node_modules/picomatch/lib/picomatch.js
var require_picomatch = __commonJS((exports2, module2) => {
  "use strict";
  var path = require("path");
  var scan = require_scan();
  var parse3 = require_parse2();
  var utils4 = require_utils2();
  var constants = require_constants2();
  var isObject = (val) => val && typeof val === "object" && !Array.isArray(val);
  var picomatch = (glob, options, returnState = false) => {
    if (Array.isArray(glob)) {
      const fns = glob.map((input) => picomatch(input, options, returnState));
      const arrayMatcher = (str) => {
        for (const isMatch of fns) {
          const state2 = isMatch(str);
          if (state2)
            return state2;
        }
        return false;
      };
      return arrayMatcher;
    }
    const isState = isObject(glob) && glob.tokens && glob.input;
    if (glob === "" || typeof glob !== "string" && !isState) {
      throw new TypeError("Expected pattern to be a non-empty string");
    }
    const opts = options || {};
    const posix = utils4.isWindows(options);
    const regex = isState ? picomatch.compileRe(glob, options) : picomatch.makeRe(glob, options, false, true);
    const state = regex.state;
    delete regex.state;
    let isIgnored = () => false;
    if (opts.ignore) {
      const ignoreOpts = {...options, ignore: null, onMatch: null, onResult: null};
      isIgnored = picomatch(opts.ignore, ignoreOpts, returnState);
    }
    const matcher = (input, returnObject = false) => {
      const {isMatch, match, output} = picomatch.test(input, regex, options, {glob, posix});
      const result = {glob, state, regex, posix, input, output, match, isMatch};
      if (typeof opts.onResult === "function") {
        opts.onResult(result);
      }
      if (isMatch === false) {
        result.isMatch = false;
        return returnObject ? result : false;
      }
      if (isIgnored(input)) {
        if (typeof opts.onIgnore === "function") {
          opts.onIgnore(result);
        }
        result.isMatch = false;
        return returnObject ? result : false;
      }
      if (typeof opts.onMatch === "function") {
        opts.onMatch(result);
      }
      return returnObject ? result : true;
    };
    if (returnState) {
      matcher.state = state;
    }
    return matcher;
  };
  picomatch.test = (input, regex, options, {glob, posix} = {}) => {
    if (typeof input !== "string") {
      throw new TypeError("Expected input to be a string");
    }
    if (input === "") {
      return {isMatch: false, output: ""};
    }
    const opts = options || {};
    const format2 = opts.format || (posix ? utils4.toPosixSlashes : null);
    let match = input === glob;
    let output = match && format2 ? format2(input) : input;
    if (match === false) {
      output = format2 ? format2(input) : input;
      match = output === glob;
    }
    if (match === false || opts.capture === true) {
      if (opts.matchBase === true || opts.basename === true) {
        match = picomatch.matchBase(input, regex, options, posix);
      } else {
        match = regex.exec(output);
      }
    }
    return {isMatch: Boolean(match), match, output};
  };
  picomatch.matchBase = (input, glob, options, posix = utils4.isWindows(options)) => {
    const regex = glob instanceof RegExp ? glob : picomatch.makeRe(glob, options);
    return regex.test(path.basename(input));
  };
  picomatch.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);
  picomatch.parse = (pattern, options) => {
    if (Array.isArray(pattern))
      return pattern.map((p) => picomatch.parse(p, options));
    return parse3(pattern, {...options, fastpaths: false});
  };
  picomatch.scan = (input, options) => scan(input, options);
  picomatch.compileRe = (state, options, returnOutput = false, returnState = false) => {
    if (returnOutput === true) {
      return state.output;
    }
    const opts = options || {};
    const prepend = opts.contains ? "" : "^";
    const append = opts.contains ? "" : "$";
    let source = `${prepend}(?:${state.output})${append}`;
    if (state && state.negated === true) {
      source = `^(?!${source}).*$`;
    }
    const regex = picomatch.toRegex(source, options);
    if (returnState === true) {
      regex.state = state;
    }
    return regex;
  };
  picomatch.makeRe = (input, options = {}, returnOutput = false, returnState = false) => {
    if (!input || typeof input !== "string") {
      throw new TypeError("Expected a non-empty string");
    }
    let parsed = {negated: false, fastpaths: true};
    if (options.fastpaths !== false && (input[0] === "." || input[0] === "*")) {
      parsed.output = parse3.fastpaths(input, options);
    }
    if (!parsed.output) {
      parsed = parse3(input, options);
    }
    return picomatch.compileRe(parsed, options, returnOutput, returnState);
  };
  picomatch.toRegex = (source, options) => {
    try {
      const opts = options || {};
      return new RegExp(source, opts.flags || (opts.nocase ? "i" : ""));
    } catch (err) {
      if (options && options.debug === true)
        throw err;
      return /$^/;
    }
  };
  picomatch.constants = constants;
  module2.exports = picomatch;
});

// node_modules/picomatch/index.js
var require_picomatch2 = __commonJS((exports2, module2) => {
  "use strict";
  module2.exports = require_picomatch();
});

// node_modules/micromatch/index.js
var require_micromatch = __commonJS((exports2, module2) => {
  "use strict";
  var util = require("util");
  var braces = require_braces();
  var picomatch = require_picomatch2();
  var utils4 = require_utils2();
  var isEmptyString = (val) => val === "" || val === "./";
  var micromatch4 = (list, patterns, options) => {
    patterns = [].concat(patterns);
    list = [].concat(list);
    let omit = new Set();
    let keep = new Set();
    let items = new Set();
    let negatives = 0;
    let onResult = (state) => {
      items.add(state.output);
      if (options && options.onResult) {
        options.onResult(state);
      }
    };
    for (let i = 0; i < patterns.length; i++) {
      let isMatch = picomatch(String(patterns[i]), {...options, onResult}, true);
      let negated = isMatch.state.negated || isMatch.state.negatedExtglob;
      if (negated)
        negatives++;
      for (let item of list) {
        let matched = isMatch(item, true);
        let match = negated ? !matched.isMatch : matched.isMatch;
        if (!match)
          continue;
        if (negated) {
          omit.add(matched.output);
        } else {
          omit.delete(matched.output);
          keep.add(matched.output);
        }
      }
    }
    let result = negatives === patterns.length ? [...items] : [...keep];
    let matches = result.filter((item) => !omit.has(item));
    if (options && matches.length === 0) {
      if (options.failglob === true) {
        throw new Error(`No matches found for "${patterns.join(", ")}"`);
      }
      if (options.nonull === true || options.nullglob === true) {
        return options.unescape ? patterns.map((p) => p.replace(/\\/g, "")) : patterns;
      }
    }
    return matches;
  };
  micromatch4.match = micromatch4;
  micromatch4.matcher = (pattern, options) => picomatch(pattern, options);
  micromatch4.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);
  micromatch4.any = micromatch4.isMatch;
  micromatch4.not = (list, patterns, options = {}) => {
    patterns = [].concat(patterns).map(String);
    let result = new Set();
    let items = [];
    let onResult = (state) => {
      if (options.onResult)
        options.onResult(state);
      items.push(state.output);
    };
    let matches = micromatch4(list, patterns, {...options, onResult});
    for (let item of items) {
      if (!matches.includes(item)) {
        result.add(item);
      }
    }
    return [...result];
  };
  micromatch4.contains = (str, pattern, options) => {
    if (typeof str !== "string") {
      throw new TypeError(`Expected a string: "${util.inspect(str)}"`);
    }
    if (Array.isArray(pattern)) {
      return pattern.some((p) => micromatch4.contains(str, p, options));
    }
    if (typeof pattern === "string") {
      if (isEmptyString(str) || isEmptyString(pattern)) {
        return false;
      }
      if (str.includes(pattern) || str.startsWith("./") && str.slice(2).includes(pattern)) {
        return true;
      }
    }
    return micromatch4.isMatch(str, pattern, {...options, contains: true});
  };
  micromatch4.matchKeys = (obj, patterns, options) => {
    if (!utils4.isObject(obj)) {
      throw new TypeError("Expected the first argument to be an object");
    }
    let keys = micromatch4(Object.keys(obj), patterns, options);
    let res = {};
    for (let key of keys)
      res[key] = obj[key];
    return res;
  };
  micromatch4.some = (list, patterns, options) => {
    let items = [].concat(list);
    for (let pattern of [].concat(patterns)) {
      let isMatch = picomatch(String(pattern), options);
      if (items.some((item) => isMatch(item))) {
        return true;
      }
    }
    return false;
  };
  micromatch4.every = (list, patterns, options) => {
    let items = [].concat(list);
    for (let pattern of [].concat(patterns)) {
      let isMatch = picomatch(String(pattern), options);
      if (!items.every((item) => isMatch(item))) {
        return false;
      }
    }
    return true;
  };
  micromatch4.all = (str, patterns, options) => {
    if (typeof str !== "string") {
      throw new TypeError(`Expected a string: "${util.inspect(str)}"`);
    }
    return [].concat(patterns).every((p) => picomatch(p, options)(str));
  };
  micromatch4.capture = (glob, input, options) => {
    let posix = utils4.isWindows(options);
    let regex = picomatch.makeRe(String(glob), {...options, capture: true});
    let match = regex.exec(posix ? utils4.toPosixSlashes(input) : input);
    if (match) {
      return match.slice(1).map((v) => v === void 0 ? "" : v);
    }
  };
  micromatch4.makeRe = (...args) => picomatch.makeRe(...args);
  micromatch4.scan = (...args) => picomatch.scan(...args);
  micromatch4.parse = (patterns, options) => {
    let res = [];
    for (let pattern of [].concat(patterns || [])) {
      for (let str of braces(String(pattern), options)) {
        res.push(picomatch.parse(str, options));
      }
    }
    return res;
  };
  micromatch4.braces = (pattern, options) => {
    if (typeof pattern !== "string")
      throw new TypeError("Expected a string");
    if (options && options.nobrace === true || !/\{.*\}/.test(pattern)) {
      return [pattern];
    }
    return braces(pattern, options);
  };
  micromatch4.braceExpand = (pattern, options) => {
    if (typeof pattern !== "string")
      throw new TypeError("Expected a string");
    return micromatch4.braces(pattern, {...options, expand: true});
  };
  module2.exports = micromatch4;
});

// vendor/fdir/compat/fs.js
var require_fs = __commonJS((exports2, module2) => {
  var {lstat, lstatSync, readdir, readdirSync, Dirent} = require("fs");
  var {sep} = require("path");
  if (!Dirent) {
    let getDirent2 = function(name, stat) {
      return {
        name,
        isFile: () => stat.isFile(),
        isDirectory: () => stat.isDirectory()
      };
    };
    getDirent = getDirent2;
    module2.exports.readdir = function(dir, _, callback) {
      readdir(dir, (err, files) => {
        if (err)
          return process.nextTick(callback, err, null);
        if (!files.length)
          return process.nextTick(callback, null, []);
        let dirents = [];
        for (let i = 0; i < files.length; ++i) {
          let name = files[i];
          let path = `${dir}${sep}${name}`;
          lstat(path, (err2, stat) => {
            if (err2)
              return process.nextTick(callback, err2, null);
            dirents[dirents.length] = getDirent2(name, stat);
            if (dirents.length === files.length) {
              process.nextTick(callback, null, dirents);
            }
          });
        }
      });
    };
    module2.exports.readdirSync = function(dir) {
      const files = readdirSync(dir);
      let dirents = [];
      for (let i = 0; i < files.length; ++i) {
        let name = files[i];
        let path = `${dir}${sep}${name}`;
        const stat = lstatSync(path);
        dirents[dirents.length] = getDirent2(name, stat);
      }
      return dirents;
    };
  } else {
    module2.exports = {readdirSync, readdir};
  }
  var getDirent;
});

// vendor/fdir/utils.js
var require_utils3 = __commonJS((exports2, module2) => {
  var {sep, normalize} = require("path");
  function cleanPath(dirPath) {
    let normalized = normalize(dirPath);
    if (normalized.length > 1 && normalized[normalized.length - 1] === sep)
      normalized = normalized.substring(0, normalized.length - 1);
    return normalized;
  }
  module2.exports = {cleanPath};
});

// vendor/fdir/api/fns.js
var require_fns = __commonJS((exports2, module2) => {
  var {sep} = require("path");
  module2.exports.getArray = function(state) {
    return state.paths;
  };
  module2.exports.getArrayGroup = function() {
    return [""].slice(0, 0);
  };
  module2.exports.pushFileFilterAndCount = function(filters) {
    return function(filename, _files, _dir, state) {
      if (filters.some((f) => f(filename)))
        state.counts.files++;
    };
  };
  module2.exports.pushFileFilter = function(filters) {
    return function(filename, files) {
      if (filters.some((f) => f(filename)))
        files.push(filename);
    };
  };
  module2.exports.pushFileCount = function(_filename, _files, _dir, state) {
    state.counts.files++;
  };
  module2.exports.pushFile = function(filename, files) {
    files.push(filename);
  };
  module2.exports.pushDir = function(dirPath, paths) {
    paths.push(dirPath);
  };
  module2.exports.joinPathWithBasePath = function(filename, dir) {
    return `${dir}${sep}${filename}`;
  };
  module2.exports.joinPath = function(filename) {
    return filename;
  };
  module2.exports.walkDirExclude = function(exclude) {
    return function(walk, state, path, dir, currentDepth, callback) {
      if (!exclude(dir, path, currentDepth)) {
        module2.exports.walkDir(walk, state, path, dir, currentDepth, callback);
      }
    };
  };
  module2.exports.walkDir = function(walk, state, path, _dir, currentDepth, callback) {
    state.queue++;
    state.counts.dirs++;
    walk(state, path, currentDepth, callback);
  };
  module2.exports.groupFiles = function(dir, files, state) {
    state.counts.files += files.length;
    state.paths.push({dir, files});
  };
  module2.exports.empty = function() {
  };
  module2.exports.callbackInvokerOnlyCountsSync = function(state) {
    return state.counts;
  };
  module2.exports.callbackInvokerDefaultSync = function(state) {
    return state.paths;
  };
  module2.exports.callbackInvokerOnlyCountsAsync = callbackInvokerBuilder("counts");
  module2.exports.callbackInvokerDefaultAsync = callbackInvokerBuilder("paths");
  function report(err, callback, output, suppressErrors) {
    if (err) {
      if (!suppressErrors)
        callback(err, null);
      return;
    }
    callback(null, output);
  }
  function callbackInvokerBuilder(output) {
    return function(err, state) {
      report(err, state.callback, state[output], state.options.suppressErrors);
    };
  }
});

// vendor/fdir/api/shared.js
var require_shared = __commonJS((exports2, module2) => {
  var {sep, resolve: pathResolve} = require("path");
  var {cleanPath} = require_utils3();
  var fns = require_fns();
  var readdirOpts = {withFileTypes: true};
  function init(dir, options, callback, isSync) {
    if (options.resolvePaths)
      dir = pathResolve(dir);
    if (options.normalizePath)
      dir = cleanPath(dir);
    const state = {
      paths: [""].slice(0, 0),
      queue: 0,
      counts: {files: 0, dirs: 0},
      options,
      callback
    };
    buildFunctions(options, isSync);
    return {state, callbackInvoker, dir};
  }
  function walkSingleDir(walk, state, dir, dirents, currentDepth, callback) {
    pushDir(dir, state.paths);
    if (dir === sep)
      dir = "";
    const files = getArray(state);
    for (var i = 0; i < dirents.length; ++i) {
      const dirent = dirents[i];
      if (dirent.isFile()) {
        const filename = joinPath(dirent.name, dir);
        pushFile(filename, files, dir, state);
      } else if (dirent.isDirectory()) {
        let dirPath = `${dir}${sep}${dirent.name}`;
        walkDir(walk, state, dirPath, dirent.name, currentDepth - 1, callback);
      }
    }
    groupFiles(dir, files, state);
  }
  function buildFunctions(options, isSync) {
    const {
      filters,
      onlyCountsVar,
      includeBasePath,
      includeDirs,
      groupVar,
      excludeFn
    } = options;
    buildPushFile(filters, onlyCountsVar);
    pushDir = includeDirs ? fns.pushDir : fns.empty;
    joinPath = includeBasePath ? fns.joinPathWithBasePath : fns.joinPath;
    walkDir = excludeFn ? fns.walkDirExclude(excludeFn) : fns.walkDir;
    groupFiles = groupVar ? fns.groupFiles : fns.empty;
    getArray = groupVar ? fns.getArrayGroup : fns.getArray;
    buildCallbackInvoker(onlyCountsVar, isSync);
  }
  module2.exports = {buildFunctions, init, walkSingleDir, readdirOpts};
  function buildPushFile(filters, onlyCountsVar) {
    if (filters.length && onlyCountsVar) {
      pushFile = fns.pushFileFilterAndCount(filters);
    } else if (filters.length) {
      pushFile = fns.pushFileFilter(filters);
    } else if (onlyCountsVar) {
      pushFile = fns.pushFileCount;
    } else {
      pushFile = fns.pushFile;
    }
  }
  function buildCallbackInvoker(onlyCountsVar, isSync) {
    if (onlyCountsVar) {
      callbackInvoker = isSync ? fns.callbackInvokerOnlyCountsSync : fns.callbackInvokerOnlyCountsAsync;
    } else {
      callbackInvoker = isSync ? fns.callbackInvokerDefaultSync : fns.callbackInvokerDefaultAsync;
    }
  }
  var pushFile = fns.empty;
  var pushDir = fns.empty;
  var walkDir = fns.empty;
  var joinPath = fns.empty;
  var groupFiles = fns.empty;
  var callbackInvoker = fns.empty;
  var getArray = fns.empty;
});

// vendor/fdir/api/async.js
var require_async = __commonJS((exports2, module2) => {
  var {readdir} = require_fs();
  var {init, walkSingleDir, readdirOpts} = require_shared();
  function promise(dir, options) {
    return new Promise((resolve2, reject) => {
      callback(dir, options, (err, output) => {
        if (err)
          return reject(err);
        resolve2(output);
      });
    });
  }
  function callback(dirPath, options, callback2) {
    const {state, callbackInvoker, dir} = init(dirPath, options, callback2);
    walk(state, dir, options.maxDepth, callbackInvoker);
  }
  function walk(state, dir, currentDepth, callback2) {
    if (currentDepth < 0) {
      --state.queue;
      return;
    }
    readdir(dir, readdirOpts, function(error, dirents) {
      if (error) {
        --state.queue;
        callback2(error, state);
        return;
      }
      walkSingleDir(walk, state, dir, dirents, currentDepth, callback2);
      if (--state.queue < 0)
        callback2(null, state);
    });
  }
  module2.exports = {promise, callback};
});

// vendor/fdir/api/sync.js
var require_sync = __commonJS((exports2, module2) => {
  var {readdirSync} = require_fs();
  var {init, walkSingleDir, readdirOpts} = require_shared();
  function sync(dirPath, options) {
    const {state, callbackInvoker, dir} = init(dirPath, options, null, true);
    walk(state, dir, options.maxDepth);
    return callbackInvoker(state);
  }
  function walk(state, dir, currentDepth) {
    if (currentDepth < 0) {
      return;
    }
    try {
      const dirents = readdirSync(dir, readdirOpts);
      walkSingleDir(walk, state, dir, dirents, currentDepth);
    } catch (e) {
      if (!state.options.suppressErrors)
        throw e;
    }
  }
  module2.exports = sync;
});

// vendor/fdir/builder/apiBuilder.js
var require_apiBuilder = __commonJS((exports2, module2) => {
  var {promise, callback} = require_async();
  var sync = require_sync();
  function APIBuilder(path, options) {
    this.dir = path;
    this.options = options;
  }
  APIBuilder.prototype.withPromise = function() {
    return promise(this.dir, this.options);
  };
  APIBuilder.prototype.withCallback = function(cb) {
    callback(this.dir, this.options, cb);
  };
  APIBuilder.prototype.sync = function() {
    return sync(this.dir, this.options);
  };
  module2.exports = APIBuilder;
});

// vendor/fdir/builder/index.js
var require_builder = __commonJS((exports2, module2) => {
  var APIBuilder = require_apiBuilder();
  var pm = require_picomatch2();
  var globCache = {};
  function Builder2() {
    this.maxDepth = Infinity;
    this.suppressErrors = true;
    this.filters = [];
  }
  Builder2.prototype.crawl = function(path) {
    return new APIBuilder(path, this);
  };
  Builder2.prototype.crawlWithOptions = function(path, options) {
    if (!options.maxDepth)
      options.maxDepth = Infinity;
    options.groupVar = options.group;
    options.onlyCountsVar = options.onlyCounts;
    options.excludeFn = options.exclude;
    options.filters = options.filters || [];
    return new APIBuilder(path, options);
  };
  Builder2.prototype.withBasePath = function() {
    this.includeBasePath = true;
    return this;
  };
  Builder2.prototype.withDirs = function() {
    this.includeDirs = true;
    return this;
  };
  Builder2.prototype.withMaxDepth = function(depth) {
    this.maxDepth = depth;
    return this;
  };
  Builder2.prototype.withFullPaths = function() {
    this.resolvePaths = true;
    this.includeBasePath = true;
    return this;
  };
  Builder2.prototype.withErrors = function() {
    this.suppressErrors = false;
    return this;
  };
  Builder2.prototype.group = function() {
    this.groupVar = true;
    return this;
  };
  Builder2.prototype.normalize = function() {
    this.normalizePath = true;
    return this;
  };
  Builder2.prototype.filter = function(filterFn) {
    this.filters.push(filterFn);
    return this;
  };
  Builder2.prototype.glob = function(...patterns) {
    if (!pm) {
      throw new Error(`Please install picomatch: "npm i picomatch" to use glob matching.`);
    }
    var isMatch = globCache[patterns.join()];
    if (!isMatch) {
      isMatch = pm(patterns, {dot: true});
      globCache[patterns.join()] = isMatch;
    }
    this.filters.push((path) => isMatch(path));
    return this;
  };
  Builder2.prototype.exclude = function(excludeFn) {
    this.excludeFn = excludeFn;
    return this;
  };
  Builder2.prototype.onlyCounts = function() {
    this.onlyCountsVar = true;
    return this;
  };
  module2.exports = Builder2;
});

// vendor/fdir/index.js
var require_fdir = __commonJS((exports2, module2) => {
  module2.exports.fdir = require_builder();
});

// node_modules/inherits/inherits_browser.js
var require_inherits_browser = __commonJS((exports2, module2) => {
  if (typeof Object.create === "function") {
    module2.exports = function inherits(ctor, superCtor) {
      if (superCtor) {
        ctor.super_ = superCtor;
        ctor.prototype = Object.create(superCtor.prototype, {
          constructor: {
            value: ctor,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
      }
    };
  } else {
    module2.exports = function inherits(ctor, superCtor) {
      if (superCtor) {
        ctor.super_ = superCtor;
        var TempCtor = function() {
        };
        TempCtor.prototype = superCtor.prototype;
        ctor.prototype = new TempCtor();
        ctor.prototype.constructor = ctor;
      }
    };
  }
});

// node_modules/inherits/inherits.js
var require_inherits = __commonJS((exports2, module2) => {
  try {
    util = require("util");
    if (typeof util.inherits !== "function")
      throw "";
    module2.exports = util.inherits;
  } catch (e) {
    module2.exports = require_inherits_browser();
  }
  var util;
});

// node_modules/queue/index.js
var require_queue = __commonJS((exports2, module2) => {
  var inherits = require_inherits();
  var EventEmitter3 = require("events").EventEmitter;
  module2.exports = Queue;
  module2.exports.default = Queue;
  function Queue(options) {
    if (!(this instanceof Queue)) {
      return new Queue(options);
    }
    EventEmitter3.call(this);
    options = options || {};
    this.concurrency = options.concurrency || Infinity;
    this.timeout = options.timeout || 0;
    this.autostart = options.autostart || false;
    this.results = options.results || null;
    this.pending = 0;
    this.session = 0;
    this.running = false;
    this.jobs = [];
    this.timers = {};
  }
  inherits(Queue, EventEmitter3);
  var arrayMethods = [
    "pop",
    "shift",
    "indexOf",
    "lastIndexOf"
  ];
  arrayMethods.forEach(function(method) {
    Queue.prototype[method] = function() {
      return Array.prototype[method].apply(this.jobs, arguments);
    };
  });
  Queue.prototype.slice = function(begin, end) {
    this.jobs = this.jobs.slice(begin, end);
    return this;
  };
  Queue.prototype.reverse = function() {
    this.jobs.reverse();
    return this;
  };
  var arrayAddMethods = [
    "push",
    "unshift",
    "splice"
  ];
  arrayAddMethods.forEach(function(method) {
    Queue.prototype[method] = function() {
      var methodResult = Array.prototype[method].apply(this.jobs, arguments);
      if (this.autostart) {
        this.start();
      }
      return methodResult;
    };
  });
  Object.defineProperty(Queue.prototype, "length", {
    get: function() {
      return this.pending + this.jobs.length;
    }
  });
  Queue.prototype.start = function(cb) {
    if (cb) {
      callOnErrorOrEnd.call(this, cb);
    }
    this.running = true;
    if (this.pending >= this.concurrency) {
      return;
    }
    if (this.jobs.length === 0) {
      if (this.pending === 0) {
        done.call(this);
      }
      return;
    }
    var self2 = this;
    var job = this.jobs.shift();
    var once = true;
    var session = this.session;
    var timeoutId = null;
    var didTimeout = false;
    var resultIndex = null;
    var timeout = job.hasOwnProperty("timeout") ? job.timeout : this.timeout;
    function next(err, result) {
      if (once && self2.session === session) {
        once = false;
        self2.pending--;
        if (timeoutId !== null) {
          delete self2.timers[timeoutId];
          clearTimeout(timeoutId);
        }
        if (err) {
          self2.emit("error", err, job);
        } else if (didTimeout === false) {
          if (resultIndex !== null) {
            self2.results[resultIndex] = Array.prototype.slice.call(arguments, 1);
          }
          self2.emit("success", result, job);
        }
        if (self2.session === session) {
          if (self2.pending === 0 && self2.jobs.length === 0) {
            done.call(self2);
          } else if (self2.running) {
            self2.start();
          }
        }
      }
    }
    if (timeout) {
      timeoutId = setTimeout(function() {
        didTimeout = true;
        if (self2.listeners("timeout").length > 0) {
          self2.emit("timeout", next, job);
        } else {
          next();
        }
      }, timeout);
      this.timers[timeoutId] = timeoutId;
    }
    if (this.results) {
      resultIndex = this.results.length;
      this.results[resultIndex] = null;
    }
    this.pending++;
    self2.emit("start", job);
    var promise = job(next);
    if (promise && promise.then && typeof promise.then === "function") {
      promise.then(function(result) {
        return next(null, result);
      }).catch(function(err) {
        return next(err || true);
      });
    }
    if (this.running && this.jobs.length > 0) {
      this.start();
    }
  };
  Queue.prototype.stop = function() {
    this.running = false;
  };
  Queue.prototype.end = function(err) {
    clearTimers.call(this);
    this.jobs.length = 0;
    this.pending = 0;
    done.call(this, err);
  };
  function clearTimers() {
    for (var key in this.timers) {
      var timeoutId = this.timers[key];
      delete this.timers[key];
      clearTimeout(timeoutId);
    }
  }
  function callOnErrorOrEnd(cb) {
    var self2 = this;
    this.on("error", onerror);
    this.on("end", onend);
    function onerror(err) {
      self2.end(err);
    }
    function onend(err) {
      self2.removeListener("error", onerror);
      self2.removeListener("end", onend);
      cb(err, this.results);
    }
  }
  function done(err) {
    this.session++;
    this.running = false;
    this.emit("end", err);
  }
});

// node_modules/image-size/dist/types/bmp.js
var require_bmp = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.BMP = void 0;
  exports2.BMP = {
    validate(buffer) {
      return buffer.toString("ascii", 0, 2) === "BM";
    },
    calculate(buffer) {
      return {
        height: Math.abs(buffer.readInt32LE(22)),
        width: buffer.readUInt32LE(18)
      };
    }
  };
});

// node_modules/image-size/dist/types/ico.js
var require_ico = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.ICO = void 0;
  var TYPE_ICON = 1;
  var SIZE_HEADER = 2 + 2 + 2;
  var SIZE_IMAGE_ENTRY = 1 + 1 + 1 + 1 + 2 + 2 + 4 + 4;
  function getSizeFromOffset(buffer, offset) {
    const value = buffer.readUInt8(offset);
    return value === 0 ? 256 : value;
  }
  function getImageSize(buffer, imageIndex) {
    const offset = SIZE_HEADER + imageIndex * SIZE_IMAGE_ENTRY;
    return {
      height: getSizeFromOffset(buffer, offset + 1),
      width: getSizeFromOffset(buffer, offset)
    };
  }
  exports2.ICO = {
    validate(buffer) {
      if (buffer.readUInt16LE(0) !== 0) {
        return false;
      }
      return buffer.readUInt16LE(2) === TYPE_ICON;
    },
    calculate(buffer) {
      const nbImages = buffer.readUInt16LE(4);
      const imageSize = getImageSize(buffer, 0);
      if (nbImages === 1) {
        return imageSize;
      }
      const imgs = [imageSize];
      for (let imageIndex = 1; imageIndex < nbImages; imageIndex += 1) {
        imgs.push(getImageSize(buffer, imageIndex));
      }
      const result = {
        height: imageSize.height,
        images: imgs,
        width: imageSize.width
      };
      return result;
    }
  };
});

// node_modules/image-size/dist/types/cur.js
var require_cur = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.CUR = void 0;
  var ico_1 = require_ico();
  var TYPE_CURSOR = 2;
  exports2.CUR = {
    validate(buffer) {
      if (buffer.readUInt16LE(0) !== 0) {
        return false;
      }
      return buffer.readUInt16LE(2) === TYPE_CURSOR;
    },
    calculate(buffer) {
      return ico_1.ICO.calculate(buffer);
    }
  };
});

// node_modules/image-size/dist/types/dds.js
var require_dds = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.DDS = void 0;
  exports2.DDS = {
    validate(buffer) {
      return buffer.readUInt32LE(0) === 542327876;
    },
    calculate(buffer) {
      return {
        height: buffer.readUInt32LE(12),
        width: buffer.readUInt32LE(16)
      };
    }
  };
});

// node_modules/image-size/dist/types/gif.js
var require_gif = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.GIF = void 0;
  var gifRegexp = /^GIF8[79]a/;
  exports2.GIF = {
    validate(buffer) {
      const signature = buffer.toString("ascii", 0, 6);
      return gifRegexp.test(signature);
    },
    calculate(buffer) {
      return {
        height: buffer.readUInt16LE(8),
        width: buffer.readUInt16LE(6)
      };
    }
  };
});

// node_modules/image-size/dist/types/icns.js
var require_icns = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.ICNS = void 0;
  var SIZE_HEADER = 4 + 4;
  var FILE_LENGTH_OFFSET = 4;
  var ENTRY_LENGTH_OFFSET = 4;
  var ICON_TYPE_SIZE = {
    ICON: 32,
    "ICN#": 32,
    "icm#": 16,
    icm4: 16,
    icm8: 16,
    "ics#": 16,
    ics4: 16,
    ics8: 16,
    is32: 16,
    s8mk: 16,
    icp4: 16,
    icl4: 32,
    icl8: 32,
    il32: 32,
    l8mk: 32,
    icp5: 32,
    ic11: 32,
    ich4: 48,
    ich8: 48,
    ih32: 48,
    h8mk: 48,
    icp6: 64,
    ic12: 32,
    it32: 128,
    t8mk: 128,
    ic07: 128,
    ic08: 256,
    ic13: 256,
    ic09: 512,
    ic14: 512,
    ic10: 1024
  };
  function readImageHeader(buffer, imageOffset) {
    const imageLengthOffset = imageOffset + ENTRY_LENGTH_OFFSET;
    return [
      buffer.toString("ascii", imageOffset, imageLengthOffset),
      buffer.readUInt32BE(imageLengthOffset)
    ];
  }
  function getImageSize(type) {
    const size = ICON_TYPE_SIZE[type];
    return {width: size, height: size, type};
  }
  exports2.ICNS = {
    validate(buffer) {
      return buffer.toString("ascii", 0, 4) === "icns";
    },
    calculate(buffer) {
      const bufferLength = buffer.length;
      const fileLength = buffer.readUInt32BE(FILE_LENGTH_OFFSET);
      let imageOffset = SIZE_HEADER;
      let imageHeader = readImageHeader(buffer, imageOffset);
      let imageSize = getImageSize(imageHeader[0]);
      imageOffset += imageHeader[1];
      if (imageOffset === fileLength) {
        return imageSize;
      }
      const result = {
        height: imageSize.height,
        images: [imageSize],
        width: imageSize.width
      };
      while (imageOffset < fileLength && imageOffset < bufferLength) {
        imageHeader = readImageHeader(buffer, imageOffset);
        imageSize = getImageSize(imageHeader[0]);
        imageOffset += imageHeader[1];
        result.images.push(imageSize);
      }
      return result;
    }
  };
});

// node_modules/image-size/dist/types/j2c.js
var require_j2c = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.J2C = void 0;
  exports2.J2C = {
    validate(buffer) {
      return buffer.toString("hex", 0, 4) === "ff4fff51";
    },
    calculate(buffer) {
      return {
        height: buffer.readUInt32BE(12),
        width: buffer.readUInt32BE(8)
      };
    }
  };
});

// node_modules/image-size/dist/types/jp2.js
var require_jp2 = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.JP2 = void 0;
  var BoxTypes = {
    ftyp: "66747970",
    ihdr: "69686472",
    jp2h: "6a703268",
    jp__: "6a502020",
    rreq: "72726571",
    xml_: "786d6c20"
  };
  var calculateRREQLength = (box) => {
    const unit = box.readUInt8(0);
    let offset = 1 + 2 * unit;
    const numStdFlags = box.readUInt16BE(offset);
    const flagsLength = numStdFlags * (2 + unit);
    offset = offset + 2 + flagsLength;
    const numVendorFeatures = box.readUInt16BE(offset);
    const featuresLength = numVendorFeatures * (16 + unit);
    return offset + 2 + featuresLength;
  };
  var parseIHDR = (box) => {
    return {
      height: box.readUInt32BE(4),
      width: box.readUInt32BE(8)
    };
  };
  exports2.JP2 = {
    validate(buffer) {
      const signature = buffer.toString("hex", 4, 8);
      const signatureLength = buffer.readUInt32BE(0);
      if (signature !== BoxTypes.jp__ || signatureLength < 1) {
        return false;
      }
      const ftypeBoxStart = signatureLength + 4;
      const ftypBoxLength = buffer.readUInt32BE(signatureLength);
      const ftypBox = buffer.slice(ftypeBoxStart, ftypeBoxStart + ftypBoxLength);
      return ftypBox.toString("hex", 0, 4) === BoxTypes.ftyp;
    },
    calculate(buffer) {
      const signatureLength = buffer.readUInt32BE(0);
      const ftypBoxLength = buffer.readUInt16BE(signatureLength + 2);
      let offset = signatureLength + 4 + ftypBoxLength;
      const nextBoxType = buffer.toString("hex", offset, offset + 4);
      switch (nextBoxType) {
        case BoxTypes.rreq:
          const MAGIC = 4;
          offset = offset + 4 + MAGIC + calculateRREQLength(buffer.slice(offset + 4));
          return parseIHDR(buffer.slice(offset + 8, offset + 24));
        case BoxTypes.jp2h:
          return parseIHDR(buffer.slice(offset + 8, offset + 24));
        default:
          throw new TypeError("Unsupported header found: " + buffer.toString("ascii", offset, offset + 4));
      }
    }
  };
});

// node_modules/image-size/dist/readUInt.js
var require_readUInt = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.readUInt = void 0;
  function readUInt(buffer, bits, offset, isBigEndian) {
    offset = offset || 0;
    const endian = isBigEndian ? "BE" : "LE";
    const methodName = "readUInt" + bits + endian;
    return buffer[methodName].call(buffer, offset);
  }
  exports2.readUInt = readUInt;
});

// node_modules/image-size/dist/types/jpg.js
var require_jpg = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.JPG = void 0;
  var readUInt_1 = require_readUInt();
  var EXIF_MARKER = "45786966";
  var APP1_DATA_SIZE_BYTES = 2;
  var EXIF_HEADER_BYTES = 6;
  var TIFF_BYTE_ALIGN_BYTES = 2;
  var BIG_ENDIAN_BYTE_ALIGN = "4d4d";
  var LITTLE_ENDIAN_BYTE_ALIGN = "4949";
  var IDF_ENTRY_BYTES = 12;
  var NUM_DIRECTORY_ENTRIES_BYTES = 2;
  function isEXIF(buffer) {
    return buffer.toString("hex", 2, 6) === EXIF_MARKER;
  }
  function extractSize(buffer, index) {
    return {
      height: buffer.readUInt16BE(index),
      width: buffer.readUInt16BE(index + 2)
    };
  }
  function extractOrientation(exifBlock, isBigEndian) {
    const idfOffset = 8;
    const offset = EXIF_HEADER_BYTES + idfOffset;
    const idfDirectoryEntries = readUInt_1.readUInt(exifBlock, 16, offset, isBigEndian);
    for (let directoryEntryNumber = 0; directoryEntryNumber < idfDirectoryEntries; directoryEntryNumber++) {
      const start = offset + NUM_DIRECTORY_ENTRIES_BYTES + directoryEntryNumber * IDF_ENTRY_BYTES;
      const end = start + IDF_ENTRY_BYTES;
      if (start > exifBlock.length) {
        return;
      }
      const block = exifBlock.slice(start, end);
      const tagNumber = readUInt_1.readUInt(block, 16, 0, isBigEndian);
      if (tagNumber === 274) {
        const dataFormat = readUInt_1.readUInt(block, 16, 2, isBigEndian);
        if (dataFormat !== 3) {
          return;
        }
        const numberOfComponents = readUInt_1.readUInt(block, 32, 4, isBigEndian);
        if (numberOfComponents !== 1) {
          return;
        }
        return readUInt_1.readUInt(block, 16, 8, isBigEndian);
      }
    }
  }
  function validateExifBlock(buffer, index) {
    const exifBlock = buffer.slice(APP1_DATA_SIZE_BYTES, index);
    const byteAlign = exifBlock.toString("hex", EXIF_HEADER_BYTES, EXIF_HEADER_BYTES + TIFF_BYTE_ALIGN_BYTES);
    const isBigEndian = byteAlign === BIG_ENDIAN_BYTE_ALIGN;
    const isLittleEndian = byteAlign === LITTLE_ENDIAN_BYTE_ALIGN;
    if (isBigEndian || isLittleEndian) {
      return extractOrientation(exifBlock, isBigEndian);
    }
  }
  function validateBuffer(buffer, index) {
    if (index > buffer.length) {
      throw new TypeError("Corrupt JPG, exceeded buffer limits");
    }
    if (buffer[index] !== 255) {
      throw new TypeError("Invalid JPG, marker table corrupted");
    }
  }
  exports2.JPG = {
    validate(buffer) {
      const SOIMarker = buffer.toString("hex", 0, 2);
      return SOIMarker === "ffd8";
    },
    calculate(buffer) {
      buffer = buffer.slice(4);
      let orientation;
      let next;
      while (buffer.length) {
        const i = buffer.readUInt16BE(0);
        if (isEXIF(buffer)) {
          orientation = validateExifBlock(buffer, i);
        }
        validateBuffer(buffer, i);
        next = buffer[i + 1];
        if (next === 192 || next === 193 || next === 194) {
          const size = extractSize(buffer, i + 5);
          if (!orientation) {
            return size;
          }
          return {
            height: size.height,
            orientation,
            width: size.width
          };
        }
        buffer = buffer.slice(i + 2);
      }
      throw new TypeError("Invalid JPG, no size found");
    }
  };
});

// node_modules/image-size/dist/types/ktx.js
var require_ktx = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.KTX = void 0;
  var SIGNATURE = "KTX 11";
  exports2.KTX = {
    validate(buffer) {
      return SIGNATURE === buffer.toString("ascii", 1, 7);
    },
    calculate(buffer) {
      return {
        height: buffer.readUInt32LE(40),
        width: buffer.readUInt32LE(36)
      };
    }
  };
});

// node_modules/image-size/dist/types/png.js
var require_png = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.PNG = void 0;
  var pngSignature = "PNG\r\n\n";
  var pngImageHeaderChunkName = "IHDR";
  var pngFriedChunkName = "CgBI";
  exports2.PNG = {
    validate(buffer) {
      if (pngSignature === buffer.toString("ascii", 1, 8)) {
        let chunkName = buffer.toString("ascii", 12, 16);
        if (chunkName === pngFriedChunkName) {
          chunkName = buffer.toString("ascii", 28, 32);
        }
        if (chunkName !== pngImageHeaderChunkName) {
          throw new TypeError("Invalid PNG");
        }
        return true;
      }
      return false;
    },
    calculate(buffer) {
      if (buffer.toString("ascii", 12, 16) === pngFriedChunkName) {
        return {
          height: buffer.readUInt32BE(36),
          width: buffer.readUInt32BE(32)
        };
      }
      return {
        height: buffer.readUInt32BE(20),
        width: buffer.readUInt32BE(16)
      };
    }
  };
});

// node_modules/image-size/dist/types/pnm.js
var require_pnm = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.PNM = void 0;
  var PNMTypes = {
    P1: "pbm/ascii",
    P2: "pgm/ascii",
    P3: "ppm/ascii",
    P4: "pbm",
    P5: "pgm",
    P6: "ppm",
    P7: "pam",
    PF: "pfm"
  };
  var Signatures = Object.keys(PNMTypes);
  var handlers = {
    default: (lines) => {
      let dimensions = [];
      while (lines.length > 0) {
        const line = lines.shift();
        if (line[0] === "#") {
          continue;
        }
        dimensions = line.split(" ");
        break;
      }
      if (dimensions.length === 2) {
        return {
          height: parseInt(dimensions[1], 10),
          width: parseInt(dimensions[0], 10)
        };
      } else {
        throw new TypeError("Invalid PNM");
      }
    },
    pam: (lines) => {
      const size = {};
      while (lines.length > 0) {
        const line = lines.shift();
        if (line.length > 16 || line.charCodeAt(0) > 128) {
          continue;
        }
        const [key, value] = line.split(" ");
        if (key && value) {
          size[key.toLowerCase()] = parseInt(value, 10);
        }
        if (size.height && size.width) {
          break;
        }
      }
      if (size.height && size.width) {
        return {
          height: size.height,
          width: size.width
        };
      } else {
        throw new TypeError("Invalid PAM");
      }
    }
  };
  exports2.PNM = {
    validate(buffer) {
      const signature = buffer.toString("ascii", 0, 2);
      return Signatures.includes(signature);
    },
    calculate(buffer) {
      const signature = buffer.toString("ascii", 0, 2);
      const type = PNMTypes[signature];
      const lines = buffer.toString("ascii", 3).split(/[\r\n]+/);
      const handler = handlers[type] || handlers.default;
      return handler(lines);
    }
  };
});

// node_modules/image-size/dist/types/psd.js
var require_psd = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.PSD = void 0;
  exports2.PSD = {
    validate(buffer) {
      return buffer.toString("ascii", 0, 4) === "8BPS";
    },
    calculate(buffer) {
      return {
        height: buffer.readUInt32BE(14),
        width: buffer.readUInt32BE(18)
      };
    }
  };
});

// node_modules/image-size/dist/types/svg.js
var require_svg = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.SVG = void 0;
  var svgReg = /<svg\s([^>"']|"[^"]*"|'[^']*')*>/;
  var extractorRegExps = {
    height: /\sheight=(['"])([^%]+?)\1/,
    root: svgReg,
    viewbox: /\sviewBox=(['"])(.+?)\1/i,
    width: /\swidth=(['"])([^%]+?)\1/
  };
  var INCH_CM = 2.54;
  var units = {
    in: 96,
    cm: 96 / INCH_CM,
    em: 16,
    ex: 8,
    m: 96 / INCH_CM * 100,
    mm: 96 / INCH_CM / 10,
    pc: 96 / 72 / 12,
    pt: 96 / 72,
    px: 1
  };
  var unitsReg = new RegExp(`^([0-9.]+(?:e\\d+)?)(${Object.keys(units).join("|")})?$`);
  function parseLength(len) {
    const m = unitsReg.exec(len);
    if (!m) {
      return void 0;
    }
    return Math.round(Number(m[1]) * (units[m[2]] || 1));
  }
  function parseViewbox(viewbox) {
    const bounds = viewbox.split(" ");
    return {
      height: parseLength(bounds[3]),
      width: parseLength(bounds[2])
    };
  }
  function parseAttributes(root) {
    const width = root.match(extractorRegExps.width);
    const height = root.match(extractorRegExps.height);
    const viewbox = root.match(extractorRegExps.viewbox);
    return {
      height: height && parseLength(height[2]),
      viewbox: viewbox && parseViewbox(viewbox[2]),
      width: width && parseLength(width[2])
    };
  }
  function calculateByDimensions(attrs) {
    return {
      height: attrs.height,
      width: attrs.width
    };
  }
  function calculateByViewbox(attrs, viewbox) {
    const ratio = viewbox.width / viewbox.height;
    if (attrs.width) {
      return {
        height: Math.floor(attrs.width / ratio),
        width: attrs.width
      };
    }
    if (attrs.height) {
      return {
        height: attrs.height,
        width: Math.floor(attrs.height * ratio)
      };
    }
    return {
      height: viewbox.height,
      width: viewbox.width
    };
  }
  exports2.SVG = {
    validate(buffer) {
      const str = String(buffer);
      return svgReg.test(str);
    },
    calculate(buffer) {
      const root = buffer.toString("utf8").match(extractorRegExps.root);
      if (root) {
        const attrs = parseAttributes(root[0]);
        if (attrs.width && attrs.height) {
          return calculateByDimensions(attrs);
        }
        if (attrs.viewbox) {
          return calculateByViewbox(attrs, attrs.viewbox);
        }
      }
      throw new TypeError("Invalid SVG");
    }
  };
});

// node_modules/image-size/dist/types/tiff.js
var require_tiff = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.TIFF = void 0;
  var fs = require("fs");
  var readUInt_1 = require_readUInt();
  function readIFD(buffer, filepath, isBigEndian) {
    const ifdOffset = readUInt_1.readUInt(buffer, 32, 4, isBigEndian);
    let bufferSize = 1024;
    const fileSize = fs.statSync(filepath).size;
    if (ifdOffset + bufferSize > fileSize) {
      bufferSize = fileSize - ifdOffset - 10;
    }
    const endBuffer = Buffer.alloc(bufferSize);
    const descriptor = fs.openSync(filepath, "r");
    fs.readSync(descriptor, endBuffer, 0, bufferSize, ifdOffset);
    fs.closeSync(descriptor);
    return endBuffer.slice(2);
  }
  function readValue(buffer, isBigEndian) {
    const low = readUInt_1.readUInt(buffer, 16, 8, isBigEndian);
    const high = readUInt_1.readUInt(buffer, 16, 10, isBigEndian);
    return (high << 16) + low;
  }
  function nextTag(buffer) {
    if (buffer.length > 24) {
      return buffer.slice(12);
    }
  }
  function extractTags(buffer, isBigEndian) {
    const tags = {};
    let temp = buffer;
    while (temp && temp.length) {
      const code = readUInt_1.readUInt(temp, 16, 0, isBigEndian);
      const type = readUInt_1.readUInt(temp, 16, 2, isBigEndian);
      const length = readUInt_1.readUInt(temp, 32, 4, isBigEndian);
      if (code === 0) {
        break;
      } else {
        if (length === 1 && (type === 3 || type === 4)) {
          tags[code] = readValue(temp, isBigEndian);
        }
        temp = nextTag(temp);
      }
    }
    return tags;
  }
  function determineEndianness(buffer) {
    const signature = buffer.toString("ascii", 0, 2);
    if (signature === "II") {
      return "LE";
    } else if (signature === "MM") {
      return "BE";
    }
  }
  var signatures = [
    "49492a00",
    "4d4d002a"
  ];
  exports2.TIFF = {
    validate(buffer) {
      return signatures.includes(buffer.toString("hex", 0, 4));
    },
    calculate(buffer, filepath) {
      if (!filepath) {
        throw new TypeError("Tiff doesn't support buffer");
      }
      const isBigEndian = determineEndianness(buffer) === "BE";
      const ifdBuffer = readIFD(buffer, filepath, isBigEndian);
      const tags = extractTags(ifdBuffer, isBigEndian);
      const width = tags[256];
      const height = tags[257];
      if (!width || !height) {
        throw new TypeError("Invalid Tiff. Missing tags");
      }
      return {height, width};
    }
  };
});

// node_modules/image-size/dist/types/webp.js
var require_webp = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.WEBP = void 0;
  function calculateExtended(buffer) {
    return {
      height: 1 + buffer.readUIntLE(7, 3),
      width: 1 + buffer.readUIntLE(4, 3)
    };
  }
  function calculateLossless(buffer) {
    return {
      height: 1 + ((buffer[4] & 15) << 10 | buffer[3] << 2 | (buffer[2] & 192) >> 6),
      width: 1 + ((buffer[2] & 63) << 8 | buffer[1])
    };
  }
  function calculateLossy(buffer) {
    return {
      height: buffer.readInt16LE(8) & 16383,
      width: buffer.readInt16LE(6) & 16383
    };
  }
  exports2.WEBP = {
    validate(buffer) {
      const riffHeader = buffer.toString("ascii", 0, 4) === "RIFF";
      const webpHeader = buffer.toString("ascii", 8, 12) === "WEBP";
      const vp8Header = buffer.toString("ascii", 12, 15) === "VP8";
      return riffHeader && webpHeader && vp8Header;
    },
    calculate(buffer) {
      const chunkHeader = buffer.toString("ascii", 12, 16);
      buffer = buffer.slice(20, 30);
      if (chunkHeader === "VP8X") {
        const extendedHeader = buffer[0];
        const validStart = (extendedHeader & 192) === 0;
        const validEnd = (extendedHeader & 1) === 0;
        if (validStart && validEnd) {
          return calculateExtended(buffer);
        } else {
          throw new TypeError("Invalid WebP");
        }
      }
      if (chunkHeader === "VP8 " && buffer[0] !== 47) {
        return calculateLossy(buffer);
      }
      const signature = buffer.toString("hex", 3, 6);
      if (chunkHeader === "VP8L" && signature !== "9d012a") {
        return calculateLossless(buffer);
      }
      throw new TypeError("Invalid WebP");
    }
  };
});

// node_modules/image-size/dist/types.js
var require_types = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.typeHandlers = void 0;
  var bmp_1 = require_bmp();
  var cur_1 = require_cur();
  var dds_1 = require_dds();
  var gif_1 = require_gif();
  var icns_1 = require_icns();
  var ico_1 = require_ico();
  var j2c_1 = require_j2c();
  var jp2_1 = require_jp2();
  var jpg_1 = require_jpg();
  var ktx_1 = require_ktx();
  var png_1 = require_png();
  var pnm_1 = require_pnm();
  var psd_1 = require_psd();
  var svg_1 = require_svg();
  var tiff_1 = require_tiff();
  var webp_1 = require_webp();
  exports2.typeHandlers = {
    bmp: bmp_1.BMP,
    cur: cur_1.CUR,
    dds: dds_1.DDS,
    gif: gif_1.GIF,
    icns: icns_1.ICNS,
    ico: ico_1.ICO,
    j2c: j2c_1.J2C,
    jp2: jp2_1.JP2,
    jpg: jpg_1.JPG,
    ktx: ktx_1.KTX,
    png: png_1.PNG,
    pnm: pnm_1.PNM,
    psd: psd_1.PSD,
    svg: svg_1.SVG,
    tiff: tiff_1.TIFF,
    webp: webp_1.WEBP
  };
});

// node_modules/image-size/dist/detector.js
var require_detector = __commonJS((exports2) => {
  "use strict";
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.detector = void 0;
  var types_1 = require_types();
  var keys = Object.keys(types_1.typeHandlers);
  var firstBytes = {
    56: "psd",
    66: "bmp",
    68: "dds",
    71: "gif",
    73: "tiff",
    77: "tiff",
    82: "webp",
    105: "icns",
    137: "png",
    255: "jpg"
  };
  function detector(buffer) {
    const byte = buffer[0];
    if (byte in firstBytes) {
      const type = firstBytes[byte];
      if (type && types_1.typeHandlers[type].validate(buffer)) {
        return type;
      }
    }
    const finder = (key) => types_1.typeHandlers[key].validate(buffer);
    return keys.find(finder);
  }
  exports2.detector = detector;
});

// node_modules/image-size/dist/index.js
var require_dist = __commonJS((exports2, module2) => {
  "use strict";
  var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
    function adopt(value) {
      return value instanceof P ? value : new P(function(resolve2) {
        resolve2(value);
      });
    }
    return new (P || (P = Promise))(function(resolve2, reject) {
      function fulfilled(value) {
        try {
          step(generator.next(value));
        } catch (e) {
          reject(e);
        }
      }
      function rejected(value) {
        try {
          step(generator["throw"](value));
        } catch (e) {
          reject(e);
        }
      }
      function step(result) {
        result.done ? resolve2(result.value) : adopt(result.value).then(fulfilled, rejected);
      }
      step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
  };
  Object.defineProperty(exports2, "__esModule", {value: true});
  exports2.types = exports2.setConcurrency = exports2.disableTypes = exports2.disableFS = exports2.imageSize = void 0;
  var fs = require("fs");
  var path = require("path");
  var queue_1 = require_queue();
  var types_1 = require_types();
  var detector_1 = require_detector();
  var MaxBufferSize = 512 * 1024;
  var queue = new queue_1.default({concurrency: 100, autostart: true});
  var globalOptions = {
    disabledFS: false,
    disabledTypes: []
  };
  function lookup(buffer, filepath) {
    const type = detector_1.detector(buffer);
    if (typeof type !== "undefined") {
      if (globalOptions.disabledTypes.indexOf(type) > -1) {
        throw new TypeError("disabled file type: " + type);
      }
      if (type in types_1.typeHandlers) {
        const size = types_1.typeHandlers[type].calculate(buffer, filepath);
        if (size !== void 0) {
          size.type = type;
          return size;
        }
      }
    }
    throw new TypeError("unsupported file type: " + type + " (file: " + filepath + ")");
  }
  function asyncFileToBuffer(filepath) {
    return __awaiter(this, void 0, void 0, function* () {
      const handle = yield fs.promises.open(filepath, "r");
      const {size} = yield handle.stat();
      if (size <= 0) {
        yield handle.close();
        throw new Error("Empty file");
      }
      const bufferSize = Math.min(size, MaxBufferSize);
      const buffer = Buffer.alloc(bufferSize);
      yield handle.read(buffer, 0, bufferSize, 0);
      yield handle.close();
      return buffer;
    });
  }
  function syncFileToBuffer(filepath) {
    const descriptor = fs.openSync(filepath, "r");
    const {size} = fs.fstatSync(descriptor);
    if (size <= 0) {
      fs.closeSync(descriptor);
      throw new Error("Empty file");
    }
    const bufferSize = Math.min(size, MaxBufferSize);
    const buffer = Buffer.alloc(bufferSize);
    fs.readSync(descriptor, buffer, 0, bufferSize, 0);
    fs.closeSync(descriptor);
    return buffer;
  }
  module2.exports = exports2 = imageSize;
  exports2.default = imageSize;
  function imageSize(input, callback) {
    if (Buffer.isBuffer(input)) {
      return lookup(input);
    }
    if (typeof input !== "string" || globalOptions.disabledFS) {
      throw new TypeError("invalid invocation. input should be a Buffer");
    }
    const filepath = path.resolve(input);
    if (typeof callback === "function") {
      queue.push(() => asyncFileToBuffer(filepath).then((buffer) => process.nextTick(callback, null, lookup(buffer, filepath))).catch(callback));
    } else {
      const buffer = syncFileToBuffer(filepath);
      return lookup(buffer, filepath);
    }
  }
  exports2.imageSize = imageSize;
  var disableFS = (v) => {
    globalOptions.disabledFS = v;
  };
  exports2.disableFS = disableFS;
  var disableTypes = (types) => {
    globalOptions.disabledTypes = types;
  };
  exports2.disableTypes = disableTypes;
  var setConcurrency = (c) => {
    queue.concurrency = c;
  };
  exports2.setConcurrency = setConcurrency;
  exports2.types = Object.keys(types_1.typeHandlers);
});

// src/bundler/utils.imba
var require_utils4 = __commonJS((exports2) => {
  __markAsModule(exports2);
  __export(exports2, {
    Extensions: () => Extensions,
    FontRegex: () => FontRegex2,
    ImageRegex: () => ImageRegex2,
    builtInModules: () => builtInModules2,
    createHash: () => createHash3,
    defaultLoaders: () => defaultLoaders,
    diagnosticToESB: () => diagnosticToESB2,
    exists: () => exists,
    extendObject: () => extendObject2,
    getCacheDir: () => getCacheDir2,
    idGenerator: () => idGenerator,
    injectStringBefore: () => injectStringBefore2,
    normalizePath: () => normalizePath2,
    pluck: () => pluck2,
    readFile: () => readFile,
    relativePath: () => relativePath2,
    rename: () => rename,
    replaceAll: () => replaceAll2,
    resolveConfig: () => resolveConfig2,
    resolveFile: () => resolveFile,
    resolvePackage: () => resolvePackage2,
    resolvePath: () => resolvePath,
    writeFile: () => writeFile
  });
  var import_fs8 = __toModule(require("fs"));
  var import_path7 = __toModule(require("path"));
  var import_crypto2 = __toModule(require("crypto"));
  var import_os3 = __toModule(require("os"));
  function iter$__13(a) {
    let v;
    return a ? (v = a.toIterable) ? v.call(a) : a : [];
  }
  var φ39 = Symbol.for("#mtime");
  var φ45 = Symbol.for("#path");
  var defaultLoaders = {
    ".png": "file",
    ".svg": "file",
    ".woff2": "file",
    ".woff": "file",
    ".ttf": "file",
    ".otf": "file"
  };
  var Extensions = {
    ".png": "file",
    ".apng": "file",
    ".webp": "file",
    ".heif": "file",
    ".avif": "file",
    ".svg": "file",
    ".gif": "file",
    ".jpg": "file",
    ".jpeg": "file",
    ".ico": "file",
    ".woff2": "file",
    ".woff": "file",
    ".eot": "file",
    ".ttf": "file",
    ".otf": "file",
    ".html": "file"
  };
  var FontRegex2 = /\.(woff2?|eot|ttf|otf)$/;
  var ImageRegex2 = /\.(gif?|a?png|jpe?g|svg|avif|heif|webp|ico)$/;
  var builtInModules2 = {
    assert: true,
    async_hooks: true,
    buffer: true,
    child_process: true,
    cluster: true,
    console: true,
    constants: true,
    crypto: true,
    dgram: true,
    dns: true,
    domain: true,
    events: true,
    fs: true,
    "fs/promises": true,
    http: true,
    http2: true,
    https: true,
    inspector: true,
    module: true,
    net: true,
    os: true,
    path: true,
    perf_hooks: true,
    process: true,
    punycode: true,
    querystring: true,
    readline: true,
    repl: true,
    stream: true,
    string_decoder: true,
    sys: true,
    timers: true,
    tls: true,
    trace_events: true,
    tty: true,
    url: true,
    util: true,
    v8: true,
    vm: true,
    worker_threads: true,
    zlib: true
  };
  function getCacheDir2(options) {
    let dir = process.env.IMBA_CACHEDIR || import_path7.default.resolve(__dirname, "..", ".imba-cache");
    if (!import_fs8.default.existsSync(dir)) {
      console.log("cache dir does not exist - create", dir);
      import_fs8.default.mkdirSync(dir);
    }
    ;
    return dir;
  }
  function diagnosticToESB2(item, add = {}) {
    return {
      text: item.message,
      location: Object.assign({
        line: item.range.start.line + 1,
        column: item.range.start.character,
        length: item.range.end.offset - item.range.start.offset,
        lineText: item.lineText
      }, add)
    };
  }
  function normalizePath2(src) {
    return src.replace(/\/+/g, "/").replace(/\/\.\//g, "/");
  }
  function relativePath2(...parts) {
    return import_path7.default.relative(...parts).split("\\").join("/");
  }
  function writeFile(src, body) {
    return import_fs8.default.promises.writeFile(src, body);
  }
  function readFile(src, encoding = "utf8") {
    return import_fs8.default.promises.readFile(src, encoding);
  }
  function exists(src) {
    let p = import_fs8.default.promises.access(src, import_fs8.default.constants.F_OK);
    return p.then(function() {
      return true;
    }).catch(function() {
      return false;
    });
  }
  function rename(src, pattern) {
    let dir = import_path7.default.dirname(src);
    let ext = import_path7.default.extname(src);
    let name = import_path7.default.basename(src, ext);
    return import_path7.default.join(dir, pattern.replace("*", name));
    let parsed = import_path7.default.parse(src);
    if (typeof pattern == "string") {
      if (pattern[0] == ".") {
        return import_path7.default.join(dir, name + pattern);
        parsed.ext = pattern;
      } else if (pattern.indexOf("")) {
        parsed.name = pattern;
      }
      ;
    } else {
      Object.assign(parsed, pattern);
    }
    ;
    console.log("rename", parsed);
    return import_path7.default.format(parsed);
  }
  function pluck2(array, cb) {
    for (let i = 0, φ114 = iter$__13(array), φ28 = φ114.length; i < φ28; i++) {
      let item = φ114[i];
      if (cb(item)) {
        array.splice(i, 1);
        return item;
      }
      ;
    }
    ;
    return null;
  }
  function resolveConfig2(cwd, name) {
    try {
      let src = import_path7.default.resolve(cwd || ".", name || "imbaconfig.json");
      let config = JSON.parse(import_fs8.default.readFileSync(src, "utf8"));
      config[φ39] = import_fs8.default.statSync(src).mtimeMs || 0;
      config[φ45] = src;
      return resolve(config);
    } catch (e) {
      return resolve({});
    }
    ;
  }
  function extendObject2(obj, patch, path = []) {
    return merge(obj, patch, ...path);
  }
  function resolvePath(name, cwd = ".", cb = null) {
    let src = import_path7.default.resolve(cwd, name);
    let dir = import_path7.default.dirname(src);
    if (import_fs8.default.existsSync(src)) {
      return src;
    }
    ;
    let up = import_path7.default.dirname(dir);
    return up != dir ? resolvePath(name, up) : null;
  }
  function resolveFile(name, cwd, handler) {
    let src;
    if (src = resolvePath(name, cwd)) {
      let file = {
        path: src,
        body: import_fs8.default.readFileSync(src, "utf-8")
      };
      return handler(file);
    }
    ;
    return null;
  }
  function resolvePackage2(cwd) {
    return resolveFile("package.json", cwd, function(_0) {
      return JSON.parse(_0.body);
    });
  }
  function idGenerator(alphabet = "bcdefghijklmnopqrstuvwxyz") {
    let remap = {};
    for (let len = alphabet.length, k = 0, rd = len - k; rd > 0 ? k < len : k > len; rd > 0 ? k++ : k--) {
      remap[k.toString(alphabet.length)] = alphabet[k];
    }
    ;
    return function(num) {
      return num.toString(alphabet.length).split("").map(function(_0) {
        return remap[_0];
      }).join("");
    };
  }
  function createHash3(body) {
    return (0, import_crypto2.createHash)("sha1").update(body).digest("base64").replace(/[\=\+\/]/g, "").slice(0, 8).toUpperCase();
  }
  function replaceAll2(str, pattern, replacement) {
    return str.replace(new RegExp(pattern, "g"), replacement);
  }
  function injectStringBefore2(target, toInject, patterns = [""]) {
    for (let φ54 = 0, φ62 = iter$__13(patterns), φ74 = φ62.length; φ54 < φ74; φ54++) {
      let patt = φ62[φ54];
      let idx = target.indexOf(patt);
      if (idx >= 0) {
        return target.slice(0, idx) + toInject + target.slice(idx);
      }
      ;
    }
    ;
    return target;
  }
});

// vendor/colors.js
var require_colors = __commonJS((exports2, module2) => {
  var convert = {
    rgb: {channels: 3, labels: "rgb"},
    hsl: {channels: 3, labels: "hsl"},
    hsv: {channels: 3, labels: "hsv"},
    hwb: {channels: 3, labels: "hwb"},
    cmyk: {channels: 4, labels: "cmyk"},
    xyz: {channels: 3, labels: "xyz"},
    lab: {channels: 3, labels: "lab"},
    lch: {channels: 3, labels: "lch"},
    hex: {channels: 1, labels: ["hex"]},
    ansi16: {channels: 1, labels: ["ansi16"]},
    ansi256: {channels: 1, labels: ["ansi256"]},
    hcg: {channels: 3, labels: ["h", "c", "g"]},
    apple: {channels: 3, labels: ["r16", "g16", "b16"]},
    gray: {channels: 1, labels: ["gray"]}
  };
  module2.exports = {conv: convert};
  for (const model of Object.keys(convert)) {
    if (!("channels" in convert[model])) {
      throw new Error("missing channels property: " + model);
    }
    if (!("labels" in convert[model])) {
      throw new Error("missing channel labels property: " + model);
    }
    if (convert[model].labels.length !== convert[model].channels) {
      throw new Error("channel and label counts mismatch: " + model);
    }
    const {channels, labels} = convert[model];
    delete convert[model].channels;
    delete convert[model].labels;
    Object.defineProperty(convert[model], "channels", {value: channels});
    Object.defineProperty(convert[model], "labels", {value: labels});
  }
  convert.rgb.hsl = function(rgb) {
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const min = Math.min(r, g, b);
    const max = Math.max(r, g, b);
    const delta = max - min;
    let h;
    let s;
    if (max === min) {
      h = 0;
    } else if (r === max) {
      h = (g - b) / delta;
    } else if (g === max) {
      h = 2 + (b - r) / delta;
    } else if (b === max) {
      h = 4 + (r - g) / delta;
    }
    h = Math.min(h * 60, 360);
    if (h < 0) {
      h += 360;
    }
    const l = (min + max) / 2;
    if (max === min) {
      s = 0;
    } else if (l <= 0.5) {
      s = delta / (max + min);
    } else {
      s = delta / (2 - max - min);
    }
    return [h, s * 100, l * 100];
  };
  convert.rgb.hsv = function(rgb) {
    let rdif;
    let gdif;
    let bdif;
    let h;
    let s;
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const v = Math.max(r, g, b);
    const diff = v - Math.min(r, g, b);
    const diffc = function(c) {
      return (v - c) / 6 / diff + 1 / 2;
    };
    if (diff === 0) {
      h = 0;
      s = 0;
    } else {
      s = diff / v;
      rdif = diffc(r);
      gdif = diffc(g);
      bdif = diffc(b);
      if (r === v) {
        h = bdif - gdif;
      } else if (g === v) {
        h = 1 / 3 + rdif - bdif;
      } else if (b === v) {
        h = 2 / 3 + gdif - rdif;
      }
      if (h < 0) {
        h += 1;
      } else if (h > 1) {
        h -= 1;
      }
    }
    return [
      h * 360,
      s * 100,
      v * 100
    ];
  };
  convert.rgb.hwb = function(rgb) {
    const r = rgb[0];
    const g = rgb[1];
    let b = rgb[2];
    const h = convert.rgb.hsl(rgb)[0];
    const w = 1 / 255 * Math.min(r, Math.min(g, b));
    b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
    return [h, w * 100, b * 100];
  };
  convert.rgb.cmyk = function(rgb) {
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const k = Math.min(1 - r, 1 - g, 1 - b);
    const c = (1 - r - k) / (1 - k) || 0;
    const m = (1 - g - k) / (1 - k) || 0;
    const y = (1 - b - k) / (1 - k) || 0;
    return [c * 100, m * 100, y * 100, k * 100];
  };
  convert.rgb.xyz = function(rgb) {
    let r = rgb[0] / 255;
    let g = rgb[1] / 255;
    let b = rgb[2] / 255;
    r = r > 0.04045 ? ((r + 0.055) / 1.055) ** 2.4 : r / 12.92;
    g = g > 0.04045 ? ((g + 0.055) / 1.055) ** 2.4 : g / 12.92;
    b = b > 0.04045 ? ((b + 0.055) / 1.055) ** 2.4 : b / 12.92;
    const x = r * 0.4124564 + g * 0.3575761 + b * 0.1804375;
    const y = r * 0.2126729 + g * 0.7151522 + b * 0.072175;
    const z = r * 0.0193339 + g * 0.119192 + b * 0.9503041;
    return [x * 100, y * 100, z * 100];
  };
  convert.rgb.lab = function(rgb) {
    const xyz = convert.rgb.xyz(rgb);
    let x = xyz[0];
    let y = xyz[1];
    let z = xyz[2];
    x /= 95.047;
    y /= 100;
    z /= 108.883;
    x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
    y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
    z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
    const l = 116 * y - 16;
    const a = 500 * (x - y);
    const b = 200 * (y - z);
    return [l, a, b];
  };
  convert.hsl.rgb = function(hsl) {
    const h = hsl[0] / 360;
    const s = hsl[1] / 100;
    const l = hsl[2] / 100;
    let t2;
    let t3;
    let val;
    if (s === 0) {
      val = l * 255;
      return [val, val, val];
    }
    if (l < 0.5) {
      t2 = l * (1 + s);
    } else {
      t2 = l + s - l * s;
    }
    const t1 = 2 * l - t2;
    const rgb = [0, 0, 0];
    for (let i = 0; i < 3; i++) {
      t3 = h + 1 / 3 * -(i - 1);
      if (t3 < 0) {
        t3++;
      }
      if (t3 > 1) {
        t3--;
      }
      if (6 * t3 < 1) {
        val = t1 + (t2 - t1) * 6 * t3;
      } else if (2 * t3 < 1) {
        val = t2;
      } else if (3 * t3 < 2) {
        val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
      } else {
        val = t1;
      }
      rgb[i] = val * 255;
    }
    return rgb;
  };
  convert.hsl.hsv = function(hsl) {
    const h = hsl[0];
    let s = hsl[1] / 100;
    let l = hsl[2] / 100;
    let smin = s;
    const lmin = Math.max(l, 0.01);
    l *= 2;
    s *= l <= 1 ? l : 2 - l;
    smin *= lmin <= 1 ? lmin : 2 - lmin;
    const v = (l + s) / 2;
    const sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l + s);
    return [h, sv * 100, v * 100];
  };
  convert.hsv.rgb = function(hsv) {
    const h = hsv[0] / 60;
    const s = hsv[1] / 100;
    let v = hsv[2] / 100;
    const hi = Math.floor(h) % 6;
    const f = h - Math.floor(h);
    const p = 255 * v * (1 - s);
    const q = 255 * v * (1 - s * f);
    const t = 255 * v * (1 - s * (1 - f));
    v *= 255;
    switch (hi) {
      case 0:
        return [v, t, p];
      case 1:
        return [q, v, p];
      case 2:
        return [p, v, t];
      case 3:
        return [p, q, v];
      case 4:
        return [t, p, v];
      case 5:
        return [v, p, q];
    }
  };
  convert.hsv.hsl = function(hsv) {
    const h = hsv[0];
    const s = hsv[1] / 100;
    const v = hsv[2] / 100;
    const vmin = Math.max(v, 0.01);
    let sl;
    let l;
    l = (2 - s) * v;
    const lmin = (2 - s) * vmin;
    sl = s * vmin;
    sl /= lmin <= 1 ? lmin : 2 - lmin;
    sl = sl || 0;
    l /= 2;
    return [h, sl * 100, l * 100];
  };
  convert.hwb.rgb = function(hwb) {
    const h = hwb[0] / 360;
    let wh = hwb[1] / 100;
    let bl = hwb[2] / 100;
    const ratio = wh + bl;
    let f;
    if (ratio > 1) {
      wh /= ratio;
      bl /= ratio;
    }
    const i = Math.floor(6 * h);
    const v = 1 - bl;
    f = 6 * h - i;
    if ((i & 1) !== 0) {
      f = 1 - f;
    }
    const n = wh + f * (v - wh);
    let r;
    let g;
    let b;
    switch (i) {
      default:
      case 6:
      case 0:
        r = v;
        g = n;
        b = wh;
        break;
      case 1:
        r = n;
        g = v;
        b = wh;
        break;
      case 2:
        r = wh;
        g = v;
        b = n;
        break;
      case 3:
        r = wh;
        g = n;
        b = v;
        break;
      case 4:
        r = n;
        g = wh;
        b = v;
        break;
      case 5:
        r = v;
        g = wh;
        b = n;
        break;
    }
    return [r * 255, g * 255, b * 255];
  };
  convert.cmyk.rgb = function(cmyk) {
    const c = cmyk[0] / 100;
    const m = cmyk[1] / 100;
    const y = cmyk[2] / 100;
    const k = cmyk[3] / 100;
    const r = 1 - Math.min(1, c * (1 - k) + k);
    const g = 1 - Math.min(1, m * (1 - k) + k);
    const b = 1 - Math.min(1, y * (1 - k) + k);
    return [r * 255, g * 255, b * 255];
  };
  convert.xyz.rgb = function(xyz) {
    const x = xyz[0] / 100;
    const y = xyz[1] / 100;
    const z = xyz[2] / 100;
    let r;
    let g;
    let b;
    r = x * 3.2404542 + y * -1.5371385 + z * -0.4985314;
    g = x * -0.969266 + y * 1.8760108 + z * 0.041556;
    b = x * 0.0556434 + y * -0.2040259 + z * 1.0572252;
    r = r > 31308e-7 ? 1.055 * r ** (1 / 2.4) - 0.055 : r * 12.92;
    g = g > 31308e-7 ? 1.055 * g ** (1 / 2.4) - 0.055 : g * 12.92;
    b = b > 31308e-7 ? 1.055 * b ** (1 / 2.4) - 0.055 : b * 12.92;
    r = Math.min(Math.max(0, r), 1);
    g = Math.min(Math.max(0, g), 1);
    b = Math.min(Math.max(0, b), 1);
    return [r * 255, g * 255, b * 255];
  };
  convert.xyz.lab = function(xyz) {
    let x = xyz[0];
    let y = xyz[1];
    let z = xyz[2];
    x /= 95.047;
    y /= 100;
    z /= 108.883;
    x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
    y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
    z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
    const l = 116 * y - 16;
    const a = 500 * (x - y);
    const b = 200 * (y - z);
    return [l, a, b];
  };
  convert.lab.xyz = function(lab) {
    const l = lab[0];
    const a = lab[1];
    const b = lab[2];
    let x;
    let y;
    let z;
    y = (l + 16) / 116;
    x = a / 500 + y;
    z = y - b / 200;
    const y2 = y ** 3;
    const x2 = x ** 3;
    const z2 = z ** 3;
    y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
    x = x2 > 8856e-6 ? x2 : (x - 16 / 116) / 7.787;
    z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
    x *= 95.047;
    y *= 100;
    z *= 108.883;
    return [x, y, z];
  };
  convert.lab.lch = function(lab) {
    const l = lab[0];
    const a = lab[1];
    const b = lab[2];
    let h;
    const hr = Math.atan2(b, a);
    h = hr * 360 / 2 / Math.PI;
    if (h < 0) {
      h += 360;
    }
    const c = Math.sqrt(a * a + b * b);
    return [l, c, h];
  };
  convert.lch.lab = function(lch) {
    const l = lch[0];
    const c = lch[1];
    const h = lch[2];
    const hr = h / 360 * 2 * Math.PI;
    const a = c * Math.cos(hr);
    const b = c * Math.sin(hr);
    return [l, a, b];
  };
  convert.rgb.ansi16 = function(args, saturation = null) {
    const [r, g, b] = args;
    let value = saturation === null ? convert.rgb.hsv(args)[2] : saturation;
    value = Math.round(value / 50);
    if (value === 0) {
      return 30;
    }
    let ansi2 = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r / 255));
    if (value === 2) {
      ansi2 += 60;
    }
    return ansi2;
  };
  convert.hsv.ansi16 = function(args) {
    return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
  };
  convert.rgb.ansi256 = function(args) {
    const r = args[0];
    const g = args[1];
    const b = args[2];
    if (r === g && g === b) {
      if (r < 8) {
        return 16;
      }
      if (r > 248) {
        return 231;
      }
      return Math.round((r - 8) / 247 * 24) + 232;
    }
    const ansi2 = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
    return ansi2;
  };
  convert.ansi16.rgb = function(args) {
    let color = args % 10;
    if (color === 0 || color === 7) {
      if (args > 50) {
        color += 3.5;
      }
      color = color / 10.5 * 255;
      return [color, color, color];
    }
    const mult = (~~(args > 50) + 1) * 0.5;
    const r = (color & 1) * mult * 255;
    const g = (color >> 1 & 1) * mult * 255;
    const b = (color >> 2 & 1) * mult * 255;
    return [r, g, b];
  };
  convert.ansi256.rgb = function(args) {
    if (args >= 232) {
      const c = (args - 232) * 10 + 8;
      return [c, c, c];
    }
    args -= 16;
    let rem;
    const r = Math.floor(args / 36) / 5 * 255;
    const g = Math.floor((rem = args % 36) / 6) / 5 * 255;
    const b = rem % 6 / 5 * 255;
    return [r, g, b];
  };
  convert.rgb.hex = function(args) {
    const integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
    const string2 = integer.toString(16).toUpperCase();
    return "000000".substring(string2.length) + string2;
  };
  convert.hex.rgb = function(args) {
    const match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
    if (!match) {
      return [0, 0, 0];
    }
    let colorString = match[0];
    if (match[0].length === 3) {
      colorString = colorString.split("").map((char) => {
        return char + char;
      }).join("");
    }
    const integer = parseInt(colorString, 16);
    const r = integer >> 16 & 255;
    const g = integer >> 8 & 255;
    const b = integer & 255;
    return [r, g, b];
  };
  convert.hex.hsl = function(args) {
    return convert.rgb.hsl(convert.hex.rgb(args));
  };
  convert.rgb.hcg = function(rgb) {
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const max = Math.max(Math.max(r, g), b);
    const min = Math.min(Math.min(r, g), b);
    const chroma = max - min;
    let grayscale;
    let hue;
    if (chroma < 1) {
      grayscale = min / (1 - chroma);
    } else {
      grayscale = 0;
    }
    if (chroma <= 0) {
      hue = 0;
    } else if (max === r) {
      hue = (g - b) / chroma % 6;
    } else if (max === g) {
      hue = 2 + (b - r) / chroma;
    } else {
      hue = 4 + (r - g) / chroma;
    }
    hue /= 6;
    hue %= 1;
    return [hue * 360, chroma * 100, grayscale * 100];
  };
  convert.hsl.hcg = function(hsl) {
    const s = hsl[1] / 100;
    const l = hsl[2] / 100;
    const c = l < 0.5 ? 2 * s * l : 2 * s * (1 - l);
    let f = 0;
    if (c < 1) {
      f = (l - 0.5 * c) / (1 - c);
    }
    return [hsl[0], c * 100, f * 100];
  };
  convert.hsv.hcg = function(hsv) {
    const s = hsv[1] / 100;
    const v = hsv[2] / 100;
    const c = s * v;
    let f = 0;
    if (c < 1) {
      f = (v - c) / (1 - c);
    }
    return [hsv[0], c * 100, f * 100];
  };
  convert.hcg.rgb = function(hcg) {
    const h = hcg[0] / 360;
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    if (c === 0) {
      return [g * 255, g * 255, g * 255];
    }
    const pure = [0, 0, 0];
    const hi = h % 1 * 6;
    const v = hi % 1;
    const w = 1 - v;
    let mg = 0;
    switch (Math.floor(hi)) {
      case 0:
        pure[0] = 1;
        pure[1] = v;
        pure[2] = 0;
        break;
      case 1:
        pure[0] = w;
        pure[1] = 1;
        pure[2] = 0;
        break;
      case 2:
        pure[0] = 0;
        pure[1] = 1;
        pure[2] = v;
        break;
      case 3:
        pure[0] = 0;
        pure[1] = w;
        pure[2] = 1;
        break;
      case 4:
        pure[0] = v;
        pure[1] = 0;
        pure[2] = 1;
        break;
      default:
        pure[0] = 1;
        pure[1] = 0;
        pure[2] = w;
    }
    mg = (1 - c) * g;
    return [
      (c * pure[0] + mg) * 255,
      (c * pure[1] + mg) * 255,
      (c * pure[2] + mg) * 255
    ];
  };
  convert.hcg.hsv = function(hcg) {
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    const v = c + g * (1 - c);
    let f = 0;
    if (v > 0) {
      f = c / v;
    }
    return [hcg[0], f * 100, v * 100];
  };
  convert.hcg.hsl = function(hcg) {
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    const l = g * (1 - c) + 0.5 * c;
    let s = 0;
    if (l > 0 && l < 0.5) {
      s = c / (2 * l);
    } else if (l >= 0.5 && l < 1) {
      s = c / (2 * (1 - l));
    }
    return [hcg[0], s * 100, l * 100];
  };
  convert.hcg.hwb = function(hcg) {
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    const v = c + g * (1 - c);
    return [hcg[0], (v - c) * 100, (1 - v) * 100];
  };
  convert.hwb.hcg = function(hwb) {
    const w = hwb[1] / 100;
    const b = hwb[2] / 100;
    const v = 1 - b;
    const c = v - w;
    let g = 0;
    if (c < 1) {
      g = (v - c) / (1 - c);
    }
    return [hwb[0], c * 100, g * 100];
  };
  convert.apple.rgb = function(apple) {
    return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
  };
  convert.rgb.apple = function(rgb) {
    return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
  };
  convert.gray.rgb = function(args) {
    return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
  };
  convert.gray.hsl = function(args) {
    return [0, 0, args[0]];
  };
  convert.gray.hsv = convert.gray.hsl;
  convert.gray.hwb = function(gray) {
    return [0, 100, gray[0]];
  };
  convert.gray.cmyk = function(gray) {
    return [0, 0, 0, gray[0]];
  };
  convert.gray.lab = function(gray) {
    return [gray[0], 0, 0];
  };
  convert.gray.hex = function(gray) {
    const val = Math.round(gray[0] / 100 * 255) & 255;
    const integer = (val << 16) + (val << 8) + val;
    const string2 = integer.toString(16).toUpperCase();
    return "000000".substring(string2.length) + string2;
  };
  convert.rgb.gray = function(rgb) {
    const val = (rgb[0] + rgb[1] + rgb[2]) / 3;
    return [val / 255 * 100];
  };
});

// node_modules/fs.realpath/old.js
var require_old = __commonJS((exports2) => {
  var pathModule = require("path");
  var isWindows = process.platform === "win32";
  var fs = require("fs");
  var DEBUG = process.env.NODE_DEBUG && /fs/.test(process.env.NODE_DEBUG);
  function rethrow() {
    var callback;
    if (DEBUG) {
      var backtrace = new Error();
      callback = debugCallback;
    } else
      callback = missingCallback;
    return callback;
    function debugCallback(err) {
      if (err) {
        backtrace.message = err.message;
        err = backtrace;
        missingCallback(err);
      }
    }
    function missingCallback(err) {
      if (err) {
        if (process.throwDeprecation)
          throw err;
        else if (!process.noDeprecation) {
          var msg = "fs: missing callback " + (err.stack || err.message);
          if (process.traceDeprecation)
            console.trace(msg);
          else
            console.error(msg);
        }
      }
    }
  }
  function maybeCallback(cb) {
    return typeof cb === "function" ? cb : rethrow();
  }
  var normalize = pathModule.normalize;
  if (isWindows) {
    nextPartRe = /(.*?)(?:[\/\\]+|$)/g;
  } else {
    nextPartRe = /(.*?)(?:[\/]+|$)/g;
  }
  var nextPartRe;
  if (isWindows) {
    splitRootRe = /^(?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/][^\\\/]+)?[\\\/]*/;
  } else {
    splitRootRe = /^[\/]*/;
  }
  var splitRootRe;
  exports2.realpathSync = function realpathSync(p, cache) {
    p = pathModule.resolve(p);
    if (cache && Object.prototype.hasOwnProperty.call(cache, p)) {
      return cache[p];
    }
    var original = p, seenLinks = {}, knownHard = {};
    var pos;
    var current;
    var base;
    var previous;
    start();
    function start() {
      var m = splitRootRe.exec(p);
      pos = m[0].length;
      current = m[0];
      base = m[0];
      previous = "";
      if (isWindows && !knownHard[base]) {
        fs.lstatSync(base);
        knownHard[base] = true;
      }
    }
    while (pos < p.length) {
      nextPartRe.lastIndex = pos;
      var result = nextPartRe.exec(p);
      previous = current;
      current += result[0];
      base = previous + result[1];
      pos = nextPartRe.lastIndex;
      if (knownHard[base] || cache && cache[base] === base) {
        continue;
      }
      var resolvedLink;
      if (cache && Object.prototype.hasOwnProperty.call(cache, base)) {
        resolvedLink = cache[base];
      } else {
        var stat = fs.lstatSync(base);
        if (!stat.isSymbolicLink()) {
          knownHard[base] = true;
          if (cache)
            cache[base] = base;
          continue;
        }
        var linkTarget = null;
        if (!isWindows) {
          var id = stat.dev.toString(32) + ":" + stat.ino.toString(32);
          if (seenLinks.hasOwnProperty(id)) {
            linkTarget = seenLinks[id];
          }
        }
        if (linkTarget === null) {
          fs.statSync(base);
          linkTarget = fs.readlinkSync(base);
        }
        resolvedLink = pathModule.resolve(previous, linkTarget);
        if (cache)
          cache[base] = resolvedLink;
        if (!isWindows)
          seenLinks[id] = linkTarget;
      }
      p = pathModule.resolve(resolvedLink, p.slice(pos));
      start();
    }
    if (cache)
      cache[original] = p;
    return p;
  };
  exports2.realpath = function realpath(p, cache, cb) {
    if (typeof cb !== "function") {
      cb = maybeCallback(cache);
      cache = null;
    }
    p = pathModule.resolve(p);
    if (cache && Object.prototype.hasOwnProperty.call(cache, p)) {
      return process.nextTick(cb.bind(null, null, cache[p]));
    }
    var original = p, seenLinks = {}, knownHard = {};
    var pos;
    var current;
    var base;
    var previous;
    start();
    function start() {
      var m = splitRootRe.exec(p);
      pos = m[0].length;
      current = m[0];
      base = m[0];
      previous = "";
      if (isWindows && !knownHard[base]) {
        fs.lstat(base, function(err) {
          if (err)
            return cb(err);
          knownHard[base] = true;
          LOOP();
        });
      } else {
        process.nextTick(LOOP);
      }
    }
    function LOOP() {
      if (pos >= p.length) {
        if (cache)
          cache[original] = p;
        return cb(null, p);
      }
      nextPartRe.lastIndex = pos;
      var result = nextPartRe.exec(p);
      previous = current;
      current += result[0];
      base = previous + result[1];
      pos = nextPartRe.lastIndex;
      if (knownHard[base] || cache && cache[base] === base) {
        return process.nextTick(LOOP);
      }
      if (cache && Object.prototype.hasOwnProperty.call(cache, base)) {
        return gotResolvedLink(cache[base]);
      }
      return fs.lstat(base, gotStat);
    }
    function gotStat(err, stat) {
      if (err)
        return cb(err);
      if (!stat.isSymbolicLink()) {
        knownHard[base] = true;
        if (cache)
          cache[base] = base;
        return process.nextTick(LOOP);
      }
      if (!isWindows) {
        var id = stat.dev.toString(32) + ":" + stat.ino.toString(32);
        if (seenLinks.hasOwnProperty(id)) {
          return gotTarget(null, seenLinks[id], base);
        }
      }
      fs.stat(base, function(err2) {
        if (err2)
          return cb(err2);
        fs.readlink(base, function(err3, target) {
          if (!isWindows)
            seenLinks[id] = target;
          gotTarget(err3, target);
        });
      });
    }
    function gotTarget(err, target, base2) {
      if (err)
        return cb(err);
      var resolvedLink = pathModule.resolve(previous, target);
      if (cache)
        cache[base2] = resolvedLink;
      gotResolvedLink(resolvedLink);
    }
    function gotResolvedLink(resolvedLink) {
      p = pathModule.resolve(resolvedLink, p.slice(pos));
      start();
    }
  };
});

// node_modules/fs.realpath/index.js
var require_fs2 = __commonJS((exports2, module2) => {
  module2.exports = realpath;
  realpath.realpath = realpath;
  realpath.sync = realpathSync;
  realpath.realpathSync = realpathSync;
  realpath.monkeypatch = monkeypatch;
  realpath.unmonkeypatch = unmonkeypatch;
  var fs = require("fs");
  var origRealpath = fs.realpath;
  var origRealpathSync = fs.realpathSync;
  var version = process.version;
  var ok = /^v[0-5]\./.test(version);
  var old = require_old();
  function newError(er) {
    return er && er.syscall === "realpath" && (er.code === "ELOOP" || er.code === "ENOMEM" || er.code === "ENAMETOOLONG");
  }
  function realpath(p, cache, cb) {
    if (ok) {
      return origRealpath(p, cache, cb);
    }
    if (typeof cache === "function") {
      cb = cache;
      cache = null;
    }
    origRealpath(p, cache, function(er, result) {
      if (newError(er)) {
        old.realpath(p, cache, cb);
      } else {
        cb(er, result);
      }
    });
  }
  function realpathSync(p, cache) {
    if (ok) {
      return origRealpathSync(p, cache);
    }
    try {
      return origRealpathSync(p, cache);
    } catch (er) {
      if (newError(er)) {
        return old.realpathSync(p, cache);
      } else {
        throw er;
      }
    }
  }
  function monkeypatch() {
    fs.realpath = realpath;
    fs.realpathSync = realpathSync;
  }
  function unmonkeypatch() {
    fs.realpath = origRealpath;
    fs.realpathSync = origRealpathSync;
  }
});

// node_modules/concat-map/index.js
var require_concat_map = __commonJS((exports2, module2) => {
  module2.exports = function(xs, fn) {
    var res = [];
    for (var i = 0; i < xs.length; i++) {
      var x = fn(xs[i], i);
      if (isArray(x))
        res.push.apply(res, x);
      else
        res.push(x);
    }
    return res;
  };
  var isArray = Array.isArray || function(xs) {
    return Object.prototype.toString.call(xs) === "[object Array]";
  };
});

// node_modules/balanced-match/index.js
var require_balanced_match = __commonJS((exports2, module2) => {
  "use strict";
  module2.exports = balanced;
  function balanced(a, b, str) {
    if (a instanceof RegExp)
      a = maybeMatch(a, str);
    if (b instanceof RegExp)
      b = maybeMatch(b, str);
    var r = range(a, b, str);
    return r && {
      start: r[0],
      end: r[1],
      pre: str.slice(0, r[0]),
      body: str.slice(r[0] + a.length, r[1]),
      post: str.slice(r[1] + b.length)
    };
  }
  function maybeMatch(reg, str) {
    var m = str.match(reg);
    return m ? m[0] : null;
  }
  balanced.range = range;
  function range(a, b, str) {
    var begs, beg, left, right, result;
    var ai = str.indexOf(a);
    var bi = str.indexOf(b, ai + 1);
    var i = ai;
    if (ai >= 0 && bi > 0) {
      if (a === b) {
        return [ai, bi];
      }
      begs = [];
      left = str.length;
      while (i >= 0 && !result) {
        if (i == ai) {
          begs.push(i);
          ai = str.indexOf(a, i + 1);
        } else if (begs.length == 1) {
          result = [begs.pop(), bi];
        } else {
          beg = begs.pop();
          if (beg < left) {
            left = beg;
            right = bi;
          }
          bi = str.indexOf(b, i + 1);
        }
        i = ai < bi && ai >= 0 ? ai : bi;
      }
      if (begs.length) {
        result = [left, right];
      }
    }
    return result;
  }
});

// node_modules/brace-expansion/index.js
var require_brace_expansion = __commonJS((exports2, module2) => {
  var concatMap = require_concat_map();
  var balanced = require_balanced_match();
  module2.exports = expandTop;
  var escSlash = "\0SLASH" + Math.random() + "\0";
  var escOpen = "\0OPEN" + Math.random() + "\0";
  var escClose = "\0CLOSE" + Math.random() + "\0";
  var escComma = "\0COMMA" + Math.random() + "\0";
  var escPeriod = "\0PERIOD" + Math.random() + "\0";
  function numeric(str) {
    return parseInt(str, 10) == str ? parseInt(str, 10) : str.charCodeAt(0);
  }
  function escapeBraces(str) {
    return str.split("\\\\").join(escSlash).split("\\{").join(escOpen).split("\\}").join(escClose).split("\\,").join(escComma).split("\\.").join(escPeriod);
  }
  function unescapeBraces(str) {
    return str.split(escSlash).join("\\").split(escOpen).join("{").split(escClose).join("}").split(escComma).join(",").split(escPeriod).join(".");
  }
  function parseCommaParts(str) {
    if (!str)
      return [""];
    var parts = [];
    var m = balanced("{", "}", str);
    if (!m)
      return str.split(",");
    var pre = m.pre;
    var body = m.body;
    var post = m.post;
    var p = pre.split(",");
    p[p.length - 1] += "{" + body + "}";
    var postParts = parseCommaParts(post);
    if (post.length) {
      p[p.length - 1] += postParts.shift();
      p.push.apply(p, postParts);
    }
    parts.push.apply(parts, p);
    return parts;
  }
  function expandTop(str) {
    if (!str)
      return [];
    if (str.substr(0, 2) === "{}") {
      str = "\\{\\}" + str.substr(2);
    }
    return expand(escapeBraces(str), true).map(unescapeBraces);
  }
  function embrace(str) {
    return "{" + str + "}";
  }
  function isPadded(el) {
    return /^-?0\d/.test(el);
  }
  function lte(i, y) {
    return i <= y;
  }
  function gte(i, y) {
    return i >= y;
  }
  function expand(str, isTop) {
    var expansions = [];
    var m = balanced("{", "}", str);
    if (!m || /\$$/.test(m.pre))
      return [str];
    var isNumericSequence = /^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(m.body);
    var isAlphaSequence = /^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(m.body);
    var isSequence = isNumericSequence || isAlphaSequence;
    var isOptions = m.body.indexOf(",") >= 0;
    if (!isSequence && !isOptions) {
      if (m.post.match(/,.*\}/)) {
        str = m.pre + "{" + m.body + escClose + m.post;
        return expand(str);
      }
      return [str];
    }
    var n;
    if (isSequence) {
      n = m.body.split(/\.\./);
    } else {
      n = parseCommaParts(m.body);
      if (n.length === 1) {
        n = expand(n[0], false).map(embrace);
        if (n.length === 1) {
          var post = m.post.length ? expand(m.post, false) : [""];
          return post.map(function(p) {
            return m.pre + n[0] + p;
          });
        }
      }
    }
    var pre = m.pre;
    var post = m.post.length ? expand(m.post, false) : [""];
    var N;
    if (isSequence) {
      var x = numeric(n[0]);
      var y = numeric(n[1]);
      var width = Math.max(n[0].length, n[1].length);
      var incr2 = n.length == 3 ? Math.abs(numeric(n[2])) : 1;
      var test = lte;
      var reverse = y < x;
      if (reverse) {
        incr2 *= -1;
        test = gte;
      }
      var pad = n.some(isPadded);
      N = [];
      for (var i = x; test(i, y); i += incr2) {
        var c;
        if (isAlphaSequence) {
          c = String.fromCharCode(i);
          if (c === "\\")
            c = "";
        } else {
          c = String(i);
          if (pad) {
            var need = width - c.length;
            if (need > 0) {
              var z = new Array(need + 1).join("0");
              if (i < 0)
                c = "-" + z + c.slice(1);
              else
                c = z + c;
            }
          }
        }
        N.push(c);
      }
    } else {
      N = concatMap(n, function(el) {
        return expand(el, false);
      });
    }
    for (var j = 0; j < N.length; j++) {
      for (var k = 0; k < post.length; k++) {
        var expansion = pre + N[j] + post[k];
        if (!isTop || isSequence || expansion)
          expansions.push(expansion);
      }
    }
    return expansions;
  }
});

// node_modules/minimatch/minimatch.js
var require_minimatch = __commonJS((exports2, module2) => {
  module2.exports = minimatch;
  minimatch.Minimatch = Minimatch;
  var path = {sep: "/"};
  try {
    path = require("path");
  } catch (er) {
  }
  var GLOBSTAR = minimatch.GLOBSTAR = Minimatch.GLOBSTAR = {};
  var expand = require_brace_expansion();
  var plTypes = {
    "!": {open: "(?:(?!(?:", close: "))[^/]*?)"},
    "?": {open: "(?:", close: ")?"},
    "+": {open: "(?:", close: ")+"},
    "*": {open: "(?:", close: ")*"},
    "@": {open: "(?:", close: ")"}
  };
  var qmark = "[^/]";
  var star = qmark + "*?";
  var twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?";
  var twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?";
  var reSpecials = charSet("().*{}+?[]^$\\!");
  function charSet(s) {
    return s.split("").reduce(function(set, c) {
      set[c] = true;
      return set;
    }, {});
  }
  var slashSplit = /\/+/;
  minimatch.filter = filter;
  function filter(pattern, options) {
    options = options || {};
    return function(p, i, list) {
      return minimatch(p, pattern, options);
    };
  }
  function ext(a, b) {
    a = a || {};
    b = b || {};
    var t = {};
    Object.keys(b).forEach(function(k) {
      t[k] = b[k];
    });
    Object.keys(a).forEach(function(k) {
      t[k] = a[k];
    });
    return t;
  }
  minimatch.defaults = function(def) {
    if (!def || !Object.keys(def).length)
      return minimatch;
    var orig = minimatch;
    var m = function minimatch2(p, pattern, options) {
      return orig.minimatch(p, pattern, ext(def, options));
    };
    m.Minimatch = function Minimatch2(pattern, options) {
      return new orig.Minimatch(pattern, ext(def, options));
    };
    return m;
  };
  Minimatch.defaults = function(def) {
    if (!def || !Object.keys(def).length)
      return Minimatch;
    return minimatch.defaults(def).Minimatch;
  };
  function minimatch(p, pattern, options) {
    if (typeof pattern !== "string") {
      throw new TypeError("glob pattern string required");
    }
    if (!options)
      options = {};
    if (!options.nocomment && pattern.charAt(0) === "#") {
      return false;
    }
    if (pattern.trim() === "")
      return p === "";
    return new Minimatch(pattern, options).match(p);
  }
  function Minimatch(pattern, options) {
    if (!(this instanceof Minimatch)) {
      return new Minimatch(pattern, options);
    }
    if (typeof pattern !== "string") {
      throw new TypeError("glob pattern string required");
    }
    if (!options)
      options = {};
    pattern = pattern.trim();
    if (path.sep !== "/") {
      pattern = pattern.split(path.sep).join("/");
    }
    this.options = options;
    this.set = [];
    this.pattern = pattern;
    this.regexp = null;
    this.negate = false;
    this.comment = false;
    this.empty = false;
    this.make();
  }
  Minimatch.prototype.debug = function() {
  };
  Minimatch.prototype.make = make;
  function make() {
    if (this._made)
      return;
    var pattern = this.pattern;
    var options = this.options;
    if (!options.nocomment && pattern.charAt(0) === "#") {
      this.comment = true;
      return;
    }
    if (!pattern) {
      this.empty = true;
      return;
    }
    this.parseNegate();
    var set = this.globSet = this.braceExpand();
    if (options.debug)
      this.debug = console.error;
    this.debug(this.pattern, set);
    set = this.globParts = set.map(function(s) {
      return s.split(slashSplit);
    });
    this.debug(this.pattern, set);
    set = set.map(function(s, si, set2) {
      return s.map(this.parse, this);
    }, this);
    this.debug(this.pattern, set);
    set = set.filter(function(s) {
      return s.indexOf(false) === -1;
    });
    this.debug(this.pattern, set);
    this.set = set;
  }
  Minimatch.prototype.parseNegate = parseNegate;
  function parseNegate() {
    var pattern = this.pattern;
    var negate = false;
    var options = this.options;
    var negateOffset = 0;
    if (options.nonegate)
      return;
    for (var i = 0, l = pattern.length; i < l && pattern.charAt(i) === "!"; i++) {
      negate = !negate;
      negateOffset++;
    }
    if (negateOffset)
      this.pattern = pattern.substr(negateOffset);
    this.negate = negate;
  }
  minimatch.braceExpand = function(pattern, options) {
    return braceExpand(pattern, options);
  };
  Minimatch.prototype.braceExpand = braceExpand;
  function braceExpand(pattern, options) {
    if (!options) {
      if (this instanceof Minimatch) {
        options = this.options;
      } else {
        options = {};
      }
    }
    pattern = typeof pattern === "undefined" ? this.pattern : pattern;
    if (typeof pattern === "undefined") {
      throw new TypeError("undefined pattern");
    }
    if (options.nobrace || !pattern.match(/\{.*\}/)) {
      return [pattern];
    }
    return expand(pattern);
  }
  Minimatch.prototype.parse = parse3;
  var SUBPARSE = {};
  function parse3(pattern, isSub) {
    if (pattern.length > 1024 * 64) {
      throw new TypeError("pattern is too long");
    }
    var options = this.options;
    if (!options.noglobstar && pattern === "**")
      return GLOBSTAR;
    if (pattern === "")
      return "";
    var re = "";
    var hasMagic = !!options.nocase;
    var escaping = false;
    var patternListStack = [];
    var negativeLists = [];
    var stateChar;
    var inClass = false;
    var reClassStart = -1;
    var classStart = -1;
    var patternStart = pattern.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)";
    var self2 = this;
    function clearStateChar() {
      if (stateChar) {
        switch (stateChar) {
          case "*":
            re += star;
            hasMagic = true;
            break;
          case "?":
            re += qmark;
            hasMagic = true;
            break;
          default:
            re += "\\" + stateChar;
            break;
        }
        self2.debug("clearStateChar %j %j", stateChar, re);
        stateChar = false;
      }
    }
    for (var i = 0, len = pattern.length, c; i < len && (c = pattern.charAt(i)); i++) {
      this.debug("%s	%s %s %j", pattern, i, re, c);
      if (escaping && reSpecials[c]) {
        re += "\\" + c;
        escaping = false;
        continue;
      }
      switch (c) {
        case "/":
          return false;
        case "\\":
          clearStateChar();
          escaping = true;
          continue;
        case "?":
        case "*":
        case "+":
        case "@":
        case "!":
          this.debug("%s	%s %s %j <-- stateChar", pattern, i, re, c);
          if (inClass) {
            this.debug("  in class");
            if (c === "!" && i === classStart + 1)
              c = "^";
            re += c;
            continue;
          }
          self2.debug("call clearStateChar %j", stateChar);
          clearStateChar();
          stateChar = c;
          if (options.noext)
            clearStateChar();
          continue;
        case "(":
          if (inClass) {
            re += "(";
            continue;
          }
          if (!stateChar) {
            re += "\\(";
            continue;
          }
          patternListStack.push({
            type: stateChar,
            start: i - 1,
            reStart: re.length,
            open: plTypes[stateChar].open,
            close: plTypes[stateChar].close
          });
          re += stateChar === "!" ? "(?:(?!(?:" : "(?:";
          this.debug("plType %j %j", stateChar, re);
          stateChar = false;
          continue;
        case ")":
          if (inClass || !patternListStack.length) {
            re += "\\)";
            continue;
          }
          clearStateChar();
          hasMagic = true;
          var pl = patternListStack.pop();
          re += pl.close;
          if (pl.type === "!") {
            negativeLists.push(pl);
          }
          pl.reEnd = re.length;
          continue;
        case "|":
          if (inClass || !patternListStack.length || escaping) {
            re += "\\|";
            escaping = false;
            continue;
          }
          clearStateChar();
          re += "|";
          continue;
        case "[":
          clearStateChar();
          if (inClass) {
            re += "\\" + c;
            continue;
          }
          inClass = true;
          classStart = i;
          reClassStart = re.length;
          re += c;
          continue;
        case "]":
          if (i === classStart + 1 || !inClass) {
            re += "\\" + c;
            escaping = false;
            continue;
          }
          if (inClass) {
            var cs = pattern.substring(classStart + 1, i);
            try {
              RegExp("[" + cs + "]");
            } catch (er) {
              var sp = this.parse(cs, SUBPARSE);
              re = re.substr(0, reClassStart) + "\\[" + sp[0] + "\\]";
              hasMagic = hasMagic || sp[1];
              inClass = false;
              continue;
            }
          }
          hasMagic = true;
          inClass = false;
          re += c;
          continue;
        default:
          clearStateChar();
          if (escaping) {
            escaping = false;
          } else if (reSpecials[c] && !(c === "^" && inClass)) {
            re += "\\";
          }
          re += c;
      }
    }
    if (inClass) {
      cs = pattern.substr(classStart + 1);
      sp = this.parse(cs, SUBPARSE);
      re = re.substr(0, reClassStart) + "\\[" + sp[0];
      hasMagic = hasMagic || sp[1];
    }
    for (pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
      var tail = re.slice(pl.reStart + pl.open.length);
      this.debug("setting tail", re, pl);
      tail = tail.replace(/((?:\\{2}){0,64})(\\?)\|/g, function(_, $1, $2) {
        if (!$2) {
          $2 = "\\";
        }
        return $1 + $1 + $2 + "|";
      });
      this.debug("tail=%j\n   %s", tail, tail, pl, re);
      var t = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
      hasMagic = true;
      re = re.slice(0, pl.reStart) + t + "\\(" + tail;
    }
    clearStateChar();
    if (escaping) {
      re += "\\\\";
    }
    var addPatternStart = false;
    switch (re.charAt(0)) {
      case ".":
      case "[":
      case "(":
        addPatternStart = true;
    }
    for (var n = negativeLists.length - 1; n > -1; n--) {
      var nl = negativeLists[n];
      var nlBefore = re.slice(0, nl.reStart);
      var nlFirst = re.slice(nl.reStart, nl.reEnd - 8);
      var nlLast = re.slice(nl.reEnd - 8, nl.reEnd);
      var nlAfter = re.slice(nl.reEnd);
      nlLast += nlAfter;
      var openParensBefore = nlBefore.split("(").length - 1;
      var cleanAfter = nlAfter;
      for (i = 0; i < openParensBefore; i++) {
        cleanAfter = cleanAfter.replace(/\)[+*?]?/, "");
      }
      nlAfter = cleanAfter;
      var dollar = "";
      if (nlAfter === "" && isSub !== SUBPARSE) {
        dollar = "$";
      }
      var newRe = nlBefore + nlFirst + nlAfter + dollar + nlLast;
      re = newRe;
    }
    if (re !== "" && hasMagic) {
      re = "(?=.)" + re;
    }
    if (addPatternStart) {
      re = patternStart + re;
    }
    if (isSub === SUBPARSE) {
      return [re, hasMagic];
    }
    if (!hasMagic) {
      return globUnescape(pattern);
    }
    var flags = options.nocase ? "i" : "";
    try {
      var regExp = new RegExp("^" + re + "$", flags);
    } catch (er) {
      return new RegExp("$.");
    }
    regExp._glob = pattern;
    regExp._src = re;
    return regExp;
  }
  minimatch.makeRe = function(pattern, options) {
    return new Minimatch(pattern, options || {}).makeRe();
  };
  Minimatch.prototype.makeRe = makeRe;
  function makeRe() {
    if (this.regexp || this.regexp === false)
      return this.regexp;
    var set = this.set;
    if (!set.length) {
      this.regexp = false;
      return this.regexp;
    }
    var options = this.options;
    var twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot;
    var flags = options.nocase ? "i" : "";
    var re = set.map(function(pattern) {
      return pattern.map(function(p) {
        return p === GLOBSTAR ? twoStar : typeof p === "string" ? regExpEscape(p) : p._src;
      }).join("\\/");
    }).join("|");
    re = "^(?:" + re + ")$";
    if (this.negate)
      re = "^(?!" + re + ").*$";
    try {
      this.regexp = new RegExp(re, flags);
    } catch (ex) {
      this.regexp = false;
    }
    return this.regexp;
  }
  minimatch.match = function(list, pattern, options) {
    options = options || {};
    var mm = new Minimatch(pattern, options);
    list = list.filter(function(f) {
      return mm.match(f);
    });
    if (mm.options.nonull && !list.length) {
      list.push(pattern);
    }
    return list;
  };
  Minimatch.prototype.match = match;
  function match(f, partial) {
    this.debug("match", f, this.pattern);
    if (this.comment)
      return false;
    if (this.empty)
      return f === "";
    if (f === "/" && partial)
      return true;
    var options = this.options;
    if (path.sep !== "/") {
      f = f.split(path.sep).join("/");
    }
    f = f.split(slashSplit);
    this.debug(this.pattern, "split", f);
    var set = this.set;
    this.debug(this.pattern, "set", set);
    var filename;
    var i;
    for (i = f.length - 1; i >= 0; i--) {
      filename = f[i];
      if (filename)
        break;
    }
    for (i = 0; i < set.length; i++) {
      var pattern = set[i];
      var file = f;
      if (options.matchBase && pattern.length === 1) {
        file = [filename];
      }
      var hit = this.matchOne(file, pattern, partial);
      if (hit) {
        if (options.flipNegate)
          return true;
        return !this.negate;
      }
    }
    if (options.flipNegate)
      return false;
    return this.negate;
  }
  Minimatch.prototype.matchOne = function(file, pattern, partial) {
    var options = this.options;
    this.debug("matchOne", {this: this, file, pattern});
    this.debug("matchOne", file.length, pattern.length);
    for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
      this.debug("matchOne loop");
      var p = pattern[pi];
      var f = file[fi];
      this.debug(pattern, p, f);
      if (p === false)
        return false;
      if (p === GLOBSTAR) {
        this.debug("GLOBSTAR", [pattern, p, f]);
        var fr = fi;
        var pr = pi + 1;
        if (pr === pl) {
          this.debug("** at the end");
          for (; fi < fl; fi++) {
            if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".")
              return false;
          }
          return true;
        }
        while (fr < fl) {
          var swallowee = file[fr];
          this.debug("\nglobstar while", file, fr, pattern, pr, swallowee);
          if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
            this.debug("globstar found match!", fr, fl, swallowee);
            return true;
          } else {
            if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
              this.debug("dot detected!", file, fr, pattern, pr);
              break;
            }
            this.debug("globstar swallow a segment, and continue");
            fr++;
          }
        }
        if (partial) {
          this.debug("\n>>> no match, partial?", file, fr, pattern, pr);
          if (fr === fl)
            return true;
        }
        return false;
      }
      var hit;
      if (typeof p === "string") {
        if (options.nocase) {
          hit = f.toLowerCase() === p.toLowerCase();
        } else {
          hit = f === p;
        }
        this.debug("string match", p, f, hit);
      } else {
        hit = f.match(p);
        this.debug("pattern match", p, f, hit);
      }
      if (!hit)
        return false;
    }
    if (fi === fl && pi === pl) {
      return true;
    } else if (fi === fl) {
      return partial;
    } else if (pi === pl) {
      var emptyFileEnd = fi === fl - 1 && file[fi] === "";
      return emptyFileEnd;
    }
    throw new Error("wtf?");
  };
  function globUnescape(s) {
    return s.replace(/\\(.)/g, "$1");
  }
  function regExpEscape(s) {
    return s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
  }
});

// node_modules/path-is-absolute/index.js
var require_path_is_absolute = __commonJS((exports2, module2) => {
  "use strict";
  function posix(path) {
    return path.charAt(0) === "/";
  }
  function win32(path) {
    var splitDeviceRe = /^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/;
    var result = splitDeviceRe.exec(path);
    var device = result[1] || "";
    var isUnc = Boolean(device && device.charAt(1) !== ":");
    return Boolean(result[2] || isUnc);
  }
  module2.exports = process.platform === "win32" ? win32 : posix;
  module2.exports.posix = posix;
  module2.exports.win32 = win32;
});

// node_modules/glob/common.js
var require_common = __commonJS((exports2) => {
  exports2.setopts = setopts;
  exports2.ownProp = ownProp;
  exports2.makeAbs = makeAbs;
  exports2.finish = finish;
  exports2.mark = mark;
  exports2.isIgnored = isIgnored;
  exports2.childrenIgnored = childrenIgnored;
  function ownProp(obj, field) {
    return Object.prototype.hasOwnProperty.call(obj, field);
  }
  var path = require("path");
  var minimatch = require_minimatch();
  var isAbsolute = require_path_is_absolute();
  var Minimatch = minimatch.Minimatch;
  function alphasort(a, b) {
    return a.localeCompare(b, "en");
  }
  function setupIgnores(self2, options) {
    self2.ignore = options.ignore || [];
    if (!Array.isArray(self2.ignore))
      self2.ignore = [self2.ignore];
    if (self2.ignore.length) {
      self2.ignore = self2.ignore.map(ignoreMap);
    }
  }
  function ignoreMap(pattern) {
    var gmatcher = null;
    if (pattern.slice(-3) === "/**") {
      var gpattern = pattern.replace(/(\/\*\*)+$/, "");
      gmatcher = new Minimatch(gpattern, {dot: true});
    }
    return {
      matcher: new Minimatch(pattern, {dot: true}),
      gmatcher
    };
  }
  function setopts(self2, pattern, options) {
    if (!options)
      options = {};
    if (options.matchBase && pattern.indexOf("/") === -1) {
      if (options.noglobstar) {
        throw new Error("base matching requires globstar");
      }
      pattern = "**/" + pattern;
    }
    self2.silent = !!options.silent;
    self2.pattern = pattern;
    self2.strict = options.strict !== false;
    self2.realpath = !!options.realpath;
    self2.realpathCache = options.realpathCache || Object.create(null);
    self2.follow = !!options.follow;
    self2.dot = !!options.dot;
    self2.mark = !!options.mark;
    self2.nodir = !!options.nodir;
    if (self2.nodir)
      self2.mark = true;
    self2.sync = !!options.sync;
    self2.nounique = !!options.nounique;
    self2.nonull = !!options.nonull;
    self2.nosort = !!options.nosort;
    self2.nocase = !!options.nocase;
    self2.stat = !!options.stat;
    self2.noprocess = !!options.noprocess;
    self2.absolute = !!options.absolute;
    self2.maxLength = options.maxLength || Infinity;
    self2.cache = options.cache || Object.create(null);
    self2.statCache = options.statCache || Object.create(null);
    self2.symlinks = options.symlinks || Object.create(null);
    setupIgnores(self2, options);
    self2.changedCwd = false;
    var cwd = process.cwd();
    if (!ownProp(options, "cwd"))
      self2.cwd = cwd;
    else {
      self2.cwd = path.resolve(options.cwd);
      self2.changedCwd = self2.cwd !== cwd;
    }
    self2.root = options.root || path.resolve(self2.cwd, "/");
    self2.root = path.resolve(self2.root);
    if (process.platform === "win32")
      self2.root = self2.root.replace(/\\/g, "/");
    self2.cwdAbs = isAbsolute(self2.cwd) ? self2.cwd : makeAbs(self2, self2.cwd);
    if (process.platform === "win32")
      self2.cwdAbs = self2.cwdAbs.replace(/\\/g, "/");
    self2.nomount = !!options.nomount;
    options.nonegate = true;
    options.nocomment = true;
    self2.minimatch = new Minimatch(pattern, options);
    self2.options = self2.minimatch.options;
  }
  function finish(self2) {
    var nou = self2.nounique;
    var all = nou ? [] : Object.create(null);
    for (var i = 0, l = self2.matches.length; i < l; i++) {
      var matches = self2.matches[i];
      if (!matches || Object.keys(matches).length === 0) {
        if (self2.nonull) {
          var literal = self2.minimatch.globSet[i];
          if (nou)
            all.push(literal);
          else
            all[literal] = true;
        }
      } else {
        var m = Object.keys(matches);
        if (nou)
          all.push.apply(all, m);
        else
          m.forEach(function(m2) {
            all[m2] = true;
          });
      }
    }
    if (!nou)
      all = Object.keys(all);
    if (!self2.nosort)
      all = all.sort(alphasort);
    if (self2.mark) {
      for (var i = 0; i < all.length; i++) {
        all[i] = self2._mark(all[i]);
      }
      if (self2.nodir) {
        all = all.filter(function(e) {
          var notDir = !/\/$/.test(e);
          var c = self2.cache[e] || self2.cache[makeAbs(self2, e)];
          if (notDir && c)
            notDir = c !== "DIR" && !Array.isArray(c);
          return notDir;
        });
      }
    }
    if (self2.ignore.length)
      all = all.filter(function(m2) {
        return !isIgnored(self2, m2);
      });
    self2.found = all;
  }
  function mark(self2, p) {
    var abs = makeAbs(self2, p);
    var c = self2.cache[abs];
    var m = p;
    if (c) {
      var isDir = c === "DIR" || Array.isArray(c);
      var slash = p.slice(-1) === "/";
      if (isDir && !slash)
        m += "/";
      else if (!isDir && slash)
        m = m.slice(0, -1);
      if (m !== p) {
        var mabs = makeAbs(self2, m);
        self2.statCache[mabs] = self2.statCache[abs];
        self2.cache[mabs] = self2.cache[abs];
      }
    }
    return m;
  }
  function makeAbs(self2, f) {
    var abs = f;
    if (f.charAt(0) === "/") {
      abs = path.join(self2.root, f);
    } else if (isAbsolute(f) || f === "") {
      abs = f;
    } else if (self2.changedCwd) {
      abs = path.resolve(self2.cwd, f);
    } else {
      abs = path.resolve(f);
    }
    if (process.platform === "win32")
      abs = abs.replace(/\\/g, "/");
    return abs;
  }
  function isIgnored(self2, path2) {
    if (!self2.ignore.length)
      return false;
    return self2.ignore.some(function(item) {
      return item.matcher.match(path2) || !!(item.gmatcher && item.gmatcher.match(path2));
    });
  }
  function childrenIgnored(self2, path2) {
    if (!self2.ignore.length)
      return false;
    return self2.ignore.some(function(item) {
      return !!(item.gmatcher && item.gmatcher.match(path2));
    });
  }
});

// node_modules/glob/sync.js
var require_sync2 = __commonJS((exports2, module2) => {
  module2.exports = globSync;
  globSync.GlobSync = GlobSync;
  var fs = require("fs");
  var rp = require_fs2();
  var minimatch = require_minimatch();
  var Minimatch = minimatch.Minimatch;
  var Glob = require_glob().Glob;
  var util = require("util");
  var path = require("path");
  var assert = require("assert");
  var isAbsolute = require_path_is_absolute();
  var common2 = require_common();
  var setopts = common2.setopts;
  var ownProp = common2.ownProp;
  var childrenIgnored = common2.childrenIgnored;
  var isIgnored = common2.isIgnored;
  function globSync(pattern, options) {
    if (typeof options === "function" || arguments.length === 3)
      throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");
    return new GlobSync(pattern, options).found;
  }
  function GlobSync(pattern, options) {
    if (!pattern)
      throw new Error("must provide pattern");
    if (typeof options === "function" || arguments.length === 3)
      throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");
    if (!(this instanceof GlobSync))
      return new GlobSync(pattern, options);
    setopts(this, pattern, options);
    if (this.noprocess)
      return this;
    var n = this.minimatch.set.length;
    this.matches = new Array(n);
    for (var i = 0; i < n; i++) {
      this._process(this.minimatch.set[i], i, false);
    }
    this._finish();
  }
  GlobSync.prototype._finish = function() {
    assert(this instanceof GlobSync);
    if (this.realpath) {
      var self2 = this;
      this.matches.forEach(function(matchset, index) {
        var set = self2.matches[index] = Object.create(null);
        for (var p in matchset) {
          try {
            p = self2._makeAbs(p);
            var real = rp.realpathSync(p, self2.realpathCache);
            set[real] = true;
          } catch (er) {
            if (er.syscall === "stat")
              set[self2._makeAbs(p)] = true;
            else
              throw er;
          }
        }
      });
    }
    common2.finish(this);
  };
  GlobSync.prototype._process = function(pattern, index, inGlobStar) {
    assert(this instanceof GlobSync);
    var n = 0;
    while (typeof pattern[n] === "string") {
      n++;
    }
    var prefix;
    switch (n) {
      case pattern.length:
        this._processSimple(pattern.join("/"), index);
        return;
      case 0:
        prefix = null;
        break;
      default:
        prefix = pattern.slice(0, n).join("/");
        break;
    }
    var remain = pattern.slice(n);
    var read;
    if (prefix === null)
      read = ".";
    else if (isAbsolute(prefix) || isAbsolute(pattern.join("/"))) {
      if (!prefix || !isAbsolute(prefix))
        prefix = "/" + prefix;
      read = prefix;
    } else
      read = prefix;
    var abs = this._makeAbs(read);
    if (childrenIgnored(this, read))
      return;
    var isGlobStar = remain[0] === minimatch.GLOBSTAR;
    if (isGlobStar)
      this._processGlobStar(prefix, read, abs, remain, index, inGlobStar);
    else
      this._processReaddir(prefix, read, abs, remain, index, inGlobStar);
  };
  GlobSync.prototype._processReaddir = function(prefix, read, abs, remain, index, inGlobStar) {
    var entries = this._readdir(abs, inGlobStar);
    if (!entries)
      return;
    var pn = remain[0];
    var negate = !!this.minimatch.negate;
    var rawGlob = pn._glob;
    var dotOk = this.dot || rawGlob.charAt(0) === ".";
    var matchedEntries = [];
    for (var i = 0; i < entries.length; i++) {
      var e = entries[i];
      if (e.charAt(0) !== "." || dotOk) {
        var m;
        if (negate && !prefix) {
          m = !e.match(pn);
        } else {
          m = e.match(pn);
        }
        if (m)
          matchedEntries.push(e);
      }
    }
    var len = matchedEntries.length;
    if (len === 0)
      return;
    if (remain.length === 1 && !this.mark && !this.stat) {
      if (!this.matches[index])
        this.matches[index] = Object.create(null);
      for (var i = 0; i < len; i++) {
        var e = matchedEntries[i];
        if (prefix) {
          if (prefix.slice(-1) !== "/")
            e = prefix + "/" + e;
          else
            e = prefix + e;
        }
        if (e.charAt(0) === "/" && !this.nomount) {
          e = path.join(this.root, e);
        }
        this._emitMatch(index, e);
      }
      return;
    }
    remain.shift();
    for (var i = 0; i < len; i++) {
      var e = matchedEntries[i];
      var newPattern;
      if (prefix)
        newPattern = [prefix, e];
      else
        newPattern = [e];
      this._process(newPattern.concat(remain), index, inGlobStar);
    }
  };
  GlobSync.prototype._emitMatch = function(index, e) {
    if (isIgnored(this, e))
      return;
    var abs = this._makeAbs(e);
    if (this.mark)
      e = this._mark(e);
    if (this.absolute) {
      e = abs;
    }
    if (this.matches[index][e])
      return;
    if (this.nodir) {
      var c = this.cache[abs];
      if (c === "DIR" || Array.isArray(c))
        return;
    }
    this.matches[index][e] = true;
    if (this.stat)
      this._stat(e);
  };
  GlobSync.prototype._readdirInGlobStar = function(abs) {
    if (this.follow)
      return this._readdir(abs, false);
    var entries;
    var lstat;
    var stat;
    try {
      lstat = fs.lstatSync(abs);
    } catch (er) {
      if (er.code === "ENOENT") {
        return null;
      }
    }
    var isSym = lstat && lstat.isSymbolicLink();
    this.symlinks[abs] = isSym;
    if (!isSym && lstat && !lstat.isDirectory())
      this.cache[abs] = "FILE";
    else
      entries = this._readdir(abs, false);
    return entries;
  };
  GlobSync.prototype._readdir = function(abs, inGlobStar) {
    var entries;
    if (inGlobStar && !ownProp(this.symlinks, abs))
      return this._readdirInGlobStar(abs);
    if (ownProp(this.cache, abs)) {
      var c = this.cache[abs];
      if (!c || c === "FILE")
        return null;
      if (Array.isArray(c))
        return c;
    }
    try {
      return this._readdirEntries(abs, fs.readdirSync(abs));
    } catch (er) {
      this._readdirError(abs, er);
      return null;
    }
  };
  GlobSync.prototype._readdirEntries = function(abs, entries) {
    if (!this.mark && !this.stat) {
      for (var i = 0; i < entries.length; i++) {
        var e = entries[i];
        if (abs === "/")
          e = abs + e;
        else
          e = abs + "/" + e;
        this.cache[e] = true;
      }
    }
    this.cache[abs] = entries;
    return entries;
  };
  GlobSync.prototype._readdirError = function(f, er) {
    switch (er.code) {
      case "ENOTSUP":
      case "ENOTDIR":
        var abs = this._makeAbs(f);
        this.cache[abs] = "FILE";
        if (abs === this.cwdAbs) {
          var error = new Error(er.code + " invalid cwd " + this.cwd);
          error.path = this.cwd;
          error.code = er.code;
          throw error;
        }
        break;
      case "ENOENT":
      case "ELOOP":
      case "ENAMETOOLONG":
      case "UNKNOWN":
        this.cache[this._makeAbs(f)] = false;
        break;
      default:
        this.cache[this._makeAbs(f)] = false;
        if (this.strict)
          throw er;
        if (!this.silent)
          console.error("glob error", er);
        break;
    }
  };
  GlobSync.prototype._processGlobStar = function(prefix, read, abs, remain, index, inGlobStar) {
    var entries = this._readdir(abs, inGlobStar);
    if (!entries)
      return;
    var remainWithoutGlobStar = remain.slice(1);
    var gspref = prefix ? [prefix] : [];
    var noGlobStar = gspref.concat(remainWithoutGlobStar);
    this._process(noGlobStar, index, false);
    var len = entries.length;
    var isSym = this.symlinks[abs];
    if (isSym && inGlobStar)
      return;
    for (var i = 0; i < len; i++) {
      var e = entries[i];
      if (e.charAt(0) === "." && !this.dot)
        continue;
      var instead = gspref.concat(entries[i], remainWithoutGlobStar);
      this._process(instead, index, true);
      var below = gspref.concat(entries[i], remain);
      this._process(below, index, true);
    }
  };
  GlobSync.prototype._processSimple = function(prefix, index) {
    var exists = this._stat(prefix);
    if (!this.matches[index])
      this.matches[index] = Object.create(null);
    if (!exists)
      return;
    if (prefix && isAbsolute(prefix) && !this.nomount) {
      var trail = /[\/\\]$/.test(prefix);
      if (prefix.charAt(0) === "/") {
        prefix = path.join(this.root, prefix);
      } else {
        prefix = path.resolve(this.root, prefix);
        if (trail)
          prefix += "/";
      }
    }
    if (process.platform === "win32")
      prefix = prefix.replace(/\\/g, "/");
    this._emitMatch(index, prefix);
  };
  GlobSync.prototype._stat = function(f) {
    var abs = this._makeAbs(f);
    var needDir = f.slice(-1) === "/";
    if (f.length > this.maxLength)
      return false;
    if (!this.stat && ownProp(this.cache, abs)) {
      var c = this.cache[abs];
      if (Array.isArray(c))
        c = "DIR";
      if (!needDir || c === "DIR")
        return c;
      if (needDir && c === "FILE")
        return false;
    }
    var exists;
    var stat = this.statCache[abs];
    if (!stat) {
      var lstat;
      try {
        lstat = fs.lstatSync(abs);
      } catch (er) {
        if (er && (er.code === "ENOENT" || er.code === "ENOTDIR")) {
          this.statCache[abs] = false;
          return false;
        }
      }
      if (lstat && lstat.isSymbolicLink()) {
        try {
          stat = fs.statSync(abs);
        } catch (er) {
          stat = lstat;
        }
      } else {
        stat = lstat;
      }
    }
    this.statCache[abs] = stat;
    var c = true;
    if (stat)
      c = stat.isDirectory() ? "DIR" : "FILE";
    this.cache[abs] = this.cache[abs] || c;
    if (needDir && c === "FILE")
      return false;
    return c;
  };
  GlobSync.prototype._mark = function(p) {
    return common2.mark(this, p);
  };
  GlobSync.prototype._makeAbs = function(f) {
    return common2.makeAbs(this, f);
  };
});

// node_modules/wrappy/wrappy.js
var require_wrappy = __commonJS((exports2, module2) => {
  module2.exports = wrappy;
  function wrappy(fn, cb) {
    if (fn && cb)
      return wrappy(fn)(cb);
    if (typeof fn !== "function")
      throw new TypeError("need wrapper function");
    Object.keys(fn).forEach(function(k) {
      wrapper[k] = fn[k];
    });
    return wrapper;
    function wrapper() {
      var args = new Array(arguments.length);
      for (var i = 0; i < args.length; i++) {
        args[i] = arguments[i];
      }
      var ret = fn.apply(this, args);
      var cb2 = args[args.length - 1];
      if (typeof ret === "function" && ret !== cb2) {
        Object.keys(cb2).forEach(function(k) {
          ret[k] = cb2[k];
        });
      }
      return ret;
    }
  }
});

// node_modules/once/once.js
var require_once = __commonJS((exports2, module2) => {
  var wrappy = require_wrappy();
  module2.exports = wrappy(once);
  module2.exports.strict = wrappy(onceStrict);
  once.proto = once(function() {
    Object.defineProperty(Function.prototype, "once", {
      value: function() {
        return once(this);
      },
      configurable: true
    });
    Object.defineProperty(Function.prototype, "onceStrict", {
      value: function() {
        return onceStrict(this);
      },
      configurable: true
    });
  });
  function once(fn) {
    var f = function() {
      if (f.called)
        return f.value;
      f.called = true;
      return f.value = fn.apply(this, arguments);
    };
    f.called = false;
    return f;
  }
  function onceStrict(fn) {
    var f = function() {
      if (f.called)
        throw new Error(f.onceError);
      f.called = true;
      return f.value = fn.apply(this, arguments);
    };
    var name = fn.name || "Function wrapped with `once`";
    f.onceError = name + " shouldn't be called more than once";
    f.called = false;
    return f;
  }
});

// node_modules/inflight/inflight.js
var require_inflight = __commonJS((exports2, module2) => {
  var wrappy = require_wrappy();
  var reqs = Object.create(null);
  var once = require_once();
  module2.exports = wrappy(inflight);
  function inflight(key, cb) {
    if (reqs[key]) {
      reqs[key].push(cb);
      return null;
    } else {
      reqs[key] = [cb];
      return makeres(key);
    }
  }
  function makeres(key) {
    return once(function RES() {
      var cbs = reqs[key];
      var len = cbs.length;
      var args = slice(arguments);
      try {
        for (var i = 0; i < len; i++) {
          cbs[i].apply(null, args);
        }
      } finally {
        if (cbs.length > len) {
          cbs.splice(0, len);
          process.nextTick(function() {
            RES.apply(null, args);
          });
        } else {
          delete reqs[key];
        }
      }
    });
  }
  function slice(args) {
    var length = args.length;
    var array = [];
    for (var i = 0; i < length; i++)
      array[i] = args[i];
    return array;
  }
});

// node_modules/glob/glob.js
var require_glob = __commonJS((exports2, module2) => {
  module2.exports = glob;
  var fs = require("fs");
  var rp = require_fs2();
  var minimatch = require_minimatch();
  var Minimatch = minimatch.Minimatch;
  var inherits = require_inherits();
  var EE = require("events").EventEmitter;
  var path = require("path");
  var assert = require("assert");
  var isAbsolute = require_path_is_absolute();
  var globSync = require_sync2();
  var common2 = require_common();
  var setopts = common2.setopts;
  var ownProp = common2.ownProp;
  var inflight = require_inflight();
  var util = require("util");
  var childrenIgnored = common2.childrenIgnored;
  var isIgnored = common2.isIgnored;
  var once = require_once();
  function glob(pattern, options, cb) {
    if (typeof options === "function")
      cb = options, options = {};
    if (!options)
      options = {};
    if (options.sync) {
      if (cb)
        throw new TypeError("callback provided to sync glob");
      return globSync(pattern, options);
    }
    return new Glob(pattern, options, cb);
  }
  glob.sync = globSync;
  var GlobSync = glob.GlobSync = globSync.GlobSync;
  glob.glob = glob;
  function extend(origin, add) {
    if (add === null || typeof add !== "object") {
      return origin;
    }
    var keys = Object.keys(add);
    var i = keys.length;
    while (i--) {
      origin[keys[i]] = add[keys[i]];
    }
    return origin;
  }
  glob.hasMagic = function(pattern, options_) {
    var options = extend({}, options_);
    options.noprocess = true;
    var g = new Glob(pattern, options);
    var set = g.minimatch.set;
    if (!pattern)
      return false;
    if (set.length > 1)
      return true;
    for (var j = 0; j < set[0].length; j++) {
      if (typeof set[0][j] !== "string")
        return true;
    }
    return false;
  };
  glob.Glob = Glob;
  inherits(Glob, EE);
  function Glob(pattern, options, cb) {
    if (typeof options === "function") {
      cb = options;
      options = null;
    }
    if (options && options.sync) {
      if (cb)
        throw new TypeError("callback provided to sync glob");
      return new GlobSync(pattern, options);
    }
    if (!(this instanceof Glob))
      return new Glob(pattern, options, cb);
    setopts(this, pattern, options);
    this._didRealPath = false;
    var n = this.minimatch.set.length;
    this.matches = new Array(n);
    if (typeof cb === "function") {
      cb = once(cb);
      this.on("error", cb);
      this.on("end", function(matches) {
        cb(null, matches);
      });
    }
    var self2 = this;
    this._processing = 0;
    this._emitQueue = [];
    this._processQueue = [];
    this.paused = false;
    if (this.noprocess)
      return this;
    if (n === 0)
      return done();
    var sync = true;
    for (var i = 0; i < n; i++) {
      this._process(this.minimatch.set[i], i, false, done);
    }
    sync = false;
    function done() {
      --self2._processing;
      if (self2._processing <= 0) {
        if (sync) {
          process.nextTick(function() {
            self2._finish();
          });
        } else {
          self2._finish();
        }
      }
    }
  }
  Glob.prototype._finish = function() {
    assert(this instanceof Glob);
    if (this.aborted)
      return;
    if (this.realpath && !this._didRealpath)
      return this._realpath();
    common2.finish(this);
    this.emit("end", this.found);
  };
  Glob.prototype._realpath = function() {
    if (this._didRealpath)
      return;
    this._didRealpath = true;
    var n = this.matches.length;
    if (n === 0)
      return this._finish();
    var self2 = this;
    for (var i = 0; i < this.matches.length; i++)
      this._realpathSet(i, next);
    function next() {
      if (--n === 0)
        self2._finish();
    }
  };
  Glob.prototype._realpathSet = function(index, cb) {
    var matchset = this.matches[index];
    if (!matchset)
      return cb();
    var found = Object.keys(matchset);
    var self2 = this;
    var n = found.length;
    if (n === 0)
      return cb();
    var set = this.matches[index] = Object.create(null);
    found.forEach(function(p, i) {
      p = self2._makeAbs(p);
      rp.realpath(p, self2.realpathCache, function(er, real) {
        if (!er)
          set[real] = true;
        else if (er.syscall === "stat")
          set[p] = true;
        else
          self2.emit("error", er);
        if (--n === 0) {
          self2.matches[index] = set;
          cb();
        }
      });
    });
  };
  Glob.prototype._mark = function(p) {
    return common2.mark(this, p);
  };
  Glob.prototype._makeAbs = function(f) {
    return common2.makeAbs(this, f);
  };
  Glob.prototype.abort = function() {
    this.aborted = true;
    this.emit("abort");
  };
  Glob.prototype.pause = function() {
    if (!this.paused) {
      this.paused = true;
      this.emit("pause");
    }
  };
  Glob.prototype.resume = function() {
    if (this.paused) {
      this.emit("resume");
      this.paused = false;
      if (this._emitQueue.length) {
        var eq = this._emitQueue.slice(0);
        this._emitQueue.length = 0;
        for (var i = 0; i < eq.length; i++) {
          var e = eq[i];
          this._emitMatch(e[0], e[1]);
        }
      }
      if (this._processQueue.length) {
        var pq = this._processQueue.slice(0);
        this._processQueue.length = 0;
        for (var i = 0; i < pq.length; i++) {
          var p = pq[i];
          this._processing--;
          this._process(p[0], p[1], p[2], p[3]);
        }
      }
    }
  };
  Glob.prototype._process = function(pattern, index, inGlobStar, cb) {
    assert(this instanceof Glob);
    assert(typeof cb === "function");
    if (this.aborted)
      return;
    this._processing++;
    if (this.paused) {
      this._processQueue.push([pattern, index, inGlobStar, cb]);
      return;
    }
    var n = 0;
    while (typeof pattern[n] === "string") {
      n++;
    }
    var prefix;
    switch (n) {
      case pattern.length:
        this._processSimple(pattern.join("/"), index, cb);
        return;
      case 0:
        prefix = null;
        break;
      default:
        prefix = pattern.slice(0, n).join("/");
        break;
    }
    var remain = pattern.slice(n);
    var read;
    if (prefix === null)
      read = ".";
    else if (isAbsolute(prefix) || isAbsolute(pattern.join("/"))) {
      if (!prefix || !isAbsolute(prefix))
        prefix = "/" + prefix;
      read = prefix;
    } else
      read = prefix;
    var abs = this._makeAbs(read);
    if (childrenIgnored(this, read))
      return cb();
    var isGlobStar = remain[0] === minimatch.GLOBSTAR;
    if (isGlobStar)
      this._processGlobStar(prefix, read, abs, remain, index, inGlobStar, cb);
    else
      this._processReaddir(prefix, read, abs, remain, index, inGlobStar, cb);
  };
  Glob.prototype._processReaddir = function(prefix, read, abs, remain, index, inGlobStar, cb) {
    var self2 = this;
    this._readdir(abs, inGlobStar, function(er, entries) {
      return self2._processReaddir2(prefix, read, abs, remain, index, inGlobStar, entries, cb);
    });
  };
  Glob.prototype._processReaddir2 = function(prefix, read, abs, remain, index, inGlobStar, entries, cb) {
    if (!entries)
      return cb();
    var pn = remain[0];
    var negate = !!this.minimatch.negate;
    var rawGlob = pn._glob;
    var dotOk = this.dot || rawGlob.charAt(0) === ".";
    var matchedEntries = [];
    for (var i = 0; i < entries.length; i++) {
      var e = entries[i];
      if (e.charAt(0) !== "." || dotOk) {
        var m;
        if (negate && !prefix) {
          m = !e.match(pn);
        } else {
          m = e.match(pn);
        }
        if (m)
          matchedEntries.push(e);
      }
    }
    var len = matchedEntries.length;
    if (len === 0)
      return cb();
    if (remain.length === 1 && !this.mark && !this.stat) {
      if (!this.matches[index])
        this.matches[index] = Object.create(null);
      for (var i = 0; i < len; i++) {
        var e = matchedEntries[i];
        if (prefix) {
          if (prefix !== "/")
            e = prefix + "/" + e;
          else
            e = prefix + e;
        }
        if (e.charAt(0) === "/" && !this.nomount) {
          e = path.join(this.root, e);
        }
        this._emitMatch(index, e);
      }
      return cb();
    }
    remain.shift();
    for (var i = 0; i < len; i++) {
      var e = matchedEntries[i];
      var newPattern;
      if (prefix) {
        if (prefix !== "/")
          e = prefix + "/" + e;
        else
          e = prefix + e;
      }
      this._process([e].concat(remain), index, inGlobStar, cb);
    }
    cb();
  };
  Glob.prototype._emitMatch = function(index, e) {
    if (this.aborted)
      return;
    if (isIgnored(this, e))
      return;
    if (this.paused) {
      this._emitQueue.push([index, e]);
      return;
    }
    var abs = isAbsolute(e) ? e : this._makeAbs(e);
    if (this.mark)
      e = this._mark(e);
    if (this.absolute)
      e = abs;
    if (this.matches[index][e])
      return;
    if (this.nodir) {
      var c = this.cache[abs];
      if (c === "DIR" || Array.isArray(c))
        return;
    }
    this.matches[index][e] = true;
    var st = this.statCache[abs];
    if (st)
      this.emit("stat", e, st);
    this.emit("match", e);
  };
  Glob.prototype._readdirInGlobStar = function(abs, cb) {
    if (this.aborted)
      return;
    if (this.follow)
      return this._readdir(abs, false, cb);
    var lstatkey = "lstat\0" + abs;
    var self2 = this;
    var lstatcb = inflight(lstatkey, lstatcb_);
    if (lstatcb)
      fs.lstat(abs, lstatcb);
    function lstatcb_(er, lstat) {
      if (er && er.code === "ENOENT")
        return cb();
      var isSym = lstat && lstat.isSymbolicLink();
      self2.symlinks[abs] = isSym;
      if (!isSym && lstat && !lstat.isDirectory()) {
        self2.cache[abs] = "FILE";
        cb();
      } else
        self2._readdir(abs, false, cb);
    }
  };
  Glob.prototype._readdir = function(abs, inGlobStar, cb) {
    if (this.aborted)
      return;
    cb = inflight("readdir\0" + abs + "\0" + inGlobStar, cb);
    if (!cb)
      return;
    if (inGlobStar && !ownProp(this.symlinks, abs))
      return this._readdirInGlobStar(abs, cb);
    if (ownProp(this.cache, abs)) {
      var c = this.cache[abs];
      if (!c || c === "FILE")
        return cb();
      if (Array.isArray(c))
        return cb(null, c);
    }
    var self2 = this;
    fs.readdir(abs, readdirCb(this, abs, cb));
  };
  function readdirCb(self2, abs, cb) {
    return function(er, entries) {
      if (er)
        self2._readdirError(abs, er, cb);
      else
        self2._readdirEntries(abs, entries, cb);
    };
  }
  Glob.prototype._readdirEntries = function(abs, entries, cb) {
    if (this.aborted)
      return;
    if (!this.mark && !this.stat) {
      for (var i = 0; i < entries.length; i++) {
        var e = entries[i];
        if (abs === "/")
          e = abs + e;
        else
          e = abs + "/" + e;
        this.cache[e] = true;
      }
    }
    this.cache[abs] = entries;
    return cb(null, entries);
  };
  Glob.prototype._readdirError = function(f, er, cb) {
    if (this.aborted)
      return;
    switch (er.code) {
      case "ENOTSUP":
      case "ENOTDIR":
        var abs = this._makeAbs(f);
        this.cache[abs] = "FILE";
        if (abs === this.cwdAbs) {
          var error = new Error(er.code + " invalid cwd " + this.cwd);
          error.path = this.cwd;
          error.code = er.code;
          this.emit("error", error);
          this.abort();
        }
        break;
      case "ENOENT":
      case "ELOOP":
      case "ENAMETOOLONG":
      case "UNKNOWN":
        this.cache[this._makeAbs(f)] = false;
        break;
      default:
        this.cache[this._makeAbs(f)] = false;
        if (this.strict) {
          this.emit("error", er);
          this.abort();
        }
        if (!this.silent)
          console.error("glob error", er);
        break;
    }
    return cb();
  };
  Glob.prototype._processGlobStar = function(prefix, read, abs, remain, index, inGlobStar, cb) {
    var self2 = this;
    this._readdir(abs, inGlobStar, function(er, entries) {
      self2._processGlobStar2(prefix, read, abs, remain, index, inGlobStar, entries, cb);
    });
  };
  Glob.prototype._processGlobStar2 = function(prefix, read, abs, remain, index, inGlobStar, entries, cb) {
    if (!entries)
      return cb();
    var remainWithoutGlobStar = remain.slice(1);
    var gspref = prefix ? [prefix] : [];
    var noGlobStar = gspref.concat(remainWithoutGlobStar);
    this._process(noGlobStar, index, false, cb);
    var isSym = this.symlinks[abs];
    var len = entries.length;
    if (isSym && inGlobStar)
      return cb();
    for (var i = 0; i < len; i++) {
      var e = entries[i];
      if (e.charAt(0) === "." && !this.dot)
        continue;
      var instead = gspref.concat(entries[i], remainWithoutGlobStar);
      this._process(instead, index, true, cb);
      var below = gspref.concat(entries[i], remain);
      this._process(below, index, true, cb);
    }
    cb();
  };
  Glob.prototype._processSimple = function(prefix, index, cb) {
    var self2 = this;
    this._stat(prefix, function(er, exists) {
      self2._processSimple2(prefix, index, er, exists, cb);
    });
  };
  Glob.prototype._processSimple2 = function(prefix, index, er, exists, cb) {
    if (!this.matches[index])
      this.matches[index] = Object.create(null);
    if (!exists)
      return cb();
    if (prefix && isAbsolute(prefix) && !this.nomount) {
      var trail = /[\/\\]$/.test(prefix);
      if (prefix.charAt(0) === "/") {
        prefix = path.join(this.root, prefix);
      } else {
        prefix = path.resolve(this.root, prefix);
        if (trail)
          prefix += "/";
      }
    }
    if (process.platform === "win32")
      prefix = prefix.replace(/\\/g, "/");
    this._emitMatch(index, prefix);
    cb();
  };
  Glob.prototype._stat = function(f, cb) {
    var abs = this._makeAbs(f);
    var needDir = f.slice(-1) === "/";
    if (f.length > this.maxLength)
      return cb();
    if (!this.stat && ownProp(this.cache, abs)) {
      var c = this.cache[abs];
      if (Array.isArray(c))
        c = "DIR";
      if (!needDir || c === "DIR")
        return cb(null, c);
      if (needDir && c === "FILE")
        return cb();
    }
    var exists;
    var stat = this.statCache[abs];
    if (stat !== void 0) {
      if (stat === false)
        return cb(null, stat);
      else {
        var type = stat.isDirectory() ? "DIR" : "FILE";
        if (needDir && type === "FILE")
          return cb();
        else
          return cb(null, type, stat);
      }
    }
    var self2 = this;
    var statcb = inflight("stat\0" + abs, lstatcb_);
    if (statcb)
      fs.lstat(abs, statcb);
    function lstatcb_(er, lstat) {
      if (lstat && lstat.isSymbolicLink()) {
        return fs.stat(abs, function(er2, stat2) {
          if (er2)
            self2._stat2(f, abs, null, lstat, cb);
          else
            self2._stat2(f, abs, er2, stat2, cb);
        });
      } else {
        self2._stat2(f, abs, er, lstat, cb);
      }
    }
  };
  Glob.prototype._stat2 = function(f, abs, er, stat, cb) {
    if (er && (er.code === "ENOENT" || er.code === "ENOTDIR")) {
      this.statCache[abs] = false;
      return cb();
    }
    var needDir = f.slice(-1) === "/";
    this.statCache[abs] = stat;
    if (abs.slice(-1) === "/" && stat && !stat.isDirectory())
      return cb(null, false, stat);
    var c = true;
    if (stat)
      c = stat.isDirectory() ? "DIR" : "FILE";
    this.cache[abs] = this.cache[abs] || c;
    if (needDir && c === "FILE")
      return cb();
    return cb(null, c, stat);
  };
});

// node_modules/tmp/node_modules/rimraf/rimraf.js
var require_rimraf = __commonJS((exports2, module2) => {
  var assert = require("assert");
  var path = require("path");
  var fs = require("fs");
  var glob = void 0;
  try {
    glob = require_glob();
  } catch (_err) {
  }
  var defaultGlobOpts = {
    nosort: true,
    silent: true
  };
  var timeout = 0;
  var isWindows = process.platform === "win32";
  var defaults = (options) => {
    const methods = [
      "unlink",
      "chmod",
      "stat",
      "lstat",
      "rmdir",
      "readdir"
    ];
    methods.forEach((m) => {
      options[m] = options[m] || fs[m];
      m = m + "Sync";
      options[m] = options[m] || fs[m];
    });
    options.maxBusyTries = options.maxBusyTries || 3;
    options.emfileWait = options.emfileWait || 1e3;
    if (options.glob === false) {
      options.disableGlob = true;
    }
    if (options.disableGlob !== true && glob === void 0) {
      throw Error("glob dependency not found, set `options.disableGlob = true` if intentional");
    }
    options.disableGlob = options.disableGlob || false;
    options.glob = options.glob || defaultGlobOpts;
  };
  var rimraf = (p, options, cb) => {
    if (typeof options === "function") {
      cb = options;
      options = {};
    }
    assert(p, "rimraf: missing path");
    assert.equal(typeof p, "string", "rimraf: path should be a string");
    assert.equal(typeof cb, "function", "rimraf: callback function required");
    assert(options, "rimraf: invalid options argument provided");
    assert.equal(typeof options, "object", "rimraf: options should be object");
    defaults(options);
    let busyTries = 0;
    let errState = null;
    let n = 0;
    const next = (er) => {
      errState = errState || er;
      if (--n === 0)
        cb(errState);
    };
    const afterGlob = (er, results) => {
      if (er)
        return cb(er);
      n = results.length;
      if (n === 0)
        return cb();
      results.forEach((p2) => {
        const CB = (er2) => {
          if (er2) {
            if ((er2.code === "EBUSY" || er2.code === "ENOTEMPTY" || er2.code === "EPERM") && busyTries < options.maxBusyTries) {
              busyTries++;
              return setTimeout(() => rimraf_(p2, options, CB), busyTries * 100);
            }
            if (er2.code === "EMFILE" && timeout < options.emfileWait) {
              return setTimeout(() => rimraf_(p2, options, CB), timeout++);
            }
            if (er2.code === "ENOENT")
              er2 = null;
          }
          timeout = 0;
          next(er2);
        };
        rimraf_(p2, options, CB);
      });
    };
    if (options.disableGlob || !glob.hasMagic(p))
      return afterGlob(null, [p]);
    options.lstat(p, (er, stat) => {
      if (!er)
        return afterGlob(null, [p]);
      glob(p, options.glob, afterGlob);
    });
  };
  var rimraf_ = (p, options, cb) => {
    assert(p);
    assert(options);
    assert(typeof cb === "function");
    options.lstat(p, (er, st) => {
      if (er && er.code === "ENOENT")
        return cb(null);
      if (er && er.code === "EPERM" && isWindows)
        fixWinEPERM(p, options, er, cb);
      if (st && st.isDirectory())
        return rmdir(p, options, er, cb);
      options.unlink(p, (er2) => {
        if (er2) {
          if (er2.code === "ENOENT")
            return cb(null);
          if (er2.code === "EPERM")
            return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
          if (er2.code === "EISDIR")
            return rmdir(p, options, er2, cb);
        }
        return cb(er2);
      });
    });
  };
  var fixWinEPERM = (p, options, er, cb) => {
    assert(p);
    assert(options);
    assert(typeof cb === "function");
    options.chmod(p, 438, (er2) => {
      if (er2)
        cb(er2.code === "ENOENT" ? null : er);
      else
        options.stat(p, (er3, stats) => {
          if (er3)
            cb(er3.code === "ENOENT" ? null : er);
          else if (stats.isDirectory())
            rmdir(p, options, er, cb);
          else
            options.unlink(p, cb);
        });
    });
  };
  var fixWinEPERMSync = (p, options, er) => {
    assert(p);
    assert(options);
    try {
      options.chmodSync(p, 438);
    } catch (er2) {
      if (er2.code === "ENOENT")
        return;
      else
        throw er;
    }
    let stats;
    try {
      stats = options.statSync(p);
    } catch (er3) {
      if (er3.code === "ENOENT")
        return;
      else
        throw er;
    }
    if (stats.isDirectory())
      rmdirSync(p, options, er);
    else
      options.unlinkSync(p);
  };
  var rmdir = (p, options, originalEr, cb) => {
    assert(p);
    assert(options);
    assert(typeof cb === "function");
    options.rmdir(p, (er) => {
      if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM"))
        rmkids(p, options, cb);
      else if (er && er.code === "ENOTDIR")
        cb(originalEr);
      else
        cb(er);
    });
  };
  var rmkids = (p, options, cb) => {
    assert(p);
    assert(options);
    assert(typeof cb === "function");
    options.readdir(p, (er, files) => {
      if (er)
        return cb(er);
      let n = files.length;
      if (n === 0)
        return options.rmdir(p, cb);
      let errState;
      files.forEach((f) => {
        rimraf(path.join(p, f), options, (er2) => {
          if (errState)
            return;
          if (er2)
            return cb(errState = er2);
          if (--n === 0)
            options.rmdir(p, cb);
        });
      });
    });
  };
  var rimrafSync = (p, options) => {
    options = options || {};
    defaults(options);
    assert(p, "rimraf: missing path");
    assert.equal(typeof p, "string", "rimraf: path should be a string");
    assert(options, "rimraf: missing options");
    assert.equal(typeof options, "object", "rimraf: options should be object");
    let results;
    if (options.disableGlob || !glob.hasMagic(p)) {
      results = [p];
    } else {
      try {
        options.lstatSync(p);
        results = [p];
      } catch (er) {
        results = glob.sync(p, options.glob);
      }
    }
    if (!results.length)
      return;
    for (let i = 0; i < results.length; i++) {
      const p2 = results[i];
      let st;
      try {
        st = options.lstatSync(p2);
      } catch (er) {
        if (er.code === "ENOENT")
          return;
        if (er.code === "EPERM" && isWindows)
          fixWinEPERMSync(p2, options, er);
      }
      try {
        if (st && st.isDirectory())
          rmdirSync(p2, options, null);
        else
          options.unlinkSync(p2);
      } catch (er) {
        if (er.code === "ENOENT")
          return;
        if (er.code === "EPERM")
          return isWindows ? fixWinEPERMSync(p2, options, er) : rmdirSync(p2, options, er);
        if (er.code !== "EISDIR")
          throw er;
        rmdirSync(p2, options, er);
      }
    }
  };
  var rmdirSync = (p, options, originalEr) => {
    assert(p);
    assert(options);
    try {
      options.rmdirSync(p);
    } catch (er) {
      if (er.code === "ENOENT")
        return;
      if (er.code === "ENOTDIR")
        throw originalEr;
      if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")
        rmkidsSync(p, options);
    }
  };
  var rmkidsSync = (p, options) => {
    assert(p);
    assert(options);
    options.readdirSync(p).forEach((f) => rimrafSync(path.join(p, f), options));
    const retries = isWindows ? 100 : 1;
    let i = 0;
    do {
      let threw = true;
      try {
        const ret = options.rmdirSync(p, options);
        threw = false;
        return ret;
      } finally {
        if (++i < retries && threw)
          continue;
      }
    } while (true);
  };
  module2.exports = rimraf;
  rimraf.sync = rimrafSync;
});

// node_modules/tmp/lib/tmp.js
var require_tmp = __commonJS((exports2, module2) => {
  /*!
   * Tmp
   *
   * Copyright (c) 2011-2017 KARASZI Istvan <github@spam.raszi.hu>
   *
   * MIT Licensed
   */
  var fs = require("fs");
  var os3 = require("os");
  var path = require("path");
  var crypto = require("crypto");
  var _c = {fs: fs.constants, os: os3.constants};
  var rimraf = require_rimraf();
  var RANDOM_CHARS = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
  var TEMPLATE_PATTERN = /XXXXXX/;
  var DEFAULT_TRIES = 3;
  var CREATE_FLAGS = (_c.O_CREAT || _c.fs.O_CREAT) | (_c.O_EXCL || _c.fs.O_EXCL) | (_c.O_RDWR || _c.fs.O_RDWR);
  var IS_WIN32 = os3.platform() === "win32";
  var EBADF = _c.EBADF || _c.os.errno.EBADF;
  var ENOENT = _c.ENOENT || _c.os.errno.ENOENT;
  var DIR_MODE = 448;
  var FILE_MODE = 384;
  var EXIT = "exit";
  var _removeObjects = [];
  var FN_RMDIR_SYNC = fs.rmdirSync.bind(fs);
  var FN_RIMRAF_SYNC = rimraf.sync;
  var _gracefulCleanup = false;
  function tmpName(options, callback) {
    const args = _parseArguments(options, callback), opts = args[0], cb = args[1];
    try {
      _assertAndSanitizeOptions(opts);
    } catch (err) {
      return cb(err);
    }
    let tries = opts.tries;
    (function _getUniqueName() {
      try {
        const name = _generateTmpName(opts);
        fs.stat(name, function(err) {
          if (!err) {
            if (tries-- > 0)
              return _getUniqueName();
            return cb(new Error("Could not get a unique tmp filename, max tries reached " + name));
          }
          cb(null, name);
        });
      } catch (err) {
        cb(err);
      }
    })();
  }
  function tmpNameSync(options) {
    const args = _parseArguments(options), opts = args[0];
    _assertAndSanitizeOptions(opts);
    let tries = opts.tries;
    do {
      const name = _generateTmpName(opts);
      try {
        fs.statSync(name);
      } catch (e) {
        return name;
      }
    } while (tries-- > 0);
    throw new Error("Could not get a unique tmp filename, max tries reached");
  }
  function file(options, callback) {
    const args = _parseArguments(options, callback), opts = args[0], cb = args[1];
    tmpName(opts, function _tmpNameCreated(err, name) {
      if (err)
        return cb(err);
      fs.open(name, CREATE_FLAGS, opts.mode || FILE_MODE, function _fileCreated(err2, fd) {
        if (err2)
          return cb(err2);
        if (opts.discardDescriptor) {
          return fs.close(fd, function _discardCallback(possibleErr) {
            return cb(possibleErr, name, void 0, _prepareTmpFileRemoveCallback(name, -1, opts, false));
          });
        } else {
          const discardOrDetachDescriptor = opts.discardDescriptor || opts.detachDescriptor;
          cb(null, name, fd, _prepareTmpFileRemoveCallback(name, discardOrDetachDescriptor ? -1 : fd, opts, false));
        }
      });
    });
  }
  function fileSync(options) {
    const args = _parseArguments(options), opts = args[0];
    const discardOrDetachDescriptor = opts.discardDescriptor || opts.detachDescriptor;
    const name = tmpNameSync(opts);
    var fd = fs.openSync(name, CREATE_FLAGS, opts.mode || FILE_MODE);
    if (opts.discardDescriptor) {
      fs.closeSync(fd);
      fd = void 0;
    }
    return {
      name,
      fd,
      removeCallback: _prepareTmpFileRemoveCallback(name, discardOrDetachDescriptor ? -1 : fd, opts, true)
    };
  }
  function dir(options, callback) {
    const args = _parseArguments(options, callback), opts = args[0], cb = args[1];
    tmpName(opts, function _tmpNameCreated(err, name) {
      if (err)
        return cb(err);
      fs.mkdir(name, opts.mode || DIR_MODE, function _dirCreated(err2) {
        if (err2)
          return cb(err2);
        cb(null, name, _prepareTmpDirRemoveCallback(name, opts, false));
      });
    });
  }
  function dirSync(options) {
    const args = _parseArguments(options), opts = args[0];
    const name = tmpNameSync(opts);
    fs.mkdirSync(name, opts.mode || DIR_MODE);
    return {
      name,
      removeCallback: _prepareTmpDirRemoveCallback(name, opts, true)
    };
  }
  function _removeFileAsync(fdPath, next) {
    const _handler = function(err) {
      if (err && !_isENOENT(err)) {
        return next(err);
      }
      next();
    };
    if (0 <= fdPath[0])
      fs.close(fdPath[0], function() {
        fs.unlink(fdPath[1], _handler);
      });
    else
      fs.unlink(fdPath[1], _handler);
  }
  function _removeFileSync(fdPath) {
    let rethrownException = null;
    try {
      if (0 <= fdPath[0])
        fs.closeSync(fdPath[0]);
    } catch (e) {
      if (!_isEBADF(e) && !_isENOENT(e))
        throw e;
    } finally {
      try {
        fs.unlinkSync(fdPath[1]);
      } catch (e) {
        if (!_isENOENT(e))
          rethrownException = e;
      }
    }
    if (rethrownException !== null) {
      throw rethrownException;
    }
  }
  function _prepareTmpFileRemoveCallback(name, fd, opts, sync) {
    const removeCallbackSync = _prepareRemoveCallback(_removeFileSync, [fd, name], sync);
    const removeCallback = _prepareRemoveCallback(_removeFileAsync, [fd, name], sync, removeCallbackSync);
    if (!opts.keep)
      _removeObjects.unshift(removeCallbackSync);
    return sync ? removeCallbackSync : removeCallback;
  }
  function _prepareTmpDirRemoveCallback(name, opts, sync) {
    const removeFunction = opts.unsafeCleanup ? rimraf : fs.rmdir.bind(fs);
    const removeFunctionSync = opts.unsafeCleanup ? FN_RIMRAF_SYNC : FN_RMDIR_SYNC;
    const removeCallbackSync = _prepareRemoveCallback(removeFunctionSync, name, sync);
    const removeCallback = _prepareRemoveCallback(removeFunction, name, sync, removeCallbackSync);
    if (!opts.keep)
      _removeObjects.unshift(removeCallbackSync);
    return sync ? removeCallbackSync : removeCallback;
  }
  function _prepareRemoveCallback(removeFunction, fileOrDirName, sync, cleanupCallbackSync) {
    let called = false;
    return function _cleanupCallback(next) {
      if (!called) {
        const toRemove = cleanupCallbackSync || _cleanupCallback;
        const index = _removeObjects.indexOf(toRemove);
        if (index >= 0)
          _removeObjects.splice(index, 1);
        called = true;
        if (sync || removeFunction === FN_RMDIR_SYNC || removeFunction === FN_RIMRAF_SYNC) {
          return removeFunction(fileOrDirName);
        } else {
          return removeFunction(fileOrDirName, next || function() {
          });
        }
      }
    };
  }
  function _garbageCollector() {
    if (!_gracefulCleanup)
      return;
    while (_removeObjects.length) {
      try {
        _removeObjects[0]();
      } catch (e) {
      }
    }
  }
  function _randomChars(howMany) {
    let value = [], rnd = null;
    try {
      rnd = crypto.randomBytes(howMany);
    } catch (e) {
      rnd = crypto.pseudoRandomBytes(howMany);
    }
    for (var i = 0; i < howMany; i++) {
      value.push(RANDOM_CHARS[rnd[i] % RANDOM_CHARS.length]);
    }
    return value.join("");
  }
  function _isBlank(s) {
    return s === null || _isUndefined(s) || !s.trim();
  }
  function _isUndefined(obj) {
    return typeof obj === "undefined";
  }
  function _parseArguments(options, callback) {
    if (typeof options === "function") {
      return [{}, options];
    }
    if (_isUndefined(options)) {
      return [{}, callback];
    }
    const actualOptions = {};
    for (const key of Object.getOwnPropertyNames(options)) {
      actualOptions[key] = options[key];
    }
    return [actualOptions, callback];
  }
  function _generateTmpName(opts) {
    const tmpDir = opts.tmpdir;
    if (!_isUndefined(opts.name))
      return path.join(tmpDir, opts.dir, opts.name);
    if (!_isUndefined(opts.template))
      return path.join(tmpDir, opts.dir, opts.template).replace(TEMPLATE_PATTERN, _randomChars(6));
    const name = [
      opts.prefix ? opts.prefix : "tmp",
      "-",
      process.pid,
      "-",
      _randomChars(12),
      opts.postfix ? "-" + opts.postfix : ""
    ].join("");
    return path.join(tmpDir, opts.dir, name);
  }
  function _assertAndSanitizeOptions(options) {
    options.tmpdir = _getTmpDir(options);
    const tmpDir = options.tmpdir;
    if (!_isUndefined(options.name))
      _assertIsRelative(options.name, "name", tmpDir);
    if (!_isUndefined(options.dir))
      _assertIsRelative(options.dir, "dir", tmpDir);
    if (!_isUndefined(options.template)) {
      _assertIsRelative(options.template, "template", tmpDir);
      if (!options.template.match(TEMPLATE_PATTERN))
        throw new Error(`Invalid template, found "${options.template}".`);
    }
    if (!_isUndefined(options.tries) && isNaN(options.tries) || options.tries < 0)
      throw new Error(`Invalid tries, found "${options.tries}".`);
    options.tries = _isUndefined(options.name) ? options.tries || DEFAULT_TRIES : 1;
    options.keep = !!options.keep;
    options.detachDescriptor = !!options.detachDescriptor;
    options.discardDescriptor = !!options.discardDescriptor;
    options.unsafeCleanup = !!options.unsafeCleanup;
    options.dir = _isUndefined(options.dir) ? "" : path.relative(tmpDir, _resolvePath(options.dir, tmpDir));
    options.template = _isUndefined(options.template) ? void 0 : path.relative(tmpDir, _resolvePath(options.template, tmpDir));
    options.template = _isBlank(options.template) ? void 0 : path.relative(options.dir, options.template);
    options.name = _isUndefined(options.name) ? void 0 : _sanitizeName(options.name);
    options.prefix = _isUndefined(options.prefix) ? "" : options.prefix;
    options.postfix = _isUndefined(options.postfix) ? "" : options.postfix;
  }
  function _resolvePath(name, tmpDir) {
    const sanitizedName = _sanitizeName(name);
    if (sanitizedName.startsWith(tmpDir)) {
      return path.resolve(sanitizedName);
    } else {
      return path.resolve(path.join(tmpDir, sanitizedName));
    }
  }
  function _sanitizeName(name) {
    if (_isBlank(name)) {
      return name;
    }
    return name.replace(/["']/g, "");
  }
  function _assertIsRelative(name, option, tmpDir) {
    if (option === "name") {
      if (path.isAbsolute(name))
        throw new Error(`${option} option must not contain an absolute path, found "${name}".`);
      let basename = path.basename(name);
      if (basename === ".." || basename === "." || basename !== name)
        throw new Error(`${option} option must not contain a path, found "${name}".`);
    } else {
      if (path.isAbsolute(name) && !name.startsWith(tmpDir)) {
        throw new Error(`${option} option must be relative to "${tmpDir}", found "${name}".`);
      }
      let resolvedPath = _resolvePath(name, tmpDir);
      if (!resolvedPath.startsWith(tmpDir))
        throw new Error(`${option} option must be relative to "${tmpDir}", found "${resolvedPath}".`);
    }
  }
  function _isEBADF(error) {
    return _isExpectedError(error, -EBADF, "EBADF");
  }
  function _isENOENT(error) {
    return _isExpectedError(error, -ENOENT, "ENOENT");
  }
  function _isExpectedError(error, errno, code) {
    return IS_WIN32 ? error.code === code : error.code === code && error.errno === errno;
  }
  function setGracefulCleanup() {
    _gracefulCleanup = true;
  }
  function _getTmpDir(options) {
    return path.resolve(_sanitizeName(options && options.tmpdir || os3.tmpdir()));
  }
  process.addListener(EXIT, _garbageCollector);
  Object.defineProperty(module2.exports, "tmpdir", {
    enumerable: true,
    configurable: false,
    get: function() {
      return _getTmpDir();
    }
  });
  module2.exports.dir = dir;
  module2.exports.dirSync = dirSync;
  module2.exports.file = file;
  module2.exports.fileSync = fileSync;
  module2.exports.tmpName = tmpName;
  module2.exports.tmpNameSync = tmpNameSync;
  module2.exports.setGracefulCleanup = setGracefulCleanup;
});

// node_modules/get-port/index.js
var require_get_port = __commonJS((exports2, module2) => {
  "use strict";
  var net = require("net");
  var Locked = class extends Error {
    constructor(port) {
      super(`${port} is locked`);
    }
  };
  var lockedPorts = {
    old: new Set(),
    young: new Set()
  };
  var releaseOldLockedPortsIntervalMs = 1e3 * 15;
  var interval;
  var getAvailablePort = (options) => new Promise((resolve2, reject) => {
    const server = net.createServer();
    server.unref();
    server.on("error", reject);
    server.listen(options, () => {
      const {port} = server.address();
      server.close(() => {
        resolve2(port);
      });
    });
  });
  var portCheckSequence = function* (ports) {
    if (ports) {
      yield* ports;
    }
    yield 0;
  };
  module2.exports = async (options) => {
    let ports;
    if (options) {
      ports = typeof options.port === "number" ? [options.port] : options.port;
    }
    if (interval === void 0) {
      interval = setInterval(() => {
        lockedPorts.old = lockedPorts.young;
        lockedPorts.young = new Set();
      }, releaseOldLockedPortsIntervalMs);
      if (interval.unref) {
        interval.unref();
      }
    }
    for (const port of portCheckSequence(ports)) {
      try {
        let availablePort = await getAvailablePort({...options, port});
        while (lockedPorts.old.has(availablePort) || lockedPorts.young.has(availablePort)) {
          if (port !== 0) {
            throw new Locked(port);
          }
          availablePort = await getAvailablePort({...options, port});
        }
        lockedPorts.young.add(availablePort);
        return availablePort;
      } catch (error) {
        if (!["EADDRINUSE", "EACCES"].includes(error.code) && !(error instanceof Locked)) {
          throw error;
        }
      }
    }
    throw new Error("No available ports found");
  };
  module2.exports.makeRange = (from, to) => {
    if (!Number.isInteger(from) || !Number.isInteger(to)) {
      throw new TypeError("`from` and `to` must be integer numbers");
    }
    if (from < 1024 || from > 65535) {
      throw new RangeError("`from` must be between 1024 and 65535");
    }
    if (to < 1024 || to > 65536) {
      throw new RangeError("`to` must be between 1024 and 65536");
    }
    if (to < from) {
      throw new RangeError("`to` must be greater than or equal to `from`");
    }
    const generator = function* (from2, to2) {
      for (let port = from2; port <= to2; port++) {
        yield port;
      }
    };
    return generator(from, to);
  };
});

// bin/imba.imba
var import_path6 = __toModule(require("path"));
var import_fs6 = __toModule(require("fs"));
var import_perf_hooks3 = __toModule(require("perf_hooks"));

// src/utils/logger.imba
var import_perf_hooks = __toModule(require("perf_hooks"));
var φ1 = Symbol.for("#spinner");
var φ2 = Symbol.for("#ctime");
var φ3 = Symbol.for("#IMBA_OPTIONS");
var ansiMap = {
  reset: [0, 0],
  bold: [1, 22],
  dim: [2, 22],
  italic: [3, 23],
  underline: [4, 24],
  inverse: [7, 27],
  hidden: [8, 28],
  strikethrough: [9, 29],
  black: [30, 39],
  red: [31, 39],
  green: [32, 39],
  yellow: [33, 39],
  blue: [34, 39],
  magenta: [35, 39],
  cyan: [36, 39],
  white: [37, 39],
  gray: [90, 39],
  redBright: [91, 39],
  greenBright: [92, 39],
  yellowBright: [93, 39],
  blueBright: [94, 39],
  magentaBright: [95, 39],
  cyanBright: [96, 39],
  whiteBright: [97, 39]
};
var ansi = {
  bold: function(text) {
    return "[1m" + text + "[22m";
  },
  red: function(text) {
    return "[31m" + text + "[39m";
  },
  green: function(text) {
    return "[32m" + text + "[39m";
  },
  yellow: function(text) {
    return "[33m" + text + "[39m";
  },
  blue: function(text) {
    return "[94m" + text + "[39m";
  },
  gray: function(text) {
    return "[90m" + text + "[39m";
  },
  white: function(text) {
    return "[37m" + text + "[39m";
  },
  f: function(name, text) {
    let pair = ansiMap[name];
    return "[" + pair[0] + "m" + text + "[" + pair[1] + "m";
  }
};
ansi.warn = ansi.yellow;
ansi.error = ansi.red;
var notWin = process.platform !== "win32" || process.env.CI || process.env.TERM === "xterm-256color";
var logSymbols = {
  info: ansi.f("yellowBright", notWin ? "ℹ" : "i"),
  success: ansi.green(notWin ? "✔" : "√"),
  warning: ansi.yellow(notWin ? "⚠" : "!!"),
  error: ansi.red(notWin ? "×" : "✖"),
  debug: ansi.blue(notWin ? "ℹ" : "i")
};
var logLevels = ["debug", "info", "success", "warning", "error", "silent"];
var addressTypeName = {
  "-1": "socket",
  "4": "ip4",
  "6": "ip6"
};
function formatMarkdown(str) {
  let fmt2 = ansi.f;
  str = str.replace(/https?\:[^\s\n\)\]]+/g, function(m) {
    return fmt2("blueBright", m);
  });
  str = str.replace(/^[\t\s]*\>[^\n]+/gm, function(m) {
    return fmt2("bold", m);
  });
  str = str.replace(/\t/g, "  ");
  str = str.replace(/^/gm, "  ");
  return str;
}
function format(str, ...rest) {
  let fmt2 = ansi.f;
  str = str.replace(/\%([\w\.]+)/g, function(m, f) {
    let part = rest.shift();
    if (f == "markdown") {
      return formatMarkdown(part);
    } else if (f == "kb") {
      return fmt2("dim", (part / 1e3).toFixed(1) + "kb");
    } else if (f == "path" || f == "bold") {
      return fmt2("bold", part);
    } else if (f == "dim") {
      return fmt2("dim", part);
    } else if (f == "address") {
      let typ = addressTypeName[part.addressType];
      if (part.port) {
        return fmt2("blueBright", [part.address || "http://127.0.0.1", part.port].join(":"));
      } else {
        return fmt2("blueBright", typ);
      }
      ;
    } else if (f == "ms") {
      return fmt2("yellow", Math.round(part) + "ms");
    } else if (f == "d") {
      return fmt2("blueBright", part);
    } else if (f == "red") {
      return fmt2("redBright", part);
    } else if (f == "green") {
      return fmt2("greenBright", part);
    } else if (f == "yellow") {
      return fmt2("yellowBright", part);
    } else if (f == "ref") {
      return fmt2("yellowBright", "#" + (part.id || part));
    } else if (f == "elapsed") {
      if (part != void 0) {
        rest.unshift(part);
      }
      ;
      let elapsed = import_perf_hooks.performance.now();
      return fmt2("yellow", Math.round(elapsed) + "ms");
    } else if (f == "heap") {
      if (part != void 0) {
        rest.unshift(part);
      }
      ;
      let used = process.memoryUsage().heapUsed / 1024 / 1024;
      return fmt2("yellow", used.toFixed(2) + "mb");
    } else {
      return part;
    }
    ;
  });
  return [str, ...rest];
}
var Spinner = null;
var Instance = null;
var Logger = class {
  static get main() {
    return Instance || (Instance = new this());
  }
  constructor({prefix = null, loglevel} = {}) {
    this[φ2] = Date.now();
    this.prefix = prefix ? format(...prefix)[0] : "";
    this.loglevel = loglevel || process.env.IMBA_LOGLEVEL || globalThis[φ3] && globalThis[φ3].loglevel || "info";
  }
  write(kind, ...parts) {
    if (logLevels.indexOf(kind) < logLevels.indexOf(this.loglevel)) {
      return this;
    }
    ;
    let sym = logSymbols[kind] || kind;
    let [str, ...rest] = format(...parts);
    if (this.prefix) {
      str = this.prefix + str;
    }
    ;
    if (this[φ1] && this[φ1].isSpinning) {
      if (kind == "success") {
        this[φ1].clear();
        console.log(sym + " " + str, ...rest);
        this[φ1].frame();
      }
      ;
      return this[φ1].text = str;
    } else {
      return console.log(sym + " " + str, ...rest);
    }
    ;
  }
  debug(...pars) {
    return this.write("debug", ...pars);
  }
  log(...pars) {
    return this.write("info", ...pars);
  }
  info(...pars) {
    return this.write("info", ...pars);
  }
  warn(...pars) {
    return this.write("warn", ...pars);
  }
  error(...pars) {
    return this.write("error", ...pars);
  }
  success(...pars) {
    return this.write("success", ...pars);
  }
  ts(...pars) {
    return this.write("debug", ...pars, import_perf_hooks.performance.now());
  }
  spinner() {
    return;
    return Spinner = this.ora("Loading").start();
  }
  get [φ1]() {
    return Spinner;
  }
  get proxy() {
    var self2 = this;
    let fn = function(...pars) {
      return self2.info(...pars);
    };
    fn.info = this.info.bind(this);
    fn.warn = this.warn.bind(this);
    fn.error = this.error.bind(this);
    fn.debug = this.debug.bind(this);
    fn.success = this.success.bind(this);
    fn.ts = this.ts.bind(this);
    fn.logger = this;
    return fn;
  }
  async time(label, cb) {
    let t = Date.now();
    if (cb) {
      let res = await cb();
      this.info("" + label + " %ms", Date.now() - t);
      return res;
    }
    ;
  }
};
var logger_default = new Logger().proxy;

// bin/imba.imba
var import_commander = __toModule(require_commander());

// src/bundler/pooler.imba
var np = require("path");
var workerPool = require_src();
var workerScript = np.resolve(__dirname, "..", "workers.imba.js");
var pool = null;
var refs = 0;
function incr() {
  refs += 1;
  return pool || (pool = workerPool.pool(workerScript, {maxWorkers: 2}));
}
function decr() {
  refs -= 1;
  if (refs < 1 && pool) {
    return pool.terminate();
  }
  ;
}
function startWorkers() {
  incr();
  return {
    stop: decr,
    exec: function(...pars) {
      return pool.exec(...pars);
    }
  };
}

// src/bundler/resolver.imba
function iter$__(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ12 = Symbol.for("#init");
var φ22 = Symbol.for("#ready");
var φ32 = Symbol.for("#abs");
var φ33 = Symbol.for("#rel");
var micromatch = require_micromatch();
var np2 = require("path");
var PathEntry = class {
  constructor(key, mappings) {
    this.key = key;
    this.pre = key.replace(/\*$/, "");
    if (typeof mappings == "string") {
      mappings = [mappings];
    }
    ;
    this.mappings = mappings;
    this.cache = {};
  }
  match(path) {
    if (path.indexOf(this.pre) == 0) {
      let sub = path.slice(this.pre.length);
      return this.mappings.map(function(_0) {
        return _0.replace("*", sub);
      });
    } else {
      return null;
    }
    ;
  }
};
var Resolver = class {
  [φ12]($$ = null) {
    this.config = $$ ? $$.config : void 0;
    this.files = $$ ? $$.files : void 0;
    this.program = $$ ? $$.program : void 0;
  }
  constructor(o = {}) {
    this[φ12]();
    this.config = o.config || {};
    this.files = o.files;
    this.program = o.program;
    this.fs = o.fs;
    this.paths = this.config.paths || {};
    this.dirs = {};
    this.aliases = {};
    this.cache = {};
    this.extensions = this.config.extensions || ["", ".imba", ".imba1", ".ts", ".js", ".css", ".svg", ".json"];
    this.resolve = this.resolve.bind(this);
    this;
  }
  setup() {
    var φ103;
    if (!(this[φ22] != 1 ? (this[φ22] = 1, true) : false)) {
      return;
    }
    ;
    this.dirs = {};
    this.aliases = {};
    this.entries = [];
    let t = Date.now();
    for (let φ54 = this.paths, φ39 = 0, φ45 = Object.keys(φ54), φ133 = φ45.length, dir, rules; φ39 < φ133; φ39++) {
      dir = φ45[φ39];
      rules = φ54[dir];
      this.entries.push(new PathEntry(dir, rules));
      let rels = this.dirs[dir] = [];
      let prefix = dir.replace("/*", "/");
      this.dirs[prefix.replace(/\/\*?$/)] = rels;
      for (let φ62 = 0, φ74 = iter$__(rules), φ123 = φ74.length; φ62 < φ123; φ62++) {
        let rule = φ74[φ62];
        let replacer = rule.replace("/*", "/");
        let matches = micromatch(this.files, [rule]);
        for (let φ83 = 0, φ92 = iter$__(matches), φ11 = φ92.length; φ83 < φ11; φ83++) {
          let match = φ92[φ83];
          let alias = match.replace(replacer, prefix);
          let stripped = match.replace(replacer, "");
          let ext = alias.slice(alias.lastIndexOf("."));
          this.aliases[alias] = [match];
          let unprefixed = alias.replace(/\.\w+$/, "");
          let wildcard = (φ103 = this.aliases)[unprefixed] || (φ103[unprefixed] = []);
          wildcard.push(match);
        }
        ;
      }
      ;
    }
    ;
    this.pathsMatcher = new RegExp("^(" + this.entries.map(function(_0) {
      return _0.pre;
    }).join("|") + ")");
    return;
  }
  find(test) {
    var φ143;
    φ143 = [];
    for (let φ152 = 0, φ162 = iter$__(this.files), φ172 = φ162.length; φ152 < φ172; φ152++) {
      let file = φ162[φ152];
      if (!file.match(test)) {
        continue;
      }
      ;
      φ143.push(file);
    }
    ;
    return φ143;
  }
  testWithExtensions(path, exts = this.extensions) {
    if (this.files.indexOf(path) >= 0) {
      return path;
    }
    ;
    for (let φ182 = 0, φ192 = iter$__(exts), φ203 = φ192.length; φ182 < φ203; φ182++) {
      let ext = φ192[φ182];
      let m = path + ext;
      if (this.files.indexOf(m) >= 0) {
        return m;
      }
      ;
    }
    ;
    return null;
  }
  relative(dir, path) {
    let res = np2.relative(dir, path);
    if (res[0] != ".") {
      res = "./" + res;
    }
    ;
    return res;
  }
  expand(path) {
    if (this.cache[path]) {
      return this.cache[path];
    }
    ;
    this.setup();
    let test = [];
    for (let φ212 = 0, φ222 = iter$__(this.entries), φ29 = φ222.length, m; φ212 < φ29; φ212++) {
      let entry = φ222[φ212];
      if (m = entry.match(path)) {
        for (let φ233 = 0, φ242 = iter$__(m), φ28 = φ242.length; φ233 < φ28; φ233++) {
          let item = φ242[φ233];
          test.push(item);
          for (let φ252 = 0, φ262 = iter$__(this.extensions), φ272 = φ262.length; φ252 < φ272; φ252++) {
            let ext = φ262[φ252];
            test.push(item + ext);
          }
          ;
        }
        ;
      }
      ;
    }
    ;
    return this.cache[path] = test;
  }
  resolve(o, options = null) {
    this.setup();
    let path = o.path;
    let found;
    let namespace = "file";
    let colonIndex = path.indexOf(":");
    let qIndex = path.indexOf("?");
    let query = "";
    if (colonIndex >= 0) {
      namespace = path.substr(0, colonIndex);
      path = path.slice(colonIndex + 1);
    }
    ;
    if (qIndex > 0) {
      query = path.slice(qIndex);
      path = path.slice(0, qIndex);
    }
    ;
    let relΦ = path.match(/^\.+\//);
    if (relΦ) {
      let m = 0;
      let norm = np2.resolve(o.resolveDir, path);
      for (let φ30 = 0, φ31 = iter$__(this.extensions), φ342 = φ31.length; φ30 < φ342; φ30++) {
        let ext = φ31[φ30];
        let m2 = norm + ext;
        if (this.fs.existsSync(m2)) {
          let rel = this.fs.relative(m2);
          path = namespace == "file" ? m2 : rel;
          return {path, namespace, [φ32]: m2 + query, [φ33]: rel};
        }
        ;
      }
      ;
      return {path: norm, namespace};
    } else if (!this.pathsMatcher.test(path)) {
      return null;
    } else if (this.fs) {
      for (let φ352 = 0, φ363 = iter$__(this.expand(path)), φ373 = φ363.length; φ352 < φ373; φ352++) {
        let m = φ363[φ352];
        if (this.fs.existsSync(m)) {
          let abs = this.fs.resolve(m);
          path = namespace == "file" ? abs : m;
          return {path, namespace, [φ32]: abs + query, [φ33]: m};
        }
        ;
      }
      ;
      return null;
    }
    ;
    return {path, namespace};
  }
};

// src/bundler/fs.imba
var import_fdir = __toModule(require_fdir());

// src/program/monarch/common.ts
var MonarchBracket;
(function(MonarchBracket2) {
  MonarchBracket2[MonarchBracket2["None"] = 0] = "None";
  MonarchBracket2[MonarchBracket2["Open"] = 1] = "Open";
  MonarchBracket2[MonarchBracket2["Close"] = -1] = "Close";
})(MonarchBracket || (MonarchBracket = {}));
function isFuzzyActionArr(what) {
  return Array.isArray(what);
}
function isFuzzyAction(what) {
  return !isFuzzyActionArr(what);
}
function isString(what) {
  return typeof what === "string";
}
function isIAction(what) {
  return !isString(what);
}
function empty(s) {
  return s ? false : true;
}
function fixCase(lexer, str) {
  return lexer.ignoreCase && str ? str.toLowerCase() : str;
}
function sanitize(s) {
  return s.replace(/[&<>'"_]/g, "-");
}
function log(lexer, msg) {
  console.log(`${lexer.languageId}: ${msg}`);
}
function createError(lexer, msg) {
  return new Error(`${lexer.languageId}: ${msg}`);
}
var substitutionCache = {};
function compileSubstitution(str) {
  const parts = [];
  let i = 0;
  let l = str.length;
  let part = "";
  let sub = 0;
  while (i < l) {
    let chr = str[i++];
    if (chr == "$") {
      let next = str[i++];
      if (next == "$") {
        part += "$";
        continue;
      }
      if (part)
        parts.push(part);
      part = "";
      if (next == "#") {
        parts.push(0);
      } else if (next == "S") {
        parts.push(parseInt(str[i++]) + 100);
      } else {
        parts.push(parseInt(next) + 1);
      }
    } else {
      part += chr;
    }
  }
  if (part)
    parts.push(part);
  substitutionCache[str] = parts;
  return parts;
}
function substituteMatches(lexer, str, id, matches, state) {
  let stateMatches = null;
  let parts = substitutionCache[str] || compileSubstitution(str);
  let out = "";
  for (let i = 0; i < parts.length; i++) {
    let part = parts[i];
    if (typeof part == "string") {
      out += part;
    } else if (part > 100) {
      if (stateMatches === null)
        stateMatches = state.split(".");
      out += stateMatches[part - 101] || "";
    } else if (part === 100) {
      out += state;
    } else if (part === 0) {
      out += id;
    } else if (part > 0) {
      out += matches[part - 1];
    }
  }
  return out;
}
var FIND_RULES_MAP = {};
function findRules(lexer, inState) {
  let state = inState;
  if (FIND_RULES_MAP[state]) {
    return lexer.tokenizer[FIND_RULES_MAP[state]];
  }
  while (state && state.length > 0) {
    const rules = lexer.tokenizer[state];
    if (rules) {
      FIND_RULES_MAP[inState] = state;
      return rules;
    }
    const idx = state.lastIndexOf(".");
    if (idx < 0) {
      state = null;
    } else {
      state = state.substr(0, idx);
    }
  }
  return null;
}
function stateExists(lexer, inState) {
  let state = inState;
  while (state && state.length > 0) {
    const exist = lexer.stateNames[state];
    if (exist) {
      return true;
    }
    const idx = state.lastIndexOf(".");
    if (idx < 0) {
      state = null;
    } else {
      state = state.substr(0, idx);
    }
  }
  return false;
}

// src/program/monarch/compile.ts
function isArrayOf(elemType, obj) {
  if (!obj) {
    return false;
  }
  if (!Array.isArray(obj)) {
    return false;
  }
  for (const el of obj) {
    if (!elemType(el)) {
      return false;
    }
  }
  return true;
}
function bool(prop, defValue) {
  if (typeof prop === "boolean") {
    return prop;
  }
  return defValue;
}
function string(prop, defValue) {
  if (typeof prop === "string") {
    return prop;
  }
  return defValue;
}
function arrayToHash(array) {
  const result = {};
  for (const e of array) {
    result[e] = true;
  }
  return result;
}
function createKeywordMatcher(arr, caseInsensitive = false) {
  if (caseInsensitive) {
    arr = arr.map(function(x) {
      return x.toLowerCase();
    });
  }
  const hash = arrayToHash(arr);
  if (caseInsensitive) {
    return function(word) {
      return hash[word.toLowerCase()] !== void 0 && hash.hasOwnProperty(word.toLowerCase());
    };
  } else {
    return function(word) {
      return hash[word] !== void 0 && hash.hasOwnProperty(word);
    };
  }
}
function compileRegExp(lexer, str) {
  let n = 0;
  while (str.indexOf("@") >= 0 && n < 5) {
    n++;
    str = str.replace(/@(\w+)/g, function(s, attr) {
      let sub = "";
      if (typeof lexer[attr] === "string") {
        sub = lexer[attr];
      } else if (lexer[attr] && lexer[attr] instanceof RegExp) {
        sub = lexer[attr].source;
      } else {
        if (lexer[attr] === void 0) {
          throw createError(lexer, "language definition does not contain attribute '" + attr + "', used at: " + str);
        } else {
          throw createError(lexer, "attribute reference '" + attr + "' must be a string, used at: " + str);
        }
      }
      return empty(sub) ? "" : "(?:" + sub + ")";
    });
  }
  return new RegExp(str, lexer.ignoreCase ? "i" : "");
}
function selectScrutinee(id, matches, state, num) {
  if (num < 0) {
    return id;
  }
  if (num < matches.length) {
    return matches[num];
  }
  if (num >= 100) {
    num = num - 100;
    let parts = state.split(".");
    parts.unshift(state);
    if (num < parts.length) {
      return parts[num];
    }
  }
  return null;
}
function createGuard(lexer, ruleName, tkey, val) {
  let scrut = -1;
  let oppat = tkey;
  let matches = tkey.match(/^\$(([sS]?)(\d\d?)|#)(.*)$/);
  if (matches) {
    if (matches[3]) {
      scrut = parseInt(matches[3]);
      if (matches[2]) {
        scrut = scrut + 100;
      }
    }
    oppat = matches[4];
  }
  let op = "~";
  let pat = oppat;
  if (!oppat || oppat.length === 0) {
    op = "!=";
    pat = "";
  } else if (/^\w*$/.test(pat)) {
    op = "==";
  } else {
    matches = oppat.match(/^(@|!@|~|!~|==|!=)(.*)$/);
    if (matches) {
      op = matches[1];
      pat = matches[2];
    }
  }
  let tester;
  if ((op === "~" || op === "!~") && /^(\w|\|)*$/.test(pat)) {
    let inWords = createKeywordMatcher(pat.split("|"), lexer.ignoreCase);
    tester = function(s) {
      return op === "~" ? inWords(s) : !inWords(s);
    };
  } else if (op === "@" || op === "!@") {
    let words = lexer[pat];
    if (!words) {
      throw createError(lexer, "the @ match target '" + pat + "' is not defined, in rule: " + ruleName);
    }
    if (!isArrayOf(function(elem) {
      return typeof elem === "string";
    }, words)) {
      throw createError(lexer, "the @ match target '" + pat + "' must be an array of strings, in rule: " + ruleName);
    }
    let inWords = createKeywordMatcher(words, lexer.ignoreCase);
    tester = function(s) {
      return op === "@" ? inWords(s) : !inWords(s);
    };
  } else if (op === "~" || op === "!~") {
    if (pat.indexOf("$") < 0) {
      let re = compileRegExp(lexer, "^" + pat + "$");
      tester = function(s) {
        return op === "~" ? re.test(s) : !re.test(s);
      };
    } else {
      tester = function(s, id, matches2, state) {
        let re = compileRegExp(lexer, "^" + substituteMatches(lexer, pat, id, matches2, state) + "$");
        return re.test(s);
      };
    }
  } else {
    if (pat.indexOf("$") < 0) {
      let patx = fixCase(lexer, pat);
      tester = function(s) {
        return op === "==" ? s === patx : s !== patx;
      };
    } else {
      let patx = fixCase(lexer, pat);
      tester = function(s, id, matches2, state, eos) {
        let patexp = substituteMatches(lexer, patx, id, matches2, state);
        return op === "==" ? s === patexp : s !== patexp;
      };
    }
  }
  if (scrut === -1) {
    return {
      name: tkey,
      value: val,
      test: function(id, matches2, state, eos) {
        return tester(id, id, matches2, state, eos);
      }
    };
  } else {
    return {
      name: tkey,
      value: val,
      test: function(id, matches2, state, eos) {
        let scrutinee = selectScrutinee(id, matches2, state, scrut);
        return tester(!scrutinee ? "" : scrutinee, id, matches2, state, eos);
      }
    };
  }
}
function compileAction(lexer, ruleName, action) {
  if (!action) {
    return {token: ""};
  } else if (typeof action === "string") {
    return action;
  } else if (action.token || action.token === "") {
    if (typeof action.token !== "string") {
      throw createError(lexer, "a 'token' attribute must be of type string, in rule: " + ruleName);
    } else {
      let newAction = {token: action.token};
      if (action.token.indexOf("$") >= 0) {
        newAction.tokenSubst = true;
      }
      if (typeof action.bracket === "string") {
        if (action.bracket === "@open") {
          newAction.bracket = MonarchBracket.Open;
        } else if (action.bracket === "@close") {
          newAction.bracket = MonarchBracket.Close;
        } else {
          throw createError(lexer, "a 'bracket' attribute must be either '@open' or '@close', in rule: " + ruleName);
        }
      }
      if (action.next) {
        if (typeof action.next !== "string") {
          throw createError(lexer, "the next state must be a string value in rule: " + ruleName);
        } else {
          let next = action.next;
          if (!/^(@pop|@push|@popall)$/.test(next)) {
            if (next[0] === "@") {
              next = next.substr(1);
            }
            if (next.indexOf("$") < 0) {
              if (!stateExists(lexer, substituteMatches(lexer, next, "", [], ""))) {
                throw createError(lexer, "the next state '" + action.next + "' is not defined in rule: " + ruleName);
              }
            }
          }
          newAction.next = next;
        }
      }
      if (typeof action.goBack === "number") {
        newAction.goBack = action.goBack;
      }
      if (typeof action.switchTo === "string") {
        newAction.switchTo = action.switchTo;
      }
      if (typeof action.log === "string") {
        newAction.log = action.log;
      }
      if (typeof action._push === "string") {
        newAction._push = action._push;
      }
      if (typeof action._pop === "string") {
        newAction._pop = action._pop;
      }
      if (typeof action.mark === "string") {
        newAction.mark = action.mark;
      }
      if (typeof action.fn === "string") {
        newAction.fn = action.fn;
      }
      if (typeof action.nextEmbedded === "string") {
        newAction.nextEmbedded = action.nextEmbedded;
        lexer.usesEmbedded = true;
      }
      return newAction;
    }
  } else if (Array.isArray(action)) {
    let results = [];
    for (let i = 0, len = action.length; i < len; i++) {
      results[i] = compileAction(lexer, ruleName, action[i]);
    }
    return {group: results};
  } else if (action.cases) {
    let cases = [];
    for (let tkey in action.cases) {
      if (action.cases.hasOwnProperty(tkey)) {
        const val = compileAction(lexer, ruleName, action.cases[tkey]);
        if (tkey === "@default" || tkey === "@" || tkey === "") {
          cases.push({test: void 0, value: val, name: tkey});
        } else if (tkey === "@eos") {
          cases.push({test: function(id, matches, state, eos) {
            return eos;
          }, value: val, name: tkey});
        } else {
          cases.push(createGuard(lexer, ruleName, tkey, val));
        }
      }
    }
    const def = lexer.defaultToken;
    return {
      test: function(id, matches, state, eos) {
        for (const _case of cases) {
          const didmatch = !_case.test || _case.test(id, matches, state, eos);
          if (didmatch) {
            return _case.value;
          }
        }
        return def;
      }
    };
  } else {
    throw createError(lexer, "an action must be a string, an object with a 'token' or 'cases' attribute, or an array of actions; in rule: " + ruleName);
  }
}
var Rule = class {
  constructor(name) {
    this.regex = new RegExp("");
    this.action = {token: ""};
    this.matchOnlyAtLineStart = false;
    this.name = "";
    this.name = name;
    this.stats = {time: 0, count: 0, hits: 0};
  }
  setRegex(lexer, re) {
    let sregex;
    if (typeof re === "string") {
      sregex = re;
    } else if (re instanceof RegExp) {
      sregex = re.source;
    } else {
      throw createError(lexer, "rules must start with a match string or regular expression: " + this.name);
    }
    if (sregex.length == 2 && sregex[0] == "\\" && /[\{\}\(\)\[\]]/.test(sregex[1])) {
      this.string = sregex[1];
    }
    this.matchOnlyAtLineStart = sregex.length > 0 && sregex[0] === "^";
    this.name = this.name + ": " + sregex;
    this.regex = compileRegExp(lexer, "^(?:" + (this.matchOnlyAtLineStart ? sregex.substr(1) : sregex) + ")");
  }
  setAction(lexer, act) {
    this.action = compileAction(lexer, this.name, act);
  }
};
function compile(languageId, json) {
  if (!json || typeof json !== "object") {
    throw new Error("Monarch: expecting a language definition object");
  }
  let lexer = {};
  lexer.languageId = languageId;
  lexer.noThrow = false;
  lexer.maxStack = 100;
  lexer.start = typeof json.start === "string" ? json.start : null;
  lexer.ignoreCase = bool(json.ignoreCase, false);
  lexer.tokenPostfix = string(json.tokenPostfix, "." + lexer.languageId);
  lexer.defaultToken = string(json.defaultToken, "source");
  lexer.usesEmbedded = false;
  let lexerMin = json;
  lexerMin.languageId = languageId;
  lexerMin.ignoreCase = lexer.ignoreCase;
  lexerMin.noThrow = lexer.noThrow;
  lexerMin.usesEmbedded = lexer.usesEmbedded;
  lexerMin.stateNames = json.tokenizer;
  lexerMin.defaultToken = lexer.defaultToken;
  function addRules(state, newrules, rules) {
    for (const rule of rules) {
      let include = rule.include;
      if (include) {
        if (typeof include !== "string") {
          throw createError(lexer, "an 'include' attribute must be a string at: " + state);
        }
        if (include[0] === "@") {
          include = include.substr(1);
        }
        if (!json.tokenizer[include]) {
          throw createError(lexer, "include target '" + include + "' is not defined at: " + state);
        }
        addRules(state + "." + include, newrules, json.tokenizer[include]);
      } else {
        const newrule = new Rule(state);
        if (Array.isArray(rule) && rule.length >= 1 && rule.length <= 3) {
          newrule.setRegex(lexerMin, rule[0]);
          if (rule.length >= 3) {
            if (typeof rule[1] === "string") {
              newrule.setAction(lexerMin, {token: rule[1], next: rule[2]});
            } else if (typeof rule[1] === "object") {
              const rule1 = rule[1];
              rule1.next = rule[2];
              newrule.setAction(lexerMin, rule1);
            } else {
              throw createError(lexer, "a next state as the last element of a rule can only be given if the action is either an object or a string, at: " + state);
            }
          } else {
            newrule.setAction(lexerMin, rule[1]);
          }
        } else {
          if (!rule.regex) {
            throw createError(lexer, "a rule must either be an array, or an object with a 'regex' or 'include' field at: " + state);
          }
          if (rule.name) {
            if (typeof rule.name === "string") {
              newrule.name = rule.name;
            }
          }
          if (rule.matchOnlyAtStart) {
            newrule.matchOnlyAtLineStart = bool(rule.matchOnlyAtLineStart, false);
          }
          newrule.setRegex(lexerMin, rule.regex);
          newrule.setAction(lexerMin, rule.action);
        }
        newrules.push(newrule);
      }
    }
  }
  if (!json.tokenizer || typeof json.tokenizer !== "object") {
    throw createError(lexer, "a language definition must define the 'tokenizer' attribute as an object");
  }
  lexer.tokenizer = [];
  for (let key in json.tokenizer) {
    if (json.tokenizer.hasOwnProperty(key)) {
      if (!lexer.start) {
        lexer.start = key;
      }
      const rules = json.tokenizer[key];
      lexer.tokenizer[key] = new Array();
      addRules("tokenizer." + key, lexer.tokenizer[key], rules);
    }
  }
  lexer.usesEmbedded = lexerMin.usesEmbedded;
  if (json.brackets) {
    if (!Array.isArray(json.brackets)) {
      throw createError(lexer, "the 'brackets' attribute must be defined as an array");
    }
  } else {
    json.brackets = [
      {open: "{", close: "}", token: "delimiter.curly"},
      {open: "[", close: "]", token: "delimiter.square"},
      {open: "(", close: ")", token: "delimiter.parenthesis"},
      {open: "<", close: ">", token: "delimiter.angle"}
    ];
  }
  let brackets = [];
  for (let el of json.brackets) {
    let desc = el;
    if (desc && Array.isArray(desc) && desc.length === 3) {
      desc = {token: desc[2], open: desc[0], close: desc[1]};
    }
    if (desc.open === desc.close) {
      throw createError(lexer, "open and close brackets in a 'brackets' attribute must be different: " + desc.open + "\n hint: use the 'bracket' attribute if matching on equal brackets is required.");
    }
    if (typeof desc.open === "string" && typeof desc.token === "string" && typeof desc.close === "string") {
      brackets.push({
        token: desc.token + lexer.tokenPostfix,
        open: fixCase(lexer, desc.open),
        close: fixCase(lexer, desc.close)
      });
    } else {
      throw createError(lexer, "every element in the 'brackets' array must be a '{open,close,token}' object or array");
    }
  }
  lexer.brackets = brackets;
  lexer.noThrow = true;
  return lexer;
}

// src/program/monarch/token.ts
var Token = class {
  constructor(offset, type, language) {
    this.offset = offset | 0;
    this.type = type;
    this.language = language;
    this.kind = 0;
    this.mods = 0;
    this.value = null;
    this.stack = null;
  }
  toString() {
    return this.value || "";
  }
  get span() {
    return {offset: this.offset, length: this.value ? this.value.length : 0};
  }
  get indent() {
    return 0;
  }
  get startOffset() {
    return this.offset;
  }
  get endOffset() {
    return this.offset + (this.value ? this.value.length : 0);
  }
  clone() {
    let tok = new Token(this.offset, this.type, this.language);
    tok.value = this.value;
    tok.stack = this.stack;
    return tok;
  }
  match(val) {
    if (typeof val == "string") {
      if (val.indexOf(" ") > 0) {
        val = val.split(" ");
      } else {
        let idx = this.type.indexOf(val);
        return val[0] == "." ? idx >= 0 : idx == 0;
      }
    }
    if (val instanceof Array) {
      for (let item of val) {
        let idx = this.type.indexOf(item);
        let hit = item[0] == "." ? idx >= 0 : idx == 0;
        if (hit)
          return true;
      }
    }
    if (val instanceof RegExp) {
      return val.test(this.type);
    }
    return false;
  }
};
var TokenizationResult = class {
  constructor(tokens, endState) {
    this.tokens = tokens;
    this.endState = endState;
  }
};

// src/program/monarch/lexer.ts
var CACHE_STACK_DEPTH = 10;
function statePart(state, index) {
  return state.split(".")[index];
}
var _MonarchStackElementFactory = class {
  static create(parent, state) {
    return this._INSTANCE.create(parent, state);
  }
  constructor(maxCacheDepth) {
    this._maxCacheDepth = maxCacheDepth;
    this._entries = Object.create(null);
  }
  create(parent, state) {
    if (parent !== null && parent.depth >= this._maxCacheDepth) {
      return new MonarchStackElement(parent, state);
    }
    let stackElementId = MonarchStackElement.getStackElementId(parent);
    if (stackElementId.length > 0) {
      stackElementId += "|";
    }
    stackElementId += state;
    let result = this._entries[stackElementId];
    if (result) {
      return result;
    }
    result = new MonarchStackElement(parent, state);
    this._entries[stackElementId] = result;
    return result;
  }
};
var MonarchStackElementFactory = _MonarchStackElementFactory;
MonarchStackElementFactory._INSTANCE = new _MonarchStackElementFactory(CACHE_STACK_DEPTH);
var MonarchStackElement = class {
  constructor(parent, state) {
    this.parent = parent;
    this.state = state;
    this.depth = (this.parent ? this.parent.depth : 0) + 1;
  }
  static getStackElementId(element) {
    let result = "";
    while (element !== null) {
      if (result.length > 0) {
        result += "|";
      }
      result += element.state;
      element = element.parent;
    }
    return result;
  }
  static _equals(a, b) {
    while (a !== null && b !== null) {
      if (a === b) {
        return true;
      }
      if (a.state !== b.state) {
        return false;
      }
      a = a.parent;
      b = b.parent;
    }
    if (a === null && b === null) {
      return true;
    }
    return false;
  }
  get indent() {
    return this.state.lastIndexOf("	") - this.state.indexOf("	");
  }
  get scope() {
    return this.part(2);
  }
  get detail() {
    return this.part(2);
  }
  part(index) {
    return this.state.split(".")[index];
  }
  equals(other) {
    return MonarchStackElement._equals(this, other);
  }
  push(state) {
    return MonarchStackElementFactory.create(this, state);
  }
  pop() {
    return this.parent;
  }
  popall() {
    let result = this;
    while (result.parent) {
      result = result.parent;
    }
    return result;
  }
  switchTo(state) {
    return MonarchStackElementFactory.create(this.parent, state);
  }
};
var _MonarchLineStateFactory = class {
  static create(stack) {
    return this._INSTANCE.create(stack);
  }
  constructor(maxCacheDepth) {
    this._maxCacheDepth = maxCacheDepth;
    this._entries = Object.create(null);
  }
  create(stack) {
    if (stack !== null && stack.depth >= this._maxCacheDepth) {
      return new MonarchLineState(stack);
    }
    let stackElementId = MonarchStackElement.getStackElementId(stack);
    let result = this._entries[stackElementId];
    if (result) {
      return result;
    }
    result = new MonarchLineState(stack);
    this._entries[stackElementId] = result;
    return result;
  }
};
var MonarchLineStateFactory = _MonarchLineStateFactory;
MonarchLineStateFactory._INSTANCE = new _MonarchLineStateFactory(CACHE_STACK_DEPTH);
var MonarchLineState = class {
  constructor(stack) {
    this.stack = stack;
  }
  clone() {
    return MonarchLineStateFactory.create(this.stack);
  }
  equals(other) {
    if (!(other instanceof MonarchLineState)) {
      return false;
    }
    if (!this.stack.equals(other.stack)) {
      return false;
    }
    return true;
  }
};
var MonarchClassicTokensCollector = class {
  constructor() {
    this._tokens = [];
    this._language = null;
    this._lastToken = new Token(0, "start", "imba");
    this._lastTokenType = null;
  }
  enterMode(startOffset, modeId) {
    this._language = modeId;
  }
  emit(startOffset, type, stack) {
    if (this._lastTokenType === type && false) {
      console.log("add to last token", type);
      return this._lastToken;
    }
    let token = new Token(startOffset, type, this._language);
    this._lastTokenType = type;
    this._lastToken = token;
    this._tokens.push(token);
    return token;
  }
  finalize(endState) {
    return new TokenizationResult(this._tokens, endState);
  }
};
var MonarchTokenizer = class {
  constructor(modeId, lexer) {
    this._modeId = modeId;
    this._lexer = lexer;
    this._profile = false;
  }
  dispose() {
  }
  getLoadStatus() {
    return {loaded: true};
  }
  getInitialState() {
    let rootState = MonarchStackElementFactory.create(null, this._lexer.start);
    return MonarchLineStateFactory.create(rootState);
  }
  tokenize(line, lineState, offsetDelta) {
    let tokensCollector = new MonarchClassicTokensCollector();
    let endLineState = this._tokenize(line, lineState, offsetDelta, tokensCollector);
    return tokensCollector.finalize(endLineState);
  }
  _tokenize(line, lineState, offsetDelta, collector) {
    return this._myTokenize(line, lineState, offsetDelta, collector);
  }
  _safeRuleName(rule) {
    if (rule) {
      return rule.name;
    }
    return "(unknown)";
  }
  _rescope(from, to, tokens, toState) {
    let a = (from || "").split("-");
    let b = (to || "").split("-");
    if (from == to)
      return;
    let diff = 1;
    while (a[diff] && a[diff] == b[diff]) {
      diff++;
    }
    let level = a.length;
    while (level > diff) {
      tokens.push("pop." + a[--level] + "." + level);
    }
    while (b.length > diff) {
      let id = "push." + b[diff++] + "." + (diff - 1);
      if (toState) {
        let indent = statePart(toState, 1);
        id += "." + indent;
      }
      tokens.push(id);
    }
  }
  _myTokenize(line, lineState, offsetDelta, tokensCollector) {
    tokensCollector.enterMode(offsetDelta, this._modeId);
    const lineLength = line.length;
    let stack = lineState.stack;
    let lastToken = null;
    let pos = 0;
    let profile = this._profile;
    let groupMatching = null;
    let forceEvaluation = true;
    let append = [];
    let tries = 0;
    let rules = [];
    let rulesState = null;
    let hangPos = -1;
    while (forceEvaluation || pos < lineLength) {
      tries++;
      if (tries > 1e3) {
        if (pos == hangPos) {
          console.log("infinite recursion", pos, lineLength, stack, tokensCollector);
          throw "infinite recursion in tokenizer?";
        } else {
          hangPos = pos;
          tries = 0;
        }
      }
      const pos0 = pos;
      const stackLen0 = stack.depth;
      const groupLen0 = groupMatching ? groupMatching.groups.length : 0;
      const state = stack.state;
      let matches = null;
      let matched = null;
      let action = null;
      let rule = null;
      if (groupMatching) {
        matches = groupMatching.matches;
        const groupEntry = groupMatching.groups.shift();
        matched = groupEntry.matched;
        action = groupEntry.action;
        rule = groupMatching.rule;
        if (groupMatching.groups.length === 0) {
          groupMatching = null;
        }
      } else {
        if (!forceEvaluation && pos >= lineLength) {
          break;
        }
        forceEvaluation = false;
        rules = this._lexer.tokenizer[state];
        if (!rules) {
          rules = findRules(this._lexer, state);
          if (!rules) {
            throw createError(this._lexer, "tokenizer state is not defined: " + state);
          }
        }
        let restOfLine = line.substr(pos);
        for (const rule2 of rules) {
          if (rule2.string !== void 0) {
            if (restOfLine[0] === rule2.string) {
              matches = [rule2.string];
              matched = rule2.string;
              action = rule2.action;
              break;
            }
          } else if (pos === 0 || !rule2.matchOnlyAtLineStart) {
            if (profile) {
              rule2.stats.count++;
              let now = performance.now();
              matches = restOfLine.match(rule2.regex);
              rule2.stats.time += performance.now() - now;
              if (matches) {
                rule2.stats.hits++;
              }
            } else {
              matches = restOfLine.match(rule2.regex);
            }
            if (matches) {
              matched = matches[0];
              action = rule2.action;
              break;
            }
          }
        }
      }
      if (!matches) {
        matches = [""];
        matched = "";
      }
      if (!action) {
        if (pos < lineLength) {
          matches = [line.charAt(pos)];
          matched = matches[0];
        }
        action = this._lexer.defaultToken;
      }
      if (matched === null) {
        break;
      }
      pos += matched.length;
      while (isFuzzyAction(action) && isIAction(action) && action.test) {
        action = action.test(matched, matches, state, pos === lineLength);
      }
      let result = null;
      if (typeof action === "string" || Array.isArray(action)) {
        result = action;
      } else if (action.group) {
        result = action.group;
      } else if (action.token !== null && action.token !== void 0) {
        if (action.tokenSubst) {
          result = substituteMatches(this._lexer, action.token, matched, matches, state);
        } else {
          result = action.token;
        }
        if (action.goBack) {
          pos = Math.max(0, pos - action.goBack);
        }
        if (action.switchTo && typeof action.switchTo === "string") {
          let nextState = substituteMatches(this._lexer, action.switchTo, matched, matches, state);
          if (nextState[0] === "@") {
            nextState = nextState.substr(1);
          }
          if (!findRules(this._lexer, nextState)) {
            throw createError(this._lexer, "trying to switch to a state '" + nextState + "' that is undefined in rule: " + this._safeRuleName(rule));
          } else {
            let from = stack.scope;
            let to = statePart(nextState, 2);
            if (from !== to)
              this._rescope(from, to, append, nextState);
            stack = stack.switchTo(nextState);
          }
        } else if (action.transform && typeof action.transform === "function") {
          throw createError(this._lexer, "action.transform not supported");
        } else if (action.next) {
          if (action.next === "@push") {
            if (stack.depth >= this._lexer.maxStack) {
              throw createError(this._lexer, "maximum tokenizer stack size reached: [" + stack.state + "," + stack.parent.state + ",...]");
            } else {
              stack = stack.push(state);
            }
          } else if (action.next === "@pop") {
            if (stack.depth <= 1) {
              throw createError(this._lexer, "trying to pop an empty stack in rule: " + this._safeRuleName(rule));
            } else {
              let prev = stack;
              stack = stack.pop();
              let from = statePart(prev.state, 2);
              let to = statePart(stack.state, 2);
              if (from !== to)
                this._rescope(from, to, append, stack.state);
            }
          } else if (action.next === "@popall") {
            stack = stack.popall();
          } else {
            let nextState = substituteMatches(this._lexer, action.next, matched, matches, state);
            if (nextState[0] === "@") {
              nextState = nextState.substr(1);
            }
            let nextScope = statePart(nextState, 2);
            if (!findRules(this._lexer, nextState)) {
              throw createError(this._lexer, "trying to set a next state '" + nextState + "' that is undefined in rule: " + this._safeRuleName(rule));
            } else {
              if (nextScope != stack.scope)
                this._rescope(stack.scope || "", nextScope, append, nextState);
              stack = stack.push(nextState);
            }
          }
        }
        if (action.log && typeof action.log === "string") {
          log(this._lexer, this._lexer.languageId + ": " + substituteMatches(this._lexer, action.log, matched, matches, state));
        }
        if (action.mark) {
          tokensCollector.emit(pos0 + offsetDelta, action.mark, stack);
        }
      }
      if (result === null) {
        throw createError(this._lexer, "lexer rule has no well-defined action in rule: " + this._safeRuleName(rule));
      }
      if (Array.isArray(result)) {
        if (groupMatching && groupMatching.groups.length > 0) {
          throw createError(this._lexer, "groups cannot be nested: " + this._safeRuleName(rule));
        }
        if (matches.length !== result.length + 1) {
          throw createError(this._lexer, "matched number of groups does not match the number of actions in rule: " + this._safeRuleName(rule));
        }
        let totalLen = 0;
        for (let i = 1; i < matches.length; i++) {
          totalLen += matches[i].length;
        }
        if (totalLen !== matched.length) {
          throw createError(this._lexer, "with groups, all characters should be matched in consecutive groups in rule: " + this._safeRuleName(rule));
        }
        groupMatching = {
          rule,
          matches,
          groups: []
        };
        for (let i = 0; i < result.length; i++) {
          groupMatching.groups[i] = {
            action: result[i],
            matched: matches[i + 1]
          };
        }
        pos -= matched.length;
        continue;
      } else {
        if (result === "@rematch") {
          pos -= matched.length;
          matched = "";
          matches = null;
          result = "";
        }
        if (matched.length === 0) {
          if (lineLength === 0 || stackLen0 !== stack.depth || state !== stack.state || (!groupMatching ? 0 : groupMatching.groups.length) !== groupLen0) {
            if (typeof result == "string" && result)
              tokensCollector.emit(pos + offsetDelta, result, stack);
            while (append.length > 0) {
              tokensCollector.emit(pos + offsetDelta, append.shift(), stack);
            }
            continue;
          } else {
            throw createError(this._lexer, "no progress in tokenizer in rule: " + this._safeRuleName(rule));
          }
        }
        let tokenType = null;
        if (isString(result) && result.indexOf("@brackets") === 0) {
          let rest = result.substr("@brackets".length);
          let bracket = findBracket(this._lexer, matched);
          if (!bracket) {
            throw createError(this._lexer, "@brackets token returned but no bracket defined as: " + matched);
          }
          tokenType = sanitize(bracket.token + rest);
        } else {
          let token2 = result === "" ? "" : result + this._lexer.tokenPostfix;
          tokenType = sanitize(token2);
        }
        let token = tokensCollector.emit(pos0 + offsetDelta, tokenType, stack);
        token.stack = stack;
        if (lastToken && lastToken != token) {
          lastToken.value = line.slice(lastToken.offset - offsetDelta, pos0);
        }
        lastToken = token;
        while (append.length > 0) {
          tokensCollector.emit(pos + offsetDelta, append.shift(), stack);
        }
      }
    }
    if (lastToken && !lastToken.value) {
      lastToken.value = line.slice(lastToken.offset - offsetDelta);
    }
    return MonarchLineStateFactory.create(stack);
  }
};
function findBracket(lexer, matched) {
  if (!matched) {
    return null;
  }
  matched = fixCase(lexer, matched);
  let brackets = lexer.brackets;
  for (const bracket of brackets) {
    if (bracket.open === matched) {
      return {token: bracket.token, bracketType: MonarchBracket.Open};
    } else if (bracket.close === matched) {
      return {token: bracket.token, bracketType: MonarchBracket.Close};
    }
  }
  return null;
}

// src/program/grammars/xml.imba
var grammar = {
  defaultToken: "",
  tokenPostfix: ".xml",
  ignoreCase: true,
  qualifiedName: /(?:[\w\.\-]+:)?[\w\.\-]+/,
  tokenizer: {
    root: [
      [/[^<&]+/, ""],
      {include: "@whitespace"},
      [/(<)(@qualifiedName)/, [
        {token: "delimiter"},
        {token: "tag", next: "@tag"}
      ]],
      [/(<\/)(@qualifiedName)(\s*)(>)/, [
        {token: "delimiter"},
        {token: "tag"},
        "",
        {token: "delimiter"}
      ]],
      [/(<\?)(@qualifiedName)/, [
        {token: "delimiter"},
        {token: "metatag", next: "@tag"}
      ]],
      [/(<\!)(@qualifiedName)/, [
        {token: "delimiter"},
        {token: "metatag", next: "@tag"}
      ]],
      [/<\!\[CDATA\[/, {token: "delimiter.cdata", next: "@cdata"}],
      [/&\w+;/, "string.escape"]
    ],
    cdata: [
      [/[^\]]+/, ""],
      [/\]\]>/, {token: "delimiter.cdata", next: "@pop"}],
      [/\]/, ""]
    ],
    tag: [
      [/[ \t\r\n]+/, ""],
      [/(@qualifiedName)(\s*=\s*)("[^"]*"|'[^']*')/, ["attribute.name", "", "attribute.value"]],
      [/(@qualifiedName)(\s*=\s*)("[^">?\/]*|'[^'>?\/]*)(?=[\?\/]\>)/, ["attribute.name", "", "attribute.value"]],
      [/(@qualifiedName)(\s*=\s*)("[^">]*|'[^'>]*)/, ["attribute.name", "", "attribute.value"]],
      [/@qualifiedName/, "attribute.name"],
      [/\?>/, {token: "delimiter", next: "@pop"}],
      [/(\/)(>)/, [
        {token: "tag"},
        {token: "delimiter", next: "@pop"}
      ]],
      [/>/, {token: "delimiter", next: "@pop"}]
    ],
    whitespace: [
      [/[ \t\r\n]+/, ""],
      [/<!--/, {token: "comment", next: "@comment"}]
    ],
    comment: [
      [/[^<\-]+/, "comment.content"],
      [/-->/, {token: "comment", next: "@pop"}],
      [/<!--/, "comment.content.invalid"],
      [/[<\-]/, "comment.content"]
    ]
  }
};

// src/program/monarch.imba
var tokenizers = {};
var Monarch = class {
  static getTokenizer(langId) {
    if (langId == "xml" && !tokenizers[langId]) {
      return this.createTokenizer("xml", grammar);
    }
    ;
    return tokenizers[langId];
  }
  static createTokenizer(langId, grammar2) {
    let compiled = compile(langId, grammar2);
    return tokenizers[langId] = new MonarchTokenizer(langId, compiled);
  }
};

// src/compiler/assets.imba
function iter$__2(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ6 = Symbol.for("#attributes");
function parseAsset(raw, name) {
  var φ45, φ54;
  let text = raw.body;
  let xml = Monarch.getTokenizer("xml");
  let state = xml.getInitialState();
  let out = xml.tokenize(text, state, 0);
  let attrs = {};
  let desc = {attributes: attrs, flags: []};
  let currAttr;
  let contentStart = 0;
  for (let φ114 = 0, φ28 = iter$__2(out.tokens), φ39 = φ28.length; φ114 < φ39; φ114++) {
    let tok = φ28[φ114];
    let val = tok.value;
    if (tok.type == "attribute.name.xml") {
      currAttr = tok;
      attrs[val] = true;
    }
    ;
    if (tok.type == "attribute.value.xml") {
      let len = val.length;
      if (len > 2 && val[0] == val[len - 1] && (val[0] == '"' || val[0] == "'")) {
        val = val.slice(1, -1);
      }
      ;
      attrs[currAttr.value] = val;
    }
    ;
    if (tok.type == "delimiter.xml" && val == ">") {
      contentStart = tok.offset + 1;
      break;
    }
    ;
  }
  ;
  desc.content = text.slice(contentStart).replace("</svg>", "");
  if (attrs.class) {
    desc.flags = attrs.class.split(/\s+/g);
    φ45 = attrs.class, delete attrs.class, φ45;
  }
  ;
  if (name) {
    desc.flags.push("asset-" + name.toLowerCase());
  }
  ;
  φ54 = attrs.xmlns, delete attrs.xmlns, φ54;
  return desc;
}
function parseHTML(raw) {
  var _a;
  let text = raw.body;
  let xml = Monarch.getTokenizer("xml");
  let state = xml.getInitialState();
  let out = xml.tokenize(text, state, 0);
  let currAttr;
  let contentStart = 0;
  let currTag = {
    attributes: {},
    [φ6]: {}
  };
  let tags = [];
  let result = {
    text: raw
  };
  let imports = result.imports = [];
  let newtext = "";
  let reftags = new Set();
  let tokens = out.tokens.slice(0);
  for (let i = 0, φ74 = iter$__2(tokens), φ83 = φ74.length; i < φ83; i++) {
    let tok = φ74[i];
    let typ = tok.type;
    let val = tok.value;
    let prev = out.tokens[i - 1];
    if (typ == "tag.xml") {
      if (prev.value == "<") {
        tags.push(currTag = tok);
        tok.attributes = {};
        tok[φ6] = {};
        tags[val] || (tags[val] = []);
        tags[val].push(tok);
      } else if (prev.value == "</") {
        currTag.closer || (currTag.closer = tok);
        true;
      }
      ;
    }
    ;
    if (typ == "delimiter.xml" && val == ">") {
      let currTyp = currTag == null ? void 0 : currTag.value;
      if (currTyp == "head" || currTyp == "body") {
        tok.value += "<!--$" + currTyp + "$-->";
      }
      ;
    }
    ;
    if (typ == "attribute.name.xml") {
      currTag[φ6][val] = tok;
      currAttr = val;
    }
    ;
    if (typ == "attribute.value.xml") {
      let unquoted = val;
      if (val.length > 2 && val[0] == val[val.length - 1] && (val[0] == '"' || val[0] == "'")) {
        unquoted = val.slice(1, -1);
      }
      ;
      tok.raw = unquoted;
      currTag.attributes[currAttr] = tok;
    }
    ;
  }
  ;
  for (let φ92 = 0, φ103 = iter$__2(tags), φ11 = φ103.length; φ92 < φ11; φ92++) {
    let el = φ103[φ92];
    let item = null;
    let src = el.attributes.src;
    if (el.value == "script" && src) {
      item = {path: src.raw, tagType: "script"};
    } else if (el.value == "img" && src) {
      item = {path: src.raw, tagType: "img"};
    } else if (el.value == "link" && ((_a = el.attributes.rel) == null ? void 0 : _a.raw) == "stylesheet") {
      src = el.attributes.href;
      item = {path: src.raw, tagType: "style"};
    } else if (el.value == "style" && src) {
      item = {path: src.raw, tagType: "style"};
      el.value = "link rel='stylesheet'";
      if (el.closer) {
        el.closer.value = "link";
      }
      ;
      if (el[φ6].src) {
        el[φ6].src.value = "href";
      }
      ;
    }
    ;
    if (src && item) {
      if (!item.path.match(/^(\/|https?\:\/\/)/)) {
        let nr = imports.push(item);
        src.value = "'ASSET_REF_" + (nr - 1) + "'";
      }
      ;
    }
    ;
  }
  ;
  let outstr = "";
  for (let φ123 = 0, φ133 = iter$__2(tokens), φ143 = φ133.length; φ123 < φ143; φ123++) {
    let tok = φ133[φ123];
    outstr += tok.value;
  }
  ;
  result.contents = outstr.replace(/<\/link>/g, "");
  return result;
}

// src/bundler/component.imba
var import_events = __toModule(require("events"));
var import_perf_hooks2 = __toModule(require("perf_hooks"));
var φ13 = Symbol.for("#logger");
var φ23 = Symbol.for("#timestamps");
var Component = class extends import_events.EventEmitter {
  get log() {
    return this[φ13] || (this[φ13] = new Logger());
  }
  time(name = "default") {
    let now = Date.now();
    this[φ23] || (this[φ23] = {});
    let prev = this[φ23][name] || now;
    let diff = now - prev;
    this[φ23][name] = now;
    return diff;
  }
  timed(name = "default") {
    let str;
    return str = "time " + name + ": " + this.time(name);
  }
  timelog(label = "timing") {
    return console.log(label, import_perf_hooks2.performance.now());
  }
};
var component_default = Component;

// src/bundler/changes.imba
function iter$__3(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var ChangeLog = class {
  constructor(o = {}) {
    this.log = [];
    this.maps = new WeakMap();
    this.cursors = o.ignoreInitial ? null : new WeakMap();
    this.depth = 0;
    this.offset = 0;
    this.pulled = 0;
    this.options = o;
    this.batch = null;
  }
  flush() {
    if (this.batch) {
      if (this.options.withFlags) {
        this.log.push(...Array.from(this.batch));
      } else {
        for (let [item, marks] of iter$__3(this.batch)) {
          this.log.push(item);
        }
        ;
      }
      ;
      this.batch = null;
    }
    ;
    return this;
  }
  push(item) {
    return this.mark(item);
  }
  mark(item, flag = 2) {
    if (!this.cursors) {
      return;
    }
    ;
    if (this.batch) {
      return this.batch.set(item, (this.batch.get(item) || 0) | flag);
    } else {
      this.batch = new Map();
      return this.batch.set(item, flag);
    }
    ;
  }
  trim() {
    this.offset += this.log.length;
    this.log.length = 0;
    return this;
  }
  get cursor() {
    return this.offset + this.log.length;
  }
  get length() {
    return this.log.length;
  }
  pull(target) {
    if (this.batch) {
      this.flush();
    }
    ;
    let map = this.cursors || (this.cursors = new WeakMap());
    let pos = map.get(target);
    let cur = this.cursor;
    if (pos == void 0 || pos < cur) {
      map.set(target, cur);
      let start = Math.max((pos || 0) - this.offset, 0);
      return this.log.slice(start);
    }
    ;
    return false;
  }
};
var changes_default = ChangeLog;

// src/bundler/fs.imba
var import_image_size = __toModule(require_dist());
function iter$__5(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ14 = Symbol.for("#cache");
var φ7 = Symbol.for("#watchers");
var φ8 = Symbol.for("#watched");
var φ10 = Symbol.for("#tree");
var φ122 = Symbol.for("#mtime");
var φ132 = Symbol.for("#body");
var φ142 = Symbol.for("#abs");
var φ15 = Symbol.for("#hash");
var φ16 = Symbol.for("#mtimesync");
var φ20 = Symbol.for("#files");
var φ21 = Symbol.for("#map");
var φ232 = Symbol.for("#resolver");
var nfs = require("fs");
var np3 = require("path");

// src/bundler/config.imba
function iter$__4(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var optionTypes = {
  esbuild: "object",
  external: "array",
  hashing: "boolean",
  minify: "boolean"
};
var defaultConfig = {
  bundles: [],
  options: {
    base: {
      target: ["es2019", "chrome80", "edge18"]
    },
    node: {
      extends: "base",
      platform: "node",
      format: "cjs",
      sourcemap: true,
      hashing: false,
      target: ["node12.19.0"],
      external: ["dependencies", "devDependencies", "!imba"]
    },
    web: {
      extends: "base",
      platform: "browser",
      sourcemap: true,
      format: "esm"
    },
    esm: {
      extends: "web",
      format: "esm",
      splitting: true
    },
    iife: {
      extends: "web",
      format: "iife",
      splitting: false,
      platform: "browser"
    },
    client: {
      extends: "web",
      splitting: true
    },
    css: {
      format: "css",
      platform: "browser",
      external: ["dependencies", "devDependencies", "!imba"],
      sourcemap: false,
      splitting: false
    },
    html: {
      format: "html",
      platform: "browser",
      sourcemap: false,
      splitting: false,
      hashing: false
    },
    worker: {
      extends: "base",
      format: "esm",
      platform: "worker",
      splitting: false
    },
    nodeworker: {
      extends: "node",
      format: "cjs",
      platform: "node",
      splitting: false
    },
    webworker: {
      extends: "base",
      format: "esm",
      platform: "webworker",
      splitting: false
    },
    serviceworker: {
      extends: "base",
      format: "esm",
      platform: "webworker",
      splitting: false,
      hashing: false
    }
  }
};
function clone(object) {
  if (object == void 0 || object == null) {
    return object;
  }
  ;
  return JSON.parse(JSON.stringify(object));
}
function merge(config, patch, ...up) {
  let otyp = typeof config;
  let vtyp = typeof patch;
  if (config instanceof Array) {
    otyp = "array";
  }
  ;
  if (patch instanceof Array) {
    vtyp = "array";
  }
  ;
  let keytype = optionTypes[up[0]];
  if (keytype == "boolean") {
    return patch;
  }
  ;
  if (otyp == "string" && vtyp == "string") {
    return patch;
  }
  ;
  if (otyp == "array") {
    if (vtyp == "string") {
      patch = patch.split(/\,\s*|\s+/g);
    }
    ;
    let mod = patch.every(function(_0) {
      return /[\-\+]/.test(_0 || "");
    });
    let cloned = new Set(mod ? clone(config) : []);
    for (let φ114 = 0, φ28 = iter$__4(patch), φ39 = φ28.length; φ114 < φ39; φ114++) {
      let item = φ28[φ114];
      if (item[0] == "+") {
        cloned.add(item.slice(1));
      } else if (item[0] == "-") {
        cloned.delete(item.slice(1));
      } else {
        cloned.add(item);
      }
      ;
    }
    ;
    return Array.from(cloned);
  }
  ;
  if (config == null) {
    return clone(patch);
  }
  ;
  for (let φ45 = 0, φ54 = Object.keys(patch), φ62 = φ54.length, key, value; φ45 < φ62; φ45++) {
    key = φ54[φ45];
    value = patch[key];
    config || (config = {});
    if (config.hasOwnProperty(key)) {
      config[key] = merge(config[key], value, key, ...up);
    } else {
      config[key] = clone(value);
    }
    ;
  }
  ;
  return config;
}
function resolve(config, cwd) {
  config = merge(clone(defaultConfig), config);
  return config;
}
function resolvePresets(imbaconfig, config = {}, types = null) {
  if (typeof types == "string") {
    types = types.split(",");
  }
  ;
  let key = Symbol.for(types.join("+"));
  let base = Object.assign({presets: []}, config);
  let presets = imbaconfig.options;
  for (let φ74 = 0, φ83 = iter$__4(types), φ123 = φ83.length; φ74 < φ123; φ74++) {
    let typ = φ83[φ74];
    let pre = presets[typ] || {};
    base.presets.push(typ);
    let curr = pre;
    let add = [pre];
    while (curr.extends && add.length < 10) {
      add.unshift(curr = presets[curr.extends]);
    }
    ;
    for (let φ92 = 0, φ103 = iter$__4(add), φ11 = φ103.length; φ92 < φ11; φ92++) {
      let item = φ103[φ92];
      Object.assign(base, item);
    }
    ;
  }
  ;
  return base;
}

// src/bundler/fs.imba
var utils = require_utils4();
var micromatch2 = require_micromatch();
var blankStat = {
  size: 0,
  blocks: 0,
  atimeMs: 0,
  mtimeMs: 0,
  ctimeMs: 0,
  birthtimeMs: 0,
  atime: "",
  mtime: "",
  ctime: "",
  birthtime: ""
};
var FLAGS = {
  CHECKED: 1,
  EXISTS: 2,
  REGISTERED: 4,
  WATCHED: 8,
  RESOLVED: 16,
  REMOVED: 32,
  ADDED: 64
};
var matchToRegexCache = {};
function matchToRegex(str) {
  return matchToRegexCache[str] || (matchToRegexCache[str] = (str = str.replace(/(\*\*|\*|\.)/g, function(m, t) {
    if (t == "**") {
      return "(.*)";
    } else if (t == "*") {
      return "([^/]+)";
    } else if (t == ".") {
      return "\\.";
    }
    ;
  }), new RegExp(str)));
}
var FSTree = class extends Array {
  constructor(...items) {
    super(...items);
    this[φ14] = {};
  }
  withExtension(ext) {
    return this.match(".(" + ext.replace(/,/g, "|") + ")$");
  }
  match(match) {
    var φ28;
    if (typeof match == "string") {
      let regex = matchToRegex(match);
      return (φ28 = this[φ14])[match] || (φ28[match] = this.filter(function(_0) {
        return regex.test(_0.rel);
      }));
    }
    ;
  }
  add(node) {
    let idx = this.indexOf(node);
    if (idx == -1) {
      this.push(node);
      this[φ14] = {};
    }
    ;
    return this;
  }
  get paths() {
    return this.map(function(_0) {
      return _0.rel;
    });
  }
  remove(node) {
    let idx = this.indexOf(node);
    if (idx >= 0) {
      this.splice(idx, 1);
      for (let φ54 = this[φ14], φ39 = 0, φ45 = Object.keys(φ54), φ62 = φ45.length, key, res; φ39 < φ62; φ39++) {
        key = φ45[φ39];
        res = φ54[key];
        res.remove(node);
      }
      ;
    }
    ;
    return this;
  }
};
var FSNode = class {
  static create(root, src, abs) {
    let ext = src.slice(src.lastIndexOf("."));
    let types = {
      ".json": JSONFile,
      ".imba": ImbaFile,
      ".imba1": Imba1File,
      ".svg": SVGFile,
      ".png": ImageFile,
      ".apng": ImageFile,
      ".jpg": ImageFile,
      ".jpeg": ImageFile,
      ".webp": ImageFile,
      ".avif": ImageFile,
      ".gif": ImageFile,
      ".ico": ImageFile,
      ".html": HTMLFile
    };
    let cls = types[ext] || FileNode;
    return new cls(root, src, abs);
  }
  constructor(root, rel, abs) {
    this.root = root;
    this.rel = rel;
    this.abs = abs;
    this.flags = 0;
    this[φ7] = new Set();
    this[φ8] = false;
  }
  get log() {
    return this.root.log;
  }
  get program() {
    return this.root.program;
  }
  get fs() {
    return this.root;
  }
  get nodefs() {
    return this.root.nodefs;
  }
  get name() {
    return np3.basename(this.rel);
  }
  get ext() {
    return np3.extname(this.rel);
  }
  memo(key, cb) {
    let cache = this.program.cache;
    return cache.memo("" + this.abs + ":" + key, this.mtimesync, cb);
  }
  watch(observer) {
    this[φ7].add(observer);
    if (this[φ8] != true ? (this[φ8] = true, true) : false) {
      return this.program.watcher.add(this.abs);
    }
    ;
  }
  get registeredΦ() {
    return this.flags & FLAGS.REGISTERED;
  }
  register() {
    var φ92;
    if ((this.flags & (φ92 = FLAGS.REGISTERED)) == 0 ? (this.flags |= φ92, true) : false) {
      this.root[φ10].add(this);
    }
    ;
    return this;
  }
  deregister() {
    var φ11;
    if (this.flags & (φ11 = FLAGS.REGISTERED) ? (this.flags &= ~φ11, true) : false) {
      return this.root[φ10].remove(this);
    }
    ;
  }
  touch() {
    this[φ122] = Date.now();
    this[φ132] = void 0;
    return this;
  }
  existsSync() {
    if (this.registeredΦ) {
      return true;
    }
    ;
    let real = this.nodefs.existsSync(this.abs);
    if (real) {
      this.register();
      return true;
    } else {
      return false;
    }
    ;
  }
  unwatch(observer) {
    this[φ7].delete(observer);
    if (this[φ8] && this[φ7].size == 0) {
      this[φ8] = false;
      return this.program.watcher.unwatch(this.abs);
    }
    ;
  }
};
var DirNode = class extends FSNode {
};
var FileNode = class extends FSNode {
  constructor(root, rel, abs) {
    super(...arguments);
    this.cache = {};
  }
  [Symbol.toPrimitive](hint) {
    return this.abs;
  }
  get reldir() {
    return this.rel.slice(0, this.rel.lastIndexOf("/") + 1);
  }
  get absdir() {
    return this.abs.slice(0, this.abs.lastIndexOf(np3.sep) + 1);
  }
  get dir() {
    return this.root.lookup(this.absdir, DirNode);
  }
  lookup(path) {
    let o = {
      importer: this.abs,
      resolveDir: this.absdir,
      path
    };
    let res = this.root.resolver.resolve(o);
    if (res && res[φ142]) {
      return this.root.lookup(res[φ142]);
    }
    ;
    return null;
  }
  async write(body, hash) {
    if (!hash || (this[φ15] != hash ? (this[φ15] = hash, true) : false)) {
      await this.nodefs.promises.mkdir(this.absdir, {recursive: true});
      if (this.rel.indexOf("../") != 0 || true) {
        this.log.success("write %path %kb", this.rel, body.length);
      }
      ;
      return this.nodefs.promises.writeFile(this.abs, body);
    }
    ;
  }
  writeSync(body, hash) {
    if (!hash || (this[φ15] != hash ? (this[φ15] = hash, true) : false)) {
      if (this.rel.indexOf("../") != 0 || true) {
        this.log.success("write %path %kb", this.rel, body.length);
      }
      ;
      return this.nodefs.writeFileSync(this.abs, body);
    }
    ;
  }
  read(enc = "utf8") {
    return this[φ132] || this.nodefs.promises.readFile(this.abs, enc);
  }
  readSync(enc = "utf8") {
    return this[φ132] || (this[φ132] = this.nodefs.readFileSync(this.abs, enc));
  }
  stat() {
    return this.nodefs.promises.stat(this.abs).then(function(_0) {
      return _0;
    }).catch(function() {
      return blankStat;
    });
  }
  get mtimesync() {
    return this[φ16] || (this.existsSync() ? this.nodefs.statSync(this.abs).mtimeMs : 1);
  }
  async mtime() {
    if (!this[φ122]) {
      let s = await this.stat();
      this[φ122] = s.mtimeMs;
    }
    ;
    return this[φ122];
  }
  unlink() {
    this.log.debug("unlink %path", this.rel);
    return this.nodefs.promises.unlink(this.abs);
  }
  extractStarPattern(pat) {
    let regex = new RegExp(pat.replace(/\*/g, "([^/]+)"));
    return (this.rel.match(regex) || []).slice(1);
  }
};
var ImbaFile = class extends FileNode {
  compile(o, context = this.program) {
    var self2 = this;
    return this.memo(o.platform, async function() {
      o = Object.assign({
        platform: o.platform,
        format: "esm",
        imbaPath: "imba",
        styles: "extern",
        hmr: true,
        bundle: true,
        sourcePath: self2.rel,
        sourceId: self2.program.cache.getPathAlias(self2.abs),
        cwd: self2.fs.cwd,
        sourcemap: "inline",
        config: self2.program.config
      }, {});
      o.format = "esm";
      let code = await self2.read();
      let t = Date.now();
      let out = await context.workers.exec("compile_imba", [code, o]);
      self2.fs.log.success("compile %path %path in %ms", self2.rel, o.platform, Date.now() - t, o.sourceId);
      return out;
    });
  }
};
var Imba1File = class extends FileNode {
  compile(o, context = this.program) {
    var self2 = this;
    return this.memo(o.platform, async function() {
      o = Object.assign({
        platform: "node",
        format: "esm",
        sourcePath: self2.rel,
        filename: self2.rel,
        inlineHelpers: 1,
        cwd: self2.fs.cwd
      }, o);
      o.target = o.platform;
      let code = await self2.read();
      let params = {
        code,
        options: o,
        type: "imba1"
      };
      let t = Date.now();
      let out = await context.workers.exec("compile_imba1", [code, o]);
      self2.log.success("compile %path in %ms", self2.rel, Date.now() - t);
      return out;
    });
  }
};
var SVGFile = class extends FileNode {
  compile(o) {
    var self2 = this;
    return this.memo(o.format, async function() {
      let svgbody = await self2.read();
      let parsed = parseAsset({body: svgbody});
      let js = "import {asset} from 'imba';\nimport url from './" + self2.name + "';\nexport default asset({\n	url: url,\n	type: 'svg',\n	meta: " + JSON.stringify(parsed) + ",\n	toString: function(){ return this.url;}\n})";
      return {js};
    });
  }
};
var HTMLFile = class extends FileNode {
  compile(o) {
    var self2 = this;
    return this.memo(o.format, async function() {
      let body = await self2.read();
      let parsed = parseHTML({body});
      let code = [];
      let refs2 = [];
      for (let i = 0, φ172 = iter$__5(parsed.imports), φ182 = φ172.length; i < φ182; i++) {
        let item = φ172[i];
        let path = item.path;
        let kind = "";
        if (item.tagType == "img") {
          kind = "";
        } else if (item.tagType == "script") {
          kind = "web";
        } else if (item.tagType == "style") {
          kind = "css";
        }
        ;
        if (kind && path.indexOf("?as=") == -1) {
          path = path + "?as=" + kind;
        }
        ;
        code.push("import ref" + i + " from '" + path + "';");
        refs2.push("ref" + i);
      }
      ;
      code.push("export const URLS = [" + refs2.join(",") + "];");
      code.push("export const HTML = " + JSON.stringify(parsed.contents));
      return {js: code.join("\n"), html: parsed.contents};
    });
  }
};
var ImageFile = class extends FileNode {
  compile(o) {
    var self2 = this;
    return this.memo(o.format, async function() {
      let size = await Promise.resolve((0, import_image_size.default)(self2.abs));
      let js = "import {asset} from 'imba';\nimport url from './" + self2.name + "';\nexport default asset({\n	url: url,\n	type: 'image',\n	width: " + (size.width || 0) + ",\n	height: " + (size.height || 0) + ",\n	toString: function(){ return this.url;}\n})";
      return {
        width: size.width,
        height: size.height,
        js
      };
    });
  }
};
var JSONFile = class extends FileNode {
  constructor() {
    super(...arguments);
  }
  load() {
    try {
      this.raw = this.readSync();
      this.data = JSON.parse(this.raw);
    } catch (φ192) {
      this.data = {};
    }
    ;
    return this;
  }
  save() {
    let out = JSON.stringify(this.data, null, 2);
    if (out != this.raw) {
      this.raw = out;
      this.writeSync(out);
    }
    ;
    return this;
  }
};
var FileSystem = class extends component_default {
  constructor(cwd, program) {
    super();
    this.cwd = np3.resolve(cwd);
    this.program = program;
    this.nodemap = {};
    this.existsCache = {};
    this.changelog = new changes_default();
    this[φ20] = null;
    this[φ10] = new FSTree();
    this[φ21] = {};
  }
  toString() {
    return this.cwd;
  }
  valueOf() {
    return this.cwd;
  }
  existsSync(src) {
    let entry = this.nodemap[src];
    if (entry) {
      return entry.existsSync();
    } else {
      if (this.existsCache[src] != void 0) {
        return this.existsCache[src];
      }
      ;
      return this.existsCache[src] = this.nodefs.existsSync(this.resolve(src));
    }
    ;
  }
  lookup(src, typ = FileNode) {
    var φ222;
    src = this.relative(src);
    return (φ222 = this.nodemap)[src] || (φ222[src] = typ.create(this, src, this.resolve(src)));
  }
  nodes(arr) {
    var self2 = this;
    return arr.map(function(_0) {
      return self2.lookup(_0);
    });
  }
  get nodefs() {
    return this.program.volume || nfs;
  }
  get files() {
    if (!this[φ20]) {
      this.prescan();
    }
    ;
    return this[φ20];
  }
  get resolver() {
    return this[φ232] || (this[φ232] = new Resolver({config: this.program.config, files: this.files, fs: this}));
  }
  get cache() {
    return this.program.cache;
  }
  resolve(...src) {
    return np3.resolve(this.cwd, ...src);
  }
  relative(src) {
    return np3.relative(this.cwd, this.resolve(src)).split(np3.sep).join(np3.posix.sep);
  }
  writeFile(src, body) {
    return this.nodefs.promises.writeFile(this.resolve(src), body);
  }
  unlink(src, body) {
    return this.nodefs.promises.unlink(this.resolve(src));
  }
  readFile(src, enc = "utf8") {
    return this.nodefs.promises.readFile(this.resolve(src), enc);
  }
  stat(src) {
    return this.nodefs.promises.stat(this.resolve(src)).then(function(_0) {
      return _0;
    }).catch(function() {
      return blankStat;
    });
  }
  touchFile(src) {
    this.changelog.mark(src);
    this.lookup(src).touch();
    return this.emit("change");
  }
  addFile(src) {
    this.changelog.mark(src);
    this.lookup(src).register();
    return this.emit("change");
  }
  removeFile(src) {
    this.changelog.mark(src);
    this.lookup(src).deregister();
    return this.emit("change");
  }
  prescan(items = null) {
    var φ262;
    if (this[φ20]) {
      return this[φ20];
    }
    ;
    this[φ20] = items || this.crawl();
    for (let φ242 = 0, φ252 = iter$__5(this[φ20]), φ272 = φ252.length; φ242 < φ272; φ242++) {
      let item = φ252[φ242];
      let li = item.lastIndexOf(".");
      let ext = li == -1 ? ".*" : item.slice(li);
      let map = (φ262 = this[φ20])[ext] || (φ262[ext] = []);
      map.push(item);
    }
    ;
    return this[φ20];
  }
  reset() {
    this[φ20] = null;
    return this;
  }
  glob(match = [], ignore = null, ext = null) {
    var self2 = this;
    this.prescan();
    let sources = this[φ10];
    if (ext) {
      sources = this[φ10].withExtension(ext);
    }
    ;
    if (match instanceof RegExp && !ignore) {
      return sources.filter(function(_0) {
        return match.test(_0.rel);
      });
    } else if (typeof match == "string") {
      if (match.indexOf("*") >= 0) {
        match = [match];
      } else {
        return new FSTree(this.existsSync(match) ? this.lookup(match) : null);
      }
      ;
    }
    ;
    if (!match || match.length == 0) {
      if (!ignore) {
        return sources.slice(0);
      }
      ;
      match = ["*"];
    }
    ;
    let res = micromatch2(sources.paths, match, {ignore});
    return new FSTree(...res.map(function(_0) {
      return self2.nodemap[_0];
    }));
  }
  find(regex, ext = null) {
    this.prescan();
    let sources = ext ? [] : this[φ20];
    if (typeof ext == "string") {
      ext = ext.split(",");
    }
    ;
    if (ext instanceof Array) {
      for (let φ28 = 0, φ29 = iter$__5(ext), φ30 = φ29.length; φ28 < φ30; φ28++) {
        let item = φ29[φ28];
        sources = sources.concat(this[φ20]["." + item] || []);
      }
      ;
    }
    ;
    return sources.filter(function(_0) {
      return regex.test(_0);
    });
  }
  scan(match) {
    this.prescan();
    let matched = [];
    for (let φ31 = 0, φ322 = iter$__5(this[φ20]), φ332 = φ322.length; φ31 < φ332; φ31++) {
      let src = φ322[φ31];
      let m = false;
      if (match instanceof RegExp) {
        m = match.test(src);
        if (m) {
          matched.push(this.lookup(src));
        }
        ;
      }
      ;
    }
    ;
    return matched;
  }
  fromJSON(structure, base) {
    var φ363, φ39;
    let paths = [];
    for (let φ342 = 0, φ352 = iter$__5(this.res), φ41 = φ352.length; φ342 < φ41; φ342++) {
      let entry = φ352[φ342];
      let absdir = entry.dir;
      let reldir = absdir.slice(this.slice);
      let dir = (φ363 = this.nodemap)[reldir] || (φ363[reldir] = new DirNode(this, reldir, absdir));
      for (let φ373 = 0, φ382 = iter$__5(entry.files), φ40 = φ382.length; φ373 < φ40; φ373++) {
        let f = φ382[φ373];
        let rel = reldir + "/" + f;
        let abs = absdir + "/" + f;
        let file = (φ39 = this.nodemap)[rel] || (φ39[rel] = FSNode.create(this, rel, abs));
        file.register();
        paths.push(rel);
      }
      ;
    }
    ;
    return true;
  }
  crawl(o = {}) {
    var φ442, φ48, φ51;
    let slice = this.cwd.length + 1;
    let filter = function(a) {
      return a[0] != ".";
    };
    let grouped = true;
    if (this.nodefs.toJSON) {
      let res = this.nodefs.toJSON();
      let paths = [];
      for (let φ423 = 0, φ433 = Object.keys(res), φ45 = φ433.length, abs, body; φ423 < φ45; φ423++) {
        abs = φ433[φ423];
        body = res[abs];
        let rel = abs.slice(slice);
        let file = (φ442 = this.nodemap)[rel] || (φ442[rel] = FSNode.create(this, rel, abs));
        file.register();
        paths.push(rel);
      }
      ;
      return paths;
    } else {
      let api = new import_fdir.fdir().crawlWithOptions(this.cwd, {
        includeBasePath: !grouped,
        group: grouped,
        includeDirs: false,
        maxDepth: 8,
        filters: [filter],
        exclude: function(_0, _1, _2) {
          if (_2 == 7) {
            if (o.includeRoots && !o.includeRoots[_0]) {
              return true;
            }
            ;
            if (o.excludeRoots && o.excludeRoots[_0]) {
              return true;
            }
            ;
          }
          ;
          return /^(\.|node_modules)/.test(_0);
        }
      });
      let res = api.sync();
      if (!grouped) {
        return res.map(function(_0) {
          return _0.slice(slice);
        });
      }
      ;
      let paths = [];
      for (let φ46 = 0, φ47 = iter$__5(res), φ532 = φ47.length; φ46 < φ532; φ46++) {
        let entry = φ47[φ46];
        let absdir = entry.dir;
        let reldir = absdir.slice(slice);
        let dir = (φ48 = this.nodemap)[reldir] || (φ48[reldir] = new DirNode(this, reldir, absdir));
        for (let φ49 = 0, φ50 = iter$__5(entry.files), φ522 = φ50.length; φ49 < φ522; φ49++) {
          let f = φ50[φ49];
          let rel = reldir ? reldir + "/" + f : f;
          let abs = absdir + np3.sep + f;
          let file = (φ51 = this.nodemap)[rel] || (φ51[rel] = FSNode.create(this, rel, abs));
          file.register();
          paths.push(rel);
        }
        ;
      }
      ;
      return paths;
    }
    ;
  }
};
var fs_default = FileSystem;

// src/bundler/cache.imba
var import_path = __toModule(require("path"));
var import_fs = __toModule(require("fs"));
var import_os = __toModule(require("os"));
var import_crypto = __toModule(require("crypto"));
function iter$__6(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ17 = Symbol.for("#key");
var utils2 = require_utils4();
var hashedKeyCache = {};
var keyPathCache = {};
var Cache = class {
  constructor(options) {
    this[φ17] = Symbol();
    this.o = options;
    this.dir = this.o.cachedir;
    this.nodefs = options.volume || import_fs.default;
    this.aliaspath = this.dir && import_path.default.resolve(this.dir, ".imba-aliases");
    this.aliasmap = [];
    this.aliascache = {};
    this.data = {
      aliases: {},
      cache: {}
    };
    this.mintime = this.o.mtime || 0;
    this.persistToDisk = !!this.dir;
    this.idFaucet = utils2.idGenerator();
    this.preload();
  }
  preload() {
    if (!this.persistToDisk) {
      return;
    }
    ;
    if (!this.nodefs.existsSync(this.dir)) {
      this.nodefs.mkdirSync(this.dir);
    }
    ;
    let entries = this.nodefs.readdirSync(this.dir);
    for (let φ28 = 0, φ39 = iter$__6(entries), φ45 = φ39.length; φ28 < φ45; φ28++) {
      let entry = φ39[φ28];
      this.cache[entry] = {exists: 1};
    }
    ;
    if (!this.nodefs.existsSync(this.aliaspath)) {
      this.nodefs.appendFileSync(this.aliaspath, "");
    }
    ;
    this.refreshAliasMap();
    logger_default.ts("cache loaded");
    return this;
  }
  setup() {
    return true;
  }
  save() {
    return this;
  }
  deserialize() {
    return this;
  }
  serialize() {
    return this;
  }
  get cache() {
    var φ54;
    return (φ54 = this.data).cache || (φ54.cache = {});
  }
  get aliases() {
    var φ62;
    return (φ62 = this.data).aliases || (φ62.aliases = {});
  }
  alias(src) {
    if (!this.aliases[src]) {
      let nr = Object.keys(this.aliases).length;
      this.aliases[src] = this.idFaucet(nr) + "0";
    }
    ;
    return this.aliases[src];
  }
  normalizeKey(key) {
    if (hashedKeyCache[key]) {
      return hashedKeyCache[key];
    }
    ;
    let hash = (0, import_crypto.createHash)("sha1");
    hash.update(key);
    return hashedKeyCache[key] = hash.digest("hex");
  }
  fullKeyPath(key) {
    return keyPathCache[key] || (keyPathCache[key] = import_path.default.resolve(this.dir, key));
  }
  getKeyTime(key) {
    let cached = this.cache[key];
    if (cached && cached.time) {
      return cached.time;
    }
    ;
    if (cached && cached.exists && this.persistToDisk) {
      let path = this.fullKeyPath(key);
      return this.nodefs.statSync(path).mtimeMs;
    } else {
      return 0;
    }
    ;
  }
  refreshAliasMap() {
    return this.aliasmap = this.nodefs.readFileSync(this.aliaspath, "utf8").split(/\r?\n/);
  }
  getPathAlias(path) {
    return this.getKeyAlias(path);
  }
  getKeyAlias(key) {
    if (this.aliascache[key]) {
      return this.aliascache[key];
    }
    ;
    let index = this.aliasmap.indexOf(key);
    if (index == -1) {
      if (this.persistToDisk) {
        this.nodefs.appendFileSync(this.aliaspath, key + "\n", "utf8");
        this.refreshAliasMap();
      } else {
        this.aliasmap.push(key);
      }
      ;
      index = this.aliasmap.indexOf(key);
    }
    ;
    if (index >= 0) {
      return this.aliascache[key] = this.idFaucet(index);
    } else {
      console.log("key not added?", key, this.aliasmap);
      throw "could not add key to aliasmap";
    }
    ;
  }
  async getKeyValue(key) {
    let path = this.fullKeyPath(key);
    let val = await this.nodefs.promises.readFile(path, "utf8");
    return JSON.parse(val);
  }
  setKeyValue(key, value) {
    if (!this.persistToDisk) {
      return;
    }
    ;
    let path = this.fullKeyPath(key);
    let json = JSON.stringify(value);
    return this.nodefs.promises.writeFile(path, json);
  }
  memo(name, time, cb) {
    var self2 = this;
    let key = this.normalizeKey(name);
    if (this.mintime > time) {
      time = this.mintime;
    }
    ;
    let cached = this.cache[key];
    if (cached && cached.time >= time) {
      return cached.promise;
    }
    ;
    let keytime = this.getKeyTime(key);
    if (keytime > time) {
      cached = this.cache[key] = {
        time: Date.now(),
        promise: this.getKeyValue(key)
      };
    } else {
      cached = this.cache[key] = {
        time: Date.now(),
        promise: cb()
      };
      cached.promise.then(function(val) {
        return self2.setKeyValue(key, val);
      });
    }
    ;
    return cached.promise;
  }
};
var cache_default = Cache;

// src/bundler/program.imba
var φ18 = Symbol.for("#resolver");
var φ24 = Symbol.for("#workers");
var φ34 = Symbol.for("#setup");
var φ72 = Symbol.for("#hasesb");
var utils3 = require_utils4();
var np5 = require("path");
var micromatch3 = require_micromatch();
var esbuild = require("esbuild");
var workerPool2 = require_src();
var workerScript2 = np5.resolve(__dirname, "..", "compiler-worker.js");

// src/bundler/runner.imba
var import_path2 = __toModule(require("path"));
var import_child_process = __toModule(require("child_process"));
function iter$__7(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ19 = Symbol.for("#init");
var φ35 = Symbol.for("#next");
var φ4 = Symbol.for("#prev");
var cluster = require("cluster");
var Instance2 = class {
  [φ19]($$ = null) {
    var φ28;
    this.runner = $$ && (φ28 = $$.runner) !== void 0 ? φ28 : null;
    this.args = $$ && (φ28 = $$.args) !== void 0 ? φ28 : {};
    this.mode = $$ && (φ28 = $$.mode) !== void 0 ? φ28 : "cluster";
    this.name = $$ && (φ28 = $$.name) !== void 0 ? φ28 : "worker";
    this.restarts = $$ && (φ28 = $$.restarts) !== void 0 ? φ28 : 0;
  }
  get manifest() {
    return this.runner.manifest;
  }
  constructor(runner, options) {
    this[φ19](options);
    this.options = options;
    this.runner = runner;
    this.atime = Date.now();
    this.state = "closed";
    this.log = new Logger({prefix: ["%bold%dim", this.name, ": "]});
    this.current = null;
    this.restarts = 0;
  }
  start() {
    var self2 = this;
    if (this.current && this.current[φ35]) {
      return;
    }
    ;
    let o = this.runner.o;
    let regpath = import_path2.default.resolve(o.imbaPath, "loader.imba.js");
    let loader = o.imbaPath ? regpath : "imba/loader";
    let path = this.manifest.main.absPath;
    let args = {
      windowsHide: true,
      args: o.extras,
      exec: path,
      execArgv: [
        o.inspect && "--inspect",
        o.sourcemap && "--enable-source-maps",
        "-r",
        loader
      ].filter(function(_0) {
        return _0;
      })
    };
    let env = {
      IMBA_RESTARTS: this.restarts,
      IMBA_SERVE: true,
      IMBA_PATH: o.imbaPath,
      IMBA_MANIFEST_PATH: this.manifest.path,
      IMBA_HMR: o.hmr ? true : void 0,
      IMBA_LOGLEVEL: process.env.IMBA_LOGLEVEL || "info",
      PORT: process.env.PORT || o.port
    };
    if (o.execMode == "fork") {
      args.env = Object.assign({}, process.env, env);
      return import_child_process.default.fork(import_path2.default.resolve(path), args.args, args);
    }
    ;
    this.log.info("starting");
    cluster.setupMaster(args);
    let worker2 = cluster.fork(env);
    worker2.nr = this.restarts++;
    let prev = worker2[φ4] = this.current;
    if (prev) {
      this.log.info("reloading");
      prev[φ35] = worker2;
    }
    ;
    worker2.on("exit", function(code, signal) {
      if (signal) {
        return self2.log.info("killed by signal: %d", signal);
      } else if (code != 0) {
        return self2.log.error("exited with error code: %red", code);
      } else if (!worker2[φ35]) {
        return self2.log.info("exited");
      }
      ;
    });
    worker2.on("listening", function(address) {
      var _a;
      self2.log.success("listening on %address", address);
      return (_a = prev == null ? void 0 : prev.send) == null ? void 0 : _a.call(prev, ["emit", "reloaded"]);
    });
    worker2.on("error", function() {
      return self2.log.info("%red", "errorerd");
    });
    worker2.on("message", function(message, handle) {
      if (message == "reload") {
        console.log("RELOAD MESSAGE");
        return self2.reload();
      }
      ;
    });
    return this.current = worker2;
  }
  broadcast(event) {
    var _a, _b;
    return (_b = (_a = this.current) == null ? void 0 : _a.send) == null ? void 0 : _b.call(_a, event);
  }
  reload() {
    this.start();
    return this;
  }
};
var Runner = class extends component_default {
  constructor(manifest2, options) {
    super();
    this.o = options;
    this.manifest = manifest2;
    this.workers = new Set();
  }
  start() {
    let max = this.o.instances || 1;
    let nr = 1;
    let args = {
      windowsHide: true,
      args: this.o.extras,
      execArgv: [
        this.o.inspect && "--inspect",
        this.o.sourcemap && "--enable-source-maps"
      ].filter(function(_0) {
        return _0;
      })
    };
    let name = this.o.name || import_path2.default.basename(this.manifest.main.source.path);
    while (nr <= max) {
      let opts = {
        number: nr,
        name: max > 1 ? "" + name + " " + nr + "/" + max : name
      };
      this.workers.add(new Instance2(this, opts));
      nr++;
    }
    ;
    for (let worker2 of iter$__7(this.workers)) {
      worker2.start();
    }
    ;
    return this;
  }
  reload() {
    for (let worker2 of iter$__7(this.workers)) {
      worker2.reload();
    }
    ;
    return this;
  }
  broadcast(...params) {
    for (let worker2 of iter$__7(this.workers)) {
      worker2.broadcast(...params);
    }
    ;
    return this;
  }
};
var runner_default = Runner;

// src/bundler/bundle.imba
var esbuild2 = __toModule(require("esbuild"));
var import_utils2 = require_utils4();

// vendor/css-selector-parser.js
function CssSelectorParser() {
  this.pseudos = {};
  this.attrEqualityMods = {};
  this.ruleNestingOperators = {};
  this.substitutesEnabled = false;
}
CssSelectorParser.prototype.registerSelectorPseudos = function(name) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    name = arguments[j];
    this.pseudos[name] = "selector";
  }
  return this;
};
CssSelectorParser.prototype.unregisterSelectorPseudos = function(name) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    name = arguments[j];
    delete this.pseudos[name];
  }
  return this;
};
CssSelectorParser.prototype.registerNumericPseudos = function(name) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    name = arguments[j];
    this.pseudos[name] = "numeric";
  }
  return this;
};
CssSelectorParser.prototype.unregisterNumericPseudos = function(name) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    name = arguments[j];
    delete this.pseudos[name];
  }
  return this;
};
CssSelectorParser.prototype.registerNestingOperators = function(operator) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    operator = arguments[j];
    this.ruleNestingOperators[operator] = true;
  }
  return this;
};
CssSelectorParser.prototype.unregisterNestingOperators = function(operator) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    operator = arguments[j];
    delete this.ruleNestingOperators[operator];
  }
  return this;
};
CssSelectorParser.prototype.registerAttrEqualityMods = function(mod) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    mod = arguments[j];
    this.attrEqualityMods[mod] = true;
  }
  return this;
};
CssSelectorParser.prototype.unregisterAttrEqualityMods = function(mod) {
  for (var j = 0, len = arguments.length; j < len; j++) {
    mod = arguments[j];
    delete this.attrEqualityMods[mod];
  }
  return this;
};
CssSelectorParser.prototype.enableSubstitutes = function() {
  this.substitutesEnabled = true;
  return this;
};
CssSelectorParser.prototype.disableSubstitutes = function() {
  this.substitutesEnabled = false;
  return this;
};
function isIdentStart(c) {
  return c >= "a" && c <= "z" || c >= "A" && c <= "Z" || c === "-" || c === "_";
}
function isIdent(c) {
  return c >= "a" && c <= "z" || c >= "A" && c <= "Z" || c >= "0" && c <= "9" || c === "-" || c === "_";
}
function isHex(c) {
  return c >= "a" && c <= "f" || c >= "A" && c <= "F" || c >= "0" && c <= "9";
}
var identSpecialChars = {
  "!": true,
  '"': true,
  "#": true,
  $: true,
  "%": true,
  "&": true,
  "'": true,
  "(": true,
  ")": true,
  "*": true,
  "+": true,
  ",": true,
  ".": true,
  "/": true,
  ";": true,
  "<": true,
  "=": true,
  ">": true,
  "?": true,
  "@": true,
  "[": true,
  "\\": true,
  "]": true,
  "^": true,
  "`": true,
  "{": true,
  "|": true,
  "}": true,
  "~": true
};
var strReplacementsRev = {
  "\n": "\\n",
  "\r": "\\r",
  "	": "\\t",
  "\f": "\\f",
  "\v": "\\v"
};
var singleQuoteEscapeChars = {
  n: "\n",
  r: "\r",
  t: "	",
  f: "\f",
  "\\": "\\",
  "'": "'"
};
var doubleQuotesEscapeChars = {
  n: "\n",
  r: "\r",
  t: "	",
  f: "\f",
  "\\": "\\",
  '"': '"'
};
function ParseContext(str, pos, pseudos, attrEqualityMods, ruleNestingOperators, substitutesEnabled) {
  var chr, getIdent, getStr, l, skipWhitespace;
  l = str.length;
  chr = null;
  getStr = function(quote, escapeTable) {
    var esc, hex, result;
    result = "";
    pos++;
    chr = str.charAt(pos);
    while (pos < l) {
      if (chr === quote) {
        pos++;
        return result;
      } else if (chr === "\\") {
        pos++;
        chr = str.charAt(pos);
        if (chr === quote) {
          result += quote;
        } else if (esc = escapeTable[chr]) {
          result += esc;
        } else if (isHex(chr)) {
          hex = chr;
          pos++;
          chr = str.charAt(pos);
          while (isHex(chr)) {
            hex += chr;
            pos++;
            chr = str.charAt(pos);
          }
          if (chr === " ") {
            pos++;
            chr = str.charAt(pos);
          }
          result += String.fromCharCode(parseInt(hex, 16));
          continue;
        } else {
          result += chr;
        }
      } else {
        result += chr;
      }
      pos++;
      chr = str.charAt(pos);
    }
    return result;
  };
  getIdent = function(specials) {
    var result = "";
    chr = str.charAt(pos);
    while (pos < l) {
      if (isIdent(chr) || specials && specials[chr]) {
        result += chr;
      } else if (chr === "\\") {
        pos++;
        if (pos >= l) {
          throw Error("Expected symbol but end of file reached.");
        }
        chr = str.charAt(pos);
        if (identSpecialChars[chr]) {
          result += chr;
        } else if (isHex(chr)) {
          var hex = chr;
          pos++;
          chr = str.charAt(pos);
          while (isHex(chr)) {
            hex += chr;
            pos++;
            chr = str.charAt(pos);
          }
          if (chr === " ") {
            pos++;
            chr = str.charAt(pos);
          }
          result += String.fromCharCode(parseInt(hex, 16));
          continue;
        } else {
          result += chr;
        }
      } else {
        return result;
      }
      pos++;
      chr = str.charAt(pos);
    }
    return result;
  };
  skipWhitespace = function() {
    chr = str.charAt(pos);
    var result = false;
    while (chr === " " || chr === "	" || chr === "\n" || chr === "\r" || chr === "\f") {
      result = true;
      pos++;
      chr = str.charAt(pos);
    }
    return result;
  };
  this.parse = function() {
    var res = this.parseSelector();
    if (pos < l) {
      throw Error('Rule expected but "' + str.charAt(pos) + '" found.');
    }
    return res;
  };
  this.parseSelector = function() {
    var res;
    var selector = res = this.parseSingleSelector();
    chr = str.charAt(pos);
    while (chr === ",") {
      pos++;
      skipWhitespace();
      if (res.type !== "selectors") {
        res = {
          type: "selectors",
          selectors: [selector]
        };
      }
      selector = this.parseSingleSelector();
      if (!selector) {
        throw Error('Rule expected after ",".');
      }
      res.selectors.push(selector);
    }
    return res;
  };
  this.parseSingleSelector = function() {
    skipWhitespace();
    var selector = {
      type: "ruleSet"
    };
    var rule = this.parseRule();
    if (!rule) {
      return null;
    }
    var currentRule = selector;
    while (rule) {
      rule.type = "rule";
      currentRule.rule = rule;
      currentRule = rule;
      skipWhitespace();
      chr = str.charAt(pos);
      if (pos >= l || chr === "," || chr === ")") {
        break;
      }
      if (ruleNestingOperators[chr]) {
        var op = chr;
        if (op == ">" && str.charAt(pos + 1) == ">" && str.charAt(pos + 2) == ">") {
          op = ">>>";
          pos = pos + 3;
        } else if (op == ">" && str.charAt(pos + 1) == ">") {
          op = ">>";
          pos = pos + 2;
        } else {
          pos++;
        }
        skipWhitespace();
        rule = this.parseRule();
        if (!rule) {
          if (op == ">" || op == ">>>" || op == ">>") {
            rule = {tagName: "*"};
          } else {
            throw Error('Rule expected after "' + op + '".');
          }
        }
        rule.nestingOperator = op;
      } else {
        rule = this.parseRule();
        if (rule) {
          rule.nestingOperator = null;
        }
      }
    }
    return selector;
  };
  this.parseRule = function() {
    var rule = null;
    while (pos < l) {
      chr = str.charAt(pos);
      if (chr === "*") {
        pos++;
        (rule = rule || {}).tagName = "*";
      } else if (isIdentStart(chr) || chr === "\\") {
        (rule = rule || {}).tagName = getIdent();
      } else if (chr === "$" || chr === "%") {
        pos++;
        rule = rule || {};
        (rule.classNames = rule.classNames || []).push(chr + getIdent());
      } else if (chr === ".") {
        pos++;
        rule = rule || {};
        (rule.classNames = rule.classNames || []).push(getIdent());
      } else if (chr === "#") {
        pos++;
        (rule = rule || {}).id = getIdent();
      } else if (chr === "[") {
        pos++;
        skipWhitespace();
        var attr = {
          name: getIdent()
        };
        skipWhitespace();
        if (chr === "]") {
          pos++;
        } else {
          var operator = "";
          if (attrEqualityMods[chr]) {
            operator = chr;
            pos++;
            chr = str.charAt(pos);
          }
          if (pos >= l) {
            throw Error('Expected "=" but end of file reached.');
          }
          if (chr !== "=") {
            throw Error('Expected "=" but "' + chr + '" found.');
          }
          attr.operator = operator + "=";
          pos++;
          skipWhitespace();
          var attrValue = "";
          attr.valueType = "string";
          if (chr === '"') {
            attrValue = getStr('"', doubleQuotesEscapeChars);
          } else if (chr === "'") {
            attrValue = getStr("'", singleQuoteEscapeChars);
          } else if (substitutesEnabled && chr === "$") {
            pos++;
            attrValue = getIdent();
            attr.valueType = "substitute";
          } else {
            while (pos < l) {
              if (chr === "]") {
                break;
              }
              attrValue += chr;
              pos++;
              chr = str.charAt(pos);
            }
            attrValue = attrValue.trim();
          }
          skipWhitespace();
          if (pos >= l) {
            throw Error('Expected "]" but end of file reached.');
          }
          if (chr !== "]") {
            throw Error('Expected "]" but "' + chr + '" found.');
          }
          pos++;
          attr.value = attrValue;
        }
        rule = rule || {};
        (rule.attrs = rule.attrs || []).push(attr);
      } else if (chr === ":" || chr === "@") {
        let special = chr === "@";
        pos++;
        var pseudoName = getIdent({"~": true, "+": true, ".": true, ">": true, "<": true, "!": true});
        var pseudo = {
          special,
          name: pseudoName
        };
        if (chr === "(") {
          pos++;
          var value = "";
          skipWhitespace();
          if (pseudos[pseudoName] === "selector") {
            pseudo.valueType = "selector";
            value = this.parseSelector();
          } else {
            pseudo.valueType = pseudos[pseudoName] || "string";
            if (chr === '"') {
              value = getStr('"', doubleQuotesEscapeChars);
            } else if (chr === "'") {
              value = getStr("'", singleQuoteEscapeChars);
            } else if (substitutesEnabled && chr === "$") {
              pos++;
              value = getIdent();
              pseudo.valueType = "substitute";
            } else {
              while (pos < l) {
                if (chr === ")") {
                  break;
                }
                value += chr;
                pos++;
                chr = str.charAt(pos);
              }
              value = value.trim();
            }
            skipWhitespace();
          }
          if (pos >= l) {
            throw Error('Expected ")" but end of file reached.');
          }
          if (chr !== ")") {
            throw Error('Expected ")" but "' + chr + '" found.');
          }
          pos++;
          pseudo.value = value;
        }
        rule = rule || {};
        (rule.pseudos = rule.pseudos || []).push(pseudo);
      } else {
        break;
      }
    }
    return rule;
  };
  return this;
}
CssSelectorParser.prototype.parse = function(str) {
  var context = new ParseContext(str, 0, this.pseudos, this.attrEqualityMods, this.ruleNestingOperators, this.substitutesEnabled);
  return context.parse();
};
CssSelectorParser.prototype.escapeIdentifier = function(s) {
  var result = "";
  var i = 0;
  var len = s.length;
  while (i < len) {
    var chr = s.charAt(i);
    if (identSpecialChars[chr]) {
      result += "\\" + chr;
    } else {
      if (!(chr === "_" || chr === "-" || chr >= "A" && chr <= "Z" || chr >= "a" && chr <= "z" || i !== 0 && chr >= "0" && chr <= "9")) {
        var charCode = chr.charCodeAt(0);
        if ((charCode & 63488) === 55296) {
          var extraCharCode = s.charCodeAt(i++);
          if ((charCode & 64512) !== 55296 || (extraCharCode & 64512) !== 56320) {
            throw Error("UCS-2(decode): illegal sequence");
          }
          charCode = ((charCode & 1023) << 10) + (extraCharCode & 1023) + 65536;
        }
        result += "\\" + charCode.toString(16) + " ";
      } else {
        result += chr;
      }
    }
    i++;
  }
  return result;
};
CssSelectorParser.prototype.escapeStr = function(s) {
  var result = "";
  var i = 0;
  var len = s.length;
  var chr, replacement;
  while (i < len) {
    chr = s.charAt(i);
    if (chr === '"') {
      chr = '\\"';
    } else if (chr === "\\") {
      chr = "\\\\";
    } else if (replacement = strReplacementsRev[chr]) {
      chr = replacement;
    }
    result += chr;
    i++;
  }
  return '"' + result + '"';
};
CssSelectorParser.prototype.render = function(path) {
  return this._renderEntity(path).trim();
};
CssSelectorParser.prototype._renderEntity = function(entity) {
  var currentEntity, parts, res;
  res = "";
  switch (entity.type) {
    case "ruleSet":
      currentEntity = entity.rule;
      parts = [];
      while (currentEntity) {
        if (currentEntity.nestingOperator) {
          parts.push(currentEntity.nestingOperator);
        }
        parts.push(this._renderEntity(currentEntity));
        currentEntity = currentEntity.rule;
      }
      res = parts.join(" ");
      break;
    case "selectors":
      res = entity.selectors.map(this._renderEntity, this).join(", ");
      break;
    case "rule":
      if (entity.tagName) {
        if (entity.tagName === "*") {
          res = "*";
        } else {
          res = this.escapeIdentifier(entity.tagName);
        }
      }
      if (entity.id) {
        res += "#" + this.escapeIdentifier(entity.id);
      }
      if (entity.classNames) {
        res += entity.classNames.map(function(cn) {
          if (cn[0] == "!") {
            return ":not(." + this.escapeIdentifier(cn.slice(1)) + ")";
          } else {
            return "." + this.escapeIdentifier(cn);
          }
        }, this).join("");
      }
      if (entity.pri > 0) {
        let i = entity.pri;
        while (--i >= 0)
          res += ":not(#_)";
      }
      if (entity.attrs) {
        res += entity.attrs.map(function(attr) {
          if (attr.operator) {
            if (attr.valueType === "substitute") {
              return "[" + this.escapeIdentifier(attr.name) + attr.operator + "$" + attr.value + "]";
            } else {
              return "[" + this.escapeIdentifier(attr.name) + attr.operator + this.escapeStr(attr.value) + "]";
            }
          } else {
            return "[" + this.escapeIdentifier(attr.name) + "]";
          }
        }, this).join("");
      }
      if (entity.pseudos) {
        res += entity.pseudos.map(function(pseudo) {
          let pre = ":" + this.escapeIdentifier(pseudo.name);
          if (pseudo.valueType) {
            if (pseudo.valueType === "selector") {
              return pre + "(" + this._renderEntity(pseudo.value) + ")";
            } else if (pseudo.valueType === "substitute") {
              return pre + "($" + pseudo.value + ")";
            } else if (pseudo.valueType === "numeric") {
              return pre + "(" + pseudo.value + ")";
            } else if (pseudo.valueType === "raw" || pseudo.valueType === "string") {
              return pre + "(" + pseudo.value + ")";
            } else {
              return pre + "(" + this.escapeIdentifier(pseudo.value) + ")";
            }
          } else if (pseudo.type == "el") {
            return ":" + pre;
          } else {
            return pre;
          }
        }, this).join("");
      }
      break;
    default:
      throw Error('Unknown entity type: "' + entity.type(+'".'));
  }
  return res;
};
var parser = new CssSelectorParser();
parser.registerSelectorPseudos("has", "not", "is", "matches", "any");
parser.registerNumericPseudos("nth-child");
parser.registerNestingOperators(">>>", ">>", ">", "+", "~");
parser.registerAttrEqualityMods("^", "$", "*", "~");

// src/compiler/theme.imba
var theme_exports = {};
__export(theme_exports, {
  colors: () => colors,
  fonts: () => fonts,
  modifiers: () => modifiers,
  variants: () => variants
});
var fonts = {
  sans: 'system-ui, -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, "Noto Sans", sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol", "Noto Color Emoji"',
  serif: 'Georgia, Cambria, "Times New Roman", Times, serif',
  mono: 'Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace'
};
var modifiers = {
  odd: {name: "nth-child", valueType: "string", value: "odd"},
  even: {name: "nth-child", valueType: "string", value: "even"},
  first: {name: "first-child"},
  last: {name: "last-child"},
  only: {name: "only-child"},
  "not-first": {name: "not", valueType: "raw", value: ":first-child"},
  "not-last": {name: "not", valueType: "raw", value: ":last-child"},
  active: {},
  checked: {},
  default: {},
  defined: {},
  disabled: {},
  empty: {},
  enabled: {},
  "first-of-type": {},
  "first-page": {name: "first"},
  fullscreen: {},
  focus: {},
  focin: {name: "focus-within"},
  "focus-within": {},
  hover: {},
  indeterminate: {},
  "in-range": {},
  invalid: {},
  is: {type: "selector"},
  lang: {},
  "last-of-type": {},
  left: {},
  link: {},
  not: {type: "selector"},
  "nth-child": {},
  "nth-last-child": {},
  "nth-last-of-type": {},
  "nth-of-type": {},
  "only-child": {},
  "only-of-type": {},
  optional: {},
  "out-of-range": {},
  "placeholder-shown": {},
  "read-only": {},
  "read-write": {},
  required: {},
  right: {},
  scope: {},
  root: {},
  target: {},
  "target-within": {},
  valid: {},
  visited: {},
  where: {},
  after: {type: "el"},
  "-webkit-scrollbar": {type: "el"},
  "-webkit-scrollbar-button": {type: "el"},
  "-webkit-scrollbar-track": {type: "el"},
  "-webkit-scrollbar-track-piece": {type: "el"},
  "-webkit-scrollbar-thumb": {type: "el"},
  "-webkit-scrollbar-corner": {type: "el"},
  "-webkit-resizer": {type: "el"},
  backdrop: {type: "el"},
  before: {type: "el"},
  cue: {type: "el"},
  "cue-region": {type: "el"},
  "first-letter": {type: "el"},
  "first-line": {type: "el"},
  marker: {type: "el"},
  placeholder: {type: "el"},
  selection: {type: "el"},
  force: {pri: 4},
  important: {pri: 3},
  print: {media: "print"},
  screen: {media: "screen"},
  xs: {media: "(min-width: 480px)"},
  sm: {media: "(min-width: 640px)"},
  md: {media: "(min-width: 768px)"},
  lg: {media: "(min-width: 1024px)"},
  xl: {media: "(min-width: 1280px)"},
  "2xl": {media: "(min-width: 1536px)"},
  "lt-xs": {media: "(max-width: 479px)"},
  "lt-sm": {media: "(max-width: 639px)"},
  "lt-md": {media: "(max-width: 767px)"},
  "lt-lg": {media: "(max-width: 1023px)"},
  "lt-xl": {media: "(max-width: 1279px)"},
  "lt-2xl": {media: "(max-width: 1535px)"},
  landscape: {media: "(orientation: landscape)"},
  portrait: {media: "(orientation: portrait)"},
  dark: {media: "(prefers-color-scheme: dark)"},
  light: {media: "(prefers-color-scheme: light)"},
  mac: {ua: "mac"},
  ios: {ua: "ios"},
  win: {ua: "win"},
  android: {ua: "android"},
  linux: {ua: "linux"},
  ie: {ua: "ie"},
  chrome: {ua: "chrome"},
  safari: {ua: "safari"},
  firefox: {ua: "firefox"},
  opera: {ua: "opera"},
  blink: {ua: "blink"},
  webkit: {ua: "webkit"},
  touch: {flag: "_touch_"},
  suspended: {flag: "_suspended_"},
  move: {flag: "_move_"},
  hold: {flag: "_hold_"},
  ssr: {flag: "_ssr_"}
};
var variants = {
  radius: {
    full: "9999px",
    xxs: "1px",
    xs: "2px",
    sm: "3px",
    md: "4px",
    lg: "6px",
    xl: "8px",
    NUMBER: "2px"
  },
  sizing: {
    NUMBER: "0.25rem"
  },
  "letter-spacing": {
    NUMBER: "0.05em"
  },
  "font-size": {
    xxs: ["10px", 1.5],
    xs: ["12px", 1.5],
    "sm-": ["13px", 1.5],
    sm: ["14px", 1.5],
    "md-": ["15px", 1.5],
    md: ["16px", 1.5],
    lg: ["18px", 1.5],
    xl: ["20px", 1.5],
    "2xl": ["24px", 1.5],
    "3xl": ["30px", 1.5],
    "4xl": ["36px", 1.5],
    "5xl": ["48px", 1.5],
    "6xl": ["64px", 1.5],
    "1": ["10px", 1.5],
    "2": ["12px", 1.5],
    "3": ["13px", 1.5],
    "4": ["14px", 1.5],
    "5": ["15px", 1.5],
    "6": ["16px", 1.5],
    "7": ["17px", 1.5],
    "8": ["18px", 1.5],
    "9": ["19px", 1.5],
    "10": ["20px", 1.5],
    "11": ["24px", 1.4],
    "12": ["30px", 1.3],
    "13": ["36px", 1.3],
    "14": ["48px", 1.2],
    "15": ["64px", 1.2],
    "16": ["96px", 1.2]
  },
  "box-shadow": {
    xxs: "0 0 0 1px rgba(0, 0, 0, 0.05)",
    xs: "0 1px 2px 0 rgba(0, 0, 0, 0.05)",
    sm: "0 1px 3px 0 rgba(0, 0, 0, 0.1), 0 1px 2px 0 rgba(0, 0, 0, 0.06)",
    md: "0 4px 6px -1px rgba(0, 0, 0, 0.1), 0 2px 4px -1px rgba(0, 0, 0, 0.06)",
    lg: "0 10px 15px -3px rgba(0, 0, 0, 0.1), 0 4px 6px -2px rgba(0, 0, 0, 0.05)",
    xl: "0 20px 25px -5px rgba(0, 0, 0, 0.1), 0 10px 10px -5px rgba(0, 0, 0, 0.04)",
    xxl: "0 25px 50px -6px rgba(0, 0, 0, 0.25)",
    inner: "inset 0 2px 4px 0 rgba(0, 0, 0, 0.06)",
    outline: "0 0 0 3px rgba(66, 153, 225, 0.5)",
    none: "none"
  },
  easings: {
    "sine-in": "cubic-bezier(0.47, 0, 0.745, 0.715)",
    "sine-out": "cubic-bezier(0.39, 0.575, 0.565, 1)",
    "sine-in-out": "cubic-bezier(0.445, 0.05, 0.55, 0.95)",
    "quad-in": "cubic-bezier(0.55, 0.085, 0.68, 0.53)",
    "quad-out": "cubic-bezier(0.25, 0.46, 0.45, 0.94)",
    "quad-in-out": "cubic-bezier(0.455, 0.03, 0.515, 0.955)",
    "cubic-in": "cubic-bezier(0.55, 0.055, 0.675, 0.19)",
    "cubic-out": "cubic-bezier(0.215, 0.61, 0.355, 1)",
    "cubic-in-out": "cubic-bezier(0.645, 0.045, 0.355, 1)",
    "quart-in": "cubic-bezier(0.895, 0.03, 0.685, 0.22)",
    "quart-out": "cubic-bezier(0.165, 0.84, 0.44, 1)",
    "quart-in-out": "cubic-bezier(0.77, 0, 0.175, 1)",
    "quint-in": "cubic-bezier(0.755, 0.05, 0.855, 0.06)",
    "quint-out": "cubic-bezier(0.23, 1, 0.32, 1)",
    "quint-in-out": "cubic-bezier(0.86, 0, 0.07, 1)",
    "expo-in": "cubic-bezier(0.95, 0.05, 0.795, 0.035)",
    "expo-out": "cubic-bezier(0.19, 1, 0.22, 1)",
    "expo-in-out": "cubic-bezier(1, 0, 0, 1)",
    "circ-in": "cubic-bezier(0.6, 0.04, 0.98, 0.335)",
    "circ-out": "cubic-bezier(0.075, 0.82, 0.165, 1)",
    "circ-in-out": "cubic-bezier(0.785, 0.135, 0.15, 0.86)",
    "back-in": "cubic-bezier(0.6, -0.28, 0.735, 0.045)",
    "back-out": "cubic-bezier(0.175, 0.885, 0.32, 1.275)",
    "back-in-out": "cubic-bezier(0.68, -0.55, 0.265, 1.55)"
  }
};
var colors = {
  rose: {
    0: "#fff1f2",
    1: "#ffe4e6",
    2: "#fecdd3",
    3: "#fda4af",
    4: "#fb7185",
    5: "#f43f5e",
    6: "#e11d48",
    7: "#be123c",
    8: "#9f1239",
    9: "#881337"
  },
  pink: {
    0: "#fdf2f8",
    1: "#fce7f3",
    2: "#fbcfe8",
    3: "#f9a8d4",
    4: "#f472b6",
    5: "#ec4899",
    6: "#db2777",
    7: "#be185d",
    8: "#9d174d",
    9: "#831843"
  },
  fuchsia: {
    0: "#fdf4ff",
    1: "#fae8ff",
    2: "#f5d0fe",
    3: "#f0abfc",
    4: "#e879f9",
    5: "#d946ef",
    6: "#c026d3",
    7: "#a21caf",
    8: "#86198f",
    9: "#701a75"
  },
  purple: {
    0: "#faf5ff",
    1: "#f3e8ff",
    2: "#e9d5ff",
    3: "#d8b4fe",
    4: "#c084fc",
    5: "#a855f7",
    6: "#9333ea",
    7: "#7e22ce",
    8: "#6b21a8",
    9: "#581c87"
  },
  violet: {
    0: "#f5f3ff",
    1: "#ede9fe",
    2: "#ddd6fe",
    3: "#c4b5fd",
    4: "#a78bfa",
    5: "#8b5cf6",
    6: "#7c3aed",
    7: "#6d28d9",
    8: "#5b21b6",
    9: "#4c1d95"
  },
  indigo: {
    0: "#eef2ff",
    1: "#e0e7ff",
    2: "#c7d2fe",
    3: "#a5b4fc",
    4: "#818cf8",
    5: "#6366f1",
    6: "#4f46e5",
    7: "#4338ca",
    8: "#3730a3",
    9: "#312e81"
  },
  blue: {
    0: "#eff6ff",
    1: "#dbeafe",
    2: "#bfdbfe",
    3: "#93c5fd",
    4: "#60a5fa",
    5: "#3b82f6",
    6: "#2563eb",
    7: "#1d4ed8",
    8: "#1e40af",
    9: "#1e3a8a"
  },
  sky: {
    0: "#f0f9ff",
    1: "#e0f2fe",
    2: "#bae6fd",
    3: "#7dd3fc",
    4: "#38bdf8",
    5: "#0ea5e9",
    6: "#0284c7",
    7: "#0369a1",
    8: "#075985",
    9: "#0c4a6e"
  },
  cyan: {
    0: "#ecfeff",
    1: "#cffafe",
    2: "#a5f3fc",
    3: "#67e8f9",
    4: "#22d3ee",
    5: "#06b6d4",
    6: "#0891b2",
    7: "#0e7490",
    8: "#155e75",
    9: "#164e63"
  },
  teal: {
    0: "#f0fdfa",
    1: "#ccfbf1",
    2: "#99f6e4",
    3: "#5eead4",
    4: "#2dd4bf",
    5: "#14b8a6",
    6: "#0d9488",
    7: "#0f766e",
    8: "#115e59",
    9: "#134e4a"
  },
  emerald: {
    0: "#ecfdf5",
    1: "#d1fae5",
    2: "#a7f3d0",
    3: "#6ee7b7",
    4: "#34d399",
    5: "#10b981",
    6: "#059669",
    7: "#047857",
    8: "#065f46",
    9: "#064e3b"
  },
  green: {
    0: "#f0fdf4",
    1: "#dcfce7",
    2: "#bbf7d0",
    3: "#86efac",
    4: "#4ade80",
    5: "#22c55e",
    6: "#16a34a",
    7: "#15803d",
    8: "#166534",
    9: "#14532d"
  },
  lime: {
    0: "#f7fee7",
    1: "#ecfccb",
    2: "#d9f99d",
    3: "#bef264",
    4: "#a3e635",
    5: "#84cc16",
    6: "#65a30d",
    7: "#4d7c0f",
    8: "#3f6212",
    9: "#365314"
  },
  yellow: {
    0: "#fefce8",
    1: "#fef9c3",
    2: "#fef08a",
    3: "#fde047",
    4: "#facc15",
    5: "#eab308",
    6: "#ca8a04",
    7: "#a16207",
    8: "#854d0e",
    9: "#713f12"
  },
  amber: {
    0: "#fffbeb",
    1: "#fef3c7",
    2: "#fde68a",
    3: "#fcd34d",
    4: "#fbbf24",
    5: "#f59e0b",
    6: "#d97706",
    7: "#b45309",
    8: "#92400e",
    9: "#78350f"
  },
  orange: {
    0: "#fff7ed",
    1: "#ffedd5",
    2: "#fed7aa",
    3: "#fdba74",
    4: "#fb923c",
    5: "#f97316",
    6: "#ea580c",
    7: "#c2410c",
    8: "#9a3412",
    9: "#7c2d12"
  },
  red: {
    0: "#fef2f2",
    1: "#fee2e2",
    2: "#fecaca",
    3: "#fca5a5",
    4: "#f87171",
    5: "#ef4444",
    6: "#dc2626",
    7: "#b91c1c",
    8: "#991b1b",
    9: "#7f1d1d"
  },
  warmer: {
    0: "#fafaf9",
    1: "#f5f5f4",
    2: "#e7e5e4",
    3: "#d6d3d1",
    4: "#a8a29e",
    5: "#78716c",
    6: "#57534e",
    7: "#44403c",
    8: "#292524",
    9: "#1c1917"
  },
  warm: {
    0: "#fafafa",
    1: "#f5f5f5",
    2: "#e5e5e5",
    3: "#d4d4d4",
    4: "#a3a3a3",
    5: "#737373",
    6: "#525252",
    7: "#404040",
    8: "#262626",
    9: "#171717"
  },
  gray: {
    0: "#fafafa",
    1: "#f4f4f5",
    2: "#e4e4e7",
    3: "#d4d4d8",
    4: "#a1a1aa",
    5: "#71717a",
    6: "#52525b",
    7: "#3f3f46",
    8: "#27272a",
    9: "#18181b"
  },
  cool: {
    0: "#f9fafb",
    1: "#f3f4f6",
    2: "#e5e7eb",
    3: "#d1d5db",
    4: "#9ca3af",
    5: "#6b7280",
    6: "#4b5563",
    7: "#374151",
    8: "#1f2937",
    9: "#111827"
  },
  cooler: {
    0: "#f8fafc",
    1: "#f1f5f9",
    2: "#e2e8f0",
    3: "#cbd5e1",
    4: "#94a3b8",
    5: "#64748b",
    6: "#475569",
    7: "#334155",
    8: "#1e293b",
    9: "#0f172a"
  }
};

// src/compiler/styler.imba
var import_colors = __toModule(require_colors());
function iter$__8(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var ThemeInstance = null;
var ThemeCache = new WeakMap();
var layouts = {
  group: function(o) {
    o.display = "flex";
    o.jc = "flex-start";
    o.flw = "wrap";
    o["--u_sx"] = "calc(var(--u_cg,0) * 0.5)";
    o["--u_sy"] = "calc(var(--u_rg,0) * 0.5)";
    o.margin = "calc(var(--u_sy) * -1) calc(var(--u_sx) * -1)";
    return o["&>*"] = {margin: "var(--u_sy) var(--u_sx)"};
  },
  vflex: function(o) {
    o.display = "flex";
    return o.fld = "column";
  },
  hflex: function(o) {
    o.display = "flex";
    return o.fld = "row";
  },
  hgrid: function(o) {
    o.display = "grid";
    o.gaf = "column";
    return o.gac = "1fr";
  },
  vgrid: function(o) {
    o.display = "grid";
    return o.gaf = "row";
  }
};
var validTypes = {
  ease: "linear|ease|ease-in|ease-out|ease-in-out|step-start|step-end|stepsƒ|cubic-bezierƒ"
};
for (let φ114 = 0, φ28 = Object.keys(validTypes), φ62 = φ28.length, k, v; φ114 < φ62; φ114++) {
  k = φ28[φ114];
  v = validTypes[k];
  let o = {};
  for (let φ39 = 0, φ45 = iter$__8(v.split("|")), φ54 = φ45.length; φ39 < φ54; φ39++) {
    let item = φ45[φ39];
    o[item] = 1;
  }
  ;
  validTypes[k] = o;
}
var aliases = {
  c: "color",
  d: "display",
  pos: "position",
  p: "padding",
  pl: "padding-left",
  pr: "padding-right",
  pt: "padding-top",
  pb: "padding-bottom",
  px: ["pl", "pr"],
  py: ["pt", "pb"],
  m: "margin",
  ml: "margin-left",
  mr: "margin-right",
  mt: "margin-top",
  mb: "margin-bottom",
  mx: ["ml", "mr"],
  my: ["mt", "mb"],
  w: "width",
  h: "height",
  t: "top",
  b: "bottom",
  l: "left",
  r: "right",
  size: ["width", "height"],
  ji: "justify-items",
  jc: "justify-content",
  js: "justify-self",
  j: ["justify-content", "justify-items"],
  ai: "align-items",
  ac: "align-content",
  as: "align-self",
  a: ["align-content", "align-items"],
  jai: ["justify-items", "align-items"],
  jac: ["justify-content", "align-content"],
  jas: ["justify-self", "align-self"],
  ja: ["justify-content", "align-content", "justify-items", "align-items"],
  fl: "flex",
  flf: "flex-flow",
  fld: "flex-direction",
  flb: "flex-basis",
  flg: "flex-grow",
  fls: "flex-shrink",
  flw: "flex-wrap",
  ff: "font-family",
  fs: "font-size",
  fw: "font-weight",
  ts: "text-shadow",
  td: "text-decoration",
  tdl: "text-decoration-line",
  tdc: "text-decoration-color",
  tds: "text-decoration-style",
  tdt: "text-decoration-thickness",
  tdsi: "text-decoration-skip-ink",
  te: "text-emphasis",
  tec: "text-emphasis-color",
  tes: "text-emphasis-style",
  tep: "text-emphasis-position",
  tet: "text-emphasis-thickness",
  tt: "text-transform",
  ta: "text-align",
  va: "vertical-align",
  ls: "letter-spacing",
  lh: "line-height",
  bd: "border",
  bdr: "border-right",
  bdl: "border-left",
  bdt: "border-top",
  bdb: "border-bottom",
  bs: "border-style",
  bsr: "border-right-style",
  bsl: "border-left-style",
  bst: "border-top-style",
  bsb: "border-bottom-style",
  bw: "border-width",
  bwr: "border-right-width",
  bwl: "border-left-width",
  bwt: "border-top-width",
  bwb: "border-bottom-width",
  bc: "border-color",
  bcr: "border-right-color",
  bcl: "border-left-color",
  bct: "border-top-color",
  bcb: "border-bottom-color",
  rd: "border-radius",
  rdtl: "border-top-left-radius",
  rdtr: "border-top-right-radius",
  rdbl: "border-bottom-left-radius",
  rdbr: "border-bottom-right-radius",
  rdt: ["border-top-left-radius", "border-top-right-radius"],
  rdb: ["border-bottom-left-radius", "border-bottom-right-radius"],
  rdl: ["border-top-left-radius", "border-bottom-left-radius"],
  rdr: ["border-top-right-radius", "border-bottom-right-radius"],
  bg: "background",
  bgp: "background-position",
  bgc: "background-color",
  bgr: "background-repeat",
  bgi: "background-image",
  bga: "background-attachment",
  bgs: "background-size",
  bgo: "background-origin",
  bgclip: "background-clip",
  g: "gap",
  rg: "row-gap",
  cg: "column-gap",
  gtr: "grid-template-rows",
  gtc: "grid-template-columns",
  gta: "grid-template-areas",
  gar: "grid-auto-rows",
  gac: "grid-auto-columns",
  gaf: "grid-auto-flow",
  gcg: "grid-column-gap",
  grg: "grid-row-gap",
  ga: "grid-area",
  gr: "grid-row",
  gc: "grid-column",
  gt: "grid-template",
  grs: "grid-row-start",
  gcs: "grid-column-start",
  gre: "grid-row-end",
  gce: "grid-column-end",
  bxs: "box-shadow",
  shadow: "box-shadow",
  of: "overflow",
  ofx: "overflow-x",
  ofy: "overflow-y",
  ofa: "overflow-anchor",
  prefix: "content@before",
  suffix: "content@after",
  x: "x",
  y: "y",
  z: "z",
  rotate: "rotate",
  scale: "scale",
  "scale-x": "scale-x",
  "scale-y": "scale-y",
  "skew-x": "skew-x",
  "skew-y": "skew-y",
  origin: "transform-origin",
  ws: "white-space",
  zi: "z-index",
  pe: "pointer-events",
  us: "user-select",
  o: "opacity",
  tween: "transition"
};
var abbreviations = {};
for (let φ74 = 0, φ83 = Object.keys(aliases), φ92 = φ83.length, k, v; φ74 < φ92; φ74++) {
  k = φ83[φ74];
  v = aliases[k];
  if (typeof v == "string") {
    abbreviations[v] = k;
  }
  ;
}
function isNumber(val) {
  if (val._value && val._value._type == "NUMBER" && !val._unit) {
    return true;
  }
  ;
  return false;
}
var Color = class {
  constructor(name, h, s, l, a = 1) {
    this.name = name;
    this.h = h;
    this.s = s;
    this.l = l;
    this.a = a;
  }
  alpha(a = 1) {
    return new Color(this.name, this.h, this.s, this.l, a);
  }
  clone() {
    return new Color(this.name, this.h, this.s, this.l, this.a);
  }
  mix(other, hw = 0.5, sw = 0.5, lw = 0.5) {
    let h1 = this.h + (other.h - this.h) * hw;
    let s1 = this.s + (other.s - this.s) * sw;
    let l1 = this.l + (other.l - this.l) * lw;
    return new Color(this.name + other.name, h1, s1, l1);
  }
  toString(a = this.a) {
    return "hsla(" + this.h.toFixed(2) + "," + this.s.toFixed(2) + "%," + this.l.toFixed(2) + "%," + a + ")";
  }
  c() {
    return this.toString();
  }
};
var Length = class {
  static parse(value) {
    let m = String(value).match(/^(\-?[\d\.]+)(\w+|%)?$/);
    if (!m) {
      return null;
    }
    ;
    return new this(parseFloat(m[1]), m[2]);
  }
  constructor(number, unit) {
    this.number = number;
    this.unit = unit;
  }
  valueOf() {
    return this.number;
  }
  toString() {
    return this.number + (this.unit || "");
  }
  clone(num = this.number, u = this.unit) {
    return new Length(num, u);
  }
  rounded() {
    return this.clone(Math.round(this.number));
  }
  c() {
    return this.toString();
  }
  get _unit() {
    return this.unit;
  }
  get _number() {
    return this.number;
  }
};
var Var = class {
  constructor(name, fallback) {
    this.name = name;
    this.fallback = fallback;
  }
  c() {
    return this.fallback ? "var(--" + this.name + "," + (this.fallback.c ? this.fallback.c() : String(this.fallback)) + ")" : "var(--" + this.name + ")";
  }
};
var defaultPalette = {
  current: {string: "currentColor", c: function() {
    return "currentColor";
  }},
  transparent: new Color("transparent", 0, 0, 100, "0%"),
  clear: new Color("transparent", 100, 100, 100, "0%"),
  black: new Color("black", 0, 0, 0, "100%"),
  white: new Color("white", 0, 0, 100, "100%")
};
function parseColorString(str) {
  let m;
  if (m = str.match(/hsl\((\d+), *(\d+\%), *(\d+\%?)/)) {
    let h = parseInt(m[1]);
    let s = parseInt(m[2]);
    let l = parseInt(m[3]);
    return [h, s, l];
  } else if (str[0] == "#") {
    return import_colors.conv.rgb.hsl(import_colors.conv.hex.rgb(str));
  }
  ;
}
function parseColors(palette, colors2) {
  for (let φ133 = 0, φ143 = Object.keys(colors2), φ182 = φ143.length, name, variations; φ133 < φ182; φ133++) {
    name = φ143[φ133];
    variations = colors2[name];
    if (typeof variations == "string") {
      palette[name] = variations;
      continue;
    }
    ;
    for (let φ152 = 0, φ162 = Object.keys(variations), φ172 = φ162.length, subname, raw; φ152 < φ172; φ152++) {
      subname = φ162[φ152];
      raw = variations[subname];
      let path = name + subname;
      if (palette[raw]) {
        palette[path] = palette[raw];
      } else {
        let [h, s, l] = parseColorString(raw);
        let color = palette[path] = new Color(path, h, s, l, "100%");
      }
      ;
    }
    ;
  }
  ;
  return palette;
}
parseColors(defaultPalette, colors);
var VALID_CSS_UNITS = "cm mm Q in pc pt px em ex ch rem vw vh vmin vmax % s ms fr deg rad grad turn Hz kHz".split(" ");
var StyleTheme = class {
  static instance() {
    return ThemeInstance || (ThemeInstance = new this());
  }
  static propAbbr(name) {
    return abbreviations[name] || name;
  }
  static wrap(config) {
    if (!config) {
      return this.instance();
    }
    ;
    let theme = ThemeCache.get(config);
    if (!theme) {
      ThemeCache.set(config, theme = new this(config));
    }
    ;
    return theme;
  }
  constructor(ext = {}) {
    this.options = theme_exports;
    this.palette = Object.assign({}, defaultPalette);
    if (ext.theme) {
      ext = ext.theme;
    }
    ;
    if (ext && ext.colors) {
      parseColors(this.palette, ext.colors);
    }
    ;
  }
  expandProperty(name) {
    return aliases[name] || void 0;
  }
  expandValue(value, config) {
    if (value == void 0) {
      value = config.default;
    }
    ;
    if (config.hasOwnProperty(value)) {
      value = config[value];
    }
    ;
    if (typeof value == "number" && config.NUMBER) {
      let [step, num, unit] = config.NUMBER.match(/^(\-?[\d\.]+)(\w+|%)?$/);
      return value * parseFloat(num) + unit;
    }
    ;
    return value;
  }
  padding_x([l, r = l]) {
    return {"padding-left": l, "padding-right": r};
  }
  padding_y([t, b = t]) {
    return {"padding-top": t, "padding-bottom": b};
  }
  margin_x([l, r = l]) {
    return {"margin-left": l, "margin-right": r};
  }
  margin_y([t, b = t]) {
    return {"margin-top": t, "margin-bottom": b};
  }
  inset([t, r = t, b = t, l = r]) {
    return {top: t, right: r, bottom: b, left: l};
  }
  size([w, h = w]) {
    return {width: w, height: h};
  }
  grid(params) {
    let m;
    if (m = this.$varFallback("grid", params)) {
      return m;
    }
    ;
    return;
  }
  animation(...params) {
    let valids = {
      normal: 1,
      reverse: 1,
      alternate: 1,
      "alternate-reverse": 1,
      infinite: 2,
      none: 3,
      forwards: 3,
      backwards: 3,
      both: 3,
      running: 4,
      paused: 4
    };
    let used = {};
    for (let k = 0, φ192 = iter$__8(params), φ222 = φ192.length; k < φ222; k++) {
      let anim = φ192[k];
      let name = null;
      let ease = null;
      for (let i = 0, φ203 = iter$__8(anim), φ212 = φ203.length; i < φ212; i++) {
        let part = φ203[i];
        let str = String(part);
        let typ = valids[str];
        if (validTypes.ease[str] && !ease) {
          ease = true;
        } else if (typ) {
          if (used[typ]) {
            name = [i, str];
          }
          ;
          used[typ] = true;
        } else if (str.match(/^[^\d\.]/) && str.indexOf("(") == -1) {
          if (name) {
            ease = [i, str];
          } else {
            name = [i, str];
          }
          ;
        }
        ;
      }
      ;
      if (name) {
        anim[name[0]] = new Var("animation-" + name[1], name[1]);
      }
      ;
      if (ease instanceof Array) {
        let fallback = this.options.variants.easings[ease[1]];
        anim[ease[0]] = new Var("ease-" + ease[1], fallback);
      }
      ;
    }
    ;
    return {animation: params};
  }
  animation_timing_function(...params) {
    for (let i = 0, φ233 = iter$__8(params), φ242 = φ233.length; i < φ242; i++) {
      let param = φ233[i];
      let fb = this.$varFallback("ease", param);
      if (fb) {
        params[i] = fb;
      }
      ;
    }
    ;
    return params;
  }
  animation_name(...params) {
    let m;
    for (let i = 0, φ252 = iter$__8(params), φ262 = φ252.length; i < φ262; i++) {
      let param = φ252[i];
      let fb = this.$varFallback("animation", param);
      if (fb) {
        params[i] = fb;
      }
      ;
    }
    ;
    return params;
    if (m = this.$varFallback("animation", params)) {
      return m;
    }
    ;
    return;
  }
  display(params) {
    let out = {display: params};
    for (let φ272 = 0, φ28 = iter$__8(params), φ29 = φ28.length, layout; φ272 < φ29; φ272++) {
      let par = φ28[φ272];
      if (layout = layouts[String(par)]) {
        layout.call(this, out, par, params);
      }
      ;
    }
    ;
    return out;
  }
  position(params) {
    let out = {position: params};
    let str = String(params[0]);
    if (str == "abs") {
      out.position = "absolute";
    } else if (str == "rel") {
      out.position = "relative";
    }
    ;
    return out;
  }
  width([...params]) {
    let o = {};
    for (let φ30 = 0, φ31 = iter$__8(params), φ322 = φ31.length; φ30 < φ322; φ30++) {
      let param = φ31[φ30];
      let opts = param._options || {};
      let u = param._unit;
      if (u == "c" || u == "col" || u == "cols") {
        o["grid-column-end"] = "span " + param._number;
      } else if (opts.op && String(opts.op) == ">") {
        o["min-width"] = param;
      } else if (opts.op && String(opts.op) == "<") {
        o["max-width"] = param;
      } else {
        o.width = param;
      }
      ;
    }
    ;
    return o;
  }
  height([...params]) {
    let o = {};
    for (let φ332 = 0, φ342 = iter$__8(params), φ352 = φ342.length; φ332 < φ352; φ332++) {
      let param = φ342[φ332];
      let opts = param._options || {};
      let u = param._unit;
      if (u == "r" || u == "row" || u == "rows") {
        o["grid-row-end"] = "span " + param._number;
      } else if (opts.op && String(opts.op) == ">") {
        o["min-height"] = param;
      } else if (opts.op && String(opts.op) == "<") {
        o["max-height"] = param;
      } else {
        o.height = param;
      }
      ;
    }
    ;
    return o;
  }
  transition(...parts) {
    let out = {};
    let add = {};
    let signatures = [
      "name | duration",
      "name | duration | delay",
      "name | duration | ease",
      "name | duration | ease | delay"
    ];
    let groups = {
      styles: ["background-color", "border-color", "color", "fill", "stroke", "opacity", "box-shadow", "transform"],
      sizes: ["width", "height", "left", "top", "right", "bottom", "margin", "padding"],
      colors: ["background-color", "border-color", "color", "fill", "stroke"]
    };
    let i = 0;
    while (i < parts.length) {
      let part = parts[i];
      let name = String(part[0]);
      if (name.match(/^[\-\+]?\d?(\.?\d+)(s|ms)?$/)) {
        part.unshift(name = "styles");
      }
      ;
      let ease = part[2];
      let group = groups[name];
      if (group && parts.length == 1) {
        part[0] = "none";
        Object.assign(add, {"transition-property": group.join(",")});
      } else if (group && parts.length > 1) {
        let subparts = group.map(function(_0) {
          return [_0].concat(part.slice(1));
        });
        parts.splice(i, 1, ...subparts);
        continue;
      }
      ;
      i++;
    }
    ;
    Object.assign(out, {transition: parts}, add);
    return out;
  }
  font(params, ...rest) {
    for (let i = 0, φ363 = iter$__8(params), φ373 = φ363.length; i < φ373; i++) {
      let param = φ363[i];
      true;
    }
    ;
    return;
  }
  font_family(params) {
    let m;
    if (m = this.$varFallback("font", params)) {
      return m;
    }
    ;
    return;
  }
  text_shadow(params) {
    let m;
    if (m = this.$varFallback("text-shadow", params)) {
      return m;
    }
    ;
    return;
  }
  grid_template(params) {
    for (let i = 0, φ382 = iter$__8(params), φ39 = φ382.length; i < φ39; i++) {
      let param = φ382[i];
      if (isNumber(param)) {
        param._resolvedValue = "repeat(" + param._value + ",1fr)";
      }
      ;
    }
    ;
    return;
  }
  grid_template_columns(params) {
    return this.grid_template(params);
  }
  grid_template_rows(params) {
    return this.grid_template(params);
  }
  font_size([v]) {
    let sizes = this.options.variants["font-size"];
    let raw = String(v);
    let size = v;
    let lh;
    let out = {};
    if (sizes[raw]) {
      [size, lh] = sizes[raw];
      size = Length.parse(size);
      lh = Length.parse(lh || "");
    }
    ;
    if (v.param && v.param) {
      lh = v.param;
    }
    ;
    out["font-size"] = size;
    if (lh) {
      let lhu = lh._unit;
      let lhn = lh._number;
      out.lh = lh;
      if (lhu == "fs") {
        out.lh = new Length(lhn);
      } else if (lhu) {
        out.lh = lh;
      } else if (lhn == 0) {
        out.lh = "inherit";
      } else if (lhn && size._unit == "px") {
        let rounded = Math.round(size._number * lhn);
        if (rounded % 2 == 1) {
          rounded++;
        }
        ;
        out.lh = new Length(rounded, "px");
      }
      ;
    }
    ;
    return out;
  }
  line_height([v]) {
    let uvar = v;
    if (v._number && !v._unit) {
      uvar = v.clone(v._number, "em");
    }
    ;
    return {
      "line-height": v,
      "--u_lh": uvar
    };
  }
  text_decoration(params) {
    for (let i = 0, φ40 = iter$__8(params), φ41 = φ40.length; i < φ41; i++) {
      let param = φ40[i];
      let str = String(param);
      if (str == "u") {
        param._resolvedValue = "underline";
      } else if (str == "s") {
        param._resolvedValue = "line-through";
      }
      ;
    }
    ;
    return [params];
  }
  border([...params]) {
    if (params.length == 1 && this.$parseColor(params[0])) {
      return [["1px", "solid", params[0]]];
    }
    ;
    return;
  }
  border_left(params) {
    return this.border(params);
  }
  border_right(params) {
    return this.border(params);
  }
  border_top(params) {
    return this.border(params);
  }
  border_bottom(params) {
    return this.border(params);
  }
  border_x(params) {
    return {"border-left": this.border(params) || params, "border-right": this.border(params) || params};
  }
  border_y(params) {
    return {"border-top": this.border(params) || params, "border-bottom": this.border(params) || params};
  }
  border_x_width([l, r = l]) {
    return {blw: l, brw: r};
  }
  border_y_width([t, b = t]) {
    return {btw: t, bbw: b};
  }
  border_x_style([l, r = l]) {
    return {bls: l, brs: r};
  }
  border_y_style([t, b = t]) {
    return {bts: t, bbs: b};
  }
  border_x_color([l, r = l]) {
    return {blc: l, brc: r};
  }
  border_y_color([t, b = t]) {
    return {btc: t, bbc: b};
  }
  gap([v]) {
    return {gap: v, "--u_rg": v, "--u_cg": v};
  }
  row_gap([v]) {
    return {"row-gap": v, "--u_rg": v};
  }
  column_gap([v]) {
    return {"column-gap": v, "--u_cg": v};
  }
  $color(name) {
    let m = name.match(/^(\w+)(\d)(?:\-(\d+))?$/);
    let ns = m && m[1];
    if (ns && typeof this.palette[ns] == "string") {
      return this.$color(this.palette[ns] + name.slice(ns.length));
    }
    ;
    if (this.palette[name]) {
      return this.palette[name];
    }
    ;
    if (m) {
      let nr = parseInt(m[2]);
      let fraction = parseInt(m[3]) || 0;
      let from = null;
      let to = null;
      let n0 = nr + 1;
      let n1 = nr;
      if (typeof this.palette[ns] == "string") {
        return this.$color(this.palette[ns] + name.slice(ns.length));
      }
      ;
      while (n0 > 1 && !from) {
        from = this.palette[ns + --n0];
      }
      ;
      while (n1 < 9 && !to) {
        to = this.palette[ns + ++n1];
      }
      ;
      let weight = (nr - n0 + fraction / 10) / (n1 - n0);
      let hw = weight;
      let sw = weight;
      let lw = weight;
      if (!to) {
        to = this.palette.blue9;
        hw = 0;
      }
      ;
      if (!from) {
        from = this.palette.blue1;
        hw = 1;
      }
      ;
      if (from && to) {
        return this.palette[name] = from.mix(to, hw, sw, lw);
      }
      ;
    }
    ;
    return null;
  }
  $parseColor(identifier) {
    let color;
    let key = String(identifier);
    if (color = this.$color(key)) {
      return color;
    }
    ;
    if (key.match(/^#[a-fA-F0-9]{3,8}/)) {
      return identifier;
    } else if (key.match(/^(rgb|hsl)/)) {
      return identifier;
    } else if (key == "currentColor") {
      return identifier;
    }
    ;
    return null;
  }
  $varFallback(name, params, exclude = []) {
    if (params.length == 1) {
      let str = String(params[0]);
      let fallback = params[0];
      exclude.push("none", "initial", "unset", "inherit");
      if (exclude.indexOf(str) == -1 && str.match(/^[\w\-]+$/)) {
        if (name == "font" && fonts[str]) {
          fallback = fonts[str];
        }
        ;
        if (name == "ease" && this.options.variants.easings[str]) {
          fallback = this.options.variants.easings[str];
        }
        ;
        return [new Var("" + name + "-" + str, fallback)];
      }
      ;
    }
    ;
    return;
  }
  $value(value, index, config) {
    let color;
    let key = config;
    let orig = value;
    let raw = value && value.toRaw ? value.toRaw() : String(value);
    let str = String(value);
    let fallback = false;
    let result = null;
    let unit = orig._unit;
    if (typeof config == "string") {
      if (aliases[config]) {
        config = aliases[config];
        if (config instanceof Array) {
          config = config[0];
        }
        ;
      }
      ;
      if (config.match(/^((min-|max-)?(width|height)|top|left|bottom|right|padding|margin|sizing|inset|spacing|sy$|s$|\-\-s[xy])/)) {
        config = "sizing";
      } else if (config.match(/^\-\-[gs][xy]_/)) {
        config = "sizing";
      } else if (config.match(/^(row-|column-)?gap/)) {
        config = "sizing";
      } else if (config.match(/^[mps][trblxy]?$/)) {
        config = "sizing";
      } else if (config.match(/^[trblwh]$/)) {
        config = "sizing";
      } else if (config.match(/^border-.*radius/) || config.match(/^rd[tlbr]{0,2}$/)) {
        config = "radius";
        fallback = "border-radius";
      } else if (config.match(/^box-shadow/)) {
        fallback = config = "box-shadow";
      } else if (config.match(/^tween|transition/) && this.options.variants.easings[raw]) {
        return this.options.variants.easings[raw];
      }
      ;
      config = this.options.variants[config] || {};
    }
    ;
    if (value == void 0) {
      value = config.default;
    }
    ;
    if (config.hasOwnProperty(raw)) {
      value = config[value];
    }
    ;
    if (typeof raw == "number" && config.NUMBER) {
      let [step, num, unit2] = config.NUMBER.match(/^(\-?[\d\.]+)(\w+|%)?$/);
      return value * parseFloat(num) + unit2;
    } else if (typeof raw == "string") {
      if (color = this.$parseColor(raw)) {
        return color;
      }
      ;
    }
    ;
    if (fallback) {
      let okstr = str.match(/^[a-zA-Z\-][\w\-]*$/) && !str.match(/^(none|inherit|unset|initial)$/);
      let oknum = unit && VALID_CSS_UNITS.indexOf(unit) == -1;
      if ((okstr || oknum) && value.alone) {
        return new Var("" + fallback + "-" + str, orig != value ? value : raw);
      }
      ;
    }
    ;
    return value;
  }
  transformColors(text) {
    var self2 = this;
    text = text.replace(/\/\*#\*\/(\w+)(?:\/(\d+%?))?/g, function(m, c, a) {
      let color = self2.$color(c);
      if (color) {
        return "/*#*/" + color.toString(a);
      }
      ;
      return m;
    });
    return text;
  }
};

// src/imba/utils.imba
function iter$__9(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ110 = Symbol.for("#type");
var φ202 = Symbol.for("#__listeners__");
function serializeData(data) {
  let map = new Map();
  let arr = [];
  let logging = false;
  let replacer = function(key, value) {
    if (value && value[φ110] && key !== "") {
      let ref = map.get(value);
      if (!map.has(value)) {
        map.set(value, ref = "$$" + arr.length + "$$");
        arr.push(value);
      }
      ;
      return key == null ? value : ref;
    }
    ;
    return value;
  };
  let json = JSON.stringify(data, replacer, 2);
  let i = 0;
  logging = true;
  while (i < arr.length) {
    arr[i] = JSON.stringify(arr[i], replacer, 2);
    i++;
  }
  ;
  let inject = "";
  for (let i2 = 0, φ28 = iter$__9(arr), φ39 = φ28.length; i2 < φ39; i2++) {
    let item = φ28[i2];
    inject += '"$$' + i2 + '$$":' + item + ",\n";
  }
  ;
  json = "{" + inject + json.slice(1);
  return json;
}
function deserializeData(data, reviver = null) {
  let objects = {};
  let reg = /\$\$\d+\$\$/;
  let lookup = function(value) {
    return objects[value] || (objects[value] = reviver ? reviver(value) : {});
  };
  let parser2 = function(key, value) {
    if (typeof value == "string") {
      if (value[0] == "$" && reg.test(value)) {
        return lookup(value);
      }
      ;
    } else if (typeof key == "string" && key[0] == "$" && reg.test(key)) {
      let obj = lookup(key);
      Object.assign(obj, value);
      return obj;
    }
    ;
    return value;
  };
  let parsed = JSON.parse(data, parser2);
  return parsed;
}
function patchManifest(prev, curr) {
  var φ74, φ62, φ11, φ182;
  let origs = {};
  let diff = {
    added: [],
    changed: [],
    removed: [],
    all: [],
    urls: {}
  };
  if (prev.assets) {
    for (let φ45 = 0, φ54 = iter$__9(prev.assets), φ83 = φ54.length; φ45 < φ83; φ45++) {
      let item = φ54[φ45];
      let ref = item.originalPath || item.path;
      origs[ref] = item;
      if (item.url) {
        (φ74 = curr.urls)[φ62 = item.url] || (φ74[φ62] = item);
      }
      ;
    }
    ;
  }
  ;
  for (let φ92 = 0, φ103 = iter$__9(curr.assets || []), φ123 = φ103.length; φ92 < φ123; φ92++) {
    let item = φ103[φ92];
    let ref = item.originalPath || item.path;
    let orig = origs[ref];
    if (item.url && prev.urls) {
      prev.urls[item.url] = item;
    }
    ;
    if (orig) {
      if (orig.hash != item.hash) {
        orig.invalidated = Date.now();
        orig.replacedBy = item;
        item.replaces = orig;
        diff.changed.push(item);
        diff.all.push(item);
        if (orig == prev.main) {
          diff.main = item;
        }
        ;
      }
      ;
      φ11 = origs[ref], delete origs[ref], φ11;
    } else {
      diff.added.push(item);
      diff.all.push(item);
    }
    ;
  }
  ;
  for (let φ133 = 0, φ143 = Object.keys(origs), φ152 = φ143.length, path, item; φ133 < φ152; φ133++) {
    path = φ143[φ133];
    item = origs[path];
    item.removed = Date.now();
    diff.all.push(item);
  }
  ;
  for (let φ162 = 0, φ172 = iter$__9(diff.all), φ192 = φ172.length; φ162 < φ192; φ162++) {
    let item = φ172[φ162];
    let typ = diff[φ182 = item.type] || (diff[φ182] = []);
    typ.push(item);
  }
  ;
  diff.removed = Object.values(origs);
  curr.changes = diff;
  return curr;
}

// src/imba/manifest.imba
var import_events2 = __toModule(require("events"));
var import_fs3 = __toModule(require("fs"));
var import_path3 = __toModule(require("path"));
var φ111 = Symbol.for("#refresh");
var φ25 = Symbol.for("#manifest");
var φ36 = Symbol.for("#absPath");
var φ42 = Symbol.for("#raw");
var φ5 = Symbol.for("#watch");
var Asset = class {
  constructor(manifest2) {
    this[φ25] = manifest2;
  }
  get absPath() {
    return this[φ36] || (this[φ36] = this[φ25].resolve(this));
  }
  get name() {
    return import_path3.default.basename(this.path);
  }
  get body() {
    return this.readSync();
  }
  readSync() {
    return import_fs3.default.readFileSync(this.absPath, "utf-8");
  }
  pipe(res) {
    let stream = import_fs3.default.createReadStream(this.absPath);
    return stream.pipe(res);
  }
  toString() {
    return this.url || this.absPath;
  }
};
var Manifest = class extends import_events2.EventEmitter {
  constructor(options = {}) {
    var self2;
    super();
    self2 = this;
    this.options = options;
    this.data = {};
    this.path = options.path;
    this.refs = {};
    this.reviver = function(key) {
      return new Asset(self2);
    };
    this.init(options.data);
  }
  get srcdir() {
    return import_path3.default.resolve(import_path3.default.dirname(this.path), this.data.srcdir);
  }
  get outdir() {
    return import_path3.default.resolve(import_path3.default.dirname(this.path), this.data.outdir);
  }
  get changes() {
    return this.data.changes || {};
  }
  get inputs() {
    return this.data.inputs;
  }
  get outputs() {
    return this.data.outputs;
  }
  get assets() {
    return this.data.assets;
  }
  get urls() {
    return this.data.urls || {};
  }
  get main() {
    return this.data.main;
  }
  get cwd() {
    return process.cwd();
  }
  get raw() {
    return this.data[φ42];
  }
  resolve(path) {
    if (path._ == "input") {
      return import_path3.default.resolve(this.srcdir || this.cwd, path.path);
    } else if (path._ == "output") {
      return import_path3.default.resolve(this.outdir, path.path);
    } else {
      return import_path3.default.resolve(this.cwd, path.path || path);
    }
    ;
  }
  resolveAssetPath(path) {
    return import_path3.default.resolve(this.outdir, path);
  }
  read(path) {
    return import_fs3.default.readFileSync(this.resolve(path), "utf-8");
  }
  loadFromFile(path) {
    return import_fs3.default.existsSync(path) ? import_fs3.default.readFileSync(path, "utf-8") : "{}";
  }
  init(data = null) {
    if (data || this.path) {
      this.update(data);
    }
    ;
    return this;
  }
  update(raw) {
    if (raw == null) {
      if (this.path) {
        raw = this.loadFromFile(this.path);
      } else {
        console.warn("cannot update manifest without path");
      }
      ;
    }
    ;
    if (typeof raw == "string") {
      let str = raw;
      raw = deserializeData(raw, this.reviver);
      raw[φ42] = str;
    }
    ;
    this.data = patchManifest(this.data || {}, raw);
    if (this.data.changes.all.length) {
      this.emit("change", this.diff, this);
    }
    ;
    if (this.data.changes.main) {
      this.emit("change:main", this.data.main, this);
    }
    ;
    return this.data.changes;
  }
  serializeForBrowser() {
    return this.data[φ42];
  }
  [φ111](data) {
    return true;
  }
  watch() {
    var self2 = this;
    if (this[φ5] != true ? (this[φ5] = true, true) : false) {
      return this.path && !process.env.IMBA_HMR && import_fs3.default.watch(this.path, function(ev, name) {
        let exists = import_fs3.default.existsSync(self2.path);
        let stat = exists && import_fs3.default.statSync(self2.path);
        if (exists) {
          self2.update();
        }
        ;
        return;
      });
    }
    ;
  }
  on(event, cb) {
    this.watch();
    return super.on(...arguments);
  }
};
var LazyProxy = class {
  static for(getter) {
    return new Proxy({}, new this(getter));
  }
  constructor(getter) {
    this.getter = getter;
  }
  get target() {
    return this.getter();
  }
  get(_, key) {
    return this.target[key];
  }
  set(_, key, value) {
    this.target[key] = value;
    return true;
  }
};
var manifest = LazyProxy.for(function() {
  return globalThis[φ25];
});

// src/bundler/bundle.imba
var import_os2 = __toModule(require("os"));
var import_path5 = __toModule(require("path"));
var import_fs4 = __toModule(require("fs"));
var import_module = __toModule(require("module"));

// src/compiler/sourcemapper.imba
var SourceMapper = class {
  static strip(input) {
    return input.replace(/\/\*\%([\w\|]*)\$\*\//g, "");
  }
  static run(input, o = {}) {
    let output = input.replace(/\/\*\%([\w\|]*)\$\*\//g, "");
    return {
      code: output,
      map: null,
      toString: function() {
        return this.code;
      }
    };
  }
};

// src/bundler/watcher.imba
var import_path4 = __toModule(require("path"));
function iter$__10(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ112 = Symbol.for("#watcher");
var FLAGS2 = {
  CHANGE: 1,
  ADD: 2,
  UNLINK: 4
};
var Watcher = class extends component_default {
  constructor(fs) {
    super();
    this.fs = fs;
    this.history = new changes_default({withFlags: true});
    this.events = [];
    this.map = {};
    this.map[fs.cwd] = 1;
  }
  get instance() {
    var self2 = this;
    if (this[φ112]) {
      return this[φ112];
    }
    ;
    let normalize = function(src) {
      return src.split(import_path4.default.sep).join(import_path4.default.posix.sep);
    };
    let initial = Object.keys(this.map);
    this[φ112] = require("chokidar").watch(initial, {
      ignoreInitial: true,
      depth: 1,
      ignored: this.isIgnored.bind(this),
      cwd: this.fs.cwd
    });
    this[φ112].on("change", function(src, stats) {
      src = normalize(src);
      self2.history.mark(src, FLAGS2.CHANGE);
      self2.emit("change", src);
      return self2.emit("touch", src);
    });
    this[φ112].on("unlink", function(src, stats) {
      src = normalize(src);
      self2.history.mark(src, FLAGS2.UNLINK);
      self2.emit("unlink", src);
      return self2.emit("touch", src);
    });
    this[φ112].on("add", function(src, stats) {
      src = normalize(src);
      console.log("add", src);
      self2.history.mark(src, FLAGS2.ADD);
      self2.emit("add", src);
      return self2.emit("touch", src);
    });
    return this[φ112];
  }
  isIgnored(path) {
    if (path.match(/(\/\.(git|imba-cache|cache)\/|\.DS_Store)/)) {
      return true;
    }
    ;
    return false;
  }
  add(...paths) {
    let uniq = [];
    for (let φ28 = 0, φ39 = iter$__10(paths), φ45 = φ39.length; φ28 < φ45; φ28++) {
      let path = φ39[φ28];
      if (!this.map[path]) {
        this.map[path] = true;
        uniq.push(path);
      }
      ;
    }
    ;
    if (this[φ112] && uniq.length) {
      this[φ112].add(...uniq);
    }
    ;
    return this;
  }
  has(path) {
    return !!this.map[path];
  }
  sync(target) {
    return this.history.pull(target);
  }
  start() {
    this.instance;
    return this;
  }
};
var watcher_default = Watcher;

// src/bundler/bundle.imba
function iter$__11(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ113 = Symbol.for("#init");
var φ37 = Symbol.for("#baseurl");
var φ43 = Symbol.for("#theme");
var φ73 = Symbol.for("#buildcache");
var φ82 = Symbol.for("#_id_");
var φ9 = Symbol.for("#bundles");
var φ102 = Symbol.for("#watchedPaths");
var φ26 = Symbol.for("#rel");
var φ27 = Symbol.for("#bundler");
var φ362 = Symbol.for("#watching");
var φ372 = Symbol.for("#rebuildTimeout");
var φ422 = Symbol.for("#finalized");
var φ432 = Symbol.for("#contents");
var φ52 = Symbol.for("#file");
var φ53 = Symbol.for("#output");
var φ60 = Symbol.for("#type");
var φ78 = Symbol.for("#ordered");
var φ80 = Symbol.for("#csschunk");
var φ822 = Symbol.for("#text");
var φ90 = Symbol.for("#resolved");
var φ98 = Symbol.for("#outfs");
var φ119 = Symbol.for("#hash");
var ASSETS_URL = "/_ASSET_PREFIX_PATH_/";
var BUNDLE_COUNTER = 0;
var Builder = class {
  constructor($$ = null) {
    this[φ113]($$);
  }
  [φ113]($$ = null) {
    var φ28;
    this.startAt = $$ && (φ28 = $$.startAt) !== void 0 ? φ28 : Date.now();
    this.refs = $$ && (φ28 = $$.refs) !== void 0 ? φ28 : {};
    this.inputs = $$ && (φ28 = $$.inputs) !== void 0 ? φ28 : {};
    this.outputs = $$ && (φ28 = $$.outputs) !== void 0 ? φ28 : new Set();
    this.bundlers = $$ && (φ28 = $$.bundlers) !== void 0 ? φ28 : {};
    this.meta = $$ && (φ28 = $$.meta) !== void 0 ? φ28 : {};
    this.styles = $$ && (φ28 = $$.styles) !== void 0 ? φ28 : {};
  }
  get elapsed() {
    return Date.now() - this.startAt;
  }
};
var Bundle = class extends component_default {
  get nodeΦ() {
    return this.platform == "node";
  }
  get nodeworkerΦ() {
    return this.platform == "nodeworker";
  }
  get nodeishΦ() {
    return this.nodeΦ || this.nodeworkerΦ;
  }
  get webΦ() {
    return !this.nodeishΦ;
  }
  get webworkerΦ() {
    return this.platform == "webworker";
  }
  get worker() {
    return this.webworkerΦ || this.nodeworkerΦ;
  }
  get webishΦ() {
    return this.webΦ || this.webworkerΦ;
  }
  get devΦ() {
    return this.program.mode == "development";
  }
  get hmrΦ() {
    return this.program.hmr == true;
  }
  get hashingΦ() {
    return this.o.hashing !== false && this.program.hashing !== false;
  }
  get o() {
    return this.options;
  }
  get mainΦ() {
    return this.root == this;
  }
  get outdir() {
    return this.program.outdir || this.fs.cwd;
  }
  get outbase() {
    return this.o.outbase || this.fs.cwd;
  }
  get assetNames() {
    return this.program.assetNames || "assets/[dir]/[name]";
  }
  get htmlNames() {
    return this.program.htmlNames || "[dir]/[name]";
  }
  get pubdir() {
    return this.program.pubdir == false ? "." : this.program.pubdir || "public";
  }
  get baseurl() {
    return this[φ37] || (this[φ37] = ((this.program.baseurl || "/") + "/").replace(/\/+/g, "/"));
  }
  get fs() {
    return this.program.fs;
  }
  get imbaconfig() {
    return this.program.config;
  }
  get theme() {
    var φ54, φ62;
    return (φ54 = this.imbaconfig)[φ43] || (φ54[φ43] = new StyleTheme(this.imbaconfig));
  }
  get root() {
    return this.parent ? this.parent.root : this;
  }
  get buildcache() {
    return this.root[φ73];
  }
  [Symbol.toPrimitive](hint) {
    return this[φ82] || (this[φ82] = Symbol());
  }
  pathForAsset(src, asset, tpl = this.assetNames, shouldHash = this.hashingΦ) {
    let o = {};
    o.ext = import_path5.default.extname(src);
    o.kind = o.ext.slice(1);
    if (o.ext == ".map") {
      o.ext = ".js.map";
      o.kind = "js";
    }
    ;
    o.name = import_path5.default.basename(src, o.ext);
    o.dir = import_path5.default.dirname(src);
    o.hash = (asset == null ? void 0 : asset.hash) || null;
    if (o.ext.match(import_utils2.FontRegex)) {
      o.kind = "fonts";
    } else if (o.ext.match(import_utils2.ImageRegex)) {
      o.kind = "img";
    } else if (o.ext == ".html") {
      o.kind = "";
      tpl = this.htmlNames;
    }
    ;
    if (tpl.indexOf("[name]") < 0) {
      tpl += "/[name]";
    }
    ;
    if (tpl.indexOf("[hash]") == -1 && shouldHash) {
      tpl = tpl.replace("[name]", "[name]-[hash]");
    }
    ;
    if (tpl.indexOf("[hash]") == -1 && tpl.indexOf("[dir]") == -1) {
      false;
    }
    ;
    let dest = tpl.replace(/\[(\w+)\]/g, function(m, k) {
      return typeof o[k] == "string" ? o[k] : m;
    });
    dest = (0, import_utils2.normalizePath)(dest).replace(/^\//, "") + o.ext;
    if (o.hash) {
      dest = dest.replace("" + o.hash + "-" + o.hash, o.hash);
    }
    ;
    return dest;
  }
  constructor(up, o) {
    var φ143, φ152, φ162, φ172, φ192, φ182;
    super();
    this[φ9] = {web: {}, node: {}};
    this[φ102] = {};
    this[φ73] = {};
    if (up instanceof Bundle) {
      this.parent = up;
      this.program = up.program;
    } else {
      this.program = up;
    }
    ;
    this.nr = BUNDLE_COUNTER++;
    this.styles = {};
    this.options = o;
    this.result = null;
    this.firstBuild = null;
    this.workers = null;
    this.built = false;
    this.meta = {};
    this.cwd = this.fs.cwd;
    this.platform = o.platform || "browser";
    this.entryPoints = o.entryPoints || [];
    this.children = new Set();
    this.builder = null;
    if (this.parent) {
      this.watcher = this.parent.watcher;
    } else if (this.program.watch) {
      this.watcher || (this.watcher = new watcher_default(this.fs));
    }
    ;
    let externals = [];
    let pkg = this.program.package || {};
    for (let φ11 = 0, φ123 = iter$__11(o.external), φ133 = φ123.length; φ11 < φ133; φ11++) {
      let ext = φ123[φ11];
      if (ext[0] == "!") {
        continue;
      }
      ;
      if (ext == "dependencies") {
        let deps = Object.keys(pkg.dependencies || {});
        externals.push(...deps);
      }
      ;
      if (ext == "devDependencies") {
        externals.push(...Object.keys(pkg.devDependencies || {}));
      }
      ;
      if (ext == "builtins") {
        externals.push(...Object.keys(import_utils2.builtInModules));
      }
      ;
      if (ext == ".json") {
        externals.push("*.json");
      }
      ;
      externals.push(ext);
    }
    ;
    externals = externals.filter(function(src) {
      return !o.external || o.external.indexOf("!" + src) == -1;
    });
    this.esoptions = {
      entryPoints: o.stdin ? void 0 : this.entryPoints,
      bundle: o.bundle === false ? false : true,
      define: o.define,
      platform: this.nodeishΦ ? "node" : "browser",
      format: o.format || "esm",
      outfile: o.outfile,
      outbase: this.fs.cwd,
      outdir: this.fs.cwd,
      outExtension: {
        ".js": ".__dist__.js",
        ".css": ".__dist__.css"
      },
      globalName: o.globalName,
      publicPath: o.publicPath || ASSETS_URL,
      banner: {
        js: "//__HEAD__" + (o.banner ? "\n" + o.banner : "")
      },
      footer: {js: o.footer || "//__FOOT__"},
      splitting: o.splitting,
      sourcemap: this.program.sourcemap === false ? false : this.webΦ ? true : "inline",
      stdin: o.stdin,
      minify: (φ143 = o.minify) != null ? φ143 : this.program.minify,
      incremental: !!this.watcher,
      loader: Object.assign({
        ".png": "file",
        ".apng": "file",
        ".webp": "file",
        ".heif": "file",
        ".avif": "file",
        ".svg": "file",
        ".gif": "file",
        ".jpg": "file",
        ".jpeg": "file",
        ".ico": "file",
        ".woff2": "file",
        ".woff": "file",
        ".eot": "file",
        ".ttf": "file",
        ".otf": "file",
        ".html": "file"
      }, o.loader || {}),
      write: false,
      metafile: true,
      external: externals,
      tsconfig: o.tsconfig,
      nodePaths: (o.nodePaths || []).slice(0),
      plugins: (o.plugins || []).concat({name: "imba", setup: this.plugin.bind(this)}),
      pure: o.pure,
      treeShaking: o.treeShaking,
      resolveExtensions: [".imba", ".imba1", ".ts", ".mjs", ".cjs", ".js"]
    };
    if (o.esbuild) {
      (0, import_utils2.extendObject)(this.esoptions, o.esbuild, "esbuild");
    }
    ;
    this.imbaoptions = {
      platform: o.platform,
      css: "external"
    };
    if (o.sourcesContent !== void 0) {
      this.esoptions.sourcesContent = o.sourcesContent;
    }
    ;
    if (o.platform == "worker") {
      this.imbaoptions.platform = "node";
    }
    ;
    if (o.target) {
      this.esoptions.target = o.target;
    }
    ;
    if (o.format == "css") {
      this.esoptions.format = "esm";
      this.esoptions.outExtension[".js"] = ".SKIP.js";
    }
    ;
    if (o.format == "html") {
      this.esoptions.format = "esm";
      this.esoptions.minify = false;
      this.esoptions.sourcemap = false;
    }
    ;
    let addExtensions = {
      webworker: [".webworker.imba", ".worker.imba"],
      serviceworker: [".serviceworker.imba", ".webworker.imba", ".worker.imba"],
      nodeworker: [".nodeworker.imba", ".worker.imba", ".node.imba"],
      worker: [".imba.web-pkg.js", ".worker.imba"],
      node: [".node.imba"],
      browser: [".web.imba"]
    };
    if (addExtensions[o.platform]) {
      this.esoptions.resolveExtensions.unshift(...addExtensions[o.platform]);
    }
    ;
    if (!this.nodeishΦ) {
      let defines = (φ152 = this.esoptions).define || (φ152.define = {});
      let env = o.env || process.env.NODE_ENV || "production";
      defines.global = "globalThis";
      defines["process.platform"] = "'web'";
      defines["process.browser"] = "true";
      this.esoptions.inject = [
        import_path5.default.resolve(this.program.imbaPath, "polyfills", "buffer", "index.js"),
        import_path5.default.resolve(this.program.imbaPath, "polyfills", "__inject__.js")
      ];
      defines[φ162 = "process.env.NODE_ENV"] || (defines[φ162] = "'" + env + "'");
      defines[φ172 = "process.env"] || (defines[φ172] = JSON.stringify({NODE_ENV: env}));
      defines.ENV_DEBUG || (defines.ENV_DEBUG = "false");
      this.esoptions.nodePaths.push(import_path5.default.resolve(this.program.imbaPath, "polyfills"));
    }
    ;
    if (o.bundle == false) {
      this.esoptions.bundle = false;
      φ182 = this.esoptions.external, delete this.esoptions.external, φ182;
    }
    ;
    if (o.splitting && this.esoptions.format != "esm") {
      this.log.error("code-splitting not allowed when format is not esm");
    }
    ;
    if (this.mainΦ) {
      this.log.ts("created main bundle");
      this.manifest = new Manifest({data: {}});
    }
    ;
  }
  addEntrypoint(src) {
    if (this.entryPoints.indexOf(src) < 0) {
      this.entryPoints.push(src);
    }
    ;
    return this;
  }
  setup() {
    return this;
  }
  watchPath(path) {
    if (!this[φ102][path]) {
      this[φ102][path] = 1;
      if (this.parent) {
        this.parent.watchPath(path);
      } else if (this.watcher && path.indexOf(":") == -1) {
        this.watcher.add(path.slice(0, path.lastIndexOf("/")));
      }
      ;
    }
    ;
    return this;
  }
  resolveConfigPreset(types = []) {
    let key = Symbol.for(types.join("+"));
    let cacher = this.imbaconfig;
    if (cacher[key]) {
      return cacher[key];
    }
    ;
    let base = {presets: []};
    let presets = this.imbaconfig.options;
    for (let φ203 = 0, φ212 = iter$__11(types), φ252 = φ212.length; φ203 < φ252; φ203++) {
      let typ = φ212[φ203];
      let pre = presets[typ] || {};
      base.presets.push(pre);
      let curr = pre;
      let add = [pre];
      while (curr.extends && add.length < 10) {
        add.unshift(curr = presets[curr.extends]);
      }
      ;
      for (let φ222 = 0, φ233 = iter$__11(add), φ242 = φ233.length; φ222 < φ242; φ222++) {
        let item = φ233[φ222];
        Object.assign(base, item);
      }
      ;
    }
    ;
    return cacher[key] = base;
  }
  plugin(esb) {
    var self2 = this;
    let externs = this.esoptions.external || [];
    let imbaDir = this.program.imbaPath;
    let isCSS = function(f) {
      return /^styles:/.test(f) || /\.css$/.test(f);
    };
    let isImba = function(f) {
      return /\.imba$/.test(f) && f.indexOf("styles:") != 0;
    };
    let pathMetadata = {};
    let toAssetJS = function(object) {
      let js;
      let json = JSON.stringify(object);
      return js = "import {asset} from 'imba';\nexport default asset(" + json + ")";
    };
    if (this.o.resolve) {
      let regex = new RegExp("^(" + Object.keys(this.o.resolve).join("|") + ")$");
      esb.onResolve({filter: regex}, function(args) {
        let res = self2.o.resolve[args.path];
        res = res && res[self2.platform] || res;
        return res;
      });
    }
    ;
    esb.onResolve({filter: /(\.(svg|png|jpe?g|gif|tiff|webp)|\?as=img)$/}, function(args) {
      if (!(isImba(args.importer) && args.namespace == "file")) {
        return;
      }
      ;
      if (self2.o.format == "css") {
        return {path: "_", namespace: "imba-raw"};
      }
      ;
      let ext = import_path5.default.extname(args.path).slice(1);
      let res = self2.fs.resolver.resolve(args);
      let out = {path: res[φ26] || res.path, namespace: "img"};
      return out;
    });
    esb.onLoad({namespace: "img", filter: /.*/}, async function({path}) {
      let file = self2.fs.lookup(path);
      let out = await file.compile({format: "esm"}, self2);
      return {loader: "js", contents: out.js, resolveDir: file.absdir};
    });
    esb.onResolve({filter: /\.html$/}, function(args) {
      if (isImba(args.importer) && args.namespace == "file") {
        let cfg = self2.resolveConfigPreset(["html"]);
        let res = self2.fs.resolver.resolve({path: args.path, resolveDir: args.resolveDir});
        let out = {path: res[φ26], namespace: "entry"};
        pathMetadata[out.path] = {path: res[φ26], config: cfg};
        return out;
      }
      ;
    });
    esb.onLoad({namespace: "html", filter: /.*/}, async function({path}) {
      let file = self2.fs.lookup(path);
      let out = await file.compile({format: "esm"}, self2);
      return {loader: "js", contents: out.js, resolveDir: file.absdir};
    });
    esb.onLoad({filter: /\.html$/, namespace: "file"}, async function({path}) {
      let file = self2.fs.lookup(path);
      let out = await file.compile({format: "esm"}, self2);
      self2.builder.meta[file.rel] = out;
      return {loader: "js", contents: out.js, resolveDir: file.absdir};
    });
    esb.onResolve({filter: /\?as=([\w\-\,\.]+)$/}, function(args) {
      if (args.path == "*?as=css") {
        return {path: "__styles__", namespace: "entry"};
      }
      ;
      if (self2.o.format == "css") {
        return {path: "_", namespace: "imba-raw"};
      }
      ;
      let [path, q] = args.path.split("?");
      let formats = q.slice(3).split(",");
      let wrkidx = formats.indexOf("worker");
      if (wrkidx >= 0) {
        formats[wrkidx] = self2.nodeishΦ ? "nodeworker" : "webworker";
        q = "as=" + formats.join(",");
      }
      ;
      if (q == "as=file" || q == "as=text") {
        let res2 = self2.fs.resolver.resolve({path, resolveDir: args.resolveDir});
        return {path: res2.path, namespace: "raw" + formats[0]};
      }
      ;
      let cfg = self2.resolveConfigPreset(formats);
      let res = self2.fs.resolver.resolve({path, resolveDir: args.resolveDir});
      let out = {path: res[φ26] + "?" + q, namespace: "entry"};
      pathMetadata[out.path] = {path: res[φ26], config: cfg};
      return out;
    });
    esb.onLoad({namespace: "entry", filter: /^__styles__$/}, function(args) {
      if (self2.o.format == "html") {
        return {loader: "text", contents: "__styles__"};
      }
      ;
      return {loader: "js", contents: toAssetJS({input: "__styles__"}), resolveDir: self2.fs.cwd};
    });
    esb.onLoad({namespace: "entry", filter: /.*/}, function({path}) {
      var φ28, φ29;
      if (self2.o.format == "css") {
        return {loader: "text", contents: ""};
      }
      ;
      let id = "entry:" + path;
      let meta = pathMetadata[path];
      let cfg = meta.config;
      let file = self2.fs.lookup(meta.path);
      if (cfg.splitting) {
        let js = "import {asset} from 'imba';\nexport default asset({input: '" + id + "'})";
        let bundle = cfg[φ27] || (cfg[φ27] = new Bundle(self2.root, Object.create(cfg)));
        bundle.addEntrypoint(meta.path);
        self2.builder.refs[id] = bundle;
        if (self2.o.format == "html") {
          return {loader: "text", contents: id};
        }
        ;
        return {loader: "js", contents: js, resolveDir: import_path5.default.dirname(path)};
      }
      ;
      self2.log.debug("lookup up bundle for id " + id);
      let bundler = self2.root[φ9][id] || (self2.root[φ9][id] = new Bundle(self2.root, Object.assign({entryPoints: [meta.path]}, cfg)));
      self2.builder.refs[id] = bundler;
      if (cfg.format != "css") {
        bundler.rebuild();
      }
      ;
      if (self2.o.format == "html") {
        return {loader: "text", contents: id};
      }
      ;
      return {loader: "js", contents: toAssetJS({input: id}), resolveDir: file.absdir};
    });
    esb.onResolve({filter: /^\//}, function(args) {
      if (args.path.indexOf("?") > 0) {
        return;
      }
      ;
      return {path: args.path, external: true};
    });
    esb.onResolve({filter: /^imba(\/|$)/}, function(args) {
      if (args.path == "imba") {
        if (self2.o.format == "css") {
          return {path: args.path, external: true};
        }
        ;
        let out = import_path5.default.resolve(imbaDir, "index.imba");
        return {path: out, namespace: "file"};
      }
      ;
      let rel = args.path.slice(args.path.indexOf("/") + 1);
      let path = import_path5.default.resolve(imbaDir, rel);
      let exts = ["", ".imba"];
      if (rel == "program" || rel == "compiler") {
        exts.unshift(".imba.js");
      }
      ;
      for (let φ30 = 0, φ31 = iter$__11(exts), φ322 = φ31.length; φ30 < φ322; φ30++) {
        let ext = φ31[φ30];
        if (import_fs4.default.existsSync(path + ext)) {
          return {path: path + ext};
        }
        ;
      }
      ;
      return null;
    });
    esb.onResolve({filter: /^_styles_$/}, function({importer}) {
      let path = self2.fs.relative(importer);
      return {path, namespace: "styles"};
    });
    esb.onResolve({filter: /^[\w\@\#]/}, function(args) {
      if (externs.indexOf(args.path) >= 0) {
        return {external: true};
      }
      ;
      if (args.importer.indexOf(".imba") > 0) {
        let out = self2.fs.resolver.resolve(args);
        return out;
      }
      ;
      return null;
    });
    esb.onLoad({filter: /.*/, namespace: "imba-raw"}, function({path}) {
      return {loader: "text", contents: ""};
    });
    esb.onLoad({filter: /.*/, namespace: "asset"}, async function({path}) {
      let file = self2.fs.lookup(path);
      let out = await file.compile({format: "esm"}, self2);
      return {loader: "js", contents: out.js, resolveDir: file.absdir};
    });
    esb.onLoad({filter: /.*/, namespace: "rawfile"}, function({path}) {
      return {loader: "file", contents: import_fs4.default.readFileSync(path, "utf-8")};
    });
    esb.onLoad({filter: /.*/, namespace: "rawtext"}, function({path}) {
      return {loader: "text", contents: import_fs4.default.readFileSync(path, "utf-8")};
    });
    esb.onLoad({filter: /\.imba$/, namespace: "styles"}, function({path, namespace}) {
      let res;
      if (res = self2.builder.styles[path]) {
        return res;
      } else {
        return {loader: "css", contents: ""};
      }
      ;
    });
    return esb.onLoad({filter: /\.imba1?$/}, async function({path, namespace}) {
      let src = self2.fs.lookup(path);
      let t = Date.now();
      let res = await src.compile(self2.imbaoptions, self2);
      if (res.css) {
        self2.builder.styles[src.rel] = {
          loader: "css",
          contents: self2.theme.transformColors(SourceMapper.strip(res.css || "")),
          resolveDir: src.absdir
        };
      }
      ;
      let incStyles = res.css || self2.o.format == "css";
      let cached = res[self2] || (res[self2] = {
        loader: "js",
        contents: SourceMapper.strip(res.js || "") + (incStyles ? "\nimport '_styles_';" : ""),
        errors: (res.errors || []).map(function(_0) {
          return (0, import_utils2.diagnosticToESB)(_0, {file: src.abs, namespace});
        }),
        warnings: (res.warnings || []).map(function(_0) {
          return (0, import_utils2.diagnosticToESB)(_0, {file: src.abs, namespace});
        }),
        resolveDir: src.absdir
      });
      return cached;
    });
  }
  build(force = false) {
    var self2 = this, φ332;
    return (φ332 = this.buildcache)[this] || (φ332[this] = new Promise(async function(resolve2) {
      var φ342, φ352;
      if ((self2.built != true ? (self2.built = true, true) : false) || force) {
        self2.workers = await startWorkers();
        self2.log.debug("build " + self2.entryPoints.join(",") + " " + self2.o.format + "|" + self2.o.platform + " " + self2.nr);
        if (self2.o.stdin && self2.o.stdin.template) {
          let tpl = self2.fs.lookup(import_path5.default.resolve(self2.program.imbaPath, "src", "templates", self2.o.stdin.template));
          let compiled = await tpl.compile({platform: "node"}, self2);
          φ342 = self2.o.stdin.template, delete self2.o.stdin.template, φ342;
          let js = compiled.js;
          let defs = self2.o.stdin.define || {};
          js = js.replace(/\__([A-Z\_]+)__/g, function(m, name) {
            return defs[name];
          });
          self2.o.stdin.contents = js;
          φ352 = self2.o.stdin.define, delete self2.o.stdin.define, φ352;
        }
        ;
        try {
          self2.builder = new Builder({previous: self2.builder});
          self2.result = await esbuild2.build(self2.esoptions);
          self2.firstBuild = self2.result;
        } catch (e) {
          self2.result = e;
        }
        ;
        await self2.transform(self2.result);
        if (self2.mainΦ) {
          await self2.write(self2.result);
        }
        ;
        if (!self2.watcher) {
          self2.workers.stop();
          self2.workers = null;
        }
        ;
        if (self2.watcher && self2.mainΦ && (self2[φ362] != true ? (self2[φ362] = true, true) : false)) {
          self2.watcher.start();
          self2.watcher.on("touch", function(_0) {
            self2.log.debug("watcher touch", _0);
            clearTimeout(self2[φ372]);
            return self2[φ372] = setTimeout(function() {
              clearTimeout(self2[φ372]);
              self2.log.debug("try rebuild", !!self2.buildcache[self2], self2.o.watch);
              return self2.rebuild();
            }, 100);
          });
        }
        ;
      }
      ;
      self2[φ73] = {};
      return resolve2(self2.result);
    }));
  }
  rebuild({force = false} = {}) {
    var self2 = this, φ382;
    if (!(this.built && this.result && this.result.rebuild instanceof Function)) {
      return this.build(true);
    }
    ;
    return (φ382 = this.buildcache)[this] || (φ382[this] = new Promise(async function(resolve2) {
      if (self2.mainΦ) {
        self2.log.debug("starting rebuild!", !!self2.watcher, force);
      }
      ;
      if (self2.watcher && !force) {
        let changes = self2.watcher.sync(self2);
        let dirty = false;
        for (let φ39 = 0, φ40 = iter$__11(changes), φ41 = φ40.length; φ39 < φ41; φ39++) {
          let [path, flags] = φ40[φ39];
          if (self2[φ102][path] || flags != 1) {
            dirty = true;
          }
          ;
        }
        ;
        if (self2.mainΦ) {
          self2.log.debug("changes demanding a resolve?", changes, dirty);
        }
        ;
        if (!dirty) {
          self2[φ73] = {};
          return resolve2(self2.result);
        }
        ;
      }
      ;
      let prev = self2.result;
      try {
        self2.builder = new Builder({previous: self2.builder});
        let rebuilt = await self2.firstBuild.rebuild();
        self2.result = rebuilt;
      } catch (e) {
        self2.log.debug("error when rebuilding", e);
        self2.result = e;
      }
      ;
      await self2.transform(self2.result, prev);
      if (self2.mainΦ) {
        await self2.write(self2.result, prev);
      }
      ;
      self2[φ73] = {};
      return resolve2(self2.result);
    }));
  }
  finalizeAsset(asset, shouldHash = this.hashingΦ) {
    if (asset[φ422]) {
      return asset;
    }
    ;
    asset[φ422] = true;
    let sub = ".";
    asset.hash || (asset.hash = (0, import_utils2.createHash)(asset[φ432]));
    if (shouldHash) {
      asset.hashed = true;
      sub = "." + asset.hash + ".";
    }
    ;
    let path = asset.originalPath = asset.path;
    path = path.replace(".__dist__.", ".");
    path = this.pathForAsset(path, asset, this.assetNames, shouldHash);
    if (sub != ".") {
      asset.ttl = 31536e3;
    }
    ;
    if (asset.url) {
      asset.url = asset.url.replace(".__dist__.", sub);
      if (sub == "." && asset.hash && asset.type != "map") {
        true;
      }
      ;
    }
    ;
    asset.path = asset.path.replace(".__dist__.", sub);
    let url = this.baseurl + path;
    if (asset.public) {
      asset.path = path;
      asset.url = url;
      if (this.pubdir != ".") {
        asset.path = "" + this.pubdir + "/" + asset.path;
      }
      ;
    }
    ;
    if (asset.type == "js" && asset.map) {
      let replace = /\/\/# sourceMappingURL=[\/\w\.\-\%]+\.map/;
      asset[φ432] = asset[φ432].replace(replace, "//# sourceMappingURL=" + asset.url + ".map");
      asset.map.path = asset.path + ".map";
      asset.map.url = asset.url + ".map";
      asset.map[φ422] = true;
    }
    ;
    return asset;
  }
  collectStyleInputs(input, deep, matched = [], visited = []) {
    if (visited.indexOf(input) >= 0) {
      return matched;
    }
    ;
    visited.push(input);
    if (input.path.match(/(^styles:)|(\.css$)/)) {
      if (matched.indexOf(input) == -1) {
        if (!matched.find(function(_0) {
          return _0.path == input.path;
        })) {
          matched.push(input);
        }
        ;
      }
      ;
    }
    ;
    for (let φ442 = 0, φ45 = iter$__11(input.imports), φ46 = φ45.length; φ442 < φ46; φ442++) {
      let item = φ45[φ442];
      if (item.path.match(/\?as=css$/)) {
        continue;
      }
      ;
      this.collectStyleInputs(item, deep, matched, visited);
    }
    ;
    if (input.asset && deep) {
      this.collectStyleInputs(input.asset.source, deep, matched, visited);
    }
    ;
    return matched;
  }
  async transform(result, prev) {
    var self2 = this;
    let t = Date.now();
    if (result instanceof Error) {
      this.log.debug("result is error!!", result);
      for (let φ47 = 0, φ48 = iter$__11(result.errors), φ49 = φ48.length; φ47 < φ49; φ47++) {
        let err = φ48[φ47];
        this.watchPath(err.location.file);
      }
      ;
      result.rebuild = prev && prev.rebuild.bind(prev);
      result.meta = {
        inputs: {},
        outputs: {},
        urls: {},
        errors: result.errors,
        warnings: result.warnings
      };
      return result;
    }
    ;
    let files = result.outputFiles || [];
    let meta = result.metafile;
    meta = result.meta = {
      format: this.o.format,
      platform: this.o.platform,
      inputs: meta.inputs,
      outputs: meta.outputs,
      errors: [].concat(result.errors || []),
      warnings: [].concat(result.warnings || []),
      urls: {}
    };
    let ins = meta.inputs;
    let outs = meta.outputs;
    let urls = meta.urls;
    let reloutdir = this.fs.relative(this.esoptions.outdir);
    for (let φ50 = 0, φ51 = iter$__11(files), φ54 = φ51.length; φ50 < φ54; φ50++) {
      let file = φ51[φ50];
      let path = this.fs.relative(file.path);
      if (outs[path]) {
        outs[path][φ52] = file;
        outs[path][φ432] = file.contents;
        file[φ53] = outs[path];
      } else {
        console.log("could not map the file to anything!!", file.path, path, reloutdir, Object.keys(outs), this.fs.cwd, this.esoptions.outdir);
      }
      ;
    }
    ;
    let tests = {
      js: ".__dist__.js",
      css: ".__dist__.css",
      map: ".__dist__.js.map"
    };
    for (let φ55 = 0, φ56 = Object.keys(outs), φ57 = φ56.length, path, output; φ55 < φ57; φ55++) {
      path = φ56[φ55];
      output = outs[path];
      this.root.builder.outputs.add(output);
      if (outs[path + ".map"]) {
        output.map = outs[path + ".map"];
      }
      ;
    }
    ;
    for (let φ58 = 0, φ59 = Object.keys(ins), φ64 = φ59.length, path, input; φ58 < φ64; φ58++) {
      path = φ59[φ58];
      input = ins[path];
      input[φ60] = input._ = "input";
      input.path = path;
      input.imports = input.imports.map(function(_0) {
        return ins[_0.path];
      });
      this.watchPath(path);
      let outname = path.replace(/\.(imba1?|[cm]?jsx?|tsx?|html|css)$/, "");
      let jsout;
      for (let φ61 = 0, φ62 = Object.keys(tests), φ63 = φ62.length, key, ext; φ61 < φ63; φ61++) {
        key = φ62[φ61];
        ext = tests[key];
        let name = outname.replace(/\.\.\//g, "_.._/") + ext;
        if (reloutdir) {
          name = "" + reloutdir + "/" + name;
        }
        ;
        if (outs[name]) {
          input[key] = outs[name];
          outs[name].source = input;
          if (key == "js") {
            jsout = outs[name];
          } else if (jsout) {
            jsout[key] = outs[name];
          }
          ;
        }
        ;
      }
      ;
    }
    ;
    let urlOutputMap = {};
    let walker = {};
    let addOutputs = new Set();
    let styleInputs = [];
    for (let φ67 = this.builder.refs, φ65 = 0, φ66 = Object.keys(φ67), φ68 = φ66.length, path, dep; φ65 < φ68; φ65++) {
      path = φ66[φ65];
      dep = φ67[path];
      let input = ins[path];
      let res = dep;
      let rawpath = path.slice(path.indexOf(":") + 1).split("?")[0];
      if (path && input && dep instanceof Bundle) {
        res = await dep.rebuild();
      }
      ;
      let inp = res && res.meta && res.meta.inputs[rawpath];
      if (dep instanceof Bundle) {
        Object.assign(this[φ102], dep[φ102]);
      }
      ;
      if (inp) {
        input.asset = res.meta.format == "css" ? inp.css : inp.js;
        addOutputs.add(res.meta.outputs);
      }
      ;
      if (res && res.meta) {
        meta.errors.push(...res.meta.errors);
        meta.warnings.push(...res.meta.warnings);
      }
      ;
    }
    ;
    walker.collectCSSInputs = function(input, matched = [], visited = []) {
      if (visited.indexOf(input) >= 0) {
        return matched;
      }
      ;
      visited.push(input);
      if (input.path.match(/(^styles:)|(\.css$)/)) {
        matched.push(input);
      }
      ;
      for (let φ69 = 0, φ70 = iter$__11(input.imports), φ71 = φ70.length; φ69 < φ71; φ69++) {
        let item = φ70[φ69];
        walker.collectCSSInputs(item, matched, visited);
      }
      ;
      return matched;
    };
    for (let φ722 = 0, φ732 = Object.keys(outs), φ83 = φ732.length, path, output, m; φ722 < φ83; φ722++) {
      path = φ732[φ722];
      output = outs[path];
      output[φ60] = output._ = "output";
      output.path = path;
      if (output.source && output.source.path.match(/\.html$/) && output == output.source.js) {
        urlOutputMap[path] = output;
        output.public = true;
        output.path = path = path.replace(".js", ".html");
      } else if (this.webishΦ || output.type == "css" || path.match(import_utils2.FontRegex) || path.match(import_utils2.ImageRegex)) {
        urlOutputMap[path] = output;
        output.public = true;
        output.url = "" + this.baseurl + path;
      }
      ;
      output.type = (import_path5.default.extname(path) || "").slice(1);
      let inputs = [];
      let dependencies = new Set();
      for (let φ76 = output.inputs, φ74 = 0, φ75 = Object.keys(φ76), φ77 = φ75.length, src, m2; φ74 < φ77; φ74++) {
        src = φ75[φ74];
        m2 = φ76[src];
        if (src.indexOf("entry:") == 0) {
          dependencies.add(ins[src]);
        }
        ;
        inputs.push([ins[src], m2.bytesInOutput]);
      }
      ;
      output.dependencies = Array.from(dependencies);
      output.inputs = inputs;
      if (output.type == "css" && !output[φ78]) {
        let origPaths = inputs.map(function(_0) {
          return _0[0].path;
        });
        let corrPaths = [];
        if (output.source) {
          walker.collectCSSInputs(output.source, corrPaths);
        }
        ;
        let offset = 0;
        let body = output[φ52].text;
        let chunks = [];
        for (let i = 0, φ79 = iter$__11(inputs), φ81 = φ79.length; i < φ81; i++) {
          let [input, bytes] = φ79[i];
          let header = "/* " + input.path + " */\n";
          if (!this.esoptions.minify) {
            offset += header.length;
            let idx = body.indexOf(header);
            if (idx >= 0) {
              offset = idx + header.length;
            }
            ;
          }
          ;
          let chunk = header + body.substr(offset, bytes) + "/* chunk:end */";
          input[φ80] = chunk;
          styleInputs.push(input);
          let index = corrPaths.indexOf(input);
          offset += bytes;
          if (!this.esoptions.minify) {
            offset += 1;
          }
          ;
          chunks[index] = chunk;
        }
        ;
        let text = chunks.filter(function(_0) {
          return _0;
        }).join("\n");
        output[φ78] = true;
        output[φ822] = text;
      }
      ;
      if (output.imports) {
        output.imports = output.imports.map(function(_0) {
          return outs[_0.path];
        });
      }
      ;
      if (m = path.match(/\.([A-Z\d]{8})\.\w+$/)) {
        output.hash = m[1];
      } else if (m = path.match(/\-([A-Z\d]{8})\.(\w{2,4})$/)) {
        output.hash = m[1];
      } else if (m = path.match(/chunk[\.\-]([A-Z\d]{8})\.\w+\.(js|css)(\.map)?$/)) {
        output.hash = m[1];
      }
      ;
      if (output.url) {
        urlOutputMap[output.url] = output;
      }
      ;
    }
    ;
    walker.replacePaths = async function(body, output) {
      let start = 0;
      let end = 0;
      let delim;
      let breaks = {"'": 1, '"': 1, "(": 1, ")": 1};
      let path;
      let useRelativePaths = false;
      while (true) {
        start = body.indexOf(ASSETS_URL, end);
        if (start == -1) {
          break;
        }
        ;
        delim = body[start - 1];
        end = start + 10;
        if (delim == "(") {
          delim = ")";
        }
        ;
        let path2 = body.substr(start, 300).match(/^[^\r\n\'\"\)]+/)[0];
        end = start + path2.length;
        path2 = body.slice(start, end);
        let origPath = path2;
        let cleanPath = path2.replace(/\/\/\.\/\//g, "/").replace(/\/\//g, "/").replace(ASSETS_URL, "");
        let rePath = origPath.replace(ASSETS_URL, self2.baseurl).replace(/\/\/\.\/\//g, "/").replace(/\/\//g, "/");
        let asset = urlOutputMap[path2] || urlOutputMap[cleanPath] || urlOutputMap[rePath];
        if (asset && !origPath.match(/\.js\.map$/)) {
          await walker.resolveAsset(asset);
          path2 = asset.url;
        } else {
          path2 = self2.baseurl + cleanPath;
        }
        ;
        if (useRelativePaths) {
          let rel = import_path5.default.relative(import_path5.default.dirname(output.url), path2);
          if (!rel.match(/^\.\.?\//)) {
            rel = "./" + rel;
          }
          ;
          path2 = rel;
        }
        ;
        if (path2 != origPath) {
          let pad = origPath.length - path2.length;
          let post = body[end];
          if (pad > 0) {
            post += " ".repeat(pad);
          }
          ;
          body = body.slice(0, start) + path2 + post + body.slice(end + 1);
        }
        ;
      }
      ;
      let header = [];
      if (output.type == "css") {
        return body;
      }
      ;
      if (self2.o.format == "html") {
        try {
          let mapping = {};
          let entryToUrlMap = {};
          for (let φ84 = 0, φ85 = iter$__11(output.dependencies), φ86 = φ85.length; φ84 < φ86; φ84++) {
            let item = φ85[φ84];
            if (!item.asset) {
              continue;
            }
            ;
            let asset = await walker.resolveAsset(item.asset);
            entryToUrlMap[item.path] = asset.url;
          }
          ;
          body.replace(/(\w+_default\d*) = \"(.*)\"/g, function(m, name, path2) {
            return mapping[name] = entryToUrlMap[path2] || path2;
          });
          let urls2 = body.match(/URLS = \[(.*)\]/)[1].split(/\,\s*/g).map(function(_0) {
            return mapping[_0];
          });
          if (useRelativePaths) {
            true;
          }
          ;
          let meta2 = self2.builder.meta[output.source.path];
          if (meta2 && meta2.html) {
            let replaced = meta2.html.replace(/ASSET_REF_(\d+)/g, function(m, nr) {
              let url = urls2[parseInt(nr)];
              return url;
            });
            body = replaced;
            if (self2.hmrΦ) {
              body = (0, import_utils2.injectStringBefore)(body, "<script src='/__hmr__.js'></script>", ["<!--$head$-->", "<!--$body$-->", "<html", ""]);
            }
            ;
          }
          ;
        } catch (e) {
        }
        ;
      } else if (self2.webishΦ) {
        let mfname = "_$MF$_";
        for (let φ87 = 0, φ88 = iter$__11(output.dependencies), φ89 = φ88.length; φ87 < φ89; φ87++) {
          let item = φ88[φ87];
          if (!item.asset) {
            continue;
          }
          ;
          let asset = await walker.resolveAsset(item.asset);
          let plain = {url: asset.url};
          header.push("" + mfname + "['" + item.path + "']=" + JSON.stringify(plain) + ";");
        }
        ;
        if (header.length) {
          header.unshift("var _$MF$_=(globalThis._MF_ = globalThis._MF_ || {});");
        }
        ;
        body = header.join("") + body.slice(body.indexOf("\n"));
      }
      ;
      return body;
    };
    walker.resolveAsset = async function(asset) {
      var _a;
      var φ91;
      if (asset[φ90]) {
        return asset;
      }
      ;
      asset[φ90] = true;
      if (asset.hash) {
        asset.ttl = 31536e3;
      }
      ;
      if (asset.type == "js" || asset.type == "html" || asset.type == "css") {
        self2.log.debug("resolving assets in " + asset.path);
        asset[φ822] || (asset[φ822] = asset[φ52].text);
        asset[φ432] = await walker.replacePaths(asset[φ822], asset);
      }
      ;
      if (asset.type == "map") {
        let js = (_a = asset.source) == null ? void 0 : _a.js;
        if (js) {
          await walker.resolveAsset(js);
          asset.hash = js.hash;
        }
        ;
      }
      ;
      self2.finalizeAsset(asset);
      return asset;
    };
    let newouts = {};
    for (let φ92 = 0, φ93 = iter$__11(styleInputs), φ94 = φ93.length; φ92 < φ94; φ92++) {
      let item = φ93[φ92];
      item[φ80] = await walker.replacePaths(item[φ80], {type: "css"});
    }
    ;
    for (let φ95 = 0, φ96 = Object.keys(outs), φ97 = φ96.length, path, output; φ95 < φ97; φ95++) {
      path = φ96[φ95];
      output = outs[path];
      if (path.indexOf(".SKIP.") > 0) {
        continue;
      }
      ;
      await walker.resolveAsset(output);
      if (!this.nodeΦ && output.url) {
        urls[output.url] = output;
      }
      ;
      newouts[output.path] = output;
    }
    ;
    for (let outs2 of iter$__11(addOutputs)) {
      Object.assign(newouts, outs2);
    }
    ;
    outs = meta.outputs = newouts;
    return result;
  }
  async write(result) {
    var φ120;
    this[φ98] || (this[φ98] = new fs_default(this.program.outdir, this.program));
    let meta = result.meta;
    let ins = meta.inputs;
    let outs = meta.outputs;
    let urls = meta.urls;
    if (meta.errors.length) {
      this.log.error("failed with " + meta.errors.length + " errors", meta.errors);
      this.emit("errored", meta.errors);
      return;
    }
    ;
    let manifest2 = result.manifest = {
      inputs: ins,
      outputs: {},
      urls,
      mappings: {},
      hash: null,
      srcdir: null,
      outdir: null,
      path: null,
      main: null,
      assets: null,
      css: null
    };
    let main = manifest2.main = ins[this.o.stdin ? this.o.stdin.sourcefile : this.entryPoints[0]].js;
    let assets = manifest2.assets = Object.values(outs);
    let cssinputs = this.collectStyleInputs(main.source, true);
    let htmlassets = assets.filter(function(_0) {
      return _0.type == "html";
    });
    if (cssinputs.length || htmlassets.length) {
      let body = "";
      for (let φ99 = 0, φ100 = iter$__11(cssinputs), φ101 = φ100.length; φ99 < φ101; φ99++) {
        let item = φ100[φ99];
        body += item[φ80] + "\n";
      }
      ;
      let asset = {
        [φ60]: "output",
        _: "output",
        type: "css",
        public: true,
        path: "all.__dist__.css",
        [φ432]: body
      };
      asset.asset = asset;
      this.finalizeAsset(asset, this.program.hashing !== false);
      manifest2.css = asset;
      ins.__styles__ = asset;
      assets.push(asset);
      for (let φ1022 = 0, φ103 = iter$__11(assets), φ104 = φ103.length; φ1022 < φ104; φ1022++) {
        let html = φ103[φ1022];
        if (html.type != "html") {
          continue;
        }
        ;
        html[φ432] = (0, import_utils2.replaceAll)(html[φ432], "href='__styles__'", "href='" + asset.url + "'");
        html.hash = (0, import_utils2.createHash)(html[φ432]);
      }
      ;
    }
    ;
    let writeFiles = {};
    let webEntries = [];
    manifest2.path = main.path + ".manifest";
    for (let φ105 = 0, φ106 = iter$__11(assets), φ107 = φ106.length; φ105 < φ107; φ105++) {
      let item = φ106[φ105];
      if (item.url) {
        manifest2.urls[item.url] = item;
      }
      ;
    }
    ;
    this.log.ts("ready to write");
    let mfile = this[φ98].lookup(manifest2.path);
    manifest2.srcdir = (0, import_utils2.relativePath)(mfile.absdir, this.outbase) || ".";
    manifest2.outdir = (0, import_utils2.relativePath)(mfile.absdir, this[φ98].cwd) || ".";
    if (true) {
      let htmlFiles = assets.filter(function(_0) {
        return _0.type == "html";
      });
      let htmlPaths = htmlFiles.map(function(_0) {
        return _0.path.split("/");
      });
      while (htmlPaths[0] && htmlPaths[0].length > 1) {
        let start = htmlPaths[0][0];
        let shared = htmlPaths.every(function(_0) {
          return _0[0] == start;
        });
        if (!shared) {
          break;
        }
        ;
        for (let φ108 = 0, φ109 = iter$__11(htmlPaths), φ1102 = φ109.length; φ108 < φ1102; φ108++) {
          let item = φ109[φ108];
          item.shift();
        }
        ;
      }
      ;
      for (let i = 0, φ1112 = iter$__11(htmlFiles), φ1122 = φ1112.length; i < φ1122; i++) {
        let item = φ1112[i];
        item.path = htmlPaths[i].join("/");
        if (this.pubdir != ".") {
          item.path = "" + this.pubdir + "/" + item.path;
        }
        ;
      }
      ;
    }
    ;
    for (let φ1132 = 0, φ114 = iter$__11(assets), φ115 = φ114.length; φ1132 < φ115; φ1132++) {
      let item = φ114[φ1132];
      manifest2.outputs[item.path] = item;
    }
    ;
    manifest2.hash = (0, import_utils2.createHash)(assets.map(function(_0) {
      return _0.hash || _0.path;
    }).sort().join("-"));
    this.log.debug("manifest hash: " + manifest2.hash);
    if (this.program.clean) {
      let rm = new Set();
      let old = this.manifest.outputs || {};
      for (let φ116 = 0, φ117 = Object.keys(old), φ118 = φ117.length, path, item; φ116 < φ118; φ116++) {
        path = φ117[φ116];
        item = old[path];
        if (!outs[item.path]) {
          rm.add(this[φ98].lookup(item.path));
        }
        ;
      }
      ;
      for (let file of iter$__11(rm)) {
        await file.unlink();
      }
      ;
    }
    ;
    let loaderData = import_fs4.default.readFileSync(import_path5.default.resolve(this.program.imbaPath, "loader.imba.js"), "utf-8");
    let loader = this[φ98].lookup(main.path.replace(/(\.js)?$/, ".loader.js"));
    if (false) {
    }
    ;
    if (this[φ119] != (φ120 = manifest2.hash) ? (this[φ119] = φ120, true) : false) {
      this.log.info("building in %path", this.program.outdir);
      for (let φ121 = 0, φ1222 = iter$__11(assets), φ123 = φ1222.length; φ121 < φ123; φ121++) {
        let asset = φ1222[φ121];
        let path = asset.path;
        let file = this[φ98].lookup(path);
        await file.write(asset[φ432], asset.hash);
      }
      ;
      let json = serializeData(manifest2);
      if (mfile) {
        await mfile.writeSync(json, manifest2.hash);
      }
      ;
      if (this.nodeishΦ) {
        await loader.write(loaderData);
      }
      ;
      this.manifest.path = mfile.abs;
      this.manifest.update(json);
    }
    ;
    try {
      this.log.debug(main.path, main.hash);
    } catch (e) {
    }
    ;
    this.log.debug("memory used: %bold", process.memoryUsage().heapUsed / 1024 / 1024);
    this.log.info("finished in %ms - %heap", this.builder.elapsed);
    return result;
  }
};
var bundle_default = Bundle;

// bin/imba.imba
var import_utils4 = require_utils4();
var import_tmp = __toModule(require_tmp());
var import_get_port = __toModule(require_get_port());
function iter$__12(a) {
  let v;
  return a ? (v = a.toIterable) ? v.call(a) : a : [];
}
var φ38 = Symbol.for("#parsed");
var φ44 = Symbol.for("#IMBA_OPTIONS");
var fmt = {
  int: function(val) {
    return parseInt(val);
  },
  i: function(val) {
    return val == "max" ? 0 : parseInt(val);
  },
  v: function(dummy, prev) {
    return prev + 1;
  }
};
var imbapkg = (0, import_utils4.resolvePackage)(import_path6.default.resolve(__dirname, "..")) || {};
var overrides = {};
var argv = process.argv.slice(0);
var overrideAliases = {
  M: {minify: false},
  m: {minify: true},
  S: {sourcemap: false},
  s: {sourcemap: true},
  H: {hashing: false},
  h: {hashing: true},
  P: {pubdir: "."}
};
var valueMap = {
  true: true,
  false: false,
  null: null,
  undefined: void 0
};
for (let i = 0, φ114 = iter$__12(argv), φ28 = φ114.length; i < φ28; i++) {
  let item = φ114[i];
  if (!item) {
    continue;
  }
  ;
  if (item.match(/^\-\-(\w+)(\.\w+)+$/)) {
    let val = argv[i + 1];
    let path = item.slice(2).split(".");
    let cfg = overrides;
    argv[i] = null;
    while (path[1]) {
      cfg = cfg[path[0]] || (cfg[path[0]] = {});
      path.shift();
    }
    ;
    let aliased = overrideAliases[path[0]];
    if (aliased) {
      Object.assign(cfg, aliased);
    } else {
      if (val.indexOf(" ") >= 0) {
        val = val.split(/\,\s*|\s+/g);
      }
      ;
      val = valueMap[val] || val;
      cfg[path[0]] = val;
      argv[i] = null;
      argv[i + 1] = null;
    }
    ;
  }
  ;
}
argv = argv.filter(function(_0) {
  return _0 !== null;
});
function parseOptions(options, extras = []) {
  if (options[φ38]) {
    return options;
  }
  ;
  let command = options._name;
  if (options.opts instanceof Function) {
    options = options.opts();
  }
  ;
  let cwd = options.cwd || (options.cwd = process.cwd());
  options.imbaPath || (options.imbaPath = import_path6.default.resolve(__dirname, ".."));
  options.command = command;
  options.extras = extras;
  options.config = (0, import_utils4.resolveConfig)(cwd, options.config || "imbaconfig.json");
  options.package = (0, import_utils4.resolvePackage)(cwd) || {};
  if (command == "build") {
    options.minify == null ? options.minify = true : options.minify;
    options.loglevel || (options.loglevel = "info");
    options.outdir || (options.outdir = "dist");
  }
  ;
  if (options.verbose > 1) {
    options.loglevel || (options.loglevel = "debug");
  } else if (options.verbose) {
    options.loglevel || (options.loglevel = "info");
  }
  ;
  if (command == "serve") {
    options.watch = true;
  }
  ;
  if (options.watch) {
    options.loglevel || (options.loglevel = "info");
    if (options.mode == "development") {
      options.hmr = true;
    }
    ;
  }
  ;
  if (options.force) {
    options.mtime = Date.now();
  } else {
    let statFiles = [
      __filename,
      import_path6.default.resolve(__dirname, "..", "workers.imba.js"),
      import_path6.default.resolve(__dirname, "..", "compiler.imba.js")
    ];
    options.mtime = Math.max(...statFiles.map(function(_0) {
      return import_fs6.default.statSync(_0).mtimeMs;
    }));
  }
  ;
  options.loglevel || (options.loglevel = "warning");
  options.cachedir = (0, import_utils4.getCacheDir)(options);
  globalThis[φ44] = options;
  options[φ38] = true;
  return options;
}
async function run(entry, o, extras) {
  var _a;
  let exec;
  if (o.args.length <= 0) {
    return import_commander.program.help();
  }
  ;
  let [path, q] = entry.split("?");
  path = import_path6.default.resolve(path);
  let prog = o = parseOptions(o, extras);
  o.cache = new cache_default(o);
  o.fs = new fs_default(o.cwd, o);
  merge(prog.config.options, overrides);
  if (!o.outdir) {
    if (o.command == "build") {
      o.outdir = "dist";
    } else {
      import_tmp.default.setGracefulCleanup();
      let tmpdir = import_tmp.default.dirSync({unsafeCleanup: true});
      o.outdir = o.tmpdir = tmpdir.name;
    }
    ;
  }
  ;
  let file = o.fs.lookup(path);
  if (q) {
    o.as = q.replace(/^as=/, "");
  } else if (file.ext == ".html") {
    o.as = "html";
  }
  ;
  let params = resolvePresets(prog.config, {entryPoints: [file.rel]}, o.as || "node");
  if (o.command != "build") {
    o.port || (o.port = await (0, import_get_port.default)({port: import_get_port.default.makeRange(3e3, 3100)}));
  }
  ;
  if (o.command == "serve" || params.platform != "node") {
    let wrapper = resolvePresets(prog.config, {}, "node");
    params = wrapper;
    params.stdin = {
      define: {ENTRYPOINT: "./" + file.rel},
      template: "serve-http.imba",
      resolveDir: o.cwd,
      sourcefile: "serve.imba",
      loader: "js"
    };
    if (file.ext == ".html") {
      params.stdin.template = "serve-html.imba";
      params.format = "cjs";
    }
    ;
  }
  ;
  let bundle = new bundle_default(o, params);
  let out = await bundle.build();
  if (o.command == "build") {
    return;
  }
  ;
  if (exec = (_a = out == null ? void 0 : out.manifest) == null ? void 0 : _a.main) {
    if (!o.watch && o.instances == 1) {
      o.execMode = "fork";
    }
    ;
    o.name || (o.name = entry);
    let runner = new runner_default(bundle.manifest, o);
    runner.start();
    if (o.watch) {
      bundle.on("errored", function(_0) {
        return runner.broadcast(["emit", "manifest:error", _0]);
      });
      bundle.manifest.on("change", function() {
        return runner.broadcast(["emit", "manifest:change", bundle.manifest.raw]);
      });
      bundle.manifest.on("change:main", function() {
        return runner.reload();
      });
    }
    ;
  }
  ;
  return;
}
var binary = import_commander.program.storeOptionsAsProperties(false).version(imbapkg.version).name("imba");
function common(cmd) {
  return cmd.option("-o, --outdir <dir>", "Directory to output files").option("-w, --watch", "Continously build and watch project").option("-v, --verbose", "verbosity (repeat to increase)", fmt.v, 0).option("-m, --minify", "Minify generated files").option("-M, --no-minify", "Disable minifying").option("-f, --force", "Disregard previously cached outputs").option("-c, --client-only", "Generate client files only").option("--sourcemap <value>", "", "inline").option("-S, --no-sourcemap", "Omit sourcemaps").option("-H, --no-hashing", "Disable hashing").option("--pubdir <dir>", "Directory to output client-side files - relative to outdir").option("-P, --no-pubdir", "Build client-side files straight into outdir").option("--baseurl <url>", "Base url for your generated site", "/").option("--asset-names <pattern>", "Paths for generated assets", "__assets__/[dir]/[name]").option("--html-names <pattern>", "Paths for generated html files", "[dir]/[name]").option("--clean", "Remove files from previous build").option("--mode <mode>", "Configuration mode", "development");
}
common(import_commander.program.command("run [script]", {isDefault: true}).description("Imba")).option("-i, --instances [count]", "Number of instances to start", fmt.i, 1).option("--inspect", "Debug").action(run);
common(import_commander.program.command("build <script>").description("Build an imba/js/html entrypoint and their dependencies")).option("--platform <platform>", "Platform for entry", "browser").option("--as <preset>", "Configuration preset", "node").action(run);
common(import_commander.program.command("serve <script>").description("Spawn a webserver for an imba/js/html entrypoint")).option("-i, --instances [count]", "Number of instances to start", fmt.i, 1).action(run);
import_commander.program.command("create [project]", "Create a new imba project from a template");
logger_default.ts("parse options");
binary.parse(argv);
